* hgaga.F
* the Higgs -> gamma gamma main program 
* this file is part of FeynHiggs
* last modified 19 Oct 07 th

#include "externals.h"

#define IDENTICALFACTOR .5D0


	subroutine hgaga(n, res, polM2, polM)
	implicit none
	integer n
	double precision res, polM2(2,2)
	double complex polM(2,2)

#include "Decay.h"

	double precision sqrtS, Pout, factor
	integer hel1, hel2

	hno = n
	sqrtS = MHiggs(hno)
	Pout = .5D0*sqrtS

* Higgs
	call VecSet(1, sqrtS, 0D0, 0D0, 0D0, 1D0)

* gamma
	call VecSet(2, 0D0, Pout, 1D0, 0D0, 0D0)

* gamma
	call VecSet(3, 0D0, Pout, -1D0, 0D0, 0D0)

	call hgaga_SquaredME(res, polM2, polM)

* throw in 4 pi from the integration, symmetry factors, and flux
	factor = 4*pi*(IDENTICALFACTOR)*
     &    1/(2*(2*pi)**2*4)*Pout/sqrtS**2

	res = factor*res

* extra factor for cross section evaluation: ga ga -> h_i
* result is then given in pico barn
* (to be multiplied with dL/dtau)
* see Eq. (2) in hep-ph/0101083
	factor = hbar_c2*(8*pi**2)/(sqrtS**2*MHiggs(hno))*factor

	do hel2 = 1, 2
	  do hel1 = 1, 2
	    polM(hel1,hel2) = factor*polM(hel1,hel2)
	  enddo
	enddo
	end
