* FH.h
* global variable declarations
* this file is part of FeynHiggs
* last modified 17 Apr 08 th


#ifndef USfC
#define USfC(a,b,t,g) DCONJG(USf(a,b,t,g))
#define UASfC(a,b,t) DCONJG(UASf(a,b,t))
#define VChaC(a,b) DCONJG(VCha(a,b))
#define UChaC(a,b) DCONJG(UCha(a,b))
#define ZNeuC(a,b) DCONJG(ZNeu(a,b))
#define CKMC(a,b) DCONJG(CKM(a,b))
#define AfC(t,g1,g2) DCONJG(Af(t,g1,g2))
#define MUEC DCONJG(MUE)
#define M_3C DCONJG(M_3)

#define Sq(c) (DBLE(c)**2 + DIMAG(c)**2)
#define SignSq(x) (x)*abs(x)
#define SignSqrt(x) sign(sqrt(abs(x)),x)
#define Delta(i,j) ibits(ieor(i,j)-1,15,1)
#define Key(se) 2**(se-1)
#endif


#include "const.h"
#include "FHCouplings.h"


* SM parameters

	double complex CKM(3,3)
	double precision Mf(4,3), Mf2(4,3), MTrun, MBrun
	double precision MW, MW2, MZ, MZ2
	double precision SW, SW2, CW, CW2
	double precision EL, Alfa, Alfa2
	double precision GS, Alfas, Alfas2, AlfasMZ, GF
	double precision CKMlambda, CKMA
	double complex CKMrhoeta
	double precision scalefactor, Qtau, Qt, Qb

	common /smpara/
     &    CKM,
     &    Mf, Mf2, MTrun, MBrun,
     &    MW, MW2, MZ, MZ2, CW, CW2, SW, SW2,
     &    EL, Alfa, Alfa2,
     &    GS, Alfas, Alfas2, AlfasMZ, GF,
     &    CKMlambda, CKMA, CKMrhoeta,
     &    scalefactor, Qtau, Qt, Qb

	double precision ME, ME2, MM, MM2, ML, ML2
	double precision MU, MU2, MC, MC2, MT, MT2
	double precision MD, MD2, MS, MS2, MB, MB2
	equivalence (Mf(2,1), ME), (Mf2(2,1), ME2)
	equivalence (Mf(2,2), MM), (Mf2(2,2), MM2)
	equivalence (Mf(2,3), ML), (Mf2(2,3), ML2)
	equivalence (Mf(3,1), MU), (Mf2(3,1), MU2)
	equivalence (Mf(3,2), MC), (Mf2(3,2), MC2)
	equivalence (Mf(3,3), MT), (Mf2(3,3), MT2)
	equivalence (Mf(4,1), MD), (Mf2(4,1), MD2)
	equivalence (Mf(4,2), MS), (Mf2(4,2), MS2)
	equivalence (Mf(4,3), MB), (Mf2(4,3), MB2)


* MSSM parameters

	double complex UCha(2,2), VCha(2,2), ZNeu(4,4)
	double precision MCha(2), MCha2(2), MNeu(4), MNeu2(4)
	double complex Af(2:4,3,3), Xf(2:4,3,3), MUETB(2:4), MUE
	double complex M_1, M_2, M_3
	double complex deltaSf(3:4,6,6)
	double precision DSf(2,4), MSS2(2,2:4,3)
        double precision Mh0, Mh02, MHH, MHH2, MA0, MA02, MHp, MHp2
	double precision MGl, MGl2
	double precision CB, SB, TB, CB2, SB2, TB2, C2B, S2B
	double precision CA, SA, CA2, SA2, C2A, S2A
	double precision CAB, SAB, CBA, SBA
	integer inputmass

	common /mssmpara/
     &    UCha, VCha, ZNeu,
     &    MCha, MCha2, MNeu, MNeu2,
     &    Af, Xf, MUETB, MUE,
     &    M_1, M_2, M_3,
     &    deltaSf,
     &    DSf, MSS2,
     &    Mh0, Mh02, MHH, MHH2, MA0, MA02, MHp, MHp2,
     &    MGl, MGl2,
     &    CB, SB, TB, CB2, SB2, TB2, C2B, S2B,
     &    CA, SA, CA2, SA2, C2A, S2A,
     &    CAB, SAB, CBA, SBA,
     &    inputmass

	double precision reimMUE(2), reMUE, imMUE
	equivalence (MUE, reimMUE)
	equivalence (reimMUE(1), reMUE)
	equivalence (reimMUE(2), imMUE)

	double complex UCha_flat(2*2), VCha_flat(2*2), ZNeu_flat(4*4)
	equivalence (UCha, UCha_flat)
	equivalence (VCha, VCha_flat)
	equivalence (ZNeu, ZNeu_flat)

	double complex Af_flat(3*3*3)
	equivalence (Af, Af_flat)

	double complex deltaSf_flat(2*6*6)
	equivalence (deltaSf, deltaSf_flat)


* Note: despite its name, sfermpara contains not only
* sfermion parameters, but all variables which need to be
* conserved during FHUncertainties.

	double precision DSS2(2,2:5,3)
	double precision MSf(2,4,3), MSf2(4,4,3)
	double complex USf(2,2,4,3)
	double precision MASf(6,3:4), MASf2(6,3:4)
	double complex UASf(6,6,3:4)
	double complex Hff(2,3,2), DeltaMBc(2)
	double precision Mdy(3,2), Mdy2(3,2)
	double precision space_for_maxpass

	common /sfermpara/
     &    DSS2,
     &    MSf, MSf2, USf,
     &    MASf, MASf2, UASf,
     &    Hff, DeltaMBc, Mdy, Mdy2,
     &    space_for_maxpass

	double precision MSf_flat(2*4*3), MASf_flat(6*2)
	equivalence (MSf, MSf_flat)
	equivalence (MASf, MASf_flat)

	double complex USf_flat(2*2*4*3), UASf_flat(6*6*2)
	equivalence (USf, USf_flat)
	equivalence (UASf, UASf_flat)

	double complex Hff_flat(2*3*2)
	equivalence (Hff, Hff_flat)

	integer DeltaMB_maxpass
	equivalence (space_for_maxpass, DeltaMB_maxpass)

	integer NSfermionData
	parameter (NSfermionData = 2*4*3 +
     &    2*4*3 + 4*4*3 + 2*2*2*4*3 +
     &    6*2 + 6*2 + 2*6*6*2 +
     &    2*2*3*2 + 2*2 + 3*2 + 3*2 + 1)
	double precision SfermionData(NSfermionData)
	equivalence (DSS2, SfermionData)


* Higgs results

	integer h0h0, HHHH, A0A0, HmHp
	integer h0HH, h0A0, HHA0
	integer G0G0, h0G0, HHG0, A0G0
	integer GmGp, HmGp
	integer semax
	integer cpeven, cpodd, goldstones
	parameter (h0h0 = 1, HHHH = 2, A0A0 = 3, HmHp = 4)
	parameter (h0HH = 5, h0A0 = 6, HHA0 = 7)
	parameter (G0G0 = 8, h0G0 = 9, HHG0 = 10, A0G0 = 11)
	parameter (GmGp = 12, HmGp = 13)
	parameter (semax = HmGp)
	parameter (cpeven = Key(h0h0) + Key(HHHH) + Key(h0HH))
	parameter (cpodd = Key(A0A0) + Key(h0A0) + Key(HHA0))
	parameter (goldstones = Key(G0G0) + Key(h0G0) +
     &    Key(HHG0) + Key(A0G0))

	integer NNeutral, NCharged, NHiggs
	parameter (NNeutral = 3)
	parameter (NCharged = 1)
	parameter (NHiggs = NNeutral + NCharged)
	double complex SAeff, XHiggs(0:NNeutral,0:NNeutral,2)
	double precision MHiggs(NHiggs), MHiggs2(0:NHiggs)

* renormalized self-energies & counter terms

	double precision dZ(semax), dMsq(semax), Msq(semax)
	double complex seR(semax), dseR(semax), se2R(semax)

	common /higgsdata/
     &    MHiggs, SAeff, XHiggs, MHiggs2,
     &    dZ, dMsq, Msq, seR, dseR, se2R

	double complex UHiggs(0:NNeutral,0:NNeutral)
	double complex ZHiggs(0:NNeutral,0:NNeutral)
	equivalence (XHiggs(0,0,1), UHiggs)
	equivalence (XHiggs(0,0,2), ZHiggs)

	integer NHiggsErr, NHiggsData
	parameter (NHiggsErr = NHiggs + 2 + 2*(NNeutral+1)**2*2)
	parameter (NHiggsData = NHiggsErr + NHiggs+1 +
     &    (3 + 3*2)*semax)
	double precision HiggsData(NHiggsData)
	equivalence (MHiggs, HiggsData)


* couplings and widths

	double complex couplings(ncouplings)
	double complex couplingsms(ncouplingsms)
	double precision gammas(ngammas)
	double precision gammasms(ngammasms)
	double precision ratios(H0FF(3,4,3))

	common /coupdata/
     &    couplings, couplingsms, gammas, gammasms, ratios

	double precision hggU(3,3), hggDRe(3,3), hggDIm(3,3)
	double precision hggSq(3), hgagaQ, hgagaSq
	double precision MdySM(3)

	common /kfactors/
     &    hggU, hggDRe, hggDIm, hggSq, hgagaQ, hgagaSq, MdySM

	double precision hggU_flat(3*3)
	double precision hggDRe_flat(3*3), hggDIm_flat(3*3)
	equivalence (hggU, hggU_flat)
	equivalence (hggDRe, hggDRe_flat)
	equivalence (hggDIm, hggDIm_flat)

* flags

	integer mssmpart, fieldren, tanbren
	integer higgsmix, p2approx, looplevel
	integer tlRunningMT, tlBotResum, tlCplxApprox
	integer debuglevel, nmfv, uzint, uzext

* debuglevel = 0: no debug messages
*              1: dump setflags and setpara values
*              2: display Higgs mass matrix at p^2 = 0 and CTs
*              3: display search for zeros

	common /flags/
     &    mssmpart, fieldren, tanbren,
     &    higgsmix, p2approx, looplevel,
     &    tlRunningMT, tlBotResum, tlCplxApprox,
     &    debuglevel, nmfv, uzint, uzext


	integer flags_valid, sm_valid, para_valid
	integer higgs_valid, coup_valid

	common /valids/
     &    flags_valid, sm_valid, para_valid,
     &    higgs_valid, coup_valid

