* dse_HHA0.F
* this file is part of FeynHiggs
* generated 06 Mar 2008 09:19

#include "externals.h"


	double complex function dse_HHA0(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex dse_HHA0_mfv, dse_HHA0_nmfv
	external dse_HHA0_mfv, dse_HHA0_nmfv

	if( nmfv .eq. 0 ) then
	  dse_HHA0 = dse_HHA0_mfv(k2)
	else
	  dse_HHA0 = dse_HHA0_nmfv(k2)
	endif

#ifdef DEBUG
	print *, 'k2 =', k2
	print *, 'dse_HHA0 =', dse_HHA0
#endif
	end


************************************************************************


	double complex function dse_HHA0_mfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha1, Cha2, Gen1, Neu1, Neu2, Sfe1, Sfe2, g

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_HHA0_mfv = 0

	do Gen1 = g, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        dse_HHA0_mfv = dse_HHA0_mfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       DB0(k2,MSf2(Sfe1,3,Gen1),MSf2(Sfe2,3,Gen1))*
     -       Mf(3,Gen1)*(USf(Sfe2,1,3,Gen1)*
     -          ((CAB*MW*MZ*SB*(3 - 4*SW2) + 6*CW*SA*Mf2(3,Gen1))*
     -             USfC(Sfe1,1,3,Gen1) + 
     -            3*CW*(-(CA*MUE) + SA*AfC(3,Gen1,Gen1))*
     -             Mf(3,Gen1)*USfC(Sfe1,2,3,Gen1)) + 
     -         USf(Sfe2,2,3,Gen1)*
     -          (3*CW*(-(CA*MUEC) + SA*Af(3,Gen1,Gen1))*Mf(3,Gen1)*
     -             USfC(Sfe1,1,3,Gen1) + 
     -            2*(2*CAB*MW*MZ*SB*SW2 + 3*CW*SA*Mf2(3,Gen1))*
     -             USfC(Sfe1,2,3,Gen1)))*
     -       (MUEC*TB*USf(Sfe1,2,3,Gen1)*USfC(Sfe2,1,3,Gen1) + 
     -         Af(3,Gen1,Gen1)*USf(Sfe1,2,3,Gen1)*
     -          USfC(Sfe2,1,3,Gen1) - 
     -         MUE*TB*USf(Sfe1,1,3,Gen1)*USfC(Sfe2,2,3,Gen1) - 
     -         AfC(3,Gen1,Gen1)*USf(Sfe1,1,3,Gen1)*
     -          USfC(Sfe2,2,3,Gen1)))/(CW*MW2*SB*SW2*TB)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_HHA0_mfv =', dse_HHA0_mfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        dse_HHA0_mfv = dse_HHA0_mfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       DB0(k2,MSf2(Sfe1,4,Gen1),MSf2(Sfe2,4,Gen1))*
     -       Mdy(Gen1,1)*(USf(Sfe2,1,4,Gen1)*
     -          ((CAB*CB*MW*MZ*(-3 + 2*SW2) + 
     -               6*CA*CW*Mdy2(Gen1,1))*USfC(Sfe1,1,4,Gen1) + 
     -            3*CW*(-(MUE*SA) + CA*AfC(4,Gen1,Gen1))*
     -             Mdy(Gen1,1)*USfC(Sfe1,2,4,Gen1)) + 
     -         USf(Sfe2,2,4,Gen1)*
     -          (3*CW*(-(MUEC*SA) + CA*Af(4,Gen1,Gen1))*
     -             Mdy(Gen1,1)*USfC(Sfe1,1,4,Gen1) - 
     -            2*(CAB*CB*MW*MZ*SW2 - 3*CA*CW*Mdy2(Gen1,1))*
     -             USfC(Sfe1,2,4,Gen1)))*
     -       ((MUEC + TB*Af(4,Gen1,Gen1))*USf(Sfe1,2,4,Gen1)*
     -          USfC(Sfe2,1,4,Gen1) - 
     -         (MUE + TB*AfC(4,Gen1,Gen1))*USf(Sfe1,1,4,Gen1)*
     -          USfC(Sfe2,2,4,Gen1)))/(CB*CW*MW2*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_HHA0_mfv =', dse_HHA0_mfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        dse_HHA0_mfv = dse_HHA0_mfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       DB0(k2,MSf2(Sfe1,2,Gen1),MSf2(Sfe2,2,Gen1))*
     -       Mf(2,Gen1)*(USf(Sfe2,1,2,Gen1)*
     -          ((CAB*CB*MW*MZ*(-1 + 2*SW2) + 2*CA*CW*Mf2(2,Gen1))*
     -             USfC(Sfe1,1,2,Gen1) + 
     -            CW*(-(MUE*SA) + CA*AfC(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,2,2,Gen1)) + 
     -         USf(Sfe2,2,2,Gen1)*
     -          (CW*(-(MUEC*SA) + CA*Af(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,1,2,Gen1) + 
     -            2*(-(CAB*CB*MW*MZ*SW2) + CA*CW*Mf2(2,Gen1))*
     -             USfC(Sfe1,2,2,Gen1)))*
     -       ((MUEC + TB*Af(2,Gen1,Gen1))*USf(Sfe1,2,2,Gen1)*
     -          USfC(Sfe2,1,2,Gen1) - 
     -         (MUE + TB*AfC(2,Gen1,Gen1))*USf(Sfe1,1,2,Gen1)*
     -          USfC(Sfe2,2,2,Gen1)))/(CB*CW*MW2*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_HHA0_mfv =', dse_HHA0_mfv
#endif

	if( mssmpart .eq. 3 ) return


	do Cha1 = 1, 2
	do Cha2 = 1, 2
        tmp1 = CA*UCha(Cha2,2)*VCha(Cha1,1) + 
     -   SA*UCha(Cha2,1)*VCha(Cha1,2)
        tmp2 = SB*UCha(Cha1,2)*VCha(Cha2,1) + 
     -   CB*UCha(Cha1,1)*VCha(Cha2,2)
        tmp3 = SB*UChaC(Cha2,2)*VChaC(Cha1,1) + 
     -   CB*UChaC(Cha2,1)*VChaC(Cha1,2)
        tmp4 = CA*UChaC(Cha1,2)*VChaC(Cha2,1) + 
     -   SA*UChaC(Cha1,1)*VChaC(Cha2,2)
        dse_HHA0_mfv = dse_HHA0_mfv + 
     -   cI/(4.D0*Pi)*(Alfa*((tmp1*tmp3 - tmp2*tmp4)*
     -          (B1(k2,MCha2(Cha1),MCha2(Cha2)) + 
     -            k2*DB1(k2,MCha2(Cha1),MCha2(Cha2))) - 
     -         DB0(k2,MCha2(Cha1),MCha2(Cha2))*
     -          (-(tmp3*tmp4*MCha(Cha1)*MCha(Cha2)) + 
     -            tmp2*tmp4*MCha2(Cha1) + 
     -            tmp1*(tmp2*MCha(Cha1)*MCha(Cha2) - 
     -               tmp3*MCha2(Cha1)))))/SW2
	enddo
	enddo

	do Neu1 = 1, 4
	do Neu2 = 1, 4
	tmp5 = SW*ZNeu(Neu1,1) - CW*ZNeu(Neu1,2)
	tmp6 = SW*ZNeu(Neu2,1) - CW*ZNeu(Neu2,2)
	tmp7 = CB*(-(SW*ZNeu(Neu2,1)) + CW*ZNeu(Neu2,2))
	tmp8 = -(SA*SW*ZNeu(Neu2,1)) + CW*SA*ZNeu(Neu2,2)
	tmp9 = SB*ZNeu(Neu2,3) - CB*ZNeu(Neu2,4)
	tmp10 = CA*ZNeu(Neu2,3) - SA*ZNeu(Neu2,4)
	tmp11 = SW*ZNeuC(Neu1,1) - CW*ZNeuC(Neu1,2)
	tmp12 = SW*ZNeuC(Neu2,1) - CW*ZNeuC(Neu2,2)
	tmp13 = CB*(-(SW*ZNeuC(Neu2,1)) + CW*ZNeuC(Neu2,2))
	tmp14 = -(SA*SW*ZNeuC(Neu2,1)) + CW*SA*ZNeuC(Neu2,2)
	tmp15 = SB*ZNeuC(Neu2,3) - CB*ZNeuC(Neu2,4)
	tmp16 = CA*ZNeuC(Neu2,3) - SA*ZNeuC(Neu2,4)
        dse_HHA0_mfv = dse_HHA0_mfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       ((B1(k2,MNeu2(Neu1),MNeu2(Neu2)) + 
     -            k2*DB1(k2,MNeu2(Neu1),MNeu2(Neu2)))*
     -          ((tmp10*tmp5 + CA*tmp6*ZNeu(Neu1,3) + 
     -               tmp8*ZNeu(Neu1,4))*
     -             (tmp11*tmp15 + SB*tmp12*ZNeuC(Neu1,3) + 
     -               tmp13*ZNeuC(Neu1,4)) - 
     -            (tmp5*tmp9 + SB*tmp6*ZNeu(Neu1,3) + 
     -               tmp7*ZNeu(Neu1,4))*
     -             (tmp11*tmp16 + CA*tmp12*ZNeuC(Neu1,3) + 
     -               tmp14*ZNeuC(Neu1,4))) + 
     -         DB0(k2,MNeu2(Neu1),MNeu2(Neu2))*
     -          (-(MNeu(Neu1)*MNeu(Neu2)*
     -               (tmp5*tmp9 + SB*tmp6*ZNeu(Neu1,3) + 
     -                 tmp7*ZNeu(Neu1,4))*
     -               (tmp10*tmp5 + CA*tmp6*ZNeu(Neu1,3) + 
     -                 tmp8*ZNeu(Neu1,4))) + 
     -            MNeu2(Neu1)*
     -             (tmp10*tmp5 + CA*tmp6*ZNeu(Neu1,3) + 
     -               tmp8*ZNeu(Neu1,4))*
     -             (tmp11*tmp15 + SB*tmp12*ZNeuC(Neu1,3) + 
     -               tmp13*ZNeuC(Neu1,4)) - 
     -            MNeu2(Neu1)*
     -             (tmp5*tmp9 + SB*tmp6*ZNeu(Neu1,3) + 
     -               tmp7*ZNeu(Neu1,4))*
     -             (tmp11*tmp16 + CA*tmp12*ZNeuC(Neu1,3) + 
     -               tmp14*ZNeuC(Neu1,4)) + 
     -            MNeu(Neu1)*MNeu(Neu2)*
     -             (tmp11*tmp15 + SB*tmp12*ZNeuC(Neu1,3) + 
     -               tmp13*ZNeuC(Neu1,4))*
     -             (tmp11*tmp16 + CA*tmp12*ZNeuC(Neu1,3) + 
     -               tmp14*ZNeuC(Neu1,4)))))/(CW2*SW2)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_HHA0_mfv =', dse_HHA0_mfv
#endif

	end


************************************************************************


	double complex function dse_HHA0_nmfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All1, All2, Cha1, Cha2, Gen1, Ind1, Ind2, Ind3, Ind4
	integer Neu1, Neu2, Sfe1, Sfe2, g

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_HHA0_nmfv = 0

	do All1 = g, 6, g
	do All2 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
	do Ind3 = g, 3
	do Ind4 = g, 3
        dse_HHA0_nmfv = dse_HHA0_nmfv - 
     -   cI/(16.D0*Pi)*(Alfa*DB0(k2,MASf2(All1,3),MASf2(All2,3))*
     -       Mf(3,Ind1)*((Delta(Ind3,Ind4)*
     -             (CAB*MW*MZ*SB*(3 - 4*SW2) + 
     -               6*CW*SA*Mf2(3,Ind3))*UASf(All2,Ind4,3) + 
     -            3*CW*(SA*Af(3,Ind3,Ind4) - 
     -               CA*MUEC*Delta(Ind3,Ind4))*Mf(3,Ind3)*
     -             UASf(All2,3 + Ind4,3))*UASfC(All1,Ind3,3) + 
     -         Delta(Ind3,Ind4)*
     -          (3*CW*(-(CA*MUE) + SA*AfC(3,Ind3,Ind3))*Mf(3,Ind3)*
     -             UASf(All2,Ind4,3) + 
     -            2*(2*CAB*MW*MZ*SB*SW2 + 3*CW*SA*Mf2(3,Ind3))*
     -             UASf(All2,3 + Ind4,3))*UASfC(All1,3 + Ind3,3))*
     -       (-((Af(3,Ind1,Ind2) + MUEC*TB*Delta(Ind1,Ind2))*
     -            UASf(All1,3 + Ind2,3)*UASfC(All2,Ind1,3)) + 
     -         (MUE*TB + AfC(3,Ind1,Ind1))*Delta(Ind1,Ind2)*
     -          UASf(All1,Ind2,3)*UASfC(All2,3 + Ind1,3)))/
     -     (CW*MW2*SB*SW2*TB)
	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_HHA0_nmfv =', dse_HHA0_nmfv
#endif

	if( mssmpart .eq. 1 ) return


	do All1 = g, 6, g
	do All2 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
	do Ind3 = g, 3
	do Ind4 = g, 3
        dse_HHA0_nmfv = dse_HHA0_nmfv - 
     -   cI/(16.D0*Pi)*(Alfa*DB0(k2,MASf2(All1,4),MASf2(All2,4))*
     -       Mdy(Ind1,1)*((Delta(Ind3,Ind4)*
     -             (CAB*CB*MW*MZ*(-3 + 2*SW2) + 
     -               6*CA*CW*Mdy2(Ind3,1))*UASf(All2,Ind4,4) + 
     -            3*CW*(CA*Af(4,Ind3,Ind4) - 
     -               MUEC*SA*Delta(Ind3,Ind4))*Mdy(Ind3,1)*
     -             UASf(All2,3 + Ind4,4))*UASfC(All1,Ind3,4) + 
     -         Delta(Ind3,Ind4)*
     -          (3*CW*(-(MUE*SA) + CA*AfC(4,Ind3,Ind3))*
     -             Mdy(Ind3,1)*UASf(All2,Ind4,4) - 
     -            2*(CAB*CB*MW*MZ*SW2 - 3*CA*CW*Mdy2(Ind3,1))*
     -             UASf(All2,3 + Ind4,4))*UASfC(All1,3 + Ind3,4))*
     -       (-((TB*Af(4,Ind1,Ind2) + MUEC*Delta(Ind1,Ind2))*
     -            UASf(All1,3 + Ind2,4)*UASfC(All2,Ind1,4)) + 
     -         (MUE + TB*AfC(4,Ind1,Ind1))*Delta(Ind1,Ind2)*
     -          UASf(All1,Ind2,4)*UASfC(All2,3 + Ind1,4)))/
     -     (CB*CW*MW2*SW2)
	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_HHA0_nmfv =', dse_HHA0_nmfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        dse_HHA0_nmfv = dse_HHA0_nmfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       DB0(k2,MSf2(Sfe1,2,Gen1),MSf2(Sfe2,2,Gen1))*
     -       Mf(2,Gen1)*(USf(Sfe2,1,2,Gen1)*
     -          ((CAB*CB*MW*MZ*(-1 + 2*SW2) + 2*CA*CW*Mf2(2,Gen1))*
     -             USfC(Sfe1,1,2,Gen1) + 
     -            CW*(-(MUE*SA) + CA*AfC(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,2,2,Gen1)) + 
     -         USf(Sfe2,2,2,Gen1)*
     -          (CW*(-(MUEC*SA) + CA*Af(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,1,2,Gen1) + 
     -            2*(-(CAB*CB*MW*MZ*SW2) + CA*CW*Mf2(2,Gen1))*
     -             USfC(Sfe1,2,2,Gen1)))*
     -       ((MUEC + TB*Af(2,Gen1,Gen1))*USf(Sfe1,2,2,Gen1)*
     -          USfC(Sfe2,1,2,Gen1) - 
     -         (MUE + TB*AfC(2,Gen1,Gen1))*USf(Sfe1,1,2,Gen1)*
     -          USfC(Sfe2,2,2,Gen1)))/(CB*CW*MW2*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_HHA0_nmfv =', dse_HHA0_nmfv
#endif

	if( mssmpart .eq. 3 ) return


	do Cha1 = 1, 2
	do Cha2 = 1, 2
        tmp1 = CA*UCha(Cha2,2)*VCha(Cha1,1) + 
     -   SA*UCha(Cha2,1)*VCha(Cha1,2)
        tmp2 = SB*UCha(Cha1,2)*VCha(Cha2,1) + 
     -   CB*UCha(Cha1,1)*VCha(Cha2,2)
        tmp3 = SB*UChaC(Cha2,2)*VChaC(Cha1,1) + 
     -   CB*UChaC(Cha2,1)*VChaC(Cha1,2)
        tmp4 = CA*UChaC(Cha1,2)*VChaC(Cha2,1) + 
     -   SA*UChaC(Cha1,1)*VChaC(Cha2,2)
        dse_HHA0_nmfv = dse_HHA0_nmfv + 
     -   cI/(4.D0*Pi)*(Alfa*((tmp1*tmp3 - tmp2*tmp4)*
     -          (B1(k2,MCha2(Cha1),MCha2(Cha2)) + 
     -            k2*DB1(k2,MCha2(Cha1),MCha2(Cha2))) - 
     -         DB0(k2,MCha2(Cha1),MCha2(Cha2))*
     -          (-(tmp3*tmp4*MCha(Cha1)*MCha(Cha2)) + 
     -            tmp2*tmp4*MCha2(Cha1) + 
     -            tmp1*(tmp2*MCha(Cha1)*MCha(Cha2) - 
     -               tmp3*MCha2(Cha1)))))/SW2
	enddo
	enddo

	do Neu1 = 1, 4
	do Neu2 = 1, 4
	tmp5 = SW*ZNeu(Neu1,1) - CW*ZNeu(Neu1,2)
	tmp6 = SW*ZNeu(Neu2,1) - CW*ZNeu(Neu2,2)
	tmp7 = CB*(-(SW*ZNeu(Neu2,1)) + CW*ZNeu(Neu2,2))
	tmp8 = -(SA*SW*ZNeu(Neu2,1)) + CW*SA*ZNeu(Neu2,2)
	tmp9 = SB*ZNeu(Neu2,3) - CB*ZNeu(Neu2,4)
	tmp10 = CA*ZNeu(Neu2,3) - SA*ZNeu(Neu2,4)
	tmp11 = SW*ZNeuC(Neu1,1) - CW*ZNeuC(Neu1,2)
	tmp12 = SW*ZNeuC(Neu2,1) - CW*ZNeuC(Neu2,2)
	tmp13 = CB*(-(SW*ZNeuC(Neu2,1)) + CW*ZNeuC(Neu2,2))
	tmp14 = -(SA*SW*ZNeuC(Neu2,1)) + CW*SA*ZNeuC(Neu2,2)
	tmp15 = SB*ZNeuC(Neu2,3) - CB*ZNeuC(Neu2,4)
	tmp16 = CA*ZNeuC(Neu2,3) - SA*ZNeuC(Neu2,4)
        dse_HHA0_nmfv = dse_HHA0_nmfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       ((B1(k2,MNeu2(Neu1),MNeu2(Neu2)) + 
     -            k2*DB1(k2,MNeu2(Neu1),MNeu2(Neu2)))*
     -          ((tmp10*tmp5 + CA*tmp6*ZNeu(Neu1,3) + 
     -               tmp8*ZNeu(Neu1,4))*
     -             (tmp11*tmp15 + SB*tmp12*ZNeuC(Neu1,3) + 
     -               tmp13*ZNeuC(Neu1,4)) - 
     -            (tmp5*tmp9 + SB*tmp6*ZNeu(Neu1,3) + 
     -               tmp7*ZNeu(Neu1,4))*
     -             (tmp11*tmp16 + CA*tmp12*ZNeuC(Neu1,3) + 
     -               tmp14*ZNeuC(Neu1,4))) + 
     -         DB0(k2,MNeu2(Neu1),MNeu2(Neu2))*
     -          (-(MNeu(Neu1)*MNeu(Neu2)*
     -               (tmp5*tmp9 + SB*tmp6*ZNeu(Neu1,3) + 
     -                 tmp7*ZNeu(Neu1,4))*
     -               (tmp10*tmp5 + CA*tmp6*ZNeu(Neu1,3) + 
     -                 tmp8*ZNeu(Neu1,4))) + 
     -            MNeu2(Neu1)*
     -             (tmp10*tmp5 + CA*tmp6*ZNeu(Neu1,3) + 
     -               tmp8*ZNeu(Neu1,4))*
     -             (tmp11*tmp15 + SB*tmp12*ZNeuC(Neu1,3) + 
     -               tmp13*ZNeuC(Neu1,4)) - 
     -            MNeu2(Neu1)*
     -             (tmp5*tmp9 + SB*tmp6*ZNeu(Neu1,3) + 
     -               tmp7*ZNeu(Neu1,4))*
     -             (tmp11*tmp16 + CA*tmp12*ZNeuC(Neu1,3) + 
     -               tmp14*ZNeuC(Neu1,4)) + 
     -            MNeu(Neu1)*MNeu(Neu2)*
     -             (tmp11*tmp15 + SB*tmp12*ZNeuC(Neu1,3) + 
     -               tmp13*ZNeuC(Neu1,4))*
     -             (tmp11*tmp16 + CA*tmp12*ZNeuC(Neu1,3) + 
     -               tmp14*ZNeuC(Neu1,4)))))/(CW2*SW2)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_HHA0_nmfv =', dse_HHA0_nmfv
#endif

	end

