* dse_WW.F
* this file is part of FeynHiggs
* generated 06 Mar 2008 09:19

#include "externals.h"


	double complex function dse_WW(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex dse_WW_mfv, dse_WW_nmfv
	external dse_WW_mfv, dse_WW_nmfv

	if( nmfv .eq. 0 ) then
	  dse_WW = dse_WW_mfv(k2)
	else
	  dse_WW = dse_WW_nmfv(k2)
	endif

#ifdef DEBUG
	print *, 'k2 =', k2
	print *, 'dse_WW =', dse_WW
#endif
	end


************************************************************************


	double complex function dse_WW_mfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha1, Gen1, Gen2, Neu1, Sfe1, Sfe2, g

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_WW_mfv = 0

#ifdef DETAILED_DEBUG
	print *, 'dse_WW_mfv =', dse_WW_mfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
	do Gen2 = g, 3
        dse_WW_mfv = dse_WW_mfv - 
     -   3/(4.D0*Pi)*(Alfa*CKM(Gen1,Gen2)*CKMC(Gen1,Gen2)*
     -       (B1(k2,Mf2(3,Gen1),Mf2(4,Gen2)) - 
     -         2*DB00(k2,Mf2(3,Gen1),Mf2(4,Gen2)) + 
     -         k2*DB1(k2,Mf2(3,Gen1),Mf2(4,Gen2)) + 
     -         DB0(k2,Mf2(3,Gen1),Mf2(4,Gen2))*Mf2(3,Gen1)))/SW2
	enddo
	enddo

	do Gen1 = g, 3
	do Gen2 = g, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        dse_WW_mfv = dse_WW_mfv - 
     -   3/(2.D0*Pi)*(Alfa*CKM(Gen1,Gen2)*CKMC(Gen1,Gen2)*
     -       DB00(k2,MSf2(Sfe1,3,Gen1),MSf2(Sfe2,4,Gen2))*
     -       USf(Sfe1,1,3,Gen1)*USf(Sfe2,1,4,Gen2)*
     -       USfC(Sfe1,1,3,Gen1)*USfC(Sfe2,1,4,Gen2))/SW2
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_WW_mfv =', dse_WW_mfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        dse_WW_mfv = dse_WW_mfv - 
     -   1/(4.D0*Pi)*(Alfa*(B1(k2,0.D0,Mf2(2,Gen1)) - 
     -         2*DB00(k2,0.D0,Mf2(2,Gen1)) + 
     -         k2*DB1(k2,0.D0,Mf2(2,Gen1))))/SW2
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        dse_WW_mfv = dse_WW_mfv - 
     -   1/(2.D0*Pi)*(Alfa*DB00(k2,MSf2(1,1,Gen1),MSf2(Sfe1,2,Gen1))*
     -       USf(Sfe1,1,2,Gen1)*USfC(Sfe1,1,2,Gen1))/SW2
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_WW_mfv =', dse_WW_mfv
#endif

	if( mssmpart .eq. 3 ) return

        dse_WW_mfv = dse_WW_mfv + 
     -   1/(4.D0*Pi)*(Alfa*(CW2**2*(-5*k2 - 2*MW2) + MW2*SW2**2)*
     -        DB0(k2,MW2,MZ2) - 
     -       Alfa*CW2*(5*SW2*B0(k2,0.D0,MW2) - 
     -          MW2*SBA**2*DB0(k2,Mh02,MW2) + DB00(k2,MA02,MHp2) + 
     -          SBA**2*(DB00(k2,Mh02,MW2) + DB00(k2,MHH2,MHp2)) + 
     -          CBA**2*(-(MW2*DB0(k2,MHH2,MW2)) + 
     -             DB00(k2,Mh02,MHp2) + DB00(k2,MHH2,MW2)) + 
     -          DB00(k2,MZ2,MW2) + 
     -          SW2*(2*B1(k2,MW2,0.D0) + MW2*DB0(k2,0.D0,MW2) + 
     -             8*DB00(k2,MW2,0.D0) + 
     -             k2*(5*DB0(k2,0.D0,MW2) + 2*DB1(k2,MW2,0.D0))) + 
     -          CW2*(5*B0(k2,MW2,MZ2) + 
     -             2*(B1(k2,MW2,MZ2) + 4*DB00(k2,MW2,MZ2) + 
     -                k2*DB1(k2,MW2,MZ2)))))/(CW2*SW2)

	do Cha1 = 1, 2
	do Neu1 = 1, 4
        tmp1 = (Sqrt(2.D0)*UChaC(Cha1,1)*ZNeu(Neu1,2) + 
     -     UChaC(Cha1,2)*ZNeu(Neu1,3))/Sqrt(2.D0)
        tmp2 = (Sqrt(2.D0)*VChaC(Cha1,1)*ZNeu(Neu1,2) - 
     -     VChaC(Cha1,2)*ZNeu(Neu1,4))/Sqrt(2.D0)
        tmp3 = (Sqrt(2.D0)*UCha(Cha1,1)*ZNeuC(Neu1,2) + 
     -     UCha(Cha1,2)*ZNeuC(Neu1,3))/Sqrt(2.D0)
        tmp4 = (Sqrt(2.D0)*VCha(Cha1,1)*ZNeuC(Neu1,2) - 
     -     VCha(Cha1,2)*ZNeuC(Neu1,4))/Sqrt(2.D0)
        dse_WW_mfv = dse_WW_mfv + 
     -   1/(2.D0*Pi)*(-(Alfa*(tmp1*tmp3 + tmp2*tmp4)*
     -          (B1(k2,MCha2(Cha1),MNeu2(Neu1)) - 
     -            2*DB00(k2,MCha2(Cha1),MNeu2(Neu1)) + 
     -            k2*DB1(k2,MCha2(Cha1),MNeu2(Neu1)))) + 
     -       Alfa*DB0(k2,MCha2(Cha1),MNeu2(Neu1))*
     -        (-(tmp2*tmp4*MCha2(Cha1)) + 
     -          tmp3*tmp4*MCha(Cha1)*MNeu(Neu1) + 
     -          tmp1*(-(tmp3*MCha2(Cha1)) + 
     -             tmp2*MCha(Cha1)*MNeu(Neu1))))/SW2
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_WW_mfv =', dse_WW_mfv
#endif

	end


************************************************************************


	double complex function dse_WW_nmfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All1, All2, Cha1, Gen1, Gen2, Ind1, Ind2, Ind3, Ind4
	integer Neu1, Sfe1, g

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_WW_nmfv = 0

#ifdef DETAILED_DEBUG
	print *, 'dse_WW_nmfv =', dse_WW_nmfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
	do Gen2 = g, 3
        dse_WW_nmfv = dse_WW_nmfv - 
     -   3/(4.D0*Pi)*(Alfa*CKM(Gen1,Gen2)*CKMC(Gen1,Gen2)*
     -       (B1(k2,Mf2(3,Gen1),Mf2(4,Gen2)) - 
     -         2*DB00(k2,Mf2(3,Gen1),Mf2(4,Gen2)) + 
     -         k2*DB1(k2,Mf2(3,Gen1),Mf2(4,Gen2)) + 
     -         DB0(k2,Mf2(3,Gen1),Mf2(4,Gen2))*Mf2(3,Gen1)))/SW2
	enddo
	enddo

	do All1 = g, 6, g
	do All2 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
	do Ind3 = g, 3
	do Ind4 = g, 3
        dse_WW_nmfv = dse_WW_nmfv - 
     -   3/(2.D0*Pi)*(Alfa*CKM(Ind3,Ind1)*CKMC(Ind4,Ind2)*
     -       DB00(k2,MASf2(All1,3),MASf2(All2,4))*
     -       UASf(All1,Ind3,3)*UASf(All2,Ind2,4)*
     -       UASfC(All1,Ind4,3)*UASfC(All2,Ind1,4))/SW2
	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_WW_nmfv =', dse_WW_nmfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        dse_WW_nmfv = dse_WW_nmfv - 
     -   1/(4.D0*Pi)*(Alfa*(B1(k2,0.D0,Mf2(2,Gen1)) - 
     -         2*DB00(k2,0.D0,Mf2(2,Gen1)) + 
     -         k2*DB1(k2,0.D0,Mf2(2,Gen1))))/SW2
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        dse_WW_nmfv = dse_WW_nmfv - 
     -   1/(2.D0*Pi)*(Alfa*DB00(k2,MSf2(1,1,Gen1),MSf2(Sfe1,2,Gen1))*
     -       USf(Sfe1,1,2,Gen1)*USfC(Sfe1,1,2,Gen1))/SW2
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_WW_nmfv =', dse_WW_nmfv
#endif

	if( mssmpart .eq. 3 ) return

        dse_WW_nmfv = dse_WW_nmfv + 
     -   1/(4.D0*Pi)*(Alfa*(CW2**2*(-5*k2 - 2*MW2) + MW2*SW2**2)*
     -        DB0(k2,MW2,MZ2) - 
     -       Alfa*CW2*(5*SW2*B0(k2,0.D0,MW2) - 
     -          MW2*SBA**2*DB0(k2,Mh02,MW2) + DB00(k2,MA02,MHp2) + 
     -          SBA**2*(DB00(k2,Mh02,MW2) + DB00(k2,MHH2,MHp2)) + 
     -          CBA**2*(-(MW2*DB0(k2,MHH2,MW2)) + 
     -             DB00(k2,Mh02,MHp2) + DB00(k2,MHH2,MW2)) + 
     -          DB00(k2,MZ2,MW2) + 
     -          SW2*(2*B1(k2,MW2,0.D0) + MW2*DB0(k2,0.D0,MW2) + 
     -             8*DB00(k2,MW2,0.D0) + 
     -             k2*(5*DB0(k2,0.D0,MW2) + 2*DB1(k2,MW2,0.D0))) + 
     -          CW2*(5*B0(k2,MW2,MZ2) + 
     -             2*(B1(k2,MW2,MZ2) + 4*DB00(k2,MW2,MZ2) + 
     -                k2*DB1(k2,MW2,MZ2)))))/(CW2*SW2)

	do Cha1 = 1, 2
	do Neu1 = 1, 4
        tmp1 = (Sqrt(2.D0)*UChaC(Cha1,1)*ZNeu(Neu1,2) + 
     -     UChaC(Cha1,2)*ZNeu(Neu1,3))/Sqrt(2.D0)
        tmp2 = (Sqrt(2.D0)*VChaC(Cha1,1)*ZNeu(Neu1,2) - 
     -     VChaC(Cha1,2)*ZNeu(Neu1,4))/Sqrt(2.D0)
        tmp3 = (Sqrt(2.D0)*UCha(Cha1,1)*ZNeuC(Neu1,2) + 
     -     UCha(Cha1,2)*ZNeuC(Neu1,3))/Sqrt(2.D0)
        tmp4 = (Sqrt(2.D0)*VCha(Cha1,1)*ZNeuC(Neu1,2) - 
     -     VCha(Cha1,2)*ZNeuC(Neu1,4))/Sqrt(2.D0)
        dse_WW_nmfv = dse_WW_nmfv + 
     -   1/(2.D0*Pi)*(-(Alfa*(tmp1*tmp3 + tmp2*tmp4)*
     -          (B1(k2,MCha2(Cha1),MNeu2(Neu1)) - 
     -            2*DB00(k2,MCha2(Cha1),MNeu2(Neu1)) + 
     -            k2*DB1(k2,MCha2(Cha1),MNeu2(Neu1)))) + 
     -       Alfa*DB0(k2,MCha2(Cha1),MNeu2(Neu1))*
     -        (-(tmp2*tmp4*MCha2(Cha1)) + 
     -          tmp3*tmp4*MCha(Cha1)*MNeu(Neu1) + 
     -          tmp1*(-(tmp3*MCha2(Cha1)) + 
     -             tmp2*MCha(Cha1)*MNeu(Neu1))))/SW2
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_WW_nmfv =', dse_WW_nmfv
#endif

	end

