* se_HmGp.F
* this file is part of FeynHiggs
* generated 06 Mar 2008 09:19

#include "externals.h"


	double complex function se_HmGp(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex se_HmGp_mfv, se_HmGp_nmfv
	external se_HmGp_mfv, se_HmGp_nmfv

	if( nmfv .eq. 0 ) then
	  se_HmGp = se_HmGp_mfv(k2)
	else
	  se_HmGp = se_HmGp_nmfv(k2)
	endif

#ifdef DEBUG
	print *, 'k2 =', k2
	print *, 'se_HmGp =', se_HmGp
#endif
	end


************************************************************************


	double complex function se_HmGp_mfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha1, Gen1, Gen2, Ind1, Neu1, Sfe1, Sfe2, g

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	se_HmGp_mfv = 0

#ifdef DETAILED_DEBUG
	print *, 'se_HmGp_mfv =', se_HmGp_mfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
	do Gen2 = g, 3
        se_HmGp_mfv = se_HmGp_mfv + 
     -   3/(4.D0*Pi)*(Alfa*CKM(Gen1,Gen2)*CKMC(Gen1,Gen2)*
     -       ((A0(Mf2(4,Gen2)) + 
     -            k2*B1(k2,Mf2(3,Gen1),Mf2(4,Gen2)))*
     -          (TB2*Mdy(Gen2,1)*Mf(4,Gen2) - Mf2(3,Gen1)) + 
     -         B0(k2,Mf2(3,Gen1),Mf2(4,Gen2))*Mf2(3,Gen1)*
     -          (-Mf2(3,Gen1) + Mf2(4,Gen2))))/(MW2*SW2*TB)
	enddo
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
        se_HmGp_mfv = se_HmGp_mfv + 
     -   1/(16.D0*Pi)*(Alfa*(A0(MSf2(Sfe1,3,Gen1))*
     -          ((1 + 2*CW2)*MW2*S2B*TB*USf(Sfe1,1,3,Gen1)*
     -             USfC(Sfe1,1,3,Gen1) + 
     -            2*(-2*MW2*S2B*SW2*TB + 3*CW2*Mf2(3,Gen1))*
     -             USf(Sfe1,2,3,Gen1)*USfC(Sfe1,2,3,Gen1)) + 
     -         TB*A0(MSf2(Sfe1,4,Gen1))*
     -          ((1 - 4*CW2)*MW2*S2B*USf(Sfe1,1,4,Gen1)*
     -             USfC(Sfe1,1,4,Gen1) + 
     -            2*(MW2*S2B*SW2 - 3*CW2*TB*Mdy2(Gen1,1))*
     -             USf(Sfe1,2,4,Gen1)*USfC(Sfe1,2,4,Gen1))))/
     -     (CW2*MW2*SW2*TB)
	enddo
	enddo

	do Gen1 = g, 3
	do Ind1 = g, 3
	do Sfe1 = 1, 2
        se_HmGp_mfv = se_HmGp_mfv + 
     -   3/(8.D0*Pi)*(Alfa*(-(TB2*A0(MSf2(Sfe1,3,Gen1))*
     -            CKM(Gen1,Ind1)*CKMC(Gen1,Ind1)*Mdy2(Ind1,1)*
     -            USf(Sfe1,1,3,Gen1)*USfC(Sfe1,1,3,Gen1)) + 
     -         A0(MSf2(Sfe1,4,Gen1))*CKM(Ind1,Gen1)*
     -          CKMC(Ind1,Gen1)*Mf2(3,Ind1)*USf(Sfe1,1,4,Gen1)*
     -          USfC(Sfe1,1,4,Gen1)))/(MW2*SW2*TB)
	enddo
	enddo
	enddo

	do Gen1 = g, 3
	do Gen2 = g, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        se_HmGp_mfv = se_HmGp_mfv - 
     -   3/(8.D0*Pi)*(Alfa*B0(k2,MSf2(Sfe1,3,Gen1),
     -        MSf2(Sfe2,4,Gen2))*CKM(Gen1,Gen2)*CKMC(Gen1,Gen2)*
     -       ((-((-(MW2*S2B*TB) + TB2*Mdy2(Gen2,1) + Mf2(3,Gen1))*
     -               USf(Sfe2,1,4,Gen2)) - 
     -            TB*(MUEC + TB*Af(4,Gen2,Gen2))*Mdy(Gen2,1)*
     -             USf(Sfe2,2,4,Gen2))*USfC(Sfe1,1,3,Gen1) - 
     -         Mf(3,Gen1)*(MUE*TB*USf(Sfe2,1,4,Gen2) + 
     -            AfC(3,Gen1,Gen1)*USf(Sfe2,1,4,Gen2) + 
     -            Mdy(Gen2,1)*USf(Sfe2,2,4,Gen2) + 
     -            TB2*Mdy(Gen2,1)*USf(Sfe2,2,4,Gen2))*
     -          USfC(Sfe1,2,3,Gen1))*
     -       ((-MUEC + TB*Af(3,Gen1,Gen1))*Mf(3,Gen1)*
     -          USf(Sfe1,2,3,Gen1)*USfC(Sfe2,1,4,Gen2) + 
     -         USf(Sfe1,1,3,Gen1)*
     -          (TB*(C2B*MW2 - Mdy2(Gen2,1) + Mf2(3,Gen1))*
     -             USfC(Sfe2,1,4,Gen2) + 
     -            (MUE*TB2 - TB*AfC(4,Gen2,Gen2))*Mdy(Gen2,1)*
     -             USfC(Sfe2,2,4,Gen2))))/(MW2*SW2*TB2)
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_HmGp_mfv =', se_HmGp_mfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        se_HmGp_mfv = se_HmGp_mfv + 
     -   1/(8.D0*Pi)*(2*Alfa*TB*
     -        (A0(Mf2(2,Gen1)) + k2*B1(k2,0.D0,Mf2(2,Gen1)))*
     -        Mf2(2,Gen1) + 
     -       (Alfa*MW2*A0(MSf2(1,1,Gen1))*
     -          (-(1/2.D0*S2B) + 
     -            (CW2*(MW2*S2B - TB*Mf2(2,Gen1)))/MW2))/CW2)/
     -     (MW2*SW2)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        se_HmGp_mfv = se_HmGp_mfv - 
     -   1/(8.D0*Pi)*(Alfa*(B0(k2,MSf2(1,1,Gen1),MSf2(Sfe1,2,Gen1))*
     -          ((MW2*S2B - TB*Mf2(2,Gen1))*USf(Sfe1,1,2,Gen1) - 
     -            (MUEC + TB*Af(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USf(Sfe1,2,2,Gen1))*
     -          ((C2B*MW2 - Mf2(2,Gen1))*USfC(Sfe1,1,2,Gen1) + 
     -            (MUE*TB - AfC(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,2,2,Gen1)) + 
     -         MW2*A0(MSf2(Sfe1,2,Gen1))*
     -          (1/2.D0*(S2B*USf(Sfe1,1,2,Gen1)*USfC(Sfe1,1,2,Gen1))/
     -              CW2 + ((-(S2B*SW2) + (CW2*TB*Mf2(2,Gen1))/MW2)*
     -               USf(Sfe1,2,2,Gen1)*USfC(Sfe1,2,2,Gen1))/CW2)))
     -      /(MW2*SW2)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_HmGp_mfv =', se_HmGp_mfv
#endif

	if( mssmpart .eq. 3 ) return

        se_HmGp_mfv = se_HmGp_mfv + 
     -   1/(32.D0*Pi)*(Alfa*(2*
     -          (-(MW2*(CBA*CW2 - S2B*SAB)*(C2B*SAB + 2*CW2*SBA)*
     -               B0(k2,Mh02,MHp2)) + 
     -            (C2B*(CBA*CW2*MW2*SAB - MW2*S2B*SAB**2) + 
     -               CBA*CW2**2*(-4*k2*SBA - MW2*SBA))*
     -             B0(k2,Mh02,MW2) + 
     -            (C2B*CAB - 2*CBA*CW2)*MW2*(CAB*S2B - CW2*SBA)*
     -             B0(k2,MHH2,MHp2) + 
     -            (CBA*CW2**2*(4*k2*SBA + MW2*SBA) + 
     -               C2B*CAB*(-(CAB*MW2*S2B) + CW2*MW2*SBA))*
     -             B0(k2,MHH2,MW2)) + 
     -         CW2*((C2B*CW2*S2A - 2*CBA*CW2*SBA + C2A*S2B*SW2)*
     -             (A0(Mh02) - A0(MHH2)) + 
     -            C2B*S2B*(A0(MA02) + 4*A0(MHp2) - 4*A0(MW2) - 
     -               A0(MZ2)) + 
     -            8*CBA*CW2*k2*SBA*
     -             (-B1(k2,MW2,Mh02) + B1(k2,MW2,MHH2)))))/
     -     (CW2**2*SW2)

	do Cha1 = 1, 2
	do Neu1 = 1, 4
	tmp1 = (SW*ZNeu(Neu1,1) + CW*ZNeu(Neu1,2))/CW
	tmp2 = (SW*ZNeuC(Neu1,1) + CW*ZNeuC(Neu1,2))/CW
        tmp3 = (-((tmp1*UCha(Cha1,2))/Sqrt(2.D0)) + 
     -      UCha(Cha1,1)*ZNeu(Neu1,3))*
     -    (-((tmp2*UChaC(Cha1,2))/Sqrt(2.D0)) + 
     -      UChaC(Cha1,1)*ZNeuC(Neu1,3)) - 
     -   ((tmp1*VCha(Cha1,2))/Sqrt(2.D0) + 
     -      VCha(Cha1,1)*ZNeu(Neu1,4))*
     -    ((tmp2*VChaC(Cha1,2))/Sqrt(2.D0) + 
     -      VChaC(Cha1,1)*ZNeuC(Neu1,4))
        se_HmGp_mfv = se_HmGp_mfv + 
     -   1/(2.D0*Pi)*(Alfa*CB*SB*tmp3*
     -        (A0(MNeu2(Neu1)) + k2*B1(k2,MCha2(Cha1),MNeu2(Neu1)))
     -         + Alfa*B0(k2,MCha2(Cha1),MNeu2(Neu1))*
     -        (1/4.D0*(SB2*MCha(Cha1)*MNeu(Neu1)*
     -             (tmp1*Sqrt(2.D0)*UCha(Cha1,2) - 
     -               2*UCha(Cha1,1)*ZNeu(Neu1,3))*
     -             (tmp1*Sqrt(2.D0)*VCha(Cha1,2) + 
     -               2*VCha(Cha1,1)*ZNeu(Neu1,4))) + 
     -          CB*SB*tmp3*MCha2(Cha1) + 
     -          CB2*MCha(Cha1)*MNeu(Neu1)*
     -           (-((tmp2*UChaC(Cha1,2))/Sqrt(2.D0)) + 
     -             UChaC(Cha1,1)*ZNeuC(Neu1,3))*
     -           ((tmp2*VChaC(Cha1,2))/Sqrt(2.D0) + 
     -             VChaC(Cha1,1)*ZNeuC(Neu1,4))))/SW2
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_HmGp_mfv =', se_HmGp_mfv
#endif

	end


************************************************************************


	double complex function se_HmGp_nmfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All1, All2, Cha1, Gen1, Gen2, Ind1, Ind2, Ind3, Ind4
	integer Neu1, Sfe1, g

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	se_HmGp_nmfv = 0

#ifdef DETAILED_DEBUG
	print *, 'se_HmGp_nmfv =', se_HmGp_nmfv
#endif

	if( mssmpart .eq. 1 ) return


	do All1 = g, 6, g
	do Ind1 = g, 3
        se_HmGp_nmfv = se_HmGp_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*(A0(MASf2(All1,3))*
     -          ((1 + 2*CW2)*MW2*S2B*TB*UASf(All1,Ind1,3)*
     -             UASfC(All1,Ind1,3) + 
     -            2*(-2*MW2*S2B*SW2*TB + 3*CW2*Mf2(3,Ind1))*
     -             UASf(All1,3 + Ind1,3)*UASfC(All1,3 + Ind1,3)) + 
     -         TB*A0(MASf2(All1,4))*
     -          ((1 - 4*CW2)*MW2*S2B*UASf(All1,Ind1,4)*
     -             UASfC(All1,Ind1,4) + 
     -            2*(MW2*S2B*SW2 - 3*CW2*TB*Mdy2(Ind1,1))*
     -             UASf(All1,3 + Ind1,4)*UASfC(All1,3 + Ind1,4))))/
     -     (CW2*MW2*SW2*TB)
	enddo
	enddo

	do Gen1 = g, 3
	do Gen2 = g, 3
        se_HmGp_nmfv = se_HmGp_nmfv + 
     -   3/(4.D0*Pi)*(Alfa*CKM(Gen1,Gen2)*CKMC(Gen1,Gen2)*
     -       ((A0(Mf2(4,Gen2)) + 
     -            k2*B1(k2,Mf2(3,Gen1),Mf2(4,Gen2)))*
     -          (TB2*Mdy(Gen2,1)*Mf(4,Gen2) - Mf2(3,Gen1)) + 
     -         B0(k2,Mf2(3,Gen1),Mf2(4,Gen2))*Mf2(3,Gen1)*
     -          (-Mf2(3,Gen1) + Mf2(4,Gen2))))/(MW2*SW2*TB)
	enddo
	enddo

	do All1 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
	do Ind3 = g, 3
        se_HmGp_nmfv = se_HmGp_nmfv + 
     -   3/(8.D0*Pi)*(Alfa*(-(TB2*A0(MASf2(All1,3))*CKM(Ind1,Ind3)*
     -            CKMC(Ind2,Ind3)*Mdy2(Ind3,1)*UASf(All1,Ind1,3)*
     -            UASfC(All1,Ind2,3)) + 
     -         A0(MASf2(All1,4))*CKM(Ind3,Ind2)*CKMC(Ind3,Ind1)*
     -          Mf2(3,Ind3)*UASf(All1,Ind1,4)*UASfC(All1,Ind2,4)))/
     -     (MW2*SW2*TB)
	enddo
	enddo
	enddo
	enddo

	do All1 = g, 6, g
	do All2 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
	do Ind3 = g, 3
	do Ind4 = g, 3
        se_HmGp_nmfv = se_HmGp_nmfv - 
     -   3/(8.D0*Pi)*(Alfa*B0(k2,MASf2(All1,3),MASf2(All2,4))*
     -       CKM(Ind2,Ind1)*CKMC(Ind4,Ind3)*
     -       (((MW2*S2B*TB - TB2*Mdy2(Ind3,1) - Mf2(3,Ind4))*
     -             UASf(All2,Ind3,4) - 
     -            (MUEC*TB*Mdy(Ind3,1) + 
     -               TB2*Af(4,Ind4,Ind3)*Mdy(Ind4,1))*
     -             UASf(All2,3 + Ind3,4))*UASfC(All1,Ind4,3) - 
     -         Mf(3,Ind4)*(MUE*TB*UASf(All2,Ind3,4) + 
     -            AfC(3,Ind4,Ind4)*UASf(All2,Ind3,4) + 
     -            Mdy(Ind3,1)*UASf(All2,3 + Ind3,4) + 
     -            TB2*Mdy(Ind3,1)*UASf(All2,3 + Ind3,4))*
     -          UASfC(All1,3 + Ind4,3))*
     -       ((TB*Af(3,Ind1,Ind2)*Mf(3,Ind1) - MUEC*Mf(3,Ind2))*
     -          UASf(All1,3 + Ind2,3)*UASfC(All2,Ind1,4) + 
     -         UASf(All1,Ind2,3)*
     -          (TB*(C2B*MW2 - Mdy2(Ind1,1) + Mf2(3,Ind2))*
     -             UASfC(All2,Ind1,4) + 
     -            (MUE*TB2 - TB*AfC(4,Ind1,Ind1))*Mdy(Ind1,1)*
     -             UASfC(All2,3 + Ind1,4))))/(MW2*SW2*TB2)
	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_HmGp_nmfv =', se_HmGp_nmfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        se_HmGp_nmfv = se_HmGp_nmfv + 
     -   1/(8.D0*Pi)*(2*Alfa*TB*
     -        (A0(Mf2(2,Gen1)) + k2*B1(k2,0.D0,Mf2(2,Gen1)))*
     -        Mf2(2,Gen1) + 
     -       (Alfa*MW2*A0(MSf2(1,1,Gen1))*
     -          (-(1/2.D0*S2B) + 
     -            (CW2*(MW2*S2B - TB*Mf2(2,Gen1)))/MW2))/CW2)/
     -     (MW2*SW2)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        se_HmGp_nmfv = se_HmGp_nmfv - 
     -   1/(8.D0*Pi)*(Alfa*(B0(k2,MSf2(1,1,Gen1),MSf2(Sfe1,2,Gen1))*
     -          ((MW2*S2B - TB*Mf2(2,Gen1))*USf(Sfe1,1,2,Gen1) - 
     -            (MUEC + TB*Af(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USf(Sfe1,2,2,Gen1))*
     -          ((C2B*MW2 - Mf2(2,Gen1))*USfC(Sfe1,1,2,Gen1) + 
     -            (MUE*TB - AfC(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,2,2,Gen1)) + 
     -         MW2*A0(MSf2(Sfe1,2,Gen1))*
     -          (1/2.D0*(S2B*USf(Sfe1,1,2,Gen1)*USfC(Sfe1,1,2,Gen1))/
     -              CW2 + ((-(S2B*SW2) + (CW2*TB*Mf2(2,Gen1))/MW2)*
     -               USf(Sfe1,2,2,Gen1)*USfC(Sfe1,2,2,Gen1))/CW2)))
     -      /(MW2*SW2)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_HmGp_nmfv =', se_HmGp_nmfv
#endif

	if( mssmpart .eq. 3 ) return

        se_HmGp_nmfv = se_HmGp_nmfv + 
     -   1/(32.D0*Pi)*(Alfa*(2*
     -          (-(MW2*(CBA*CW2 - S2B*SAB)*(C2B*SAB + 2*CW2*SBA)*
     -               B0(k2,Mh02,MHp2)) + 
     -            (C2B*(CBA*CW2*MW2*SAB - MW2*S2B*SAB**2) + 
     -               CBA*CW2**2*(-4*k2*SBA - MW2*SBA))*
     -             B0(k2,Mh02,MW2) + 
     -            (C2B*CAB - 2*CBA*CW2)*MW2*(CAB*S2B - CW2*SBA)*
     -             B0(k2,MHH2,MHp2) + 
     -            (CBA*CW2**2*(4*k2*SBA + MW2*SBA) + 
     -               C2B*CAB*(-(CAB*MW2*S2B) + CW2*MW2*SBA))*
     -             B0(k2,MHH2,MW2)) + 
     -         CW2*((C2B*CW2*S2A - 2*CBA*CW2*SBA + C2A*S2B*SW2)*
     -             (A0(Mh02) - A0(MHH2)) + 
     -            C2B*S2B*(A0(MA02) + 4*A0(MHp2) - 4*A0(MW2) - 
     -               A0(MZ2)) + 
     -            8*CBA*CW2*k2*SBA*
     -             (-B1(k2,MW2,Mh02) + B1(k2,MW2,MHH2)))))/
     -     (CW2**2*SW2)

	do Cha1 = 1, 2
	do Neu1 = 1, 4
	tmp1 = (SW*ZNeu(Neu1,1) + CW*ZNeu(Neu1,2))/CW
	tmp2 = (SW*ZNeuC(Neu1,1) + CW*ZNeuC(Neu1,2))/CW
        tmp3 = (-((tmp1*UCha(Cha1,2))/Sqrt(2.D0)) + 
     -      UCha(Cha1,1)*ZNeu(Neu1,3))*
     -    (-((tmp2*UChaC(Cha1,2))/Sqrt(2.D0)) + 
     -      UChaC(Cha1,1)*ZNeuC(Neu1,3)) - 
     -   ((tmp1*VCha(Cha1,2))/Sqrt(2.D0) + 
     -      VCha(Cha1,1)*ZNeu(Neu1,4))*
     -    ((tmp2*VChaC(Cha1,2))/Sqrt(2.D0) + 
     -      VChaC(Cha1,1)*ZNeuC(Neu1,4))
        se_HmGp_nmfv = se_HmGp_nmfv + 
     -   1/(2.D0*Pi)*(Alfa*CB*SB*tmp3*
     -        (A0(MNeu2(Neu1)) + k2*B1(k2,MCha2(Cha1),MNeu2(Neu1)))
     -         + Alfa*B0(k2,MCha2(Cha1),MNeu2(Neu1))*
     -        (1/4.D0*(SB2*MCha(Cha1)*MNeu(Neu1)*
     -             (tmp1*Sqrt(2.D0)*UCha(Cha1,2) - 
     -               2*UCha(Cha1,1)*ZNeu(Neu1,3))*
     -             (tmp1*Sqrt(2.D0)*VCha(Cha1,2) + 
     -               2*VCha(Cha1,1)*ZNeu(Neu1,4))) + 
     -          CB*SB*tmp3*MCha2(Cha1) + 
     -          CB2*MCha(Cha1)*MNeu(Neu1)*
     -           (-((tmp2*UChaC(Cha1,2))/Sqrt(2.D0)) + 
     -             UChaC(Cha1,1)*ZNeuC(Neu1,3))*
     -           ((tmp2*VChaC(Cha1,2))/Sqrt(2.D0) + 
     -             VChaC(Cha1,1)*ZNeuC(Neu1,4))))/SW2
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_HmGp_nmfv =', se_HmGp_nmfv
#endif

	end

