* se_HmHp.F
* this file is part of FeynHiggs
* generated 06 Mar 2008 09:19

#include "externals.h"


	double complex function se_HmHp(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex se_HmHp_mfv, se_HmHp_nmfv
	external se_HmHp_mfv, se_HmHp_nmfv

	if( nmfv .eq. 0 ) then
	  se_HmHp = se_HmHp_mfv(k2)
	else
	  se_HmHp = se_HmHp_nmfv(k2)
	endif

#ifdef DEBUG
	print *, 'k2 =', k2
	print *, 'se_HmHp =', se_HmHp
#endif
	end


************************************************************************


	double complex function se_HmHp_mfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha1, Gen1, Gen2, Ind1, Neu1, Sfe1, Sfe2, g

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	se_HmHp_mfv = 0

#ifdef DETAILED_DEBUG
	print *, 'se_HmHp_mfv =', se_HmHp_mfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
	do Gen2 = g, 3
        se_HmHp_mfv = se_HmHp_mfv + 
     -   3/(4.D0*Pi)*(Alfa*CKM(Gen1,Gen2)*CKMC(Gen1,Gen2)*
     -       (-((A0(Mf2(4,Gen2)) + 
     -              k2*B1(k2,Mf2(3,Gen1),Mf2(4,Gen2)))*
     -            (TB2**2*Mdy2(Gen2,1) + Mf2(3,Gen1))) - 
     -         B0(k2,Mf2(3,Gen1),Mf2(4,Gen2))*Mf2(3,Gen1)*
     -          (TB2*(TB2*Mdy2(Gen2,1) + 
     -               2*Mdy(Gen2,1)*Mf(4,Gen2)) + Mf2(3,Gen1))))/
     -     (MW2*SW2*TB2)
	enddo
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
        se_HmHp_mfv = se_HmHp_mfv + 
     -   1/(16.D0*Pi)*(Alfa*(A0(MSf2(Sfe1,3,Gen1))*
     -          (C2B*(1 + 2*CW2)*MW2*TB2*USf(Sfe1,1,3,Gen1)*
     -             USfC(Sfe1,1,3,Gen1) + 
     -            2*(-2*C2B*MW2*SW2*TB2 + 3*CW2*Mf2(3,Gen1))*
     -             USf(Sfe1,2,3,Gen1)*USfC(Sfe1,2,3,Gen1)) + 
     -         TB2*A0(MSf2(Sfe1,4,Gen1))*
     -          (C2B*(1 - 4*CW2)*MW2*USf(Sfe1,1,4,Gen1)*
     -             USfC(Sfe1,1,4,Gen1) + 
     -            2*(C2B*MW2*SW2 + 3*CW2*TB2*Mdy2(Gen1,1))*
     -             USf(Sfe1,2,4,Gen1)*USfC(Sfe1,2,4,Gen1))))/
     -     (CW2*MW2*SW2*TB2)
	enddo
	enddo

	do Gen1 = g, 3
	do Ind1 = g, 3
	do Sfe1 = 1, 2
        se_HmHp_mfv = se_HmHp_mfv + 
     -   3/(8.D0*Pi)*(Alfa*(TB2**2*A0(MSf2(Sfe1,3,Gen1))*
     -          CKM(Gen1,Ind1)*CKMC(Gen1,Ind1)*Mdy2(Ind1,1)*
     -          USf(Sfe1,1,3,Gen1)*USfC(Sfe1,1,3,Gen1) + 
     -         A0(MSf2(Sfe1,4,Gen1))*CKM(Ind1,Gen1)*
     -          CKMC(Ind1,Gen1)*Mf2(3,Ind1)*USf(Sfe1,1,4,Gen1)*
     -          USfC(Sfe1,1,4,Gen1)))/(MW2*SW2*TB2)
	enddo
	enddo
	enddo

	do Gen1 = g, 3
	do Gen2 = g, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
	tmp1 = -(MW2*S2B*TB) + TB2*Mdy2(Gen2,1) + Mf2(3,Gen1)
        se_HmHp_mfv = se_HmHp_mfv + 
     -   3/(8.D0*Pi)*(Alfa*B0(k2,MSf2(Sfe1,3,Gen1),
     -        MSf2(Sfe2,4,Gen2))*CKM(Gen1,Gen2)*CKMC(Gen1,Gen2)*
     -       (Mdy(Gen2,1)*USf(Sfe2,2,4,Gen2)*
     -          ((MUEC*TB + TB2*Af(4,Gen2,Gen2))*
     -             USfC(Sfe1,1,3,Gen1) + 
     -            (1 + TB2)*Mf(3,Gen1)*USfC(Sfe1,2,3,Gen1)) + 
     -         USf(Sfe2,1,4,Gen2)*
     -          (tmp1*USfC(Sfe1,1,3,Gen1) + 
     -            MUE*TB*Mf(3,Gen1)*USfC(Sfe1,2,3,Gen1) + 
     -            AfC(3,Gen1,Gen1)*Mf(3,Gen1)*USfC(Sfe1,2,3,Gen1)))
     -        *(Mf(3,Gen1)*USf(Sfe1,2,3,Gen1)*
     -          (MUEC*TB*USfC(Sfe2,1,4,Gen2) + 
     -            Af(3,Gen1,Gen1)*USfC(Sfe2,1,4,Gen2) + 
     -            Mdy(Gen2,1)*USfC(Sfe2,2,4,Gen2) + 
     -            TB2*Mdy(Gen2,1)*USfC(Sfe2,2,4,Gen2)) + 
     -         USf(Sfe1,1,3,Gen1)*
     -          (tmp1*USfC(Sfe2,1,4,Gen2) + 
     -            (MUE*TB + TB2*AfC(4,Gen2,Gen2))*Mdy(Gen2,1)*
     -             USfC(Sfe2,2,4,Gen2))))/(MW2*SW2*TB2)
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_HmHp_mfv =', se_HmHp_mfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        se_HmHp_mfv = se_HmHp_mfv + 
     -   1/(8.D0*Pi)*(-2*Alfa*TB2*
     -        (A0(Mf2(2,Gen1)) + k2*B1(k2,0.D0,Mf2(2,Gen1)))*
     -        Mf2(2,Gen1) + 
     -       Alfa*MW2*A0(MSf2(1,1,Gen1))*
     -        ((C2B*(-1/2.D0 + CW2))/CW2 + (TB2*Mf2(2,Gen1))/MW2))/
     -     (MW2*SW2)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        se_HmHp_mfv = se_HmHp_mfv + 
     -   1/(16.D0*Pi)*(Alfa*(2*CW2*
     -          B0(k2,MSf2(1,1,Gen1),MSf2(Sfe1,2,Gen1))*
     -          ((MW2*S2B - TB*Mf2(2,Gen1))*USf(Sfe1,1,2,Gen1) - 
     -            (MUEC + TB*Af(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USf(Sfe1,2,2,Gen1))*
     -          ((MW2*S2B - TB*Mf2(2,Gen1))*USfC(Sfe1,1,2,Gen1) - 
     -            (MUE + TB*AfC(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,2,2,Gen1)) + 
     -         A0(MSf2(Sfe1,2,Gen1))*
     -          (-(C2B*MW2*USf(Sfe1,1,2,Gen1)*
     -               USfC(Sfe1,1,2,Gen1)) + 
     -            2*(C2B*MW2*SW2 + CW2*TB2*Mf2(2,Gen1))*
     -             USf(Sfe1,2,2,Gen1)*USfC(Sfe1,2,2,Gen1))))/
     -     (CW2*MW2*SW2)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_HmHp_mfv =', se_HmHp_mfv
#endif

	if( mssmpart .eq. 3 ) return

        se_HmHp_mfv = se_HmHp_mfv + 
     -   1/(32.D0*Pi)*(Alfa*(2*
     -          (MW2*(C2B*SAB + 2*CW2*SBA)**2*B0(k2,Mh02,MHp2) + 
     -            (MW2*S2B**2*SAB**2 + 
     -               CBA*(CBA*CW2**2*(-k2 - Mh02 + MW2) - 
     -                  2*CW2*MW2*S2B*SAB))*B0(k2,Mh02,MW2) + 
     -            (C2B*CAB - 2*CBA*CW2)**2*MW2*B0(k2,MHH2,MHp2) + 
     -            (CAB*(CAB*MW2*S2B**2 - 2*CW2*MW2*S2B*SBA) + 
     -               CW2**2*
     -                (-(k2*SBA**2) - MHH2*SBA**2 + MW2*SBA**2))*
     -             B0(k2,MHH2,MW2)) + 
     -         CW2*((CW2*(1 - S2A*S2B) + C2A*C2B*SW2)*A0(Mh02) + 
     -            (CW2*(1 + S2A*S2B) - C2A*C2B*SW2)*A0(MHH2) + 
     -            C2B**2*(A0(MA02) + 4*A0(MHp2)) + 
     -            2*(-C2B**2 + 6*CW2 + S2B**2)*A0(MW2) + 
     -            (CW2*(1 + 6*CW2 + S2B**2 - 12*SW2) - 
     -               C2B**2*SW2 + 6*SW2**2)*A0(MZ2) - 
     -            8*CW2*(k2 + MHp2)*SW2*B0(k2,0.D0,MHp2) - 
     -            2*CW2*(k2 + MA02 - MW2)*B0(k2,MA02,MW2) - 
     -            2*(k2 + MHp2)*(CW2 - SW2)**2*B0(k2,MHp2,MZ2) + 
     -            4*CW2*k2*B1(k2,MA02,MW2) + 
     -            4*CBA**2*CW2*k2*B1(k2,Mh02,MW2) + 
     -            4*CW2*k2*SBA**2*B1(k2,MHH2,MW2) + 
     -            16*CW2*k2*SW2*B1(k2,MHp2,0.D0) + 
     -            4*k2*(CW2 - SW2)**2*B1(k2,MHp2,MZ2))))/
     -     (CW2**2*SW2)

	do Cha1 = 1, 2
	do Neu1 = 1, 4
	tmp2 = (SW*ZNeu(Neu1,1) + CW*ZNeu(Neu1,2))/CW
	tmp3 = (SW*ZNeuC(Neu1,1) + CW*ZNeuC(Neu1,2))/CW
        se_HmHp_mfv = se_HmHp_mfv + 
     -   1/(2.D0*Pi)*(Alfa*(A0(MNeu2(Neu1)) + 
     -          k2*B1(k2,MCha2(Cha1),MNeu2(Neu1)))*
     -        (-(1/4.D0*(SB2*
     -               (tmp2*Sqrt(2.D0)*UCha(Cha1,2) - 
     -                 2*UCha(Cha1,1)*ZNeu(Neu1,3))*
     -               (tmp3*Sqrt(2.D0)*UChaC(Cha1,2) - 
     -                 2*UChaC(Cha1,1)*ZNeuC(Neu1,3)))) - 
     -          CB2*((tmp2*VCha(Cha1,2))/Sqrt(2.D0) + 
     -             VCha(Cha1,1)*ZNeu(Neu1,4))*
     -           ((tmp3*VChaC(Cha1,2))/Sqrt(2.D0) + 
     -             VChaC(Cha1,1)*ZNeuC(Neu1,4))) + 
     -       Alfa*B0(k2,MCha2(Cha1),MNeu2(Neu1))*
     -        (-(1/4.D0*(SB2*MCha2(Cha1)*
     -               (tmp2*Sqrt(2.D0)*UCha(Cha1,2) - 
     -                 2*UCha(Cha1,1)*ZNeu(Neu1,3))*
     -               (tmp3*Sqrt(2.D0)*UChaC(Cha1,2) - 
     -                 2*UChaC(Cha1,1)*ZNeuC(Neu1,3)))) - 
     -          CB2*MCha2(Cha1)*
     -           ((tmp2*VCha(Cha1,2))/Sqrt(2.D0) + 
     -             VCha(Cha1,1)*ZNeu(Neu1,4))*
     -           ((tmp3*VChaC(Cha1,2))/Sqrt(2.D0) + 
     -             VChaC(Cha1,1)*ZNeuC(Neu1,4)) - 
     -          CB*SB*MCha(Cha1)*MNeu(Neu1)*
     -           ((-((tmp2*UCha(Cha1,2))/Sqrt(2.D0)) + 
     -                UCha(Cha1,1)*ZNeu(Neu1,3))*
     -              ((tmp2*VCha(Cha1,2))/Sqrt(2.D0) + 
     -                VCha(Cha1,1)*ZNeu(Neu1,4)) + 
     -             (-((tmp3*UChaC(Cha1,2))/Sqrt(2.D0)) + 
     -                UChaC(Cha1,1)*ZNeuC(Neu1,3))*
     -              ((tmp3*VChaC(Cha1,2))/Sqrt(2.D0) + 
     -                VChaC(Cha1,1)*ZNeuC(Neu1,4)))))/SW2
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_HmHp_mfv =', se_HmHp_mfv
#endif

	end


************************************************************************


	double complex function se_HmHp_nmfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All1, All2, Cha1, Gen1, Gen2, Ind1, Ind2, Ind3, Ind4
	integer Neu1, Sfe1, g

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	se_HmHp_nmfv = 0

#ifdef DETAILED_DEBUG
	print *, 'se_HmHp_nmfv =', se_HmHp_nmfv
#endif

	if( mssmpart .eq. 1 ) return


	do All1 = g, 6, g
	do Ind1 = g, 3
        se_HmHp_nmfv = se_HmHp_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*(A0(MASf2(All1,3))*
     -          (C2B*(1 + 2*CW2)*MW2*TB2*UASf(All1,Ind1,3)*
     -             UASfC(All1,Ind1,3) + 
     -            2*(-2*C2B*MW2*SW2*TB2 + 3*CW2*Mf2(3,Ind1))*
     -             UASf(All1,3 + Ind1,3)*UASfC(All1,3 + Ind1,3)) + 
     -         TB2*A0(MASf2(All1,4))*
     -          (C2B*(1 - 4*CW2)*MW2*UASf(All1,Ind1,4)*
     -             UASfC(All1,Ind1,4) + 
     -            2*(C2B*MW2*SW2 + 3*CW2*TB2*Mdy2(Ind1,1))*
     -             UASf(All1,3 + Ind1,4)*UASfC(All1,3 + Ind1,4))))/
     -     (CW2*MW2*SW2*TB2)
	enddo
	enddo

	do Gen1 = g, 3
	do Gen2 = g, 3
        se_HmHp_nmfv = se_HmHp_nmfv + 
     -   3/(4.D0*Pi)*(Alfa*CKM(Gen1,Gen2)*CKMC(Gen1,Gen2)*
     -       (-((A0(Mf2(4,Gen2)) + 
     -              k2*B1(k2,Mf2(3,Gen1),Mf2(4,Gen2)))*
     -            (TB2**2*Mdy2(Gen2,1) + Mf2(3,Gen1))) - 
     -         B0(k2,Mf2(3,Gen1),Mf2(4,Gen2))*Mf2(3,Gen1)*
     -          (TB2*(TB2*Mdy2(Gen2,1) + 
     -               2*Mdy(Gen2,1)*Mf(4,Gen2)) + Mf2(3,Gen1))))/
     -     (MW2*SW2*TB2)
	enddo
	enddo

	do All1 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
	do Ind3 = g, 3
        se_HmHp_nmfv = se_HmHp_nmfv + 
     -   3/(8.D0*Pi)*(Alfa*(TB2**2*A0(MASf2(All1,3))*CKM(Ind1,Ind3)*
     -          CKMC(Ind2,Ind3)*Mdy2(Ind3,1)*UASf(All1,Ind1,3)*
     -          UASfC(All1,Ind2,3) + 
     -         A0(MASf2(All1,4))*CKM(Ind3,Ind2)*CKMC(Ind3,Ind1)*
     -          Mf2(3,Ind3)*UASf(All1,Ind1,4)*UASfC(All1,Ind2,4)))/
     -     (MW2*SW2*TB2)
	enddo
	enddo
	enddo
	enddo

	do All1 = g, 6, g
	do All2 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
	do Ind3 = g, 3
	do Ind4 = g, 3
        se_HmHp_nmfv = se_HmHp_nmfv + 
     -   3/(8.D0*Pi)*(Alfa*B0(k2,MASf2(All1,3),MASf2(All2,4))*
     -       CKM(Ind2,Ind1)*CKMC(Ind4,Ind3)*
     -       (((MW2*S2B*TB - TB2*Mdy2(Ind3,1) - Mf2(3,Ind4))*
     -             UASf(All2,Ind3,4) - 
     -            (MUEC*TB*Mdy(Ind3,1) + 
     -               TB2*Af(4,Ind4,Ind3)*Mdy(Ind4,1))*
     -             UASf(All2,3 + Ind3,4))*UASfC(All1,Ind4,3) - 
     -         Mf(3,Ind4)*(MUE*TB*UASf(All2,Ind3,4) + 
     -            AfC(3,Ind4,Ind4)*UASf(All2,Ind3,4) + 
     -            Mdy(Ind3,1)*UASf(All2,3 + Ind3,4) + 
     -            TB2*Mdy(Ind3,1)*UASf(All2,3 + Ind3,4))*
     -          UASfC(All1,3 + Ind4,3))*
     -       (((MW2*S2B*TB - TB2*Mdy2(Ind1,1) - Mf2(3,Ind2))*
     -             UASf(All1,Ind2,3) - 
     -            (Af(3,Ind1,Ind2)*Mf(3,Ind1) + 
     -               MUEC*TB*Mf(3,Ind2))*UASf(All1,3 + Ind2,3))*
     -          UASfC(All2,Ind1,4) - 
     -         Mdy(Ind1,1)*
     -          ((MUE*TB + TB2*AfC(4,Ind1,Ind1))*
     -             UASf(All1,Ind2,3) + 
     -            (1 + TB2)*Mf(3,Ind2)*UASf(All1,3 + Ind2,3))*
     -          UASfC(All2,3 + Ind1,4)))/(MW2*SW2*TB2)
	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_HmHp_nmfv =', se_HmHp_nmfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        se_HmHp_nmfv = se_HmHp_nmfv + 
     -   1/(8.D0*Pi)*(-2*Alfa*TB2*
     -        (A0(Mf2(2,Gen1)) + k2*B1(k2,0.D0,Mf2(2,Gen1)))*
     -        Mf2(2,Gen1) + 
     -       Alfa*MW2*A0(MSf2(1,1,Gen1))*
     -        ((C2B*(-1/2.D0 + CW2))/CW2 + (TB2*Mf2(2,Gen1))/MW2))/
     -     (MW2*SW2)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        se_HmHp_nmfv = se_HmHp_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*(2*CW2*
     -          B0(k2,MSf2(1,1,Gen1),MSf2(Sfe1,2,Gen1))*
     -          ((MW2*S2B - TB*Mf2(2,Gen1))*USf(Sfe1,1,2,Gen1) - 
     -            (MUEC + TB*Af(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USf(Sfe1,2,2,Gen1))*
     -          ((MW2*S2B - TB*Mf2(2,Gen1))*USfC(Sfe1,1,2,Gen1) - 
     -            (MUE + TB*AfC(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,2,2,Gen1)) + 
     -         A0(MSf2(Sfe1,2,Gen1))*
     -          (-(C2B*MW2*USf(Sfe1,1,2,Gen1)*
     -               USfC(Sfe1,1,2,Gen1)) + 
     -            2*(C2B*MW2*SW2 + CW2*TB2*Mf2(2,Gen1))*
     -             USf(Sfe1,2,2,Gen1)*USfC(Sfe1,2,2,Gen1))))/
     -     (CW2*MW2*SW2)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_HmHp_nmfv =', se_HmHp_nmfv
#endif

	if( mssmpart .eq. 3 ) return

        se_HmHp_nmfv = se_HmHp_nmfv + 
     -   1/(32.D0*Pi)*(Alfa*(2*
     -          (MW2*(C2B*SAB + 2*CW2*SBA)**2*B0(k2,Mh02,MHp2) + 
     -            (MW2*S2B**2*SAB**2 + 
     -               CBA*(CBA*CW2**2*(-k2 - Mh02 + MW2) - 
     -                  2*CW2*MW2*S2B*SAB))*B0(k2,Mh02,MW2) + 
     -            (C2B*CAB - 2*CBA*CW2)**2*MW2*B0(k2,MHH2,MHp2) + 
     -            (CAB*(CAB*MW2*S2B**2 - 2*CW2*MW2*S2B*SBA) + 
     -               CW2**2*
     -                (-(k2*SBA**2) - MHH2*SBA**2 + MW2*SBA**2))*
     -             B0(k2,MHH2,MW2)) + 
     -         CW2*((CW2*(1 - S2A*S2B) + C2A*C2B*SW2)*A0(Mh02) + 
     -            (CW2*(1 + S2A*S2B) - C2A*C2B*SW2)*A0(MHH2) + 
     -            C2B**2*(A0(MA02) + 4*A0(MHp2)) + 
     -            2*(-C2B**2 + 6*CW2 + S2B**2)*A0(MW2) + 
     -            (CW2*(1 + 6*CW2 + S2B**2 - 12*SW2) - 
     -               C2B**2*SW2 + 6*SW2**2)*A0(MZ2) - 
     -            8*CW2*(k2 + MHp2)*SW2*B0(k2,0.D0,MHp2) - 
     -            2*CW2*(k2 + MA02 - MW2)*B0(k2,MA02,MW2) - 
     -            2*(k2 + MHp2)*(CW2 - SW2)**2*B0(k2,MHp2,MZ2) + 
     -            4*CW2*k2*B1(k2,MA02,MW2) + 
     -            4*CBA**2*CW2*k2*B1(k2,Mh02,MW2) + 
     -            4*CW2*k2*SBA**2*B1(k2,MHH2,MW2) + 
     -            16*CW2*k2*SW2*B1(k2,MHp2,0.D0) + 
     -            4*k2*(CW2 - SW2)**2*B1(k2,MHp2,MZ2))))/
     -     (CW2**2*SW2)

	do Cha1 = 1, 2
	do Neu1 = 1, 4
	tmp1 = (SW*ZNeu(Neu1,1) + CW*ZNeu(Neu1,2))/CW
	tmp2 = (SW*ZNeuC(Neu1,1) + CW*ZNeuC(Neu1,2))/CW
        se_HmHp_nmfv = se_HmHp_nmfv + 
     -   1/(2.D0*Pi)*(Alfa*(A0(MNeu2(Neu1)) + 
     -          k2*B1(k2,MCha2(Cha1),MNeu2(Neu1)))*
     -        (-(1/4.D0*(SB2*
     -               (tmp1*Sqrt(2.D0)*UCha(Cha1,2) - 
     -                 2*UCha(Cha1,1)*ZNeu(Neu1,3))*
     -               (tmp2*Sqrt(2.D0)*UChaC(Cha1,2) - 
     -                 2*UChaC(Cha1,1)*ZNeuC(Neu1,3)))) - 
     -          CB2*((tmp1*VCha(Cha1,2))/Sqrt(2.D0) + 
     -             VCha(Cha1,1)*ZNeu(Neu1,4))*
     -           ((tmp2*VChaC(Cha1,2))/Sqrt(2.D0) + 
     -             VChaC(Cha1,1)*ZNeuC(Neu1,4))) + 
     -       Alfa*B0(k2,MCha2(Cha1),MNeu2(Neu1))*
     -        (-(1/4.D0*(SB2*MCha2(Cha1)*
     -               (tmp1*Sqrt(2.D0)*UCha(Cha1,2) - 
     -                 2*UCha(Cha1,1)*ZNeu(Neu1,3))*
     -               (tmp2*Sqrt(2.D0)*UChaC(Cha1,2) - 
     -                 2*UChaC(Cha1,1)*ZNeuC(Neu1,3)))) - 
     -          CB2*MCha2(Cha1)*
     -           ((tmp1*VCha(Cha1,2))/Sqrt(2.D0) + 
     -             VCha(Cha1,1)*ZNeu(Neu1,4))*
     -           ((tmp2*VChaC(Cha1,2))/Sqrt(2.D0) + 
     -             VChaC(Cha1,1)*ZNeuC(Neu1,4)) - 
     -          CB*SB*MCha(Cha1)*MNeu(Neu1)*
     -           ((-((tmp1*UCha(Cha1,2))/Sqrt(2.D0)) + 
     -                UCha(Cha1,1)*ZNeu(Neu1,3))*
     -              ((tmp1*VCha(Cha1,2))/Sqrt(2.D0) + 
     -                VCha(Cha1,1)*ZNeu(Neu1,4)) + 
     -             (-((tmp2*UChaC(Cha1,2))/Sqrt(2.D0)) + 
     -                UChaC(Cha1,1)*ZNeuC(Neu1,3))*
     -              ((tmp2*VChaC(Cha1,2))/Sqrt(2.D0) + 
     -                VChaC(Cha1,1)*ZNeuC(Neu1,4)))))/SW2
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_HmHp_nmfv =', se_HmHp_nmfv
#endif

	end

