* td_HH.F
* this file is part of FeynHiggs
* generated 06 Mar 2008 09:19

#include "externals.h"


	double complex function td_HH()
	implicit none


#include "FH.h"

	double complex td_HH_mfv, td_HH_nmfv
	external td_HH_mfv, td_HH_nmfv

	if( nmfv .eq. 0 ) then
	  td_HH = td_HH_mfv()
	else
	  td_HH = td_HH_nmfv()
	endif

#ifdef DEBUG

	print *, 'td_HH =', td_HH
#endif
	end


************************************************************************


	double complex function td_HH_mfv()
	implicit character (a-s,u-z)
	implicit double complex (t)

#include "FH.h"
#include "looptools.h"

	integer Cha1, Gen1, Neu1, Sfe1, g

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	td_HH_mfv = 0

	do Gen1 = g, 3
        td_HH_mfv = td_HH_mfv - 
     -   3/(8.D0*Pi**2)*(EL*SA*A0(Mf2(3,Gen1))*Mf2(3,Gen1))/
     -     (MW*SB*SW)
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
        td_HH_mfv = td_HH_mfv + 
     -   1/(32.D0*Pi**2)*(EL*A0(MSf2(Sfe1,3,Gen1))*
     -       (USf(Sfe1,1,3,Gen1)*
     -          ((CAB*MW*MZ*SB*(3 - 4*SW2) + 6*CW*SA*Mf2(3,Gen1))*
     -             USfC(Sfe1,1,3,Gen1) + 
     -            3*CW*(-(CA*MUE) + SA*AfC(3,Gen1,Gen1))*
     -             Mf(3,Gen1)*USfC(Sfe1,2,3,Gen1)) + 
     -         USf(Sfe1,2,3,Gen1)*
     -          (3*CW*(-(CA*MUEC) + SA*Af(3,Gen1,Gen1))*Mf(3,Gen1)*
     -             USfC(Sfe1,1,3,Gen1) + 
     -            2*(2*CAB*MW*MZ*SB*SW2 + 3*CW*SA*Mf2(3,Gen1))*
     -             USfC(Sfe1,2,3,Gen1))))/(CW*MW*SB*SW)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_HH_mfv =', td_HH_mfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
        td_HH_mfv = td_HH_mfv - 
     -   3/(8.D0*Pi**2)*(CA*EL*A0(Mf2(4,Gen1))*Hff(2,Gen1,1)*
     -       Mdy(Gen1,1)*Mf(4,Gen1))/(CB*MW*SW)
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
        td_HH_mfv = td_HH_mfv + 
     -   1/(32.D0*Pi**2)*(EL*A0(MSf2(Sfe1,4,Gen1))*
     -       (USf(Sfe1,1,4,Gen1)*
     -          ((CAB*CB*MW*MZ*(-3 + 2*SW2) + 
     -               6*CA*CW*Mdy2(Gen1,1))*USfC(Sfe1,1,4,Gen1) + 
     -            3*CW*(-(MUE*SA) + CA*AfC(4,Gen1,Gen1))*
     -             Mdy(Gen1,1)*USfC(Sfe1,2,4,Gen1)) + 
     -         USf(Sfe1,2,4,Gen1)*
     -          (3*CW*(-(MUEC*SA) + CA*Af(4,Gen1,Gen1))*
     -             Mdy(Gen1,1)*USfC(Sfe1,1,4,Gen1) - 
     -            2*(CAB*CB*MW*MZ*SW2 - 3*CA*CW*Mdy2(Gen1,1))*
     -             USfC(Sfe1,2,4,Gen1))))/(CB*CW*MW*SW)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_HH_mfv =', td_HH_mfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        td_HH_mfv = td_HH_mfv + 
     -   1/(32.D0*Pi**2)*(EL*
     -       (CAB*CB*MW*MZ*A0(MSf2(1,1,Gen1)) - 
     -         4*CA*CW*A0(Mf2(2,Gen1))*Mf2(2,Gen1)))/(CB*CW*MW*SW)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        td_HH_mfv = td_HH_mfv + 
     -   1/(32.D0*Pi**2)*(EL*A0(MSf2(Sfe1,2,Gen1))*
     -       (USf(Sfe1,1,2,Gen1)*
     -          ((CAB*CB*MW*MZ*(-1 + 2*SW2) + 2*CA*CW*Mf2(2,Gen1))*
     -             USfC(Sfe1,1,2,Gen1) + 
     -            CW*(-(MUE*SA) + CA*AfC(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,2,2,Gen1)) + 
     -         USf(Sfe1,2,2,Gen1)*
     -          (CW*(-(MUEC*SA) + CA*Af(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,1,2,Gen1) + 
     -            2*(-(CAB*CB*MW*MZ*SW2) + CA*CW*Mf2(2,Gen1))*
     -             USfC(Sfe1,2,2,Gen1))))/(CB*CW*MW*SW)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_HH_mfv =', td_HH_mfv
#endif

	if( mssmpart .eq. 3 ) return

        td_HH_mfv = td_HH_mfv + 
     -   1/(64.D0*Pi**2)*(EL*MW*
     -       (-(C2B*CAB*A0(MA02)) - 
     -         (C2A*CAB - 2*S2A*SAB)*A0(Mh02) + 
     -         3*C2A*CAB*A0(MHH2) + 
     -         2*(C2B*CAB + 6*CBA*CW2)*A0(MW2) + 
     -         (C2B*CAB + 6*CBA)*A0(MZ2) + 
     -         4*CW2*A0(MHp2)*(CBA - 1/2.D0*(C2B*CAB)/CW2)))/(CW2*SW)

	do Cha1 = 1, 2
        td_HH_mfv = td_HH_mfv - 
     -   1/(8.D0*Pi**2)*(EL*A0(MCha2(Cha1))*MCha(Cha1)*
     -       (CA*(UCha(Cha1,2)*VCha(Cha1,1) + 
     -            UChaC(Cha1,2)*VChaC(Cha1,1)) + 
     -         SA*(UCha(Cha1,1)*VCha(Cha1,2) + 
     -            UChaC(Cha1,1)*VChaC(Cha1,2))))/(SW*Sqrt(2.D0))
	enddo

	do Neu1 = 1, 4
        td_HH_mfv = td_HH_mfv + 
     -   1/(16.D0*Pi**2)*(EL*A0(MNeu2(Neu1))*MNeu(Neu1)*
     -       (SW*ZNeu(Neu1,1)*
     -          (CA*ZNeu(Neu1,3) - SA*ZNeu(Neu1,4)) + 
     -         ZNeu(Neu1,2)*
     -          (-(CA*CW*ZNeu(Neu1,3)) + CW*SA*ZNeu(Neu1,4)) + 
     -         (SW*ZNeuC(Neu1,1) - CW*ZNeuC(Neu1,2))*
     -          (CA*ZNeuC(Neu1,3) - SA*ZNeuC(Neu1,4))))/(CW*SW)
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_HH_mfv =', td_HH_mfv
#endif

	end


************************************************************************


	double complex function td_HH_nmfv()
	implicit character (a-s,u-z)
	implicit double complex (t)

#include "FH.h"
#include "looptools.h"

	integer All1, Cha1, Gen1, Ind1, Ind2, Neu1, Sfe1, g

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	td_HH_nmfv = 0

	do Gen1 = g, 3
        td_HH_nmfv = td_HH_nmfv - 
     -   3/(8.D0*Pi**2)*(EL*SA*A0(Mf2(3,Gen1))*Mf2(3,Gen1))/
     -     (MW*SB*SW)
	enddo

	do All1 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
        td_HH_nmfv = td_HH_nmfv + 
     -   1/(32.D0*Pi**2)*(EL*A0(MASf2(All1,3))*
     -       ((Delta(Ind1,Ind2)*
     -             (CAB*MW*MZ*SB*(3 - 4*SW2) + 
     -               6*CW*SA*Mf2(3,Ind1))*UASf(All1,Ind2,3) + 
     -            3*CW*(SA*Af(3,Ind1,Ind2) - 
     -               CA*MUEC*Delta(Ind1,Ind2))*Mf(3,Ind1)*
     -             UASf(All1,3 + Ind2,3))*UASfC(All1,Ind1,3) + 
     -         Delta(Ind1,Ind2)*
     -          (3*CW*(-(CA*MUE) + SA*AfC(3,Ind1,Ind1))*Mf(3,Ind1)*
     -             UASf(All1,Ind2,3) + 
     -            2*(2*CAB*MW*MZ*SB*SW2 + 3*CW*SA*Mf2(3,Ind1))*
     -             UASf(All1,3 + Ind2,3))*UASfC(All1,3 + Ind1,3)))/
     -     (CW*MW*SB*SW)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_HH_nmfv =', td_HH_nmfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
        td_HH_nmfv = td_HH_nmfv - 
     -   3/(8.D0*Pi**2)*(CA*EL*A0(Mf2(4,Gen1))*Hff(2,Gen1,1)*
     -       Mdy(Gen1,1)*Mf(4,Gen1))/(CB*MW*SW)
	enddo

	do All1 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
        td_HH_nmfv = td_HH_nmfv + 
     -   1/(32.D0*Pi**2)*(EL*A0(MASf2(All1,4))*
     -       ((Delta(Ind1,Ind2)*
     -             (CAB*CB*MW*MZ*(-3 + 2*SW2) + 
     -               6*CA*CW*Mdy2(Ind1,1))*UASf(All1,Ind2,4) + 
     -            3*CW*(CA*Af(4,Ind1,Ind2) - 
     -               MUEC*SA*Delta(Ind1,Ind2))*Mdy(Ind1,1)*
     -             UASf(All1,3 + Ind2,4))*UASfC(All1,Ind1,4) + 
     -         Delta(Ind1,Ind2)*
     -          (3*CW*(-(MUE*SA) + CA*AfC(4,Ind1,Ind1))*
     -             Mdy(Ind1,1)*UASf(All1,Ind2,4) - 
     -            2*(CAB*CB*MW*MZ*SW2 - 3*CA*CW*Mdy2(Ind1,1))*
     -             UASf(All1,3 + Ind2,4))*UASfC(All1,3 + Ind1,4)))/
     -     (CB*CW*MW*SW)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_HH_nmfv =', td_HH_nmfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        td_HH_nmfv = td_HH_nmfv + 
     -   1/(32.D0*Pi**2)*(EL*
     -       (CAB*CB*MW*MZ*A0(MSf2(1,1,Gen1)) - 
     -         4*CA*CW*A0(Mf2(2,Gen1))*Mf2(2,Gen1)))/(CB*CW*MW*SW)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        td_HH_nmfv = td_HH_nmfv + 
     -   1/(32.D0*Pi**2)*(EL*A0(MSf2(Sfe1,2,Gen1))*
     -       (USf(Sfe1,1,2,Gen1)*
     -          ((CAB*CB*MW*MZ*(-1 + 2*SW2) + 2*CA*CW*Mf2(2,Gen1))*
     -             USfC(Sfe1,1,2,Gen1) + 
     -            CW*(-(MUE*SA) + CA*AfC(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,2,2,Gen1)) + 
     -         USf(Sfe1,2,2,Gen1)*
     -          (CW*(-(MUEC*SA) + CA*Af(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,1,2,Gen1) + 
     -            2*(-(CAB*CB*MW*MZ*SW2) + CA*CW*Mf2(2,Gen1))*
     -             USfC(Sfe1,2,2,Gen1))))/(CB*CW*MW*SW)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_HH_nmfv =', td_HH_nmfv
#endif

	if( mssmpart .eq. 3 ) return

        td_HH_nmfv = td_HH_nmfv + 
     -   1/(64.D0*Pi**2)*(EL*MW*
     -       (-(C2B*CAB*A0(MA02)) - 
     -         (C2A*CAB - 2*S2A*SAB)*A0(Mh02) + 
     -         3*C2A*CAB*A0(MHH2) + 
     -         2*(C2B*CAB + 6*CBA*CW2)*A0(MW2) + 
     -         (C2B*CAB + 6*CBA)*A0(MZ2) + 
     -         4*CW2*A0(MHp2)*(CBA - 1/2.D0*(C2B*CAB)/CW2)))/(CW2*SW)

	do Cha1 = 1, 2
        td_HH_nmfv = td_HH_nmfv - 
     -   1/(8.D0*Pi**2)*(EL*A0(MCha2(Cha1))*MCha(Cha1)*
     -       (CA*(UCha(Cha1,2)*VCha(Cha1,1) + 
     -            UChaC(Cha1,2)*VChaC(Cha1,1)) + 
     -         SA*(UCha(Cha1,1)*VCha(Cha1,2) + 
     -            UChaC(Cha1,1)*VChaC(Cha1,2))))/(SW*Sqrt(2.D0))
	enddo

	do Neu1 = 1, 4
        td_HH_nmfv = td_HH_nmfv + 
     -   1/(16.D0*Pi**2)*(EL*A0(MNeu2(Neu1))*MNeu(Neu1)*
     -       (SW*ZNeu(Neu1,1)*
     -          (CA*ZNeu(Neu1,3) - SA*ZNeu(Neu1,4)) + 
     -         ZNeu(Neu1,2)*
     -          (-(CA*CW*ZNeu(Neu1,3)) + CW*SA*ZNeu(Neu1,4)) + 
     -         (SW*ZNeuC(Neu1,1) - CW*ZNeuC(Neu1,2))*
     -          (CA*ZNeuC(Neu1,3) - SA*ZNeuC(Neu1,4))))/(CW*SW)
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_HH_nmfv =', td_HH_nmfv
#endif

	end

