* td_h0.F
* this file is part of FeynHiggs
* generated 06 Mar 2008 09:19

#include "externals.h"


	double complex function td_h0()
	implicit none


#include "FH.h"

	double complex td_h0_mfv, td_h0_nmfv
	external td_h0_mfv, td_h0_nmfv

	if( nmfv .eq. 0 ) then
	  td_h0 = td_h0_mfv()
	else
	  td_h0 = td_h0_nmfv()
	endif

#ifdef DEBUG

	print *, 'td_h0 =', td_h0
#endif
	end


************************************************************************


	double complex function td_h0_mfv()
	implicit character (a-s,u-z)
	implicit double complex (t)

#include "FH.h"
#include "looptools.h"

	integer Cha1, Gen1, Neu1, Sfe1, g

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	td_h0_mfv = 0

	do Gen1 = g, 3
        td_h0_mfv = td_h0_mfv - 
     -   3/(8.D0*Pi**2)*(CA*EL*A0(Mf2(3,Gen1))*Mf2(3,Gen1))/
     -     (MW*SB*SW)
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
        td_h0_mfv = td_h0_mfv + 
     -   1/(32.D0*Pi**2)*(EL*A0(MSf2(Sfe1,3,Gen1))*
     -       (USf(Sfe1,1,3,Gen1)*
     -          ((MW*MZ*SAB*SB*(-3 + 4*SW2) + 6*CA*CW*Mf2(3,Gen1))*
     -             USfC(Sfe1,1,3,Gen1) + 
     -            3*CW*(MUE*SA + CA*AfC(3,Gen1,Gen1))*Mf(3,Gen1)*
     -             USfC(Sfe1,2,3,Gen1)) + 
     -         USf(Sfe1,2,3,Gen1)*
     -          (3*CW*(MUEC*SA + CA*Af(3,Gen1,Gen1))*Mf(3,Gen1)*
     -             USfC(Sfe1,1,3,Gen1) + 
     -            2*(-2*MW*MZ*SAB*SB*SW2 + 3*CA*CW*Mf2(3,Gen1))*
     -             USfC(Sfe1,2,3,Gen1))))/(CW*MW*SB*SW)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_h0_mfv =', td_h0_mfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
        td_h0_mfv = (td_h0_mfv*CB + 
     -     3/(8.D0*Pi**2)*(EL*SA*A0(Mf2(4,Gen1))*Hff(1,Gen1,1)*
     -         Mdy(Gen1,1)*Mf(4,Gen1))/(MW*SW))/CB
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
        td_h0_mfv = td_h0_mfv - 
     -   1/(32.D0*Pi**2)*(EL*A0(MSf2(Sfe1,4,Gen1))*
     -       (USf(Sfe1,1,4,Gen1)*
     -          ((CB*MW*MZ*SAB*(-3 + 2*SW2) + 
     -               6*CW*SA*Mdy2(Gen1,1))*USfC(Sfe1,1,4,Gen1) + 
     -            3*CW*(CA*MUE + SA*AfC(4,Gen1,Gen1))*Mdy(Gen1,1)*
     -             USfC(Sfe1,2,4,Gen1)) + 
     -         USf(Sfe1,2,4,Gen1)*
     -          (3*CW*(CA*MUEC + SA*Af(4,Gen1,Gen1))*Mdy(Gen1,1)*
     -             USfC(Sfe1,1,4,Gen1) - 
     -            2*(CB*MW*MZ*SAB*SW2 - 3*CW*SA*Mdy2(Gen1,1))*
     -             USfC(Sfe1,2,4,Gen1))))/(CB*CW*MW*SW)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_h0_mfv =', td_h0_mfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        td_h0_mfv = td_h0_mfv - 
     -   1/(32.D0*Pi**2)*(EL*
     -       (CB*MW*MZ*SAB*A0(MSf2(1,1,Gen1)) - 
     -         4*CW*SA*A0(Mf2(2,Gen1))*Mf2(2,Gen1)))/(CB*CW*MW*SW)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        td_h0_mfv = td_h0_mfv - 
     -   1/(32.D0*Pi**2)*(EL*A0(MSf2(Sfe1,2,Gen1))*
     -       (USf(Sfe1,1,2,Gen1)*
     -          ((CB*MW*MZ*SAB*(-1 + 2*SW2) + 2*CW*SA*Mf2(2,Gen1))*
     -             USfC(Sfe1,1,2,Gen1) + 
     -            CW*(CA*MUE + SA*AfC(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,2,2,Gen1)) + 
     -         USf(Sfe1,2,2,Gen1)*
     -          (CW*(CA*MUEC + SA*Af(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,1,2,Gen1) + 
     -            2*(-(CB*MW*MZ*SAB*SW2) + CW*SA*Mf2(2,Gen1))*
     -             USfC(Sfe1,2,2,Gen1))))/(CB*CW*MW*SW)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_h0_mfv =', td_h0_mfv
#endif

	if( mssmpart .eq. 3 ) return

        td_h0_mfv = td_h0_mfv + 
     -   1/(64.D0*Pi**2)*(EL*MW*
     -       (C2A*SAB*(3*A0(Mh02) - A0(MHH2)) - 
     -         2*CAB*S2A*A0(MHH2) + 
     -         CW2*SBA*(4*A0(MHp2) + 12*A0(MW2)) + 
     -         C2B*SAB*(A0(MA02) + 2*A0(MHp2) - 2*A0(MW2) - 
     -            A0(MZ2)) + 6*SBA*A0(MZ2)))/(CW2*SW)

	do Cha1 = 1, 2
        td_h0_mfv = td_h0_mfv + 
     -   1/(8.D0*Pi**2)*(EL*A0(MCha2(Cha1))*MCha(Cha1)*
     -       (SA*UCha(Cha1,2)*VCha(Cha1,1) + 
     -         SA*UChaC(Cha1,2)*VChaC(Cha1,1) - 
     -         CA*(UCha(Cha1,1)*VCha(Cha1,2) + 
     -            UChaC(Cha1,1)*VChaC(Cha1,2))))/(SW*Sqrt(2.D0))
	enddo

	do Neu1 = 1, 4
	tmp1 = SA*ZNeu(Neu1,3) + CA*ZNeu(Neu1,4)
        td_h0_mfv = td_h0_mfv + 
     -   1/(16.D0*Pi**2)*(EL*A0(MNeu2(Neu1))*MNeu(Neu1)*
     -       (-(SW*tmp1*ZNeu(Neu1,1)) + CW*tmp1*ZNeu(Neu1,2) - 
     -         (SW*ZNeuC(Neu1,1) - CW*ZNeuC(Neu1,2))*
     -          (SA*ZNeuC(Neu1,3) + CA*ZNeuC(Neu1,4))))/(CW*SW)
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_h0_mfv =', td_h0_mfv
#endif

	end


************************************************************************


	double complex function td_h0_nmfv()
	implicit character (a-s,u-z)
	implicit double complex (t)

#include "FH.h"
#include "looptools.h"

	integer All1, Cha1, Gen1, Ind1, Ind2, Neu1, Sfe1, g

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	td_h0_nmfv = 0

	do Gen1 = g, 3
        td_h0_nmfv = td_h0_nmfv - 
     -   3/(8.D0*Pi**2)*(CA*EL*A0(Mf2(3,Gen1))*Mf2(3,Gen1))/
     -     (MW*SB*SW)
	enddo

	do All1 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
        td_h0_nmfv = td_h0_nmfv + 
     -   1/(32.D0*Pi**2)*(EL*A0(MASf2(All1,3))*
     -       ((Delta(Ind1,Ind2)*
     -             (MW*MZ*SAB*SB*(-3 + 4*SW2) + 
     -               6*CA*CW*Mf2(3,Ind1))*UASf(All1,Ind2,3) + 
     -            3*CW*(CA*Af(3,Ind1,Ind2) + 
     -               MUEC*SA*Delta(Ind1,Ind2))*Mf(3,Ind1)*
     -             UASf(All1,3 + Ind2,3))*UASfC(All1,Ind1,3) + 
     -         Delta(Ind1,Ind2)*
     -          (3*CW*(MUE*SA + CA*AfC(3,Ind1,Ind1))*Mf(3,Ind1)*
     -             UASf(All1,Ind2,3) + 
     -            2*(-2*MW*MZ*SAB*SB*SW2 + 3*CA*CW*Mf2(3,Ind1))*
     -             UASf(All1,3 + Ind2,3))*UASfC(All1,3 + Ind1,3)))/
     -     (CW*MW*SB*SW)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_h0_nmfv =', td_h0_nmfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
        td_h0_nmfv = (td_h0_nmfv*CB + 
     -     3/(8.D0*Pi**2)*(EL*SA*A0(Mf2(4,Gen1))*Hff(1,Gen1,1)*
     -         Mdy(Gen1,1)*Mf(4,Gen1))/(MW*SW))/CB
	enddo

	do All1 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
        td_h0_nmfv = td_h0_nmfv - 
     -   1/(32.D0*Pi**2)*(EL*A0(MASf2(All1,4))*
     -       ((Delta(Ind1,Ind2)*
     -             (CB*MW*MZ*SAB*(-3 + 2*SW2) + 
     -               6*CW*SA*Mdy2(Ind1,1))*UASf(All1,Ind2,4) + 
     -            3*CW*(SA*Af(4,Ind1,Ind2) + 
     -               CA*MUEC*Delta(Ind1,Ind2))*Mdy(Ind1,1)*
     -             UASf(All1,3 + Ind2,4))*UASfC(All1,Ind1,4) + 
     -         Delta(Ind1,Ind2)*
     -          (3*CW*(CA*MUE + SA*AfC(4,Ind1,Ind1))*Mdy(Ind1,1)*
     -             UASf(All1,Ind2,4) - 
     -            2*(CB*MW*MZ*SAB*SW2 - 3*CW*SA*Mdy2(Ind1,1))*
     -             UASf(All1,3 + Ind2,4))*UASfC(All1,3 + Ind1,4)))/
     -     (CB*CW*MW*SW)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_h0_nmfv =', td_h0_nmfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        td_h0_nmfv = td_h0_nmfv - 
     -   1/(32.D0*Pi**2)*(EL*
     -       (CB*MW*MZ*SAB*A0(MSf2(1,1,Gen1)) - 
     -         4*CW*SA*A0(Mf2(2,Gen1))*Mf2(2,Gen1)))/(CB*CW*MW*SW)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        td_h0_nmfv = td_h0_nmfv - 
     -   1/(32.D0*Pi**2)*(EL*A0(MSf2(Sfe1,2,Gen1))*
     -       (USf(Sfe1,1,2,Gen1)*
     -          ((CB*MW*MZ*SAB*(-1 + 2*SW2) + 2*CW*SA*Mf2(2,Gen1))*
     -             USfC(Sfe1,1,2,Gen1) + 
     -            CW*(CA*MUE + SA*AfC(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,2,2,Gen1)) + 
     -         USf(Sfe1,2,2,Gen1)*
     -          (CW*(CA*MUEC + SA*Af(2,Gen1,Gen1))*Mf(2,Gen1)*
     -             USfC(Sfe1,1,2,Gen1) + 
     -            2*(-(CB*MW*MZ*SAB*SW2) + CW*SA*Mf2(2,Gen1))*
     -             USfC(Sfe1,2,2,Gen1))))/(CB*CW*MW*SW)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_h0_nmfv =', td_h0_nmfv
#endif

	if( mssmpart .eq. 3 ) return

        td_h0_nmfv = td_h0_nmfv + 
     -   1/(64.D0*Pi**2)*(EL*MW*
     -       (C2A*SAB*(3*A0(Mh02) - A0(MHH2)) - 
     -         2*CAB*S2A*A0(MHH2) + 
     -         CW2*SBA*(4*A0(MHp2) + 12*A0(MW2)) + 
     -         C2B*SAB*(A0(MA02) + 2*A0(MHp2) - 2*A0(MW2) - 
     -            A0(MZ2)) + 6*SBA*A0(MZ2)))/(CW2*SW)

	do Cha1 = 1, 2
        td_h0_nmfv = td_h0_nmfv + 
     -   1/(8.D0*Pi**2)*(EL*A0(MCha2(Cha1))*MCha(Cha1)*
     -       (SA*UCha(Cha1,2)*VCha(Cha1,1) + 
     -         SA*UChaC(Cha1,2)*VChaC(Cha1,1) - 
     -         CA*(UCha(Cha1,1)*VCha(Cha1,2) + 
     -            UChaC(Cha1,1)*VChaC(Cha1,2))))/(SW*Sqrt(2.D0))
	enddo

	do Neu1 = 1, 4
	tmp1 = SA*ZNeu(Neu1,3) + CA*ZNeu(Neu1,4)
        td_h0_nmfv = td_h0_nmfv + 
     -   1/(16.D0*Pi**2)*(EL*A0(MNeu2(Neu1))*MNeu(Neu1)*
     -       (-(SW*tmp1*ZNeu(Neu1,1)) + CW*tmp1*ZNeu(Neu1,2) - 
     -         (SW*ZNeuC(Neu1,1) - CW*ZNeuC(Neu1,2))*
     -          (SA*ZNeuC(Neu1,3) + CA*ZNeuC(Neu1,4))))/(CW*SW)
	enddo

#ifdef DETAILED_DEBUG
	print *, 'td_h0_nmfv =', td_h0_nmfv
#endif

	end

