* RecordIndex.F
* convert variable names to indices
* this file is part of FeynHiggs
* last modified 27 Mar 08 th

#include "externals.h"
#include "debug.h"


	subroutine FHRecordIndex(ind, para)
	implicit none
	integer ind
	character*(*) para

#include "FHRecord.h"
#define __SUBROUTINE__ "FHRecordIndex"

	integer v
	character*128 line

#if U77EXT
	integer lnblnk
	external lnblnk
#endif

	external recordnamesini

	do v = FHRangeA
	  ind = v
	  if( para .eq. FHName(v) ) return
	enddo

* e.g. At is shorthand for Re(At)
	do v = FHRangeC
	  ind = v
	  if( para .eq. FHNameC(v) ) return
	enddo

	line = "Unknown parameter "//para
	Warning(Strip(line))
	ind = 0
	end


************************************************************************

	block data recordnamesini

#include "FHRecord.h"

	data FHName(iinvAlfa) /"invAlfa"/
	data FHName(iAlfasMZ) /"AlfasMZ"/
	data FHName(iGF) /"GF"/

	data FHName(iMS) /"MS"/
	data FHName(iMC) /"MC"/
	data FHName(iMT) /"MT"/
	data FHName(iMB) /"MB"/
	data FHName(iMW) /"MW"/
	data FHName(iMZ) /"MZ"/

	data FHName(iCKMlambda) /"CKMlambda"/
	data FHName(iCKMA) /"CKMA"/
	data FHName(iCKMrho) /"CKMrho"/
	data FHName(iCKMeta) /"CKMeta"/

	data FHName(iTB) /"TB"/
	data FHName(iMA0) /"MA0"/
	data FHName(iMHp) /"MHp"/

	data FHName(iMSusy) /"MSusy"/
	data FHName(iM1SL) /"M1SL"/
	data FHName(iM2SL) /"M2SL"/
	data FHName(iM3SL) /"M3SL"/
	data FHName(iM1SE) /"M1SE"/
	data FHName(iM2SE) /"M2SE"/
	data FHName(iM3SE) /"M3SE"/
	data FHName(iM1SQ) /"M1SQ"/
	data FHName(iM2SQ) /"M2SQ"/
	data FHName(iM3SQ) /"M3SQ"/
	data FHName(iM1SU) /"M1SU"/
	data FHName(iM2SU) /"M2SU"/
	data FHName(iM3SU) /"M3SU"/
	data FHName(iM1SD) /"M1SD"/
	data FHName(iM2SD) /"M2SD"/
	data FHName(iM3SD) /"M3SD"/
	data FHName(iQtau) /"Qtau"/
	data FHName(iQt) /"Qt"/
	data FHName(iQb) /"Qb"/

	data FHName(iRe(iAe)) /"Re(Ae)"/
	data FHName(iIm(iAe)) /"Im(Ae)"/
	data FHName(iAbs(iAe)) /"Abs(Ae)"/
	data FHName(iArg(iAe)) /"Arg(Ae)"/

	data FHName(iRe(iAu)) /"Re(Au)"/
	data FHName(iIm(iAu)) /"Im(Au)"/
	data FHName(iAbs(iAu)) /"Abs(Au)"/
	data FHName(iArg(iAu)) /"Arg(Au)"/

	data FHName(iRe(iAd)) /"Re(Ad)"/
	data FHName(iIm(iAd)) /"Im(Ad)"/
	data FHName(iAbs(iAd)) /"Abs(Ad)"/
	data FHName(iArg(iAd)) /"Arg(Ad)"/

	data FHName(iRe(iAmu)) /"Re(Amu)"/
	data FHName(iIm(iAmu)) /"Im(Amu)"/
	data FHName(iAbs(iAmu)) /"Abs(Amu)"/
	data FHName(iArg(iAmu)) /"Arg(Amu)"/

	data FHName(iRe(iAc)) /"Re(Ac)"/
	data FHName(iIm(iAc)) /"Im(Ac)"/
	data FHName(iAbs(iAc)) /"Abs(Ac)"/
	data FHName(iArg(iAc)) /"Arg(Ac)"/

	data FHName(iRe(iAs)) /"Re(As)"/
	data FHName(iIm(iAs)) /"Im(As)"/
	data FHName(iAbs(iAs)) /"Abs(As)"/
	data FHName(iArg(iAs)) /"Arg(As)"/

	data FHName(iRe(iAtau)) /"Re(Atau)"/
	data FHName(iIm(iAtau)) /"Im(Atau)"/
	data FHName(iAbs(iAtau)) /"Abs(Atau)"/
	data FHName(iArg(iAtau)) /"Arg(Atau)"/

	data FHName(iRe(iAt)) /"Re(At)"/
	data FHName(iIm(iAt)) /"Im(At)"/
	data FHName(iAbs(iAt)) /"Abs(At)"/
	data FHName(iArg(iAt)) /"Arg(At)"/

	data FHName(iRe(iAb)) /"Re(Ab)"/
	data FHName(iIm(iAb)) /"Im(Ab)"/
	data FHName(iAbs(iAb)) /"Abs(Ab)"/
	data FHName(iArg(iAb)) /"Arg(Ab)"/

	data FHName(iRe(iXtau)) /"Re(Xtau)"/
	data FHName(iIm(iXtau)) /"Im(Xtau)"/
	data FHName(iAbs(iXtau)) /"Abs(Xtau)"/
	data FHName(iArg(iXtau)) /"Arg(Xtau)"/

	data FHName(iRe(iXt)) /"Re(Xt)"/
	data FHName(iIm(iXt)) /"Im(Xt)"/
	data FHName(iAbs(iXt)) /"Abs(Xt)"/
	data FHName(iArg(iXt)) /"Arg(Xt)"/

	data FHName(iRe(iXb)) /"Re(Xb)"/
	data FHName(iIm(iXb)) /"Im(Xb)"/
	data FHName(iAbs(iXb)) /"Abs(Xb)"/
	data FHName(iArg(iXb)) /"Arg(Xb)"/

	data FHName(iRe(iMUE)) /"Re(MUE)"/
	data FHName(iIm(iMUE)) /"Im(MUE)"/
	data FHName(iAbs(iMUE)) /"Abs(MUE)"/
	data FHName(iArg(iMUE)) /"Arg(MUE)"/

	data FHName(iRe(iM1)) /"Re(M_1)"/
	data FHName(iIm(iM1)) /"Im(M_1)"/
	data FHName(iAbs(iM1)) /"Abs(M_1)"/
	data FHName(iArg(iM1)) /"Arg(M_1)"/

	data FHName(iRe(iM2)) /"Re(M_2)"/
	data FHName(iIm(iM2)) /"Im(M_2)"/
	data FHName(iAbs(iM2)) /"Abs(M_2)"/
	data FHName(iArg(iM2)) /"Arg(M_2)"/

	data FHName(iRe(iM3)) /"Re(M_3)"/
	data FHName(iIm(iM3)) /"Im(M_3)"/
	data FHName(iAbs(iM3)) /"Abs(M_3)"/
	data FHName(iArg(iM3)) /"Arg(M_3)"/

	data FHName(iRe(ideltaLLuc)) /"Re(deltaLLuc)"/
	data FHName(iIm(ideltaLLuc)) /"Im(deltaLLuc)"/
	data FHName(iAbs(ideltaLLuc)) /"Abs(deltaLLuc)"/
	data FHName(iArg(ideltaLLuc)) /"Arg(deltaLLuc)"/

	data FHName(iRe(ideltaLRuc)) /"Re(deltaLRuc)"/
	data FHName(iIm(ideltaLRuc)) /"Im(deltaLRuc)"/
	data FHName(iAbs(ideltaLRuc)) /"Abs(deltaLRuc)"/
	data FHName(iArg(ideltaLRuc)) /"Arg(deltaLRuc)"/

	data FHName(iRe(ideltaRLuc)) /"Re(deltaRLuc)"/
	data FHName(iIm(ideltaRLuc)) /"Im(deltaRLuc)"/
	data FHName(iAbs(ideltaRLuc)) /"Abs(deltaRLuc)"/
	data FHName(iArg(ideltaRLuc)) /"Arg(deltaRLuc)"/

	data FHName(iRe(ideltaRRuc)) /"Re(deltaRRuc)"/
	data FHName(iIm(ideltaRRuc)) /"Im(deltaRRuc)"/
	data FHName(iAbs(ideltaRRuc)) /"Abs(deltaRRuc)"/
	data FHName(iArg(ideltaRRuc)) /"Arg(deltaRRuc)"/

	data FHName(iRe(ideltaLLct)) /"Re(deltaLLct)"/
	data FHName(iIm(ideltaLLct)) /"Im(deltaLLct)"/
	data FHName(iAbs(ideltaLLct)) /"Abs(deltaLLct)"/
	data FHName(iArg(ideltaLLct)) /"Arg(deltaLLct)"/

	data FHName(iRe(ideltaLRct)) /"Re(deltaLRct)"/
	data FHName(iIm(ideltaLRct)) /"Im(deltaLRct)"/
	data FHName(iAbs(ideltaLRct)) /"Abs(deltaLRct)"/
	data FHName(iArg(ideltaLRct)) /"Arg(deltaLRct)"/

	data FHName(iRe(ideltaRLct)) /"Re(deltaRLct)"/
	data FHName(iIm(ideltaRLct)) /"Im(deltaRLct)"/
	data FHName(iAbs(ideltaRLct)) /"Abs(deltaRLct)"/
	data FHName(iArg(ideltaRLct)) /"Arg(deltaRLct)"/

	data FHName(iRe(ideltaRRct)) /"Re(deltaRRct)"/
	data FHName(iIm(ideltaRRct)) /"Im(deltaRRct)"/
	data FHName(iAbs(ideltaRRct)) /"Abs(deltaRRct)"/
	data FHName(iArg(ideltaRRct)) /"Arg(deltaRRct)"/

	data FHName(iRe(ideltaLLut)) /"Re(deltaLLut)"/
	data FHName(iIm(ideltaLLut)) /"Im(deltaLLut)"/
	data FHName(iAbs(ideltaLLut)) /"Abs(deltaLLut)"/
	data FHName(iArg(ideltaLLut)) /"Arg(deltaLLut)"/

	data FHName(iRe(ideltaLRut)) /"Re(deltaLRut)"/
	data FHName(iIm(ideltaLRut)) /"Im(deltaLRut)"/
	data FHName(iAbs(ideltaLRut)) /"Abs(deltaLRut)"/
	data FHName(iArg(ideltaLRut)) /"Arg(deltaLRut)"/

	data FHName(iRe(ideltaRLut)) /"Re(deltaRLut)"/
	data FHName(iIm(ideltaRLut)) /"Im(deltaRLut)"/
	data FHName(iAbs(ideltaRLut)) /"Abs(deltaRLut)"/
	data FHName(iArg(ideltaRLut)) /"Arg(deltaRLut)"/

	data FHName(iRe(ideltaRRut)) /"Re(deltaRRut)"/
	data FHName(iIm(ideltaRRut)) /"Im(deltaRRut)"/
	data FHName(iAbs(ideltaRRut)) /"Abs(deltaRRut)"/
	data FHName(iArg(ideltaRRut)) /"Arg(deltaRRut)"/

	data FHName(iRe(ideltaLLds)) /"Re(deltaLLds)"/
	data FHName(iIm(ideltaLLds)) /"Im(deltaLLds)"/
	data FHName(iAbs(ideltaLLds)) /"Abs(deltaLLds)"/
	data FHName(iArg(ideltaLLds)) /"Arg(deltaLLds)"/

	data FHName(iRe(ideltaLRds)) /"Re(deltaLRds)"/
	data FHName(iIm(ideltaLRds)) /"Im(deltaLRds)"/
	data FHName(iAbs(ideltaLRds)) /"Abs(deltaLRds)"/
	data FHName(iArg(ideltaLRds)) /"Arg(deltaLRds)"/

	data FHName(iRe(ideltaRLds)) /"Re(deltaRLds)"/
	data FHName(iIm(ideltaRLds)) /"Im(deltaRLds)"/
	data FHName(iAbs(ideltaRLds)) /"Abs(deltaRLds)"/
	data FHName(iArg(ideltaRLds)) /"Arg(deltaRLds)"/

	data FHName(iRe(ideltaRRds)) /"Re(deltaRRds)"/
	data FHName(iIm(ideltaRRds)) /"Im(deltaRRds)"/
	data FHName(iAbs(ideltaRRds)) /"Abs(deltaRRds)"/
	data FHName(iArg(ideltaRRds)) /"Arg(deltaRRds)"/

	data FHName(iRe(ideltaLLsb)) /"Re(deltaLLsb)"/
	data FHName(iIm(ideltaLLsb)) /"Im(deltaLLsb)"/
	data FHName(iAbs(ideltaLLsb)) /"Abs(deltaLLsb)"/
	data FHName(iArg(ideltaLLsb)) /"Arg(deltaLLsb)"/

	data FHName(iRe(ideltaLRsb)) /"Re(deltaLRsb)"/
	data FHName(iIm(ideltaLRsb)) /"Im(deltaLRsb)"/
	data FHName(iAbs(ideltaLRsb)) /"Abs(deltaLRsb)"/
	data FHName(iArg(ideltaLRsb)) /"Arg(deltaLRsb)"/

	data FHName(iRe(ideltaRLsb)) /"Re(deltaRLsb)"/
	data FHName(iIm(ideltaRLsb)) /"Im(deltaRLsb)"/
	data FHName(iAbs(ideltaRLsb)) /"Abs(deltaRLsb)"/
	data FHName(iArg(ideltaRLsb)) /"Arg(deltaRLsb)"/

	data FHName(iRe(ideltaRRsb)) /"Re(deltaRRsb)"/
	data FHName(iIm(ideltaRRsb)) /"Im(deltaRRsb)"/
	data FHName(iAbs(ideltaRRsb)) /"Abs(deltaRRsb)"/
	data FHName(iArg(ideltaRRsb)) /"Arg(deltaRRsb)"/

	data FHName(iRe(ideltaLLdb)) /"Re(deltaLLdb)"/
	data FHName(iIm(ideltaLLdb)) /"Im(deltaLLdb)"/
	data FHName(iAbs(ideltaLLdb)) /"Abs(deltaLLdb)"/
	data FHName(iArg(ideltaLLdb)) /"Arg(deltaLLdb)"/

	data FHName(iRe(ideltaLRdb)) /"Re(deltaLRdb)"/
	data FHName(iIm(ideltaLRdb)) /"Im(deltaLRdb)"/
	data FHName(iAbs(ideltaLRdb)) /"Abs(deltaLRdb)"/
	data FHName(iArg(ideltaLRdb)) /"Arg(deltaLRdb)"/

	data FHName(iRe(ideltaRLdb)) /"Re(deltaRLdb)"/
	data FHName(iIm(ideltaRLdb)) /"Im(deltaRLdb)"/
	data FHName(iAbs(ideltaRLdb)) /"Abs(deltaRLdb)"/
	data FHName(iArg(ideltaRLdb)) /"Arg(deltaRLdb)"/

	data FHName(iRe(ideltaRRdb)) /"Re(deltaRRdb)"/
	data FHName(iIm(ideltaRRdb)) /"Im(deltaRRdb)"/
	data FHName(iAbs(ideltaRRdb)) /"Abs(deltaRRdb)"/
	data FHName(iArg(ideltaRRdb)) /"Arg(deltaRRdb)"/
	end

