* ReverseSVD.F
* recover the original matrix A from the singular values and
* the left and right transformation matrices U and V by
* forming A = U^T diag(d) V.
* this file is part of FeynHiggs
* last modified 16 Jun 06 th

#include "externals.h"


	subroutine ReverseSVD(n, A,ldA, d, U,ldU, V,ldV)
	implicit none
	integer n, ldA, ldU, ldV
	double complex A(ldA,*), U(ldU,*), V(ldV,*)
	double precision d(*)

	integer i, j, k
	double complex s

	do j = 1, n
	  do i = 1, n
	    s = 0
	    do k = 1, n
	      s = s + d(k)*U(k,i)*V(k,j)
	    enddo
	    A(i,j) = s
	  enddo
	enddo
	end

