#if 0
	FHCouplings.h
		human-readable indexing for the
		couplings, gammas, and gammasms arrays
		this file is part of FeynHiggs
		last modified 20 Mar 08 th

Note1: comments are real funny here because we want to include
       this file in both Fortran and C

Note2: for the same reason, the funny notation couplingS etc.
       is used because we have to remap array indices in C and
       Fortran does not care about caps.
#endif


#ifndef __FHCOUPLINGS_H__
#define __FHCOUPLINGS_H__

#define ncouplings 465
#define Roffset 340
#define Coupling(c)		couplingS(c)
#define LCoupling(c)		couplingS(c)
#define RCoupling(c)		couplingS(c+Roffset)

#define ncouplingsms 87
#define RSMoffset 36
#define CouplingSM(c)		couplingsmS(c)
#define LCouplingSM(c)		couplingsmS(c)
#define RCouplingSM(c)		couplingsmS(c+RSMoffset)

#define ngammas 714
#define BRoffset 359
#define GammaTot(h)		gammaS(h)
#define Gamma(c)		gammaS(c+4)
#define BR(c)			gammaS(c+BRoffset)

#define ngammasms 106
#define BRSMoffset 55
#define GammaSMTot(h)		gammasmS(h)
#define GammaSM(c)		gammasmS(c+4)
#define BRSM(c)			gammasmS(c+BRSMoffset)


#define H0VV(h,vv) h+3*vv-3
#if 0
  h  = 1..3	Higgs: h0, HH, A0
  vv = 1..5	vector-boson pair: gamma gamma, gamma Z, ZZ, WW, gg
#endif

#define H0FF(h,t,g) h+3*t+12*g
#if 0
  h  = 1..3	Higgs: h0, HH, A0
  t  = 1..4	fermion type: nu, e, u, d
  g  = 1..3	fermion generation
#endif

#define HpFF(p,g) p+2*g+49
#if 0
  p  = 1..2	decay products: leptons, quarks
  g  = 1..3	fermion generation
#endif

#define H0ChaCha(h,c1,c2) h+3*c1+6*c2+48
#if 0
  h  = 1..3	Higgs: h0, HH, A0
  c1 = 1..2	chargino 1
  c2 = 1..2	chargino 2
#endif

#define H0NeuNeu(h,n1,n2) h+3*n1+12*n2+54
#if 0
  h  = 1..3	Higgs: h0, HH, A0
  n1 = 1..4	neutralino 1
  n2 = 1..4	neutralino 2
#endif

#define HpNeuCha(n1,c2) n1+4*c2+113
#if 0
  n1 = 1..4	neutralino
  c2 = 1..2	chargino
#endif

#define H0HV(h,hv) h+3*hv+122
#if 0
  h  = 1..3	decaying Higgs: h0, HH, A0
  hv = 1..3	produced pair: h0-Z, HH-Z, A0-Z
#endif

#define HpHV(hv) hv+134
#if 0
  hv = 1..3	produced pair: h0-W, HH-W, A0-W
#endif

#define H0HH(h,h1,h2) h+3*h1+12*h2+122
#if 0
  h  = 1..3	decaying Higgs: h0, HH, A0
  h1 = 1..4	produced Higgs 1: h0, HH, A0, Hp
  h2 = 1..4	produced Higgs 2: h0, HH, A0, Hp
#endif

#define H0SfSf(h,s1,s2,t,g) h+3*s1+6*s2+12*t+48*g+116
#if 0
  h  = 1..3	Higgs: h0, HH, A0
  s1 = 1..2	sfermion 1
  s2 = 1..2	sfermion 2
  t  = 1..4	sfermion type: nu, e, u, d
  g  = 1..3	sfermion generation
#endif

#define HpSfSf(s1,s2,p,g) s1+2*s2+4*p+8*g+315
#if 0
  s1 = 1..2	sfermion 1
  s2 = 1..2	sfermion 2
  p  = 1..2	decay products: sleptons, squarks
  g  = 1..3	sfermion generation
#endif

#define tBF(bf) bf+353
#if 0
  bf = 1..2	W-b, H-b
#endif


#define nprodxs 88

#define bbhTev(h)	prodXS(h)
#define bbhTevSM(h)	prodXS(h+3)
#define bbhLHC(h)	prodXS(h+6)
#define bbhLHCSM(h)	prodXS(h+9)
#define btagbhTev(h)	prodXS(h+12)
#define btagbhTevSM(h)	prodXS(h+15)
#define btagbhLHC(h)	prodXS(h+18)
#define btagbhLHCSM(h)	prodXS(h+21)
#define gghTev(h)	prodXS(h+24)
#define gghTevSM(h)	prodXS(h+27)
#define gghLHC(h)	prodXS(h+30)
#define gghLHCSM(h)	prodXS(h+33)
#define qqhTev(h)	prodXS(h+36)
#define qqhTevSM(h)	prodXS(h+39)
#define qqhLHC(h)	prodXS(h+42)
#define qqhLHCSM(h)	prodXS(h+45)
#define tthTev(h)	prodXS(h+48)
#define tthTevSM(h)	prodXS(h+51)
#define tthLHC(h)	prodXS(h+54)
#define tthLHCSM(h)	prodXS(h+57)
#define WhTev(h)	prodXS(h+60)
#define WhTevSM(h)	prodXS(h+63)
#define WhLHC(h)	prodXS(h+66)
#define WhLHCSM(h)	prodXS(h+69)
#define ZhTev(h)	prodXS(h+72)
#define ZhTevSM(h)	prodXS(h+75)
#define ZhLHC(h)	prodXS(h+78)
#define ZhLHCSM(h)	prodXS(h+81)
#define StSthLHC(h)	prodXS(h+84)
#define tHmLHC		prodXS(88)

#endif

