* RetrieveNMFV.F
* retrieve the non-minimal flavour-violation parameters
* this file is part of FeynHiggs
* last modified 27 Jul 07 th

#include "externals.h"
#include "debug.h"


	subroutine FHRetrieveNMFV(error,
     &    deltaLLuc_, deltaLRuc_, deltaRLuc_, deltaRRuc_,
     &    deltaLLct_, deltaLRct_, deltaRLct_, deltaRRct_,
     &    deltaLLut_, deltaLRut_, deltaRLut_, deltaRRut_,
     &    deltaLLds_, deltaLRds_, deltaRLds_, deltaRRds_,
     &    deltaLLsb_, deltaLRsb_, deltaRLsb_, deltaRRsb_,
     &    deltaLLdb_, deltaLRdb_, deltaRLdb_, deltaRRdb_)
	implicit none
	integer error
	double complex deltaLLuc_, deltaLRuc_
	double complex deltaRLuc_, deltaRRuc_
	double complex deltaLLct_, deltaLRct_
	double complex deltaRLct_, deltaRRct_
	double complex deltaLLut_, deltaLRut_
	double complex deltaRLut_, deltaRRut_
	double complex deltaLLds_, deltaLRds_
	double complex deltaRLds_, deltaRRds_
	double complex deltaLLsb_, deltaLRsb_
	double complex deltaRLsb_, deltaRRsb_
	double complex deltaLLdb_, deltaLRdb_
	double complex deltaRLdb_, deltaRRdb_

#include "FH.h"
#define __SUBROUTINE__ "FHRetrieveNMFV"

	error = 0

	CheckPara()

	if( error .ne. 0 ) return

	deltaLLuc_ = deltaSf(3,1  ,2  )
	deltaLRuc_ = deltaSf(3,1  ,2+3)
	deltaRLuc_ = DCONJG(deltaSf(3,2  ,1+3))
	deltaRRuc_ = deltaSf(3,1+3,2+3)

	deltaLLct_ = deltaSf(3,2  ,3  )
	deltaLRct_ = deltaSf(3,2  ,3+3)
	deltaRLct_ = DCONJG(deltaSf(3,3  ,2+3))
	deltaRRct_ = deltaSf(3,2+3,3+3)

	deltaLLut_ = deltaSf(3,1  ,3  )
	deltaLRut_ = deltaSf(3,1  ,3+3)
	deltaRLut_ = DCONJG(deltaSf(3,3  ,1+3))
	deltaRRut_ = deltaSf(3,1+3,3+3)

	deltaLLds_ = deltaSf(4,1  ,2  )
	deltaLRds_ = deltaSf(4,1  ,2+3)
	deltaRLds_ = DCONJG(deltaSf(4,2  ,1+3))
	deltaRRds_ = deltaSf(4,1+3,2+3)

	deltaLLsb_ = deltaSf(4,2  ,3  )
	deltaLRsb_ = deltaSf(4,2  ,3+3)
	deltaRLsb_ = DCONJG(deltaSf(4,3  ,2+3))
	deltaRRsb_ = deltaSf(4,2+3,3+3)

	deltaLLdb_ = deltaSf(4,1  ,3  )
	deltaLRdb_ = deltaSf(4,1  ,3+3)
	deltaRLdb_ = DCONJG(deltaSf(4,3  ,1+3))
	deltaRRdb_ = deltaSf(4,1+3,3+3)
	end

