* dse_h0G0.F
* this file is part of FeynHiggs
* generated 15 Jun 2008 08:42

#include "externals.h"


	double complex function dse_h0G0(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex dse_h0G0_mfv, dse_h0G0_nmfv
	external dse_h0G0_mfv, dse_h0G0_nmfv

	if( nmfv .eq. 0 ) then
	  dse_h0G0 = dse_h0G0_mfv(k2)
	else
	  dse_h0G0 = dse_h0G0_nmfv(k2)
	endif

#ifdef DEBUG
	print *, 'k2 =', k2
	print *, 'dse_h0G0 =', dse_h0G0
#endif
	end


************************************************************************


	double complex function dse_h0G0_mfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha3, Cha4, Gen3, Neu3, Neu4, Sfe3, Sfe4, g
	double complex dup1, dup10, dup11, dup12, dup13, dup2, dup3
	double complex dup4, dup5, dup6, dup7, dup8, dup9

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_h0G0_mfv = 0

	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

        dse_h0G0_mfv = dse_h0G0_mfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       DB0(k2,MSf2(Sfe3,3,Gen3),MSf2(Sfe4,3,Gen3))*
     -       Mf(3,Gen3)*(USf(Sfe4,1,3,Gen3)*
     -          ((MW*MZ*SAB*SB*(-3 + 4*SW2) + 6*CA*CW*Mf2(3,Gen3))*
     -             USfC(Sfe3,1,3,Gen3) + 
     -            3*CW*(MUE*SA + CA*AfC(3,Gen3,Gen3))*Mf(3,Gen3)*
     -             USfC(Sfe3,2,3,Gen3)) + 
     -         USf(Sfe4,2,3,Gen3)*
     -          (3*CW*(MUEC*SA + CA*Af(3,Gen3,Gen3))*Mf(3,Gen3)*
     -             USfC(Sfe3,1,3,Gen3) + 
     -            2*(-2*MW*MZ*SAB*SB*SW2 + 3*CA*CW*Mf2(3,Gen3))*
     -             USfC(Sfe3,2,3,Gen3)))*
     -       ((-MUEC + TB*Af(3,Gen3,Gen3))*USf(Sfe3,2,3,Gen3)*
     -          USfC(Sfe4,1,3,Gen3) + 
     -         (MUE - TB*AfC(3,Gen3,Gen3))*USf(Sfe3,1,3,Gen3)*
     -          USfC(Sfe4,2,3,Gen3)))/(CW*MW2*SB*SW2*TB)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0G0_mfv =', dse_h0G0_mfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

        dse_h0G0_mfv = dse_h0G0_mfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       DB0(k2,MSf2(Sfe3,4,Gen3),MSf2(Sfe4,4,Gen3))*
     -       Mdy(Gen3,1)*(USf(Sfe4,1,4,Gen3)*
     -          ((CB*MW*MZ*SAB*(-3 + 2*SW2) + 
     -               6*CW*SA*Mdy2(Gen3,1))*USfC(Sfe3,1,4,Gen3) + 
     -            3*CW*(CA*MUE + SA*AfC(4,Gen3,Gen3))*Mdy(Gen3,1)*
     -             USfC(Sfe3,2,4,Gen3)) + 
     -         USf(Sfe4,2,4,Gen3)*
     -          (3*CW*(CA*MUEC + SA*Af(4,Gen3,Gen3))*Mdy(Gen3,1)*
     -             USfC(Sfe3,1,4,Gen3) - 
     -            2*(CB*MW*MZ*SAB*SW2 - 3*CW*SA*Mdy2(Gen3,1))*
     -             USfC(Sfe3,2,4,Gen3)))*
     -       ((-(MUEC*TB) + Af(4,Gen3,Gen3))*USf(Sfe3,2,4,Gen3)*
     -          USfC(Sfe4,1,4,Gen3) + 
     -         (MUE*TB - AfC(4,Gen3,Gen3))*USf(Sfe3,1,4,Gen3)*
     -          USfC(Sfe4,2,4,Gen3)))/(CB*CW*MW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0G0_mfv =', dse_h0G0_mfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Sfe4 = 1,2
	do Sfe3 = 1,2
	do Gen3 = 1,3

        dse_h0G0_mfv = dse_h0G0_mfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       DB0(k2,MSf2(Sfe3,2,Gen3),MSf2(Sfe4,2,Gen3))*
     -       Mf(2,Gen3)*(USf(Sfe4,1,2,Gen3)*
     -          ((CB*MW*MZ*SAB*(-1 + 2*SW2) + 2*CW*SA*Mf2(2,Gen3))*
     -             USfC(Sfe3,1,2,Gen3) + 
     -            CW*(CA*MUE + SA*AfC(2,Gen3,Gen3))*Mf(2,Gen3)*
     -             USfC(Sfe3,2,2,Gen3)) + 
     -         USf(Sfe4,2,2,Gen3)*
     -          (CW*(CA*MUEC + SA*Af(2,Gen3,Gen3))*Mf(2,Gen3)*
     -             USfC(Sfe3,1,2,Gen3) + 
     -            2*(-(CB*MW*MZ*SAB*SW2) + CW*SA*Mf2(2,Gen3))*
     -             USfC(Sfe3,2,2,Gen3)))*
     -       ((-(MUEC*TB) + Af(2,Gen3,Gen3))*USf(Sfe3,2,2,Gen3)*
     -          USfC(Sfe4,1,2,Gen3) + 
     -         (MUE*TB - AfC(2,Gen3,Gen3))*USf(Sfe3,1,2,Gen3)*
     -          USfC(Sfe4,2,2,Gen3)))/(CB*CW*MW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0G0_mfv =', dse_h0G0_mfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

	do Cha4 = 1,2
	do Cha3 = 1,2

        dup1 = SA*UCha(Cha4,2)*VCha(Cha3,1) - 
     -   CA*UCha(Cha4,1)*VCha(Cha3,2)

        dup2 = -(CB*UCha(Cha3,2)*VCha(Cha4,1)) + 
     -   SB*UCha(Cha3,1)*VCha(Cha4,2)

        dup3 = CB*UChaC(Cha4,2)*VChaC(Cha3,1) - 
     -   SB*UChaC(Cha4,1)*VChaC(Cha3,2)

        dup4 = SA*UChaC(Cha3,2)*VChaC(Cha4,1) - 
     -   CA*UChaC(Cha3,1)*VChaC(Cha4,2)

        dse_h0G0_mfv = dse_h0G0_mfv + 
     -   cI/(4.D0*Pi)*(Alfa*((dup1*dup3 + dup2*dup4)*
     -          (B1(k2,MCha2(Cha3),MCha2(Cha4)) + 
     -            k2*DB1(k2,MCha2(Cha3),MCha2(Cha4))) + 
     -         DB0(k2,MCha2(Cha3),MCha2(Cha4))*
     -          (dup3*dup4*MCha(Cha3)*MCha(Cha4) + 
     -            dup2*dup4*MCha2(Cha3) + 
     -            dup1*(dup2*MCha(Cha3)*MCha(Cha4) + 
     -               dup3*MCha2(Cha3)))))/SW2

	enddo
	enddo

	do Neu4 = 1,4
	do Neu3 = 1,4

	dup5 = SW*ZNeu(Neu3,1) - CW*ZNeu(Neu3,2)

	dup6 = SW*ZNeu(Neu4,1) - CW*ZNeu(Neu4,2)

	dup7 = -(SW*ZNeu(Neu4,1)) + CW*ZNeu(Neu4,2)

	dup8 = SA*ZNeu(Neu4,3) + CA*ZNeu(Neu4,4)

	dup9 = CB*ZNeu(Neu4,3) + SB*ZNeu(Neu4,4)

	dup10 = SW*ZNeuC(Neu3,1) - CW*ZNeuC(Neu3,2)

	dup11 = SW*ZNeuC(Neu4,1) - CW*ZNeuC(Neu4,2)

	dup12 = SA*ZNeuC(Neu4,3) + CA*ZNeuC(Neu4,4)

	dup13 = CB*ZNeuC(Neu4,3) + SB*ZNeuC(Neu4,4)

        dse_h0G0_mfv = dse_h0G0_mfv - 
     -   cI/(16.D0*Pi)*(Alfa*
     -       ((B1(k2,MNeu2(Neu3),MNeu2(Neu4)) + 
     -            k2*DB1(k2,MNeu2(Neu3),MNeu2(Neu4)))*
     -          ((dup5*dup9 + CB*dup6*ZNeu(Neu3,3) + 
     -               dup6*SB*ZNeu(Neu3,4))*
     -             (dup10*dup12 + 
     -               dup11*(SA*ZNeuC(Neu3,3) + CA*ZNeuC(Neu3,4)))+
     -              (-(dup5*dup8) + dup7*SA*ZNeu(Neu3,3) + 
     -               CA*dup7*ZNeu(Neu3,4))*
     -             (dup10*dup13 + 
     -               dup11*(CB*ZNeuC(Neu3,3) + SB*ZNeuC(Neu3,4))))+
     -           DB0(k2,MNeu2(Neu3),MNeu2(Neu4))*
     -          (MNeu(Neu3)*MNeu(Neu4)*
     -             (dup5*dup9 + CB*dup6*ZNeu(Neu3,3) + 
     -               dup6*SB*ZNeu(Neu3,4))*
     -             (dup5*dup8 - 
     -               dup7*(SA*ZNeu(Neu3,3) + CA*ZNeu(Neu3,4))) + 
     -            MNeu2(Neu3)*
     -             (dup5*dup9 + CB*dup6*ZNeu(Neu3,3) + 
     -               dup6*SB*ZNeu(Neu3,4))*
     -             (dup10*dup12 + 
     -               dup11*(SA*ZNeuC(Neu3,3) + CA*ZNeuC(Neu3,4)))+
     -              MNeu2(Neu3)*
     -             (-(dup5*dup8) + dup7*SA*ZNeu(Neu3,3) + 
     -               CA*dup7*ZNeu(Neu3,4))*
     -             (dup10*dup13 + 
     -               dup11*(CB*ZNeuC(Neu3,3) + SB*ZNeuC(Neu3,4)))-
     -              MNeu(Neu3)*MNeu(Neu4)*
     -             (dup10*dup12 + 
     -               dup11*(SA*ZNeuC(Neu3,3) + CA*ZNeuC(Neu3,4)))*
     -             (dup10*dup13 + 
     -               dup11*(CB*ZNeuC(Neu3,3) + SB*ZNeuC(Neu3,4)))))
     -       )/(CW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0G0_mfv =', dse_h0G0_mfv ENDL
#endif

	end



************************************************************************


	double complex function dse_h0G0_nmfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All3, All4, Cha3, Cha4, Gen3, Ind1, Ind2, Ind3, Ind4
	integer Neu3, Neu4, Sfe3, Sfe4, g
	double complex dup1, dup10, dup11, dup12, dup13, dup2, dup3
	double complex dup4, dup5, dup6, dup7, dup8, dup9

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_h0G0_nmfv = 0

	do All4 = g,6,g
	do All3 = g,6,g
	do Ind4 = g,3
	do Ind3 = g,3
	do Ind2 = g,3
	do Ind1 = g,3

        dse_h0G0_nmfv = dse_h0G0_nmfv + 
     -   cI/(16.D0*Pi)*(Alfa*DB0(k2,MASf2(All3,3),MASf2(All4,3))*
     -       ((Delta(Ind3,Ind4)*
     -             (MW*MZ*SAB*SB*(-3 + 4*SW2) + 
     -               6*CA*CW*Mf2(3,Ind3))*UASf(All4,Ind4,3) + 
     -            3*CW*(CA*Af(3,Ind3,Ind4) + 
     -               MUEC*SA*Delta(Ind3,Ind4))*Mf(3,Ind3)*
     -             UASf(All4,3 + Ind4,3))*UASfC(All3,Ind3,3) + 
     -         (3*CW*(MUE*SA*Delta(Ind3,Ind4)*Mf(3,Ind3) + 
     -               CA*AfC(3,Ind4,Ind3)*Mf(3,Ind4))*
     -             UASf(All4,Ind4,3) + 
     -            2*Delta(Ind3,Ind4)*
     -             (-2*MW*MZ*SAB*SB*SW2 + 3*CA*CW*Mf2(3,Ind3))*
     -             UASf(All4,3 + Ind4,3))*UASfC(All3,3 + Ind3,3))*
     -       ((TB*Af(3,Ind1,Ind2) - MUEC*Delta(Ind1,Ind2))*
     -          Mf(3,Ind1)*UASf(All3,3 + Ind2,3)*UASfC(All4,Ind1,3)
     -           + (MUE*Delta(Ind1,Ind2)*Mf(3,Ind1) - 
     -            TB*AfC(3,Ind2,Ind1)*Mf(3,Ind2))*
     -          UASf(All3,Ind2,3)*UASfC(All4,3 + Ind1,3)))/
     -     (CW*MW2*SB*SW2*TB)

	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0G0_nmfv =', dse_h0G0_nmfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do All4 = g,6,g
	do All3 = g,6,g
	do Ind4 = g,3
	do Ind3 = g,3
	do Ind2 = g,3
	do Ind1 = g,3

        dse_h0G0_nmfv = dse_h0G0_nmfv + 
     -   cI/(16.D0*Pi)*(Alfa*DB0(k2,MASf2(All3,4),MASf2(All4,4))*
     -       ((Delta(Ind3,Ind4)*
     -             (CB*MW*MZ*SAB*(-3 + 2*SW2) + 
     -               6*CW*SA*Mdy2(Ind3,1))*UASf(All4,Ind4,4) + 
     -            3*CW*(SA*Af(4,Ind3,Ind4) + 
     -               CA*MUEC*Delta(Ind3,Ind4))*Mdy(Ind3,1)*
     -             UASf(All4,3 + Ind4,4))*UASfC(All3,Ind3,4) + 
     -         (3*CW*(CA*MUE*Delta(Ind3,Ind4)*Mdy(Ind3,1) + 
     -               SA*AfC(4,Ind4,Ind3)*Mdy(Ind4,1))*
     -             UASf(All4,Ind4,4) - 
     -            2*Delta(Ind3,Ind4)*
     -             (CB*MW*MZ*SAB*SW2 - 3*CW*SA*Mdy2(Ind3,1))*
     -             UASf(All4,3 + Ind4,4))*UASfC(All3,3 + Ind3,4))*
     -       ((Af(4,Ind1,Ind2) - MUEC*TB*Delta(Ind1,Ind2))*
     -          Mdy(Ind1,1)*UASf(All3,3 + Ind2,4)*
     -          UASfC(All4,Ind1,4) + 
     -         (MUE*TB*Delta(Ind1,Ind2)*Mdy(Ind1,1) - 
     -            AfC(4,Ind2,Ind1)*Mdy(Ind2,1))*UASf(All3,Ind2,4)*
     -          UASfC(All4,3 + Ind1,4)))/(CB*CW*MW2*SW2)

	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0G0_nmfv =', dse_h0G0_nmfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Sfe4 = 1,2
	do Sfe3 = 1,2
	do Gen3 = 1,3

        dse_h0G0_nmfv = dse_h0G0_nmfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       DB0(k2,MSf2(Sfe3,2,Gen3),MSf2(Sfe4,2,Gen3))*
     -       Mf(2,Gen3)*(USf(Sfe4,1,2,Gen3)*
     -          ((CB*MW*MZ*SAB*(-1 + 2*SW2) + 2*CW*SA*Mf2(2,Gen3))*
     -             USfC(Sfe3,1,2,Gen3) + 
     -            CW*(CA*MUE + SA*AfC(2,Gen3,Gen3))*Mf(2,Gen3)*
     -             USfC(Sfe3,2,2,Gen3)) + 
     -         USf(Sfe4,2,2,Gen3)*
     -          (CW*(CA*MUEC + SA*Af(2,Gen3,Gen3))*Mf(2,Gen3)*
     -             USfC(Sfe3,1,2,Gen3) + 
     -            2*(-(CB*MW*MZ*SAB*SW2) + CW*SA*Mf2(2,Gen3))*
     -             USfC(Sfe3,2,2,Gen3)))*
     -       ((-(MUEC*TB) + Af(2,Gen3,Gen3))*USf(Sfe3,2,2,Gen3)*
     -          USfC(Sfe4,1,2,Gen3) + 
     -         (MUE*TB - AfC(2,Gen3,Gen3))*USf(Sfe3,1,2,Gen3)*
     -          USfC(Sfe4,2,2,Gen3)))/(CB*CW*MW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0G0_nmfv =', dse_h0G0_nmfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

	do Cha4 = 1,2
	do Cha3 = 1,2

        dup1 = SA*UCha(Cha4,2)*VCha(Cha3,1) - 
     -   CA*UCha(Cha4,1)*VCha(Cha3,2)

        dup2 = -(CB*UCha(Cha3,2)*VCha(Cha4,1)) + 
     -   SB*UCha(Cha3,1)*VCha(Cha4,2)

        dup3 = CB*UChaC(Cha4,2)*VChaC(Cha3,1) - 
     -   SB*UChaC(Cha4,1)*VChaC(Cha3,2)

        dup4 = SA*UChaC(Cha3,2)*VChaC(Cha4,1) - 
     -   CA*UChaC(Cha3,1)*VChaC(Cha4,2)

        dse_h0G0_nmfv = dse_h0G0_nmfv + 
     -   cI/(4.D0*Pi)*(Alfa*((dup1*dup3 + dup2*dup4)*
     -          (B1(k2,MCha2(Cha3),MCha2(Cha4)) + 
     -            k2*DB1(k2,MCha2(Cha3),MCha2(Cha4))) + 
     -         DB0(k2,MCha2(Cha3),MCha2(Cha4))*
     -          (dup3*dup4*MCha(Cha3)*MCha(Cha4) + 
     -            dup2*dup4*MCha2(Cha3) + 
     -            dup1*(dup2*MCha(Cha3)*MCha(Cha4) + 
     -               dup3*MCha2(Cha3)))))/SW2

	enddo
	enddo

	do Neu4 = 1,4
	do Neu3 = 1,4

	dup5 = SW*ZNeu(Neu3,1) - CW*ZNeu(Neu3,2)

	dup6 = SW*ZNeu(Neu4,1) - CW*ZNeu(Neu4,2)

	dup7 = -(SW*ZNeu(Neu4,1)) + CW*ZNeu(Neu4,2)

	dup8 = SA*ZNeu(Neu4,3) + CA*ZNeu(Neu4,4)

	dup9 = CB*ZNeu(Neu4,3) + SB*ZNeu(Neu4,4)

	dup10 = SW*ZNeuC(Neu3,1) - CW*ZNeuC(Neu3,2)

	dup11 = SW*ZNeuC(Neu4,1) - CW*ZNeuC(Neu4,2)

	dup12 = SA*ZNeuC(Neu4,3) + CA*ZNeuC(Neu4,4)

	dup13 = CB*ZNeuC(Neu4,3) + SB*ZNeuC(Neu4,4)

        dse_h0G0_nmfv = dse_h0G0_nmfv - 
     -   cI/(16.D0*Pi)*(Alfa*
     -       ((B1(k2,MNeu2(Neu3),MNeu2(Neu4)) + 
     -            k2*DB1(k2,MNeu2(Neu3),MNeu2(Neu4)))*
     -          ((dup5*dup9 + CB*dup6*ZNeu(Neu3,3) + 
     -               dup6*SB*ZNeu(Neu3,4))*
     -             (dup10*dup12 + 
     -               dup11*(SA*ZNeuC(Neu3,3) + CA*ZNeuC(Neu3,4)))+
     -              (-(dup5*dup8) + dup7*SA*ZNeu(Neu3,3) + 
     -               CA*dup7*ZNeu(Neu3,4))*
     -             (dup10*dup13 + 
     -               dup11*(CB*ZNeuC(Neu3,3) + SB*ZNeuC(Neu3,4))))+
     -           DB0(k2,MNeu2(Neu3),MNeu2(Neu4))*
     -          (MNeu(Neu3)*MNeu(Neu4)*
     -             (dup5*dup9 + CB*dup6*ZNeu(Neu3,3) + 
     -               dup6*SB*ZNeu(Neu3,4))*
     -             (dup5*dup8 - 
     -               dup7*(SA*ZNeu(Neu3,3) + CA*ZNeu(Neu3,4))) + 
     -            MNeu2(Neu3)*
     -             (dup5*dup9 + CB*dup6*ZNeu(Neu3,3) + 
     -               dup6*SB*ZNeu(Neu3,4))*
     -             (dup10*dup12 + 
     -               dup11*(SA*ZNeuC(Neu3,3) + CA*ZNeuC(Neu3,4)))+
     -              MNeu2(Neu3)*
     -             (-(dup5*dup8) + dup7*SA*ZNeu(Neu3,3) + 
     -               CA*dup7*ZNeu(Neu3,4))*
     -             (dup10*dup13 + 
     -               dup11*(CB*ZNeuC(Neu3,3) + SB*ZNeuC(Neu3,4)))-
     -              MNeu(Neu3)*MNeu(Neu4)*
     -             (dup10*dup12 + 
     -               dup11*(SA*ZNeuC(Neu3,3) + CA*ZNeuC(Neu3,4)))*
     -             (dup10*dup13 + 
     -               dup11*(CB*ZNeuC(Neu3,3) + SB*ZNeuC(Neu3,4)))))
     -       )/(CW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0G0_nmfv =', dse_h0G0_nmfv ENDL
#endif

	end


