* dse_h0HH.F
* this file is part of FeynHiggs
* generated 15 Jun 2008 08:42

#include "externals.h"


	double complex function dse_h0HH(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex dse_h0HH_mfv, dse_h0HH_nmfv
	external dse_h0HH_mfv, dse_h0HH_nmfv

	if( nmfv .eq. 0 ) then
	  dse_h0HH = dse_h0HH_mfv(k2)
	else
	  dse_h0HH = dse_h0HH_nmfv(k2)
	endif

#ifdef DEBUG
	print *, 'k2 =', k2
	print *, 'dse_h0HH =', dse_h0HH
#endif
	end


************************************************************************


	double complex function dse_h0HH_mfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha3, Cha4, Gen3, Neu3, Neu4, Sfe3, Sfe4, g
	double complex dup1, dup10, dup11, dup12, dup13, dup14, dup2
	double complex dup3, dup4, dup5, dup6, dup7, dup8, dup9

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_h0HH_mfv = 0

	do Gen3 = g,3

        dse_h0HH_mfv = dse_h0HH_mfv - 
     -   3/(4.D0*Pi)*(Alfa*CA*SA*Mf2(3,Gen3)*
     -       (B1(k2,Mf2(3,Gen3),Mf2(3,Gen3)) + 
     -         k2*DB1(k2,Mf2(3,Gen3),Mf2(3,Gen3)) + 
     -         2*DB0(k2,Mf2(3,Gen3),Mf2(3,Gen3))*Mf2(3,Gen3)))/
     -     (MW2*SB2*SW2)

	enddo

	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

        dse_h0HH_mfv = dse_h0HH_mfv + 
     -   1/(48.D0*Pi)*(Alfa*DB0(k2,MSf2(Sfe3,3,Gen3),
     -        MSf2(Sfe4,3,Gen3))*
     -       (USf(Sfe4,1,3,Gen3)*
     -          ((MW*MZ*SAB*SB*(-3 + 4*SW2) + 6*CA*CW*Mf2(3,Gen3))*
     -             USfC(Sfe3,1,3,Gen3) + 
     -            3*CW*(MUE*SA + CA*AfC(3,Gen3,Gen3))*Mf(3,Gen3)*
     -             USfC(Sfe3,2,3,Gen3)) + 
     -         USf(Sfe4,2,3,Gen3)*
     -          (3*CW*(MUEC*SA + CA*Af(3,Gen3,Gen3))*Mf(3,Gen3)*
     -             USfC(Sfe3,1,3,Gen3) + 
     -            2*(-2*MW*MZ*SAB*SB*SW2 + 3*CA*CW*Mf2(3,Gen3))*
     -             USfC(Sfe3,2,3,Gen3)))*
     -       (USf(Sfe3,1,3,Gen3)*
     -          ((CAB*MW*MZ*SB*(3 - 4*SW2) + 6*CW*SA*Mf2(3,Gen3))*
     -             USfC(Sfe4,1,3,Gen3) + 
     -            3*CW*(-(CA*MUE) + SA*AfC(3,Gen3,Gen3))*
     -             Mf(3,Gen3)*USfC(Sfe4,2,3,Gen3)) + 
     -         USf(Sfe3,2,3,Gen3)*
     -          (3*CW*(-(CA*MUEC) + SA*Af(3,Gen3,Gen3))*Mf(3,Gen3)*
     -             USfC(Sfe4,1,3,Gen3) + 
     -            2*(2*CAB*MW*MZ*SB*SW2 + 3*CW*SA*Mf2(3,Gen3))*
     -             USfC(Sfe4,2,3,Gen3))))/(CW2*MW2*SB2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0HH_mfv =', dse_h0HH_mfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen3 = g,3

        dse_h0HH_mfv = dse_h0HH_mfv + 
     -   3/(4.D0*Pi)*(Alfa*CA*SA*Hff(1,Gen3,1)*Hff(2,Gen3,1)*
     -       Mdy2(Gen3,1)*(B1(k2,Mf2(4,Gen3),Mf2(4,Gen3)) + 
     -         k2*DB1(k2,Mf2(4,Gen3),Mf2(4,Gen3)) + 
     -         2*DB0(k2,Mf2(4,Gen3),Mf2(4,Gen3))*Mf2(4,Gen3)))/
     -     (CB2*MW2*SW2)

	enddo

	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

        dse_h0HH_mfv = dse_h0HH_mfv - 
     -   1/(48.D0*Pi)*(Alfa*DB0(k2,MSf2(Sfe3,4,Gen3),
     -        MSf2(Sfe4,4,Gen3))*
     -       (USf(Sfe4,1,4,Gen3)*
     -          ((CB*MW*MZ*SAB*(-3 + 2*SW2) + 
     -               6*CW*SA*Mdy2(Gen3,1))*USfC(Sfe3,1,4,Gen3) + 
     -            3*CW*(CA*MUE + SA*AfC(4,Gen3,Gen3))*Mdy(Gen3,1)*
     -             USfC(Sfe3,2,4,Gen3)) + 
     -         USf(Sfe4,2,4,Gen3)*
     -          (3*CW*(CA*MUEC + SA*Af(4,Gen3,Gen3))*Mdy(Gen3,1)*
     -             USfC(Sfe3,1,4,Gen3) - 
     -            2*(CB*MW*MZ*SAB*SW2 - 3*CW*SA*Mdy2(Gen3,1))*
     -             USfC(Sfe3,2,4,Gen3)))*
     -       (USf(Sfe3,1,4,Gen3)*
     -          ((CAB*CB*MW*MZ*(-3 + 2*SW2) + 
     -               6*CA*CW*Mdy2(Gen3,1))*USfC(Sfe4,1,4,Gen3) + 
     -            3*CW*(-(MUE*SA) + CA*AfC(4,Gen3,Gen3))*
     -             Mdy(Gen3,1)*USfC(Sfe4,2,4,Gen3)) + 
     -         USf(Sfe3,2,4,Gen3)*
     -          (3*CW*(-(MUEC*SA) + CA*Af(4,Gen3,Gen3))*
     -             Mdy(Gen3,1)*USfC(Sfe4,1,4,Gen3) - 
     -            2*(CAB*CB*MW*MZ*SW2 - 3*CA*CW*Mdy2(Gen3,1))*
     -             USfC(Sfe4,2,4,Gen3))))/(CB2*CW2*MW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0HH_mfv =', dse_h0HH_mfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        dse_h0HH_mfv = dse_h0HH_mfv + 
     -   1/(16.D0*Pi)*(Alfa*(-(CAB*CB2*MW2*MZ2*SAB*
     -            DB0(k2,MSf2(1,1,Gen3),MSf2(1,1,Gen3))) + 
     -         4*CA*CW2*SA*Mf2(2,Gen3)*
     -          (B1(k2,Mf2(2,Gen3),Mf2(2,Gen3)) + 
     -            k2*DB1(k2,Mf2(2,Gen3),Mf2(2,Gen3)) + 
     -            2*DB0(k2,Mf2(2,Gen3),Mf2(2,Gen3))*Mf2(2,Gen3))))/
     -     (CB2*CW2*MW2*SW2)

	enddo

	do Sfe4 = 1,2
	do Sfe3 = 1,2
	do Gen3 = 1,3

        dse_h0HH_mfv = dse_h0HH_mfv - 
     -   1/(16.D0*Pi)*(Alfa*DB0(k2,MSf2(Sfe3,2,Gen3),
     -        MSf2(Sfe4,2,Gen3))*
     -       (USf(Sfe4,1,2,Gen3)*
     -          ((CB*MW*MZ*SAB*(-1 + 2*SW2) + 2*CW*SA*Mf2(2,Gen3))*
     -             USfC(Sfe3,1,2,Gen3) + 
     -            CW*(CA*MUE + SA*AfC(2,Gen3,Gen3))*Mf(2,Gen3)*
     -             USfC(Sfe3,2,2,Gen3)) + 
     -         USf(Sfe4,2,2,Gen3)*
     -          (CW*(CA*MUEC + SA*Af(2,Gen3,Gen3))*Mf(2,Gen3)*
     -             USfC(Sfe3,1,2,Gen3) + 
     -            2*(-(CB*MW*MZ*SAB*SW2) + CW*SA*Mf2(2,Gen3))*
     -             USfC(Sfe3,2,2,Gen3)))*
     -       (USf(Sfe3,1,2,Gen3)*
     -          ((CAB*CB*MW*MZ*(-1 + 2*SW2) + 2*CA*CW*Mf2(2,Gen3))*
     -             USfC(Sfe4,1,2,Gen3) + 
     -            CW*(-(MUE*SA) + CA*AfC(2,Gen3,Gen3))*Mf(2,Gen3)*
     -             USfC(Sfe4,2,2,Gen3)) + 
     -         USf(Sfe3,2,2,Gen3)*
     -          (CW*(-(MUEC*SA) + CA*Af(2,Gen3,Gen3))*Mf(2,Gen3)*
     -             USfC(Sfe4,1,2,Gen3) + 
     -            2*(-(CAB*CB*MW*MZ*SW2) + CA*CW*Mf2(2,Gen3))*
     -             USfC(Sfe4,2,2,Gen3))))/(CB2*CW2*MW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0HH_mfv =', dse_h0HH_mfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        dse_h0HH_mfv = dse_h0HH_mfv - 
     -   1/(32.D0*Pi)*(Alfa*(-2*
     -          (-(CAB*MW2*S2B**2*SAB) + 
     -            CBA*CW2*(k2*SBA + MA02*SBA))*DB0(k2,MA02,MZ2) + 
     -         MW2*(C2B**2*CAB*SAB*DB0(k2,MA02,MA02) + 
     -            3*C2A*SAB*(C2A*CAB - 2*S2A*SAB)*
     -             DB0(k2,Mh02,Mh02) + 
     -            (2*CAB*S2A + C2A*SAB)*
     -             (4*S2A*SAB*DB0(k2,Mh02,MHH2) + 
     -               C2A*CAB*
     -                (-2*DB0(k2,Mh02,MHH2) + 3*DB0(k2,MHH2,MHH2)))
     -              - 2*(-(C2B*CAB) + 2*CBA*CW2)*
     -             (C2B*SAB + 2*CW2*SBA)*DB0(k2,MHp2,MHp2)) - 
     -         4*(CAB*MW2*S2B*(CBA*CW2 - S2B*SAB) + 
     -            CW2*(CBA*CW2*(k2 + MHp2 - MW2) + MW2*S2B*SAB)*SBA
     -            )*DB0(k2,MHp2,MW2) + 
     -         2*(C2B**2*CAB*MW2*SAB + 
     -            CBA*CW2**2*(2*k2*SBA - 12*MW2*SBA))*
     -          DB0(k2,MW2,MW2) + 
     -         (C2B**2*CAB*MW2*SAB + 
     -            2*CBA*(-7*MW2 + CW2*(k2 + MZ2))*SBA)*
     -          DB0(k2,MZ2,MZ2) + 
     -         2*CBA*CW2*SBA*
     -          (-B0(k2,MA02,MZ2) + B0(k2,MZ2,MZ2) + 
     -            2*(B1(k2,MA02,MZ2) - B1(k2,MZ2,MZ2) + 
     -               k2*DB1(k2,MA02,MZ2)) + 
     -            2*CW2*(-B0(k2,MHp2,MW2) + B0(k2,MW2,MW2) + 
     -               2*(B1(k2,MHp2,MW2) - B1(k2,MW2,MW2) + 
     -                  k2*(DB1(k2,MHp2,MW2) - DB1(k2,MW2,MW2))))-
     -              2*k2*DB1(k2,MZ2,MZ2))))/(CW2**2*SW2)

	do Cha4 = 1,2
	do Cha3 = 1,2

        dup1 = SA*UCha(Cha4,2)*VCha(Cha3,1) - 
     -   CA*UCha(Cha4,1)*VCha(Cha3,2)

        dup2 = CA*UCha(Cha3,2)*VCha(Cha4,1) + 
     -   SA*UCha(Cha3,1)*VCha(Cha4,2)

        dup3 = CA*UChaC(Cha4,2)*VChaC(Cha3,1) + 
     -   SA*UChaC(Cha4,1)*VChaC(Cha3,2)

        dup4 = SA*UChaC(Cha3,2)*VChaC(Cha4,1) - 
     -   CA*UChaC(Cha3,1)*VChaC(Cha4,2)

        dse_h0HH_mfv = dse_h0HH_mfv + 
     -   1/(4.D0*Pi)*(Alfa*(dup1*dup3 + dup2*dup4)*
     -        (B1(k2,MCha2(Cha3),MCha2(Cha4)) + 
     -          k2*DB1(k2,MCha2(Cha3),MCha2(Cha4))) + 
     -       Alfa*DB0(k2,MCha2(Cha3),MCha2(Cha4))*
     -        (dup3*dup4*MCha(Cha3)*MCha(Cha4) + 
     -          dup2*dup4*MCha2(Cha3) + 
     -          dup1*(dup2*MCha(Cha3)*MCha(Cha4) + 
     -             dup3*MCha2(Cha3))))/SW2

	enddo
	enddo

	do Neu4 = 1,4
	do Neu3 = 1,4

	dup5 = SW*ZNeu(Neu3,1) - CW*ZNeu(Neu3,2)

	dup6 = SW*ZNeu(Neu4,1) - CW*ZNeu(Neu4,2)

	dup7 = -(SW*ZNeu(Neu4,1)) + CW*ZNeu(Neu4,2)

	dup8 = SA*ZNeu(Neu4,3) + CA*ZNeu(Neu4,4)

	dup9 = CA*ZNeu(Neu4,3) - SA*ZNeu(Neu4,4)

	dup10 = SW*ZNeuC(Neu3,1) - CW*ZNeuC(Neu3,2)

	dup11 = SW*ZNeuC(Neu4,1) - CW*ZNeuC(Neu4,2)

	dup12 = -(SW*ZNeuC(Neu4,1)) + CW*ZNeuC(Neu4,2)

	dup13 = SA*ZNeuC(Neu4,3) + CA*ZNeuC(Neu4,4)

	dup14 = CA*ZNeuC(Neu4,3) - SA*ZNeuC(Neu4,4)

        dse_h0HH_mfv = dse_h0HH_mfv + 
     -   1/(16.D0*Pi)*(Alfa*(B1(k2,MNeu2(Neu3),MNeu2(Neu4)) + 
     -          k2*DB1(k2,MNeu2(Neu3),MNeu2(Neu4)))*
     -        ((dup5*dup8 - 
     -             dup7*(SA*ZNeu(Neu3,3) + CA*ZNeu(Neu3,4)))*
     -           (dup10*dup14 + CA*dup11*ZNeuC(Neu3,3) + 
     -             dup12*SA*ZNeuC(Neu3,4)) + 
     -          (dup5*dup9 + CA*dup6*ZNeu(Neu3,3) + 
     -             dup7*SA*ZNeu(Neu3,4))*
     -           (dup10*dup13 + 
     -             dup11*(SA*ZNeuC(Neu3,3) + CA*ZNeuC(Neu3,4)))) + 
     -       Alfa*DB0(k2,MNeu2(Neu3),MNeu2(Neu4))*
     -        (MNeu(Neu3)*MNeu(Neu4)*
     -           (dup5*dup9 + CA*dup6*ZNeu(Neu3,3) + 
     -             dup7*SA*ZNeu(Neu3,4))*
     -           (dup5*dup8 - 
     -             dup7*(SA*ZNeu(Neu3,3) + CA*ZNeu(Neu3,4))) + 
     -          MNeu2(Neu3)*
     -           (dup5*dup8 - 
     -             dup7*(SA*ZNeu(Neu3,3) + CA*ZNeu(Neu3,4)))*
     -           (dup10*dup14 + CA*dup11*ZNeuC(Neu3,3) + 
     -             dup12*SA*ZNeuC(Neu3,4)) + 
     -          MNeu2(Neu3)*
     -           (dup5*dup9 + CA*dup6*ZNeu(Neu3,3) + 
     -             dup7*SA*ZNeu(Neu3,4))*
     -           (dup10*dup13 + 
     -             dup11*(SA*ZNeuC(Neu3,3) + CA*ZNeuC(Neu3,4))) + 
     -          MNeu(Neu3)*MNeu(Neu4)*
     -           (dup10*dup14 + CA*dup11*ZNeuC(Neu3,3) + 
     -             dup12*SA*ZNeuC(Neu3,4))*
     -           (dup10*dup13 + 
     -             dup11*(SA*ZNeuC(Neu3,3) + CA*ZNeuC(Neu3,4)))))/
     -     (CW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0HH_mfv =', dse_h0HH_mfv ENDL
#endif

	end



************************************************************************


	double complex function dse_h0HH_nmfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All3, All4, Cha3, Cha4, Gen3, Ind1, Ind2, Ind3, Ind4
	integer Neu3, Neu4, Sfe3, Sfe4, g
	double complex dup1, dup10, dup11, dup12, dup13, dup14, dup2
	double complex dup3, dup4, dup5, dup6, dup7, dup8, dup9

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_h0HH_nmfv = 0

	do Gen3 = g,3

        dse_h0HH_nmfv = dse_h0HH_nmfv - 
     -   3/(4.D0*Pi)*(Alfa*CA*SA*Mf2(3,Gen3)*
     -       (B1(k2,Mf2(3,Gen3),Mf2(3,Gen3)) + 
     -         k2*DB1(k2,Mf2(3,Gen3),Mf2(3,Gen3)) + 
     -         2*DB0(k2,Mf2(3,Gen3),Mf2(3,Gen3))*Mf2(3,Gen3)))/
     -     (MW2*SB2*SW2)

	enddo

	do All4 = g,6,g
	do All3 = g,6,g
	do Ind4 = g,3
	do Ind3 = g,3
	do Ind2 = g,3
	do Ind1 = g,3

        dse_h0HH_nmfv = dse_h0HH_nmfv + 
     -   1/(48.D0*Pi)*(Alfa*DB0(k2,MASf2(All3,3),MASf2(All4,3))*
     -       ((Delta(Ind1,Ind2)*
     -             (MW*MZ*SAB*SB*(-3 + 4*SW2) + 
     -               6*CA*CW*Mf2(3,Ind1))*UASf(All4,Ind2,3) + 
     -            3*CW*(CA*Af(3,Ind1,Ind2) + 
     -               MUEC*SA*Delta(Ind1,Ind2))*Mf(3,Ind1)*
     -             UASf(All4,3 + Ind2,3))*UASfC(All3,Ind1,3) + 
     -         (3*CW*(MUE*SA*Delta(Ind1,Ind2)*Mf(3,Ind1) + 
     -               CA*AfC(3,Ind2,Ind1)*Mf(3,Ind2))*
     -             UASf(All4,Ind2,3) + 
     -            2*Delta(Ind1,Ind2)*
     -             (-2*MW*MZ*SAB*SB*SW2 + 3*CA*CW*Mf2(3,Ind1))*
     -             UASf(All4,3 + Ind2,3))*UASfC(All3,3 + Ind1,3))*
     -       ((Delta(Ind3,Ind4)*
     -             (CAB*MW*MZ*SB*(3 - 4*SW2) + 
     -               6*CW*SA*Mf2(3,Ind3))*UASf(All3,Ind4,3) + 
     -            3*CW*(SA*Af(3,Ind3,Ind4) - 
     -               CA*MUEC*Delta(Ind3,Ind4))*Mf(3,Ind3)*
     -             UASf(All3,3 + Ind4,3))*UASfC(All4,Ind3,3) + 
     -         (3*CW*(-(CA*MUE*Delta(Ind3,Ind4)*Mf(3,Ind3)) + 
     -               SA*AfC(3,Ind4,Ind3)*Mf(3,Ind4))*
     -             UASf(All3,Ind4,3) + 
     -            2*Delta(Ind3,Ind4)*
     -             (2*CAB*MW*MZ*SB*SW2 + 3*CW*SA*Mf2(3,Ind3))*
     -             UASf(All3,3 + Ind4,3))*UASfC(All4,3 + Ind3,3)))/
     -     (CW2*MW2*SB2*SW2)

	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0HH_nmfv =', dse_h0HH_nmfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen3 = g,3

        dse_h0HH_nmfv = dse_h0HH_nmfv + 
     -   3/(4.D0*Pi)*(Alfa*CA*SA*Hff(1,Gen3,1)*Hff(2,Gen3,1)*
     -       Mdy2(Gen3,1)*(B1(k2,Mf2(4,Gen3),Mf2(4,Gen3)) + 
     -         k2*DB1(k2,Mf2(4,Gen3),Mf2(4,Gen3)) + 
     -         2*DB0(k2,Mf2(4,Gen3),Mf2(4,Gen3))*Mf2(4,Gen3)))/
     -     (CB2*MW2*SW2)

	enddo

	do All4 = g,6,g
	do All3 = g,6,g
	do Ind4 = g,3
	do Ind3 = g,3
	do Ind2 = g,3
	do Ind1 = g,3

        dse_h0HH_nmfv = dse_h0HH_nmfv - 
     -   1/(48.D0*Pi)*(Alfa*DB0(k2,MASf2(All3,4),MASf2(All4,4))*
     -       ((Delta(Ind1,Ind2)*
     -             (CB*MW*MZ*SAB*(-3 + 2*SW2) + 
     -               6*CW*SA*Mdy2(Ind1,1))*UASf(All4,Ind2,4) + 
     -            3*CW*(SA*Af(4,Ind1,Ind2) + 
     -               CA*MUEC*Delta(Ind1,Ind2))*Mdy(Ind1,1)*
     -             UASf(All4,3 + Ind2,4))*UASfC(All3,Ind1,4) + 
     -         (3*CW*(CA*MUE*Delta(Ind1,Ind2)*Mdy(Ind1,1) + 
     -               SA*AfC(4,Ind2,Ind1)*Mdy(Ind2,1))*
     -             UASf(All4,Ind2,4) - 
     -            2*Delta(Ind1,Ind2)*
     -             (CB*MW*MZ*SAB*SW2 - 3*CW*SA*Mdy2(Ind1,1))*
     -             UASf(All4,3 + Ind2,4))*UASfC(All3,3 + Ind1,4))*
     -       ((Delta(Ind3,Ind4)*
     -             (CAB*CB*MW*MZ*(-3 + 2*SW2) + 
     -               6*CA*CW*Mdy2(Ind3,1))*UASf(All3,Ind4,4) + 
     -            3*CW*(CA*Af(4,Ind3,Ind4) - 
     -               MUEC*SA*Delta(Ind3,Ind4))*Mdy(Ind3,1)*
     -             UASf(All3,3 + Ind4,4))*UASfC(All4,Ind3,4) + 
     -         (3*CW*(-(MUE*SA*Delta(Ind3,Ind4)*Mdy(Ind3,1)) + 
     -               CA*AfC(4,Ind4,Ind3)*Mdy(Ind4,1))*
     -             UASf(All3,Ind4,4) - 
     -            2*Delta(Ind3,Ind4)*
     -             (CAB*CB*MW*MZ*SW2 - 3*CA*CW*Mdy2(Ind3,1))*
     -             UASf(All3,3 + Ind4,4))*UASfC(All4,3 + Ind3,4)))/
     -     (CB2*CW2*MW2*SW2)

	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0HH_nmfv =', dse_h0HH_nmfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        dse_h0HH_nmfv = dse_h0HH_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*(-(CAB*CB2*MW2*MZ2*SAB*
     -            DB0(k2,MSf2(1,1,Gen3),MSf2(1,1,Gen3))) + 
     -         4*CA*CW2*SA*Mf2(2,Gen3)*
     -          (B1(k2,Mf2(2,Gen3),Mf2(2,Gen3)) + 
     -            k2*DB1(k2,Mf2(2,Gen3),Mf2(2,Gen3)) + 
     -            2*DB0(k2,Mf2(2,Gen3),Mf2(2,Gen3))*Mf2(2,Gen3))))/
     -     (CB2*CW2*MW2*SW2)

	enddo

	do Sfe4 = 1,2
	do Sfe3 = 1,2
	do Gen3 = 1,3

        dse_h0HH_nmfv = dse_h0HH_nmfv - 
     -   1/(16.D0*Pi)*(Alfa*DB0(k2,MSf2(Sfe3,2,Gen3),
     -        MSf2(Sfe4,2,Gen3))*
     -       (USf(Sfe4,1,2,Gen3)*
     -          ((CB*MW*MZ*SAB*(-1 + 2*SW2) + 2*CW*SA*Mf2(2,Gen3))*
     -             USfC(Sfe3,1,2,Gen3) + 
     -            CW*(CA*MUE + SA*AfC(2,Gen3,Gen3))*Mf(2,Gen3)*
     -             USfC(Sfe3,2,2,Gen3)) + 
     -         USf(Sfe4,2,2,Gen3)*
     -          (CW*(CA*MUEC + SA*Af(2,Gen3,Gen3))*Mf(2,Gen3)*
     -             USfC(Sfe3,1,2,Gen3) + 
     -            2*(-(CB*MW*MZ*SAB*SW2) + CW*SA*Mf2(2,Gen3))*
     -             USfC(Sfe3,2,2,Gen3)))*
     -       (USf(Sfe3,1,2,Gen3)*
     -          ((CAB*CB*MW*MZ*(-1 + 2*SW2) + 2*CA*CW*Mf2(2,Gen3))*
     -             USfC(Sfe4,1,2,Gen3) + 
     -            CW*(-(MUE*SA) + CA*AfC(2,Gen3,Gen3))*Mf(2,Gen3)*
     -             USfC(Sfe4,2,2,Gen3)) + 
     -         USf(Sfe3,2,2,Gen3)*
     -          (CW*(-(MUEC*SA) + CA*Af(2,Gen3,Gen3))*Mf(2,Gen3)*
     -             USfC(Sfe4,1,2,Gen3) + 
     -            2*(-(CAB*CB*MW*MZ*SW2) + CA*CW*Mf2(2,Gen3))*
     -             USfC(Sfe4,2,2,Gen3))))/(CB2*CW2*MW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0HH_nmfv =', dse_h0HH_nmfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        dse_h0HH_nmfv = dse_h0HH_nmfv - 
     -   1/(32.D0*Pi)*(Alfa*(-2*
     -          (-(CAB*MW2*S2B**2*SAB) + 
     -            CBA*CW2*(k2*SBA + MA02*SBA))*DB0(k2,MA02,MZ2) + 
     -         MW2*(C2B**2*CAB*SAB*DB0(k2,MA02,MA02) + 
     -            3*C2A*SAB*(C2A*CAB - 2*S2A*SAB)*
     -             DB0(k2,Mh02,Mh02) + 
     -            (2*CAB*S2A + C2A*SAB)*
     -             (4*S2A*SAB*DB0(k2,Mh02,MHH2) + 
     -               C2A*CAB*
     -                (-2*DB0(k2,Mh02,MHH2) + 3*DB0(k2,MHH2,MHH2)))
     -              - 2*(-(C2B*CAB) + 2*CBA*CW2)*
     -             (C2B*SAB + 2*CW2*SBA)*DB0(k2,MHp2,MHp2)) - 
     -         4*(CAB*MW2*S2B*(CBA*CW2 - S2B*SAB) + 
     -            CW2*(CBA*CW2*(k2 + MHp2 - MW2) + MW2*S2B*SAB)*SBA
     -            )*DB0(k2,MHp2,MW2) + 
     -         2*(C2B**2*CAB*MW2*SAB + 
     -            CBA*CW2**2*(2*k2*SBA - 12*MW2*SBA))*
     -          DB0(k2,MW2,MW2) + 
     -         (C2B**2*CAB*MW2*SAB + 
     -            2*CBA*(-7*MW2 + CW2*(k2 + MZ2))*SBA)*
     -          DB0(k2,MZ2,MZ2) + 
     -         2*CBA*CW2*SBA*
     -          (-B0(k2,MA02,MZ2) + B0(k2,MZ2,MZ2) + 
     -            2*(B1(k2,MA02,MZ2) - B1(k2,MZ2,MZ2) + 
     -               k2*DB1(k2,MA02,MZ2)) + 
     -            2*CW2*(-B0(k2,MHp2,MW2) + B0(k2,MW2,MW2) + 
     -               2*(B1(k2,MHp2,MW2) - B1(k2,MW2,MW2) + 
     -                  k2*(DB1(k2,MHp2,MW2) - DB1(k2,MW2,MW2))))-
     -              2*k2*DB1(k2,MZ2,MZ2))))/(CW2**2*SW2)

	do Cha4 = 1,2
	do Cha3 = 1,2

        dup1 = SA*UCha(Cha4,2)*VCha(Cha3,1) - 
     -   CA*UCha(Cha4,1)*VCha(Cha3,2)

        dup2 = CA*UCha(Cha3,2)*VCha(Cha4,1) + 
     -   SA*UCha(Cha3,1)*VCha(Cha4,2)

        dup3 = CA*UChaC(Cha4,2)*VChaC(Cha3,1) + 
     -   SA*UChaC(Cha4,1)*VChaC(Cha3,2)

        dup4 = SA*UChaC(Cha3,2)*VChaC(Cha4,1) - 
     -   CA*UChaC(Cha3,1)*VChaC(Cha4,2)

        dse_h0HH_nmfv = dse_h0HH_nmfv + 
     -   1/(4.D0*Pi)*(Alfa*(dup1*dup3 + dup2*dup4)*
     -        (B1(k2,MCha2(Cha3),MCha2(Cha4)) + 
     -          k2*DB1(k2,MCha2(Cha3),MCha2(Cha4))) + 
     -       Alfa*DB0(k2,MCha2(Cha3),MCha2(Cha4))*
     -        (dup3*dup4*MCha(Cha3)*MCha(Cha4) + 
     -          dup2*dup4*MCha2(Cha3) + 
     -          dup1*(dup2*MCha(Cha3)*MCha(Cha4) + 
     -             dup3*MCha2(Cha3))))/SW2

	enddo
	enddo

	do Neu4 = 1,4
	do Neu3 = 1,4

	dup5 = SW*ZNeu(Neu3,1) - CW*ZNeu(Neu3,2)

	dup6 = SW*ZNeu(Neu4,1) - CW*ZNeu(Neu4,2)

	dup7 = -(SW*ZNeu(Neu4,1)) + CW*ZNeu(Neu4,2)

	dup8 = SA*ZNeu(Neu4,3) + CA*ZNeu(Neu4,4)

	dup9 = CA*ZNeu(Neu4,3) - SA*ZNeu(Neu4,4)

	dup10 = SW*ZNeuC(Neu3,1) - CW*ZNeuC(Neu3,2)

	dup11 = SW*ZNeuC(Neu4,1) - CW*ZNeuC(Neu4,2)

	dup12 = -(SW*ZNeuC(Neu4,1)) + CW*ZNeuC(Neu4,2)

	dup13 = SA*ZNeuC(Neu4,3) + CA*ZNeuC(Neu4,4)

	dup14 = CA*ZNeuC(Neu4,3) - SA*ZNeuC(Neu4,4)

        dse_h0HH_nmfv = dse_h0HH_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*(B1(k2,MNeu2(Neu3),MNeu2(Neu4)) + 
     -          k2*DB1(k2,MNeu2(Neu3),MNeu2(Neu4)))*
     -        ((dup5*dup8 - 
     -             dup7*(SA*ZNeu(Neu3,3) + CA*ZNeu(Neu3,4)))*
     -           (dup10*dup14 + CA*dup11*ZNeuC(Neu3,3) + 
     -             dup12*SA*ZNeuC(Neu3,4)) + 
     -          (dup5*dup9 + CA*dup6*ZNeu(Neu3,3) + 
     -             dup7*SA*ZNeu(Neu3,4))*
     -           (dup10*dup13 + 
     -             dup11*(SA*ZNeuC(Neu3,3) + CA*ZNeuC(Neu3,4)))) + 
     -       Alfa*DB0(k2,MNeu2(Neu3),MNeu2(Neu4))*
     -        (MNeu(Neu3)*MNeu(Neu4)*
     -           (dup5*dup9 + CA*dup6*ZNeu(Neu3,3) + 
     -             dup7*SA*ZNeu(Neu3,4))*
     -           (dup5*dup8 - 
     -             dup7*(SA*ZNeu(Neu3,3) + CA*ZNeu(Neu3,4))) + 
     -          MNeu2(Neu3)*
     -           (dup5*dup8 - 
     -             dup7*(SA*ZNeu(Neu3,3) + CA*ZNeu(Neu3,4)))*
     -           (dup10*dup14 + CA*dup11*ZNeuC(Neu3,3) + 
     -             dup12*SA*ZNeuC(Neu3,4)) + 
     -          MNeu2(Neu3)*
     -           (dup5*dup9 + CA*dup6*ZNeu(Neu3,3) + 
     -             dup7*SA*ZNeu(Neu3,4))*
     -           (dup10*dup13 + 
     -             dup11*(SA*ZNeuC(Neu3,3) + CA*ZNeuC(Neu3,4))) + 
     -          MNeu(Neu3)*MNeu(Neu4)*
     -           (dup10*dup14 + CA*dup11*ZNeuC(Neu3,3) + 
     -             dup12*SA*ZNeuC(Neu3,4))*
     -           (dup10*dup13 + 
     -             dup11*(SA*ZNeuC(Neu3,3) + CA*ZNeuC(Neu3,4)))))/
     -     (CW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_h0HH_nmfv =', dse_h0HH_nmfv ENDL
#endif

	end


