* se_G0G0.F
* this file is part of FeynHiggs
* generated 15 Jun 2008 08:42

#include "externals.h"


	double complex function se_G0G0(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex se_G0G0_mfv, se_G0G0_nmfv
	external se_G0G0_mfv, se_G0G0_nmfv

	if( nmfv .eq. 0 ) then
	  se_G0G0 = se_G0G0_mfv(k2)
	else
	  se_G0G0 = se_G0G0_nmfv(k2)
	endif

#ifdef DEBUG
	print *, 'k2 =', k2
	print *, 'se_G0G0 =', se_G0G0
#endif
	end


************************************************************************


	double complex function se_G0G0_mfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha3, Cha4, Gen3, Neu3, Neu4, Sfe3, Sfe4, g
	double complex dup1, dup10, dup2, dup3, dup4, dup5, dup6, dup7
	double complex dup8, dup9

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	se_G0G0_mfv = 0

	do Gen3 = g,3

        se_G0G0_mfv = se_G0G0_mfv - 
     -   3/(4.D0*Pi)*(Alfa*(A0(Mf2(3,Gen3)) + 
     -         k2*B1(k2,Mf2(3,Gen3),Mf2(3,Gen3)))*Mf2(3,Gen3))/
     -     (MW2*SW2)

	enddo

	do Gen3 = g,3
	do Sfe3 = 1,2

        se_G0G0_mfv = se_G0G0_mfv + 
     -   1/(16.D0*Pi)*(Alfa*A0(MSf2(Sfe3,3,Gen3))*
     -       ((C2B*MW2*(3 - 4*SW2) + 6*CW2*Mf2(3,Gen3))*
     -          USf(Sfe3,1,3,Gen3)*USfC(Sfe3,1,3,Gen3) + 
     -         2*(2*C2B*MW2*SW2 + 3*CW2*Mf2(3,Gen3))*
     -          USf(Sfe3,2,3,Gen3)*USfC(Sfe3,2,3,Gen3)))/
     -     (CW2*MW2*SW2)

	enddo
	enddo

	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

        se_G0G0_mfv = se_G0G0_mfv - 
     -   3/(16.D0*Pi)*(Alfa*B0(k2,MSf2(Sfe3,3,Gen3),
     -        MSf2(Sfe4,3,Gen3))*Mf2(3,Gen3)*
     -       ((-MUEC + TB*Af(3,Gen3,Gen3))*USf(Sfe4,2,3,Gen3)*
     -          USfC(Sfe3,1,3,Gen3) + 
     -         (MUE - TB*AfC(3,Gen3,Gen3))*USf(Sfe4,1,3,Gen3)*
     -          USfC(Sfe3,2,3,Gen3))*
     -       ((-MUEC + TB*Af(3,Gen3,Gen3))*USf(Sfe3,2,3,Gen3)*
     -          USfC(Sfe4,1,3,Gen3) + 
     -         (MUE - TB*AfC(3,Gen3,Gen3))*USf(Sfe3,1,3,Gen3)*
     -          USfC(Sfe4,2,3,Gen3)))/(MW2*SW2*TB2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_G0G0_mfv =', se_G0G0_mfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen3 = g,3

        se_G0G0_mfv = se_G0G0_mfv - 
     -   3/(4.D0*Pi)*(Alfa*(A0(Mf2(4,Gen3)) + 
     -         k2*B1(k2,Mf2(4,Gen3),Mf2(4,Gen3)))*Mf2(4,Gen3))/
     -     (MW2*SW2)

	enddo

	do Gen3 = g,3
	do Sfe3 = 1,2

        se_G0G0_mfv = se_G0G0_mfv + 
     -   1/(16.D0*Pi)*(Alfa*A0(MSf2(Sfe3,4,Gen3))*
     -       ((C2B*MW2*(-3 + 2*SW2) + 6*CW2*Mdy2(Gen3,1))*
     -          USf(Sfe3,1,4,Gen3)*USfC(Sfe3,1,4,Gen3) - 
     -         2*(C2B*MW2*SW2 - 3*CW2*Mdy2(Gen3,1))*
     -          USf(Sfe3,2,4,Gen3)*USfC(Sfe3,2,4,Gen3)))/
     -     (CW2*MW2*SW2)

	enddo
	enddo

	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

        se_G0G0_mfv = se_G0G0_mfv - 
     -   3/(16.D0*Pi)*(Alfa*B0(k2,MSf2(Sfe3,4,Gen3),
     -        MSf2(Sfe4,4,Gen3))*Mdy2(Gen3,1)*
     -       ((-(MUEC*TB) + Af(4,Gen3,Gen3))*USf(Sfe4,2,4,Gen3)*
     -          USfC(Sfe3,1,4,Gen3) + 
     -         (MUE*TB - AfC(4,Gen3,Gen3))*USf(Sfe4,1,4,Gen3)*
     -          USfC(Sfe3,2,4,Gen3))*
     -       ((-(MUEC*TB) + Af(4,Gen3,Gen3))*USf(Sfe3,2,4,Gen3)*
     -          USfC(Sfe4,1,4,Gen3) + 
     -         (MUE*TB - AfC(4,Gen3,Gen3))*USf(Sfe3,1,4,Gen3)*
     -          USfC(Sfe4,2,4,Gen3)))/(MW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_G0G0_mfv =', se_G0G0_mfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        se_G0G0_mfv = se_G0G0_mfv + 
     -   1/(16.D0*Pi)*(Alfa*(C2B*MW2*A0(MSf2(1,1,Gen3)) - 
     -         4*CW2*(A0(Mf2(2,Gen3)) + 
     -            k2*B1(k2,Mf2(2,Gen3),Mf2(2,Gen3)))*Mf2(2,Gen3)))/
     -     (CW2*MW2*SW2)

	enddo

	do Sfe3 = 1,2
	do Gen3 = 1,3

        se_G0G0_mfv = se_G0G0_mfv + 
     -   1/(16.D0*Pi)*(Alfa*A0(MSf2(Sfe3,2,Gen3))*
     -       ((C2B*MW2*(-1 + 2*SW2) + 2*CW2*Mf2(2,Gen3))*
     -          USf(Sfe3,1,2,Gen3)*USfC(Sfe3,1,2,Gen3) + 
     -         2*(-(C2B*MW2*SW2) + CW2*Mf2(2,Gen3))*
     -          USf(Sfe3,2,2,Gen3)*USfC(Sfe3,2,2,Gen3)))/
     -     (CW2*MW2*SW2)

	enddo
	enddo

	do Sfe4 = 1,2
	do Sfe3 = 1,2
	do Gen3 = 1,3

        se_G0G0_mfv = se_G0G0_mfv - 
     -   1/(16.D0*Pi)*(Alfa*B0(k2,MSf2(Sfe3,2,Gen3),
     -        MSf2(Sfe4,2,Gen3))*Mf2(2,Gen3)*
     -       ((-(MUEC*TB) + Af(2,Gen3,Gen3))*USf(Sfe4,2,2,Gen3)*
     -          USfC(Sfe3,1,2,Gen3) + 
     -         (MUE*TB - AfC(2,Gen3,Gen3))*USf(Sfe4,1,2,Gen3)*
     -          USfC(Sfe3,2,2,Gen3))*
     -       ((-(MUEC*TB) + Af(2,Gen3,Gen3))*USf(Sfe3,2,2,Gen3)*
     -          USfC(Sfe4,1,2,Gen3) + 
     -         (MUE*TB - AfC(2,Gen3,Gen3))*USf(Sfe3,1,2,Gen3)*
     -          USfC(Sfe4,2,2,Gen3)))/(MW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_G0G0_mfv =', se_G0G0_mfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        se_G0G0_mfv = se_G0G0_mfv + 
     -   1/(32.D0*Pi)*(Alfa*(2*
     -          (MW2*S2B**2*
     -             (SAB**2*B0(k2,MA02,Mh02) + 
     -               CAB**2*B0(k2,MA02,MHH2)) + 
     -            (C2B**2*MW2*SAB**2 + 
     -               CW2*(-(k2*SBA**2) - Mh02*SBA**2))*
     -             B0(k2,Mh02,MZ2) - 
     -            (CBA**2*CW2*(k2 + MHH2) - C2B**2*CAB**2*MW2)*
     -             B0(k2,MHH2,MZ2)) + 
     -         CW2*((-1 + 3*S2B**2)*A0(MA02) + 
     -            C2A*C2B*(-A0(Mh02) + A0(MHH2)) + 
     -            2*(CW2*(1 + S2B**2) - C2B**2*SW2)*A0(MHp2) + 
     -            2*(C2B**2 + 6*CW2)*A0(MW2) + 
     -            3*(2 + C2B**2)*A0(MZ2) + 
     -            4*k2*(SBA**2*B1(k2,Mh02,MZ2) + 
     -               CBA**2*B1(k2,MHH2,MZ2) + 
     -               CW2*(-B0(k2,MW2,MW2) + 2*B1(k2,MW2,MW2))))))/
     -     (CW2**2*SW2)

	do Cha4 = 1,2
	do Cha3 = 1,2

        dup1 = -(CB*UCha(Cha4,2)*VCha(Cha3,1)) + 
     -   SB*UCha(Cha4,1)*VCha(Cha3,2)

        dup2 = -(CB*UCha(Cha3,2)*VCha(Cha4,1)) + 
     -   SB*UCha(Cha3,1)*VCha(Cha4,2)

        dup3 = CB*UChaC(Cha4,2)*VChaC(Cha3,1) - 
     -   SB*UChaC(Cha4,1)*VChaC(Cha3,2)

        dup4 = CB*UChaC(Cha3,2)*VChaC(Cha4,1) - 
     -   SB*UChaC(Cha3,1)*VChaC(Cha4,2)

        se_G0G0_mfv = se_G0G0_mfv + 
     -   1/(4.D0*Pi)*(Alfa*(dup1*dup3 + dup2*dup4)*
     -        (A0(MCha2(Cha4)) + k2*B1(k2,MCha2(Cha3),MCha2(Cha4)))
     -         + Alfa*B0(k2,MCha2(Cha3),MCha2(Cha4))*
     -        (dup3*dup4*MCha(Cha3)*MCha(Cha4) + 
     -          dup1*dup3*MCha2(Cha3) + dup2*dup4*MCha2(Cha3) + 
     -          MCha(Cha3)*MCha(Cha4)*
     -           (CB*UCha(Cha4,2)*VCha(Cha3,1) - 
     -             SB*UCha(Cha4,1)*VCha(Cha3,2))*
     -           (CB*UCha(Cha3,2)*VCha(Cha4,1) - 
     -             SB*UCha(Cha3,1)*VCha(Cha4,2))))/SW2

	enddo
	enddo

	do Neu4 = 1,4
	do Neu3 = 1,4

	dup5 = SW*ZNeu(Neu3,1) - CW*ZNeu(Neu3,2)

	dup6 = SW*ZNeu(Neu4,1) - CW*ZNeu(Neu4,2)

	dup7 = CB*ZNeu(Neu4,3) + SB*ZNeu(Neu4,4)

	dup8 = SW*ZNeuC(Neu3,1) - CW*ZNeuC(Neu3,2)

	dup9 = SW*ZNeuC(Neu4,1) - CW*ZNeuC(Neu4,2)

	dup10 = CB*ZNeuC(Neu4,3) + SB*ZNeuC(Neu4,4)

        se_G0G0_mfv = se_G0G0_mfv + 
     -   1/(16.D0*Pi)*(-2*Alfa*
     -        (A0(MNeu2(Neu4)) + 
     -          k2*B1(k2,MNeu2(Neu3),MNeu2(Neu4)))*
     -        (dup5*dup7 + CB*dup6*ZNeu(Neu3,3) + 
     -          dup6*SB*ZNeu(Neu3,4))*
     -        (dup10*dup8 + CB*dup9*ZNeuC(Neu3,3) + 
     -          dup9*SB*ZNeuC(Neu3,4)) + 
     -       Alfa*B0(k2,MNeu2(Neu3),MNeu2(Neu4))*
     -        (MNeu(Neu3)*MNeu(Neu4)*
     -           (dup5*dup7 + CB*dup6*ZNeu(Neu3,3) + 
     -              dup6*SB*ZNeu(Neu3,4))**2 - 
     -          2*MNeu2(Neu3)*
     -           (dup5*dup7 + CB*dup6*ZNeu(Neu3,3) + 
     -             dup6*SB*ZNeu(Neu3,4))*
     -           (dup10*dup8 + CB*dup9*ZNeuC(Neu3,3) + 
     -             dup9*SB*ZNeuC(Neu3,4)) + 
     -          MNeu(Neu3)*MNeu(Neu4)*
     -           (dup10*dup8 + CB*dup9*ZNeuC(Neu3,3) + 
     -              dup9*SB*ZNeuC(Neu3,4))**2))/(CW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_G0G0_mfv =', se_G0G0_mfv ENDL
#endif

	end



************************************************************************


	double complex function se_G0G0_nmfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All3, All4, Cha3, Cha4, Gen3, Ind1, Ind2, Ind3, Ind4
	integer Neu3, Neu4, Sfe3, Sfe4, g
	double complex dup1, dup10, dup2, dup3, dup4, dup5, dup6, dup7
	double complex dup8, dup9

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	se_G0G0_nmfv = 0

	do Gen3 = g,3

        se_G0G0_nmfv = se_G0G0_nmfv - 
     -   3/(4.D0*Pi)*(Alfa*(A0(Mf2(3,Gen3)) + 
     -         k2*B1(k2,Mf2(3,Gen3),Mf2(3,Gen3)))*Mf2(3,Gen3))/
     -     (MW2*SW2)

	enddo

	do All3 = g,6,g
	do Ind1 = g,3

        se_G0G0_nmfv = se_G0G0_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*A0(MASf2(All3,3))*
     -       ((C2B*MW2*(3 - 4*SW2) + 6*CW2*Mf2(3,Ind1))*
     -          UASf(All3,Ind1,3)*UASfC(All3,Ind1,3) + 
     -         2*(2*C2B*MW2*SW2 + 3*CW2*Mf2(3,Ind1))*
     -          UASf(All3,3 + Ind1,3)*UASfC(All3,3 + Ind1,3)))/
     -     (CW2*MW2*SW2)

	enddo
	enddo

	do All4 = g,6,g
	do All3 = g,6,g
	do Ind4 = g,3
	do Ind3 = g,3
	do Ind2 = g,3
	do Ind1 = g,3

        se_G0G0_nmfv = se_G0G0_nmfv - 
     -   3/(16.D0*Pi)*(Alfa*B0(k2,MASf2(All3,3),MASf2(All4,3))*
     -       ((TB*Af(3,Ind1,Ind2) - MUEC*Delta(Ind1,Ind2))*
     -          Mf(3,Ind1)*UASf(All4,3 + Ind2,3)*UASfC(All3,Ind1,3)
     -           + (MUE*Delta(Ind1,Ind2)*Mf(3,Ind1) - 
     -            TB*AfC(3,Ind2,Ind1)*Mf(3,Ind2))*
     -          UASf(All4,Ind2,3)*UASfC(All3,3 + Ind1,3))*
     -       ((TB*Af(3,Ind3,Ind4) - MUEC*Delta(Ind3,Ind4))*
     -          Mf(3,Ind3)*UASf(All3,3 + Ind4,3)*UASfC(All4,Ind3,3)
     -           + (MUE*Delta(Ind3,Ind4)*Mf(3,Ind3) - 
     -            TB*AfC(3,Ind4,Ind3)*Mf(3,Ind4))*
     -          UASf(All3,Ind4,3)*UASfC(All4,3 + Ind3,3)))/
     -     (MW2*SW2*TB2)

	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_G0G0_nmfv =', se_G0G0_nmfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen3 = g,3

        se_G0G0_nmfv = se_G0G0_nmfv - 
     -   3/(4.D0*Pi)*(Alfa*(A0(Mf2(4,Gen3)) + 
     -         k2*B1(k2,Mf2(4,Gen3),Mf2(4,Gen3)))*Mf2(4,Gen3))/
     -     (MW2*SW2)

	enddo

	do All3 = g,6,g
	do Ind1 = g,3

        se_G0G0_nmfv = se_G0G0_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*A0(MASf2(All3,4))*
     -       ((C2B*MW2*(-3 + 2*SW2) + 6*CW2*Mdy2(Ind1,1))*
     -          UASf(All3,Ind1,4)*UASfC(All3,Ind1,4) - 
     -         2*(C2B*MW2*SW2 - 3*CW2*Mdy2(Ind1,1))*
     -          UASf(All3,3 + Ind1,4)*UASfC(All3,3 + Ind1,4)))/
     -     (CW2*MW2*SW2)

	enddo
	enddo

	do All4 = g,6,g
	do All3 = g,6,g
	do Ind4 = g,3
	do Ind3 = g,3
	do Ind2 = g,3
	do Ind1 = g,3

        se_G0G0_nmfv = se_G0G0_nmfv - 
     -   3/(16.D0*Pi)*(Alfa*B0(k2,MASf2(All3,4),MASf2(All4,4))*
     -       ((Af(4,Ind1,Ind2) - MUEC*TB*Delta(Ind1,Ind2))*
     -          Mdy(Ind1,1)*UASf(All4,3 + Ind2,4)*
     -          UASfC(All3,Ind1,4) + 
     -         (MUE*TB*Delta(Ind1,Ind2)*Mdy(Ind1,1) - 
     -            AfC(4,Ind2,Ind1)*Mdy(Ind2,1))*UASf(All4,Ind2,4)*
     -          UASfC(All3,3 + Ind1,4))*
     -       ((Af(4,Ind3,Ind4) - MUEC*TB*Delta(Ind3,Ind4))*
     -          Mdy(Ind3,1)*UASf(All3,3 + Ind4,4)*
     -          UASfC(All4,Ind3,4) + 
     -         (MUE*TB*Delta(Ind3,Ind4)*Mdy(Ind3,1) - 
     -            AfC(4,Ind4,Ind3)*Mdy(Ind4,1))*UASf(All3,Ind4,4)*
     -          UASfC(All4,3 + Ind3,4)))/(MW2*SW2)

	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_G0G0_nmfv =', se_G0G0_nmfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        se_G0G0_nmfv = se_G0G0_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*(C2B*MW2*A0(MSf2(1,1,Gen3)) - 
     -         4*CW2*(A0(Mf2(2,Gen3)) + 
     -            k2*B1(k2,Mf2(2,Gen3),Mf2(2,Gen3)))*Mf2(2,Gen3)))/
     -     (CW2*MW2*SW2)

	enddo

	do Sfe3 = 1,2
	do Gen3 = 1,3

        se_G0G0_nmfv = se_G0G0_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*A0(MSf2(Sfe3,2,Gen3))*
     -       ((C2B*MW2*(-1 + 2*SW2) + 2*CW2*Mf2(2,Gen3))*
     -          USf(Sfe3,1,2,Gen3)*USfC(Sfe3,1,2,Gen3) + 
     -         2*(-(C2B*MW2*SW2) + CW2*Mf2(2,Gen3))*
     -          USf(Sfe3,2,2,Gen3)*USfC(Sfe3,2,2,Gen3)))/
     -     (CW2*MW2*SW2)

	enddo
	enddo

	do Sfe4 = 1,2
	do Sfe3 = 1,2
	do Gen3 = 1,3

        se_G0G0_nmfv = se_G0G0_nmfv - 
     -   1/(16.D0*Pi)*(Alfa*B0(k2,MSf2(Sfe3,2,Gen3),
     -        MSf2(Sfe4,2,Gen3))*Mf2(2,Gen3)*
     -       ((-(MUEC*TB) + Af(2,Gen3,Gen3))*USf(Sfe4,2,2,Gen3)*
     -          USfC(Sfe3,1,2,Gen3) + 
     -         (MUE*TB - AfC(2,Gen3,Gen3))*USf(Sfe4,1,2,Gen3)*
     -          USfC(Sfe3,2,2,Gen3))*
     -       ((-(MUEC*TB) + Af(2,Gen3,Gen3))*USf(Sfe3,2,2,Gen3)*
     -          USfC(Sfe4,1,2,Gen3) + 
     -         (MUE*TB - AfC(2,Gen3,Gen3))*USf(Sfe3,1,2,Gen3)*
     -          USfC(Sfe4,2,2,Gen3)))/(MW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_G0G0_nmfv =', se_G0G0_nmfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        se_G0G0_nmfv = se_G0G0_nmfv + 
     -   1/(32.D0*Pi)*(Alfa*(2*
     -          (MW2*S2B**2*
     -             (SAB**2*B0(k2,MA02,Mh02) + 
     -               CAB**2*B0(k2,MA02,MHH2)) + 
     -            (C2B**2*MW2*SAB**2 + 
     -               CW2*(-(k2*SBA**2) - Mh02*SBA**2))*
     -             B0(k2,Mh02,MZ2) - 
     -            (CBA**2*CW2*(k2 + MHH2) - C2B**2*CAB**2*MW2)*
     -             B0(k2,MHH2,MZ2)) + 
     -         CW2*((-1 + 3*S2B**2)*A0(MA02) + 
     -            C2A*C2B*(-A0(Mh02) + A0(MHH2)) + 
     -            2*(CW2*(1 + S2B**2) - C2B**2*SW2)*A0(MHp2) + 
     -            2*(C2B**2 + 6*CW2)*A0(MW2) + 
     -            3*(2 + C2B**2)*A0(MZ2) + 
     -            4*k2*(SBA**2*B1(k2,Mh02,MZ2) + 
     -               CBA**2*B1(k2,MHH2,MZ2) + 
     -               CW2*(-B0(k2,MW2,MW2) + 2*B1(k2,MW2,MW2))))))/
     -     (CW2**2*SW2)

	do Cha4 = 1,2
	do Cha3 = 1,2

        dup1 = -(CB*UCha(Cha4,2)*VCha(Cha3,1)) + 
     -   SB*UCha(Cha4,1)*VCha(Cha3,2)

        dup2 = -(CB*UCha(Cha3,2)*VCha(Cha4,1)) + 
     -   SB*UCha(Cha3,1)*VCha(Cha4,2)

        dup3 = CB*UChaC(Cha4,2)*VChaC(Cha3,1) - 
     -   SB*UChaC(Cha4,1)*VChaC(Cha3,2)

        dup4 = CB*UChaC(Cha3,2)*VChaC(Cha4,1) - 
     -   SB*UChaC(Cha3,1)*VChaC(Cha4,2)

        se_G0G0_nmfv = se_G0G0_nmfv + 
     -   1/(4.D0*Pi)*(Alfa*(dup1*dup3 + dup2*dup4)*
     -        (A0(MCha2(Cha4)) + k2*B1(k2,MCha2(Cha3),MCha2(Cha4)))
     -         + Alfa*B0(k2,MCha2(Cha3),MCha2(Cha4))*
     -        (dup3*dup4*MCha(Cha3)*MCha(Cha4) + 
     -          dup1*dup3*MCha2(Cha3) + dup2*dup4*MCha2(Cha3) + 
     -          MCha(Cha3)*MCha(Cha4)*
     -           (CB*UCha(Cha4,2)*VCha(Cha3,1) - 
     -             SB*UCha(Cha4,1)*VCha(Cha3,2))*
     -           (CB*UCha(Cha3,2)*VCha(Cha4,1) - 
     -             SB*UCha(Cha3,1)*VCha(Cha4,2))))/SW2

	enddo
	enddo

	do Neu4 = 1,4
	do Neu3 = 1,4

	dup5 = SW*ZNeu(Neu3,1) - CW*ZNeu(Neu3,2)

	dup6 = SW*ZNeu(Neu4,1) - CW*ZNeu(Neu4,2)

	dup7 = CB*ZNeu(Neu4,3) + SB*ZNeu(Neu4,4)

	dup8 = SW*ZNeuC(Neu3,1) - CW*ZNeuC(Neu3,2)

	dup9 = SW*ZNeuC(Neu4,1) - CW*ZNeuC(Neu4,2)

	dup10 = CB*ZNeuC(Neu4,3) + SB*ZNeuC(Neu4,4)

        se_G0G0_nmfv = se_G0G0_nmfv + 
     -   1/(16.D0*Pi)*(-2*Alfa*
     -        (A0(MNeu2(Neu4)) + 
     -          k2*B1(k2,MNeu2(Neu3),MNeu2(Neu4)))*
     -        (dup5*dup7 + CB*dup6*ZNeu(Neu3,3) + 
     -          dup6*SB*ZNeu(Neu3,4))*
     -        (dup10*dup8 + CB*dup9*ZNeuC(Neu3,3) + 
     -          dup9*SB*ZNeuC(Neu3,4)) + 
     -       Alfa*B0(k2,MNeu2(Neu3),MNeu2(Neu4))*
     -        (MNeu(Neu3)*MNeu(Neu4)*
     -           (dup5*dup7 + CB*dup6*ZNeu(Neu3,3) + 
     -              dup6*SB*ZNeu(Neu3,4))**2 - 
     -          2*MNeu2(Neu3)*
     -           (dup5*dup7 + CB*dup6*ZNeu(Neu3,3) + 
     -             dup6*SB*ZNeu(Neu3,4))*
     -           (dup10*dup8 + CB*dup9*ZNeuC(Neu3,3) + 
     -             dup9*SB*ZNeuC(Neu3,4)) + 
     -          MNeu(Neu3)*MNeu(Neu4)*
     -           (dup10*dup8 + CB*dup9*ZNeuC(Neu3,3) + 
     -              dup9*SB*ZNeuC(Neu3,4))**2))/(CW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_G0G0_nmfv =', se_G0G0_nmfv ENDL
#endif

	end


