* se_ZZ.F
* this file is part of FeynHiggs
* generated 15 Jun 2008 08:42

#include "externals.h"


	double complex function se_ZZ(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex se_ZZ_mfv, se_ZZ_nmfv
	external se_ZZ_mfv, se_ZZ_nmfv

	if( nmfv .eq. 0 ) then
	  se_ZZ = se_ZZ_mfv(k2)
	else
	  se_ZZ = se_ZZ_nmfv(k2)
	endif

#ifdef DEBUG
	print *, 'k2 =', k2
	print *, 'se_ZZ =', se_ZZ
#endif
	end


************************************************************************


	double complex function se_ZZ_mfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha3, Cha4, Gen3, Neu3, Neu4, Sfe3, Sfe4, g
	double complex dup1, dup2, dup3, dup4, dup5, dup6

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	se_ZZ_mfv = 0

	do Gen3 = g,3

        se_ZZ_mfv = se_ZZ_mfv - 
     -   1/(8.D0*Pi)*(Alfa*(8*SW2*
     -          (1/12.D0*((-9 + (24 - 32*SW2)*SW2)*
     -                B00(k2,Mf2(3,Gen3),Mf2(3,Gen3)))/SW2 + 
     -            1/24.D0*((9 + SW2*(-24 + 32*SW2))*
     -                (A0(Mf2(3,Gen3)) + 
     -                  k2*B1(k2,Mf2(3,Gen3),Mf2(3,Gen3))))/SW2) + 
     -         3*B0(k2,Mf2(3,Gen3),Mf2(3,Gen3))*Mf2(3,Gen3)))/
     -     (CW2*SW2)

	enddo

	do Gen3 = g,3
	do Sfe3 = 1,2

        se_ZZ_mfv = se_ZZ_mfv + 
     -   1/(24.D0*Pi)*(Alfa*A0(MSf2(Sfe3,3,Gen3))*
     -       ((3 - 4*SW2)**2*USf(Sfe3,1,3,Gen3)*
     -          USfC(Sfe3,1,3,Gen3) + 
     -         16*SW2**2*USf(Sfe3,2,3,Gen3)*USfC(Sfe3,2,3,Gen3)))/
     -     (CW2*SW2)

	enddo
	enddo

	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

        se_ZZ_mfv = se_ZZ_mfv - 
     -   1/(12.D0*Pi)*(Alfa*B00(k2,MSf2(Sfe3,3,Gen3),
     -        MSf2(Sfe4,3,Gen3))*
     -       (-3*USf(Sfe4,1,3,Gen3)*USfC(Sfe3,1,3,Gen3) + 
     -         SW2*(4*USf(Sfe4,1,3,Gen3)*USfC(Sfe3,1,3,Gen3) + 
     -            4*USf(Sfe4,2,3,Gen3)*USfC(Sfe3,2,3,Gen3)))*
     -       (-3*USf(Sfe3,1,3,Gen3)*USfC(Sfe4,1,3,Gen3) + 
     -         SW2*(4*USf(Sfe3,1,3,Gen3)*USfC(Sfe4,1,3,Gen3) + 
     -            4*USf(Sfe3,2,3,Gen3)*USfC(Sfe4,2,3,Gen3))))/
     -     (CW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_ZZ_mfv =', se_ZZ_mfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen3 = g,3

        se_ZZ_mfv = se_ZZ_mfv - 
     -   1/(24.D0*Pi)*(Alfa*(2*(-9 + (12 - 8*SW2)*SW2)*
     -          B00(k2,Mf2(4,Gen3),Mf2(4,Gen3)) + 
     -         (9 + SW2*(-12 + 8*SW2))*
     -          (A0(Mf2(4,Gen3)) + 
     -            k2*B1(k2,Mf2(4,Gen3),Mf2(4,Gen3))) + 
     -         9*B0(k2,Mf2(4,Gen3),Mf2(4,Gen3))*Mf2(4,Gen3)))/
     -     (CW2*SW2)

	enddo

	do Gen3 = g,3
	do Sfe3 = 1,2

        se_ZZ_mfv = se_ZZ_mfv + 
     -   1/(24.D0*Pi)*(Alfa*A0(MSf2(Sfe3,4,Gen3))*
     -       ((3 - 2*SW2)**2*USf(Sfe3,1,4,Gen3)*
     -          USfC(Sfe3,1,4,Gen3) + 
     -         4*SW2**2*USf(Sfe3,2,4,Gen3)*USfC(Sfe3,2,4,Gen3)))/
     -     (CW2*SW2)

	enddo
	enddo

	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

        se_ZZ_mfv = se_ZZ_mfv - 
     -   1/(12.D0*Pi)*(Alfa*B00(k2,MSf2(Sfe3,4,Gen3),
     -        MSf2(Sfe4,4,Gen3))*
     -       (-3*USf(Sfe4,1,4,Gen3)*USfC(Sfe3,1,4,Gen3) + 
     -         SW2*(2*USf(Sfe4,1,4,Gen3)*USfC(Sfe3,1,4,Gen3) + 
     -            2*USf(Sfe4,2,4,Gen3)*USfC(Sfe3,2,4,Gen3)))*
     -       (-3*USf(Sfe3,1,4,Gen3)*USfC(Sfe4,1,4,Gen3) + 
     -         SW2*(2*USf(Sfe3,1,4,Gen3)*USfC(Sfe4,1,4,Gen3) + 
     -            2*USf(Sfe3,2,4,Gen3)*USfC(Sfe4,2,4,Gen3))))/
     -     (CW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_ZZ_mfv =', se_ZZ_mfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

        se_ZZ_mfv = se_ZZ_mfv + 
     -   3/(8.D0*Pi)*(Alfa*(2*B00(k2,0.D0,0.D0) - k2*B1(k2,0.D0,0.D0)))/
     -     (CW2*SW2)

	do Gen3 = 1,3

        se_ZZ_mfv = se_ZZ_mfv - 
     -   1/(8.D0*Pi)*(Alfa*(-A0(MSf2(1,1,Gen3)) + 
     -         2*(-1 + (4 - 8*SW2)*SW2)*
     -          B00(k2,Mf2(2,Gen3),Mf2(2,Gen3)) + 
     -         2*B00(k2,MSf2(1,1,Gen3),MSf2(1,1,Gen3)) + 
     -         (1 + SW2*(-4 + 8*SW2))*
     -          (A0(Mf2(2,Gen3)) + 
     -            k2*B1(k2,Mf2(2,Gen3),Mf2(2,Gen3))) + 
     -         B0(k2,Mf2(2,Gen3),Mf2(2,Gen3))*Mf2(2,Gen3)))/
     -     (CW2*SW2)

	enddo

	do Sfe3 = 1,2
	do Gen3 = 1,3

        se_ZZ_mfv = se_ZZ_mfv + 
     -   1/(8.D0*Pi)*(Alfa*A0(MSf2(Sfe3,2,Gen3))*
     -       ((1 - 2*SW2)**2*USf(Sfe3,1,2,Gen3)*
     -          USfC(Sfe3,1,2,Gen3) + 
     -         4*SW2**2*USf(Sfe3,2,2,Gen3)*USfC(Sfe3,2,2,Gen3)))/
     -     (CW2*SW2)

	enddo
	enddo

	do Sfe4 = 1,2
	do Sfe3 = 1,2
	do Gen3 = 1,3

        se_ZZ_mfv = se_ZZ_mfv - 
     -   1/(4.D0*Pi)*(Alfa*B00(k2,MSf2(Sfe3,2,Gen3),
     -        MSf2(Sfe4,2,Gen3))*
     -       (-(USf(Sfe4,1,2,Gen3)*USfC(Sfe3,1,2,Gen3)) + 
     -         SW2*(2*USf(Sfe4,1,2,Gen3)*USfC(Sfe3,1,2,Gen3) + 
     -            2*USf(Sfe4,2,2,Gen3)*USfC(Sfe3,2,2,Gen3)))*
     -       (-(USf(Sfe3,1,2,Gen3)*USfC(Sfe4,1,2,Gen3)) + 
     -         SW2*(2*USf(Sfe3,1,2,Gen3)*USfC(Sfe4,1,2,Gen3) + 
     -            2*USf(Sfe3,2,2,Gen3)*USfC(Sfe4,2,2,Gen3))))/
     -     (CW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_ZZ_mfv =', se_ZZ_mfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        se_ZZ_mfv = se_ZZ_mfv + 
     -   1/(16.D0*Pi)*(Alfa*(4*MW2*
     -          (SBA**2*B0(k2,Mh02,MZ2) + CBA**2*B0(k2,MHH2,MZ2))+
     -           CW2*(A0(MA02) + A0(Mh02) + A0(MHH2) + A0(MZ2) - 
     -            2*(-((CW2*(9*CW2 - 2*SW2) + SW2**2)*A0(MW2)) - 
     -               2*(CW2**2*(-5*k2 - 2*MW2) + 2*MW2*SW2**2)*
     -                B0(k2,MW2,MW2) + 
     -               2*SBA**2*
     -                (B00(k2,Mh02,MZ2) + B00(k2,MHH2,MA02)) + 
     -               2*CBA**2*
     -                (B00(k2,Mh02,MA02) + B00(k2,MHH2,MZ2)) - 
     -               (CW2 - SW2)**2*
     -                (A0(MHp2) - 2*B00(k2,MHp2,MHp2)) + 
     -               2*CW2*
     -                (((CW2*(9*CW2 - 2*SW2) + SW2**2)*
     -                     B00(k2,MW2,MW2))/CW2 + 
     -                  2*CW2*k2*B1(k2,MW2,MW2))))))/(CW2**2*SW2)

	do Cha4 = 1,2
	do Cha3 = 1,2

        dup1 = SW2*Delta(Cha3,Cha4) - 
     -   1/2.D0*(UCha(Cha4,2)*UChaC(Cha3,2)) - 
     -   UCha(Cha4,1)*UChaC(Cha3,1)

        dup2 = SW2*Delta(Cha3,Cha4) - 
     -   1/2.D0*(UCha(Cha3,2)*UChaC(Cha4,2)) - 
     -   UCha(Cha3,1)*UChaC(Cha4,1)

        dup3 = SW2*Delta(Cha3,Cha4) - 
     -   1/2.D0*(VCha(Cha4,2)*VChaC(Cha3,2)) - 
     -   VCha(Cha4,1)*VChaC(Cha3,1)

        dup4 = SW2*Delta(Cha3,Cha4) - 
     -   1/2.D0*(VCha(Cha3,2)*VChaC(Cha4,2)) - 
     -   VCha(Cha3,1)*VChaC(Cha4,1)

        se_ZZ_mfv = se_ZZ_mfv + 
     -   1/(2.D0*Pi)*(-(Alfa*(dup1*dup2 + dup3*dup4)*
     -          (A0(MCha2(Cha4)) - 
     -            2*B00(k2,MCha2(Cha3),MCha2(Cha4)) + 
     -            k2*B1(k2,MCha2(Cha3),MCha2(Cha4)))) + 
     -       Alfa*B0(k2,MCha2(Cha3),MCha2(Cha4))*
     -        (dup2*dup4*MCha(Cha3)*MCha(Cha4) - 
     -          dup3*dup4*MCha2(Cha3) + 
     -          dup1*(dup3*MCha(Cha3)*MCha(Cha4) - 
     -             dup2*MCha2(Cha3))))/(CW2*SW2)

	enddo
	enddo

	do Neu4 = 1,4
	do Neu3 = 1,4

	dup5 = ZNeu(Neu4,3)*ZNeuC(Neu3,3) - ZNeu(Neu4,4)*ZNeuC(Neu3,4)

	dup6 = ZNeu(Neu3,3)*ZNeuC(Neu4,3) - ZNeu(Neu3,4)*ZNeuC(Neu4,4)

        se_ZZ_mfv = se_ZZ_mfv + 
     -   1/(16.D0*Pi)*(Alfa*(4*dup5*dup6*
     -          B00(k2,MNeu2(Neu3),MNeu2(Neu4)) - 
     -         B0(k2,MNeu2(Neu3),MNeu2(Neu4))*
     -          (dup6**2*MNeu(Neu3)*MNeu(Neu4) + 
     -            dup5*(dup5*MNeu(Neu3)*MNeu(Neu4) + 
     -               2*dup6*MNeu2(Neu3))) + 
     -         2*dup5*(A0(MNeu2(Neu4)) + 
     -            k2*B1(k2,MNeu2(Neu3),MNeu2(Neu4)))*
     -          (-(ZNeu(Neu3,3)*ZNeuC(Neu4,3)) + 
     -            ZNeu(Neu3,4)*ZNeuC(Neu4,4))))/(CW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_ZZ_mfv =', se_ZZ_mfv ENDL
#endif

	end



************************************************************************


	double complex function se_ZZ_nmfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All3, All4, Cha3, Cha4, Gen3, Ind1, Ind2, Neu3, Neu4
	integer Sfe3, Sfe4, g
	double complex dup1, dup2, dup3, dup4, dup5, dup6

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	se_ZZ_nmfv = 0

	do Gen3 = g,3

        se_ZZ_nmfv = se_ZZ_nmfv - 
     -   1/(8.D0*Pi)*(Alfa*(8*SW2*
     -          (1/12.D0*((-9 + (24 - 32*SW2)*SW2)*
     -                B00(k2,Mf2(3,Gen3),Mf2(3,Gen3)))/SW2 + 
     -            1/24.D0*((9 + SW2*(-24 + 32*SW2))*
     -                (A0(Mf2(3,Gen3)) + 
     -                  k2*B1(k2,Mf2(3,Gen3),Mf2(3,Gen3))))/SW2) + 
     -         3*B0(k2,Mf2(3,Gen3),Mf2(3,Gen3))*Mf2(3,Gen3)))/
     -     (CW2*SW2)

	enddo

	do All3 = g,6,g
	do Ind1 = g,3

        se_ZZ_nmfv = se_ZZ_nmfv + 
     -   1/(24.D0*Pi)*(Alfa*A0(MASf2(All3,3))*
     -       ((3 - 4*SW2)**2*UASf(All3,Ind1,3)*
     -          UASfC(All3,Ind1,3) + 
     -         16*SW2**2*UASf(All3,3 + Ind1,3)*
     -          UASfC(All3,3 + Ind1,3)))/(CW2*SW2)

	enddo
	enddo

	do All4 = g,6,g
	do All3 = g,6,g
	do Ind2 = g,3
	do Ind1 = g,3

        se_ZZ_nmfv = se_ZZ_nmfv - 
     -   1/(12.D0*Pi)*(Alfa*B00(k2,MASf2(All3,3),MASf2(All4,3))*
     -       (-3*UASf(All4,Ind1,3)*UASfC(All3,Ind1,3) + 
     -         SW2*(4*UASf(All4,Ind1,3)*UASfC(All3,Ind1,3) + 
     -            4*UASf(All4,3 + Ind1,3)*UASfC(All3,3 + Ind1,3)))*
     -       (-3*UASf(All3,Ind2,3)*UASfC(All4,Ind2,3) + 
     -         SW2*(4*UASf(All3,Ind2,3)*UASfC(All4,Ind2,3) + 
     -            4*UASf(All3,3 + Ind2,3)*UASfC(All4,3 + Ind2,3))))
     -      /(CW2*SW2)

	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_ZZ_nmfv =', se_ZZ_nmfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen3 = g,3

        se_ZZ_nmfv = se_ZZ_nmfv - 
     -   1/(24.D0*Pi)*(Alfa*(2*(-9 + (12 - 8*SW2)*SW2)*
     -          B00(k2,Mf2(4,Gen3),Mf2(4,Gen3)) + 
     -         (9 + SW2*(-12 + 8*SW2))*
     -          (A0(Mf2(4,Gen3)) + 
     -            k2*B1(k2,Mf2(4,Gen3),Mf2(4,Gen3))) + 
     -         9*B0(k2,Mf2(4,Gen3),Mf2(4,Gen3))*Mf2(4,Gen3)))/
     -     (CW2*SW2)

	enddo

	do All3 = g,6,g
	do Ind1 = g,3

        se_ZZ_nmfv = se_ZZ_nmfv + 
     -   1/(24.D0*Pi)*(Alfa*A0(MASf2(All3,4))*
     -       ((3 - 2*SW2)**2*UASf(All3,Ind1,4)*
     -          UASfC(All3,Ind1,4) + 
     -         4*SW2**2*UASf(All3,3 + Ind1,4)*
     -          UASfC(All3,3 + Ind1,4)))/(CW2*SW2)

	enddo
	enddo

	do All4 = g,6,g
	do All3 = g,6,g
	do Ind2 = g,3
	do Ind1 = g,3

        se_ZZ_nmfv = se_ZZ_nmfv - 
     -   1/(12.D0*Pi)*(Alfa*B00(k2,MASf2(All3,4),MASf2(All4,4))*
     -       (-3*UASf(All4,Ind1,4)*UASfC(All3,Ind1,4) + 
     -         SW2*(2*UASf(All4,Ind1,4)*UASfC(All3,Ind1,4) + 
     -            2*UASf(All4,3 + Ind1,4)*UASfC(All3,3 + Ind1,4)))*
     -       (-3*UASf(All3,Ind2,4)*UASfC(All4,Ind2,4) + 
     -         SW2*(2*UASf(All3,Ind2,4)*UASfC(All4,Ind2,4) + 
     -            2*UASf(All3,3 + Ind2,4)*UASfC(All4,3 + Ind2,4))))
     -      /(CW2*SW2)

	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_ZZ_nmfv =', se_ZZ_nmfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

        se_ZZ_nmfv = se_ZZ_nmfv + 
     -   3/(8.D0*Pi)*(Alfa*(2*B00(k2,0.D0,0.D0) - k2*B1(k2,0.D0,0.D0)))/
     -     (CW2*SW2)

	do Gen3 = 1,3

        se_ZZ_nmfv = se_ZZ_nmfv - 
     -   1/(8.D0*Pi)*(Alfa*(-A0(MSf2(1,1,Gen3)) + 
     -         2*(-1 + (4 - 8*SW2)*SW2)*
     -          B00(k2,Mf2(2,Gen3),Mf2(2,Gen3)) + 
     -         2*B00(k2,MSf2(1,1,Gen3),MSf2(1,1,Gen3)) + 
     -         (1 + SW2*(-4 + 8*SW2))*
     -          (A0(Mf2(2,Gen3)) + 
     -            k2*B1(k2,Mf2(2,Gen3),Mf2(2,Gen3))) + 
     -         B0(k2,Mf2(2,Gen3),Mf2(2,Gen3))*Mf2(2,Gen3)))/
     -     (CW2*SW2)

	enddo

	do Sfe3 = 1,2
	do Gen3 = 1,3

        se_ZZ_nmfv = se_ZZ_nmfv + 
     -   1/(8.D0*Pi)*(Alfa*A0(MSf2(Sfe3,2,Gen3))*
     -       ((1 - 2*SW2)**2*USf(Sfe3,1,2,Gen3)*
     -          USfC(Sfe3,1,2,Gen3) + 
     -         4*SW2**2*USf(Sfe3,2,2,Gen3)*USfC(Sfe3,2,2,Gen3)))/
     -     (CW2*SW2)

	enddo
	enddo

	do Sfe4 = 1,2
	do Sfe3 = 1,2
	do Gen3 = 1,3

        se_ZZ_nmfv = se_ZZ_nmfv - 
     -   1/(4.D0*Pi)*(Alfa*B00(k2,MSf2(Sfe3,2,Gen3),
     -        MSf2(Sfe4,2,Gen3))*
     -       (-(USf(Sfe4,1,2,Gen3)*USfC(Sfe3,1,2,Gen3)) + 
     -         SW2*(2*USf(Sfe4,1,2,Gen3)*USfC(Sfe3,1,2,Gen3) + 
     -            2*USf(Sfe4,2,2,Gen3)*USfC(Sfe3,2,2,Gen3)))*
     -       (-(USf(Sfe3,1,2,Gen3)*USfC(Sfe4,1,2,Gen3)) + 
     -         SW2*(2*USf(Sfe3,1,2,Gen3)*USfC(Sfe4,1,2,Gen3) + 
     -            2*USf(Sfe3,2,2,Gen3)*USfC(Sfe4,2,2,Gen3))))/
     -     (CW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_ZZ_nmfv =', se_ZZ_nmfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        se_ZZ_nmfv = se_ZZ_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*(4*MW2*
     -          (SBA**2*B0(k2,Mh02,MZ2) + CBA**2*B0(k2,MHH2,MZ2))+
     -           CW2*(A0(MA02) + A0(Mh02) + A0(MHH2) + A0(MZ2) - 
     -            2*(-((CW2*(9*CW2 - 2*SW2) + SW2**2)*A0(MW2)) - 
     -               2*(CW2**2*(-5*k2 - 2*MW2) + 2*MW2*SW2**2)*
     -                B0(k2,MW2,MW2) + 
     -               2*SBA**2*
     -                (B00(k2,Mh02,MZ2) + B00(k2,MHH2,MA02)) + 
     -               2*CBA**2*
     -                (B00(k2,Mh02,MA02) + B00(k2,MHH2,MZ2)) - 
     -               (CW2 - SW2)**2*
     -                (A0(MHp2) - 2*B00(k2,MHp2,MHp2)) + 
     -               2*CW2*
     -                (((CW2*(9*CW2 - 2*SW2) + SW2**2)*
     -                     B00(k2,MW2,MW2))/CW2 + 
     -                  2*CW2*k2*B1(k2,MW2,MW2))))))/(CW2**2*SW2)

	do Cha4 = 1,2
	do Cha3 = 1,2

        dup1 = SW2*Delta(Cha3,Cha4) - 
     -   1/2.D0*(UCha(Cha4,2)*UChaC(Cha3,2)) - 
     -   UCha(Cha4,1)*UChaC(Cha3,1)

        dup2 = SW2*Delta(Cha3,Cha4) - 
     -   1/2.D0*(UCha(Cha3,2)*UChaC(Cha4,2)) - 
     -   UCha(Cha3,1)*UChaC(Cha4,1)

        dup3 = SW2*Delta(Cha3,Cha4) - 
     -   1/2.D0*(VCha(Cha4,2)*VChaC(Cha3,2)) - 
     -   VCha(Cha4,1)*VChaC(Cha3,1)

        dup4 = SW2*Delta(Cha3,Cha4) - 
     -   1/2.D0*(VCha(Cha3,2)*VChaC(Cha4,2)) - 
     -   VCha(Cha3,1)*VChaC(Cha4,1)

        se_ZZ_nmfv = se_ZZ_nmfv + 
     -   1/(2.D0*Pi)*(-(Alfa*(dup1*dup2 + dup3*dup4)*
     -          (A0(MCha2(Cha4)) - 
     -            2*B00(k2,MCha2(Cha3),MCha2(Cha4)) + 
     -            k2*B1(k2,MCha2(Cha3),MCha2(Cha4)))) + 
     -       Alfa*B0(k2,MCha2(Cha3),MCha2(Cha4))*
     -        (dup2*dup4*MCha(Cha3)*MCha(Cha4) - 
     -          dup3*dup4*MCha2(Cha3) + 
     -          dup1*(dup3*MCha(Cha3)*MCha(Cha4) - 
     -             dup2*MCha2(Cha3))))/(CW2*SW2)

	enddo
	enddo

	do Neu4 = 1,4
	do Neu3 = 1,4

	dup5 = ZNeu(Neu4,3)*ZNeuC(Neu3,3) - ZNeu(Neu4,4)*ZNeuC(Neu3,4)

	dup6 = ZNeu(Neu3,3)*ZNeuC(Neu4,3) - ZNeu(Neu3,4)*ZNeuC(Neu4,4)

        se_ZZ_nmfv = se_ZZ_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*(4*dup5*dup6*
     -          B00(k2,MNeu2(Neu3),MNeu2(Neu4)) - 
     -         B0(k2,MNeu2(Neu3),MNeu2(Neu4))*
     -          (dup6**2*MNeu(Neu3)*MNeu(Neu4) + 
     -            dup5*(dup5*MNeu(Neu3)*MNeu(Neu4) + 
     -               2*dup6*MNeu2(Neu3))) + 
     -         2*dup5*(A0(MNeu2(Neu4)) + 
     -            k2*B1(k2,MNeu2(Neu3),MNeu2(Neu4)))*
     -          (-(ZNeu(Neu3,3)*ZNeuC(Neu4,3)) + 
     -            ZNeu(Neu3,4)*ZNeuC(Neu4,4))))/(CW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_ZZ_nmfv =', se_ZZ_nmfv ENDL
#endif

	end


