* TLhr.F
* master file for Heidi Rzehak's two-loop corrections
* this file is part of FeynHiggs
* last modified 16 Apr 08 th

#include "externals.h"


	subroutine TLhrSE(error, mudim)
	implicit none
	integer error
	double precision mudim

#include "TLhr.h"
#define __SUBROUTINE__ "TLhrSE"

	double precision c, DSStop2(2)
	double complex seinput
	logical fail

	Q = mudim
	MUE2 = Sq(MUE)
	c = abs(Af(3,3,3))
	PhiAt = c
	if( c .gt. 1D-14 ) PhiAt = Af(3,3,3)/c

* use squark masses w/o D-terms & neglect MB
	DSStop2(1) = MSS2(1,3,3) - MSS2(2,3,3)
	if( DSStop2(1)**2 + Sq(Xf(3,3,3)) .lt. .1D0 )
     &    DSStop2(1) = -.2D0*sqrt(MSS2(2,3,3))
	DSStop2(2) = MSS2(2,3,3)
	call EigenSf(fail, MStop, MStop2, UStop,
     &    DSStop2, MT, Xf(3,3,3), 0)
	if( fail ) then
	  Error("negative stop mass squares")
	  return
	endif

	MSbot2(1) = MSS2(1,4,3)
	MSbot2(2) = MSS2(2,4,3)
	MSbot2(3) = MSbot2(2) - MSbot2(1)
	MSbot2(4) = MSbot2(2) + MSbot2(1)
	MSbot(1) = sqrt(MSbot2(1))
	MSbot(2) = sqrt(MSbot2(2))

c	USbot(1,1) = 1
c	USbot(2,1) = 0
c	USbot(1,2) = 0
c	USbot(2,2) = 1

	c = 2*MGl*MT
	MGlmT2 = MGl2 - MT2
	MGlpT2 = MGl2 + MT2
	MGlpTmSt2(1) = MGlpT2 - MStop2(1)
	MGlpTmSt4(1) = MGlpTmSt2(1)**2
	MGlpTmStxGlT4(1) = (MGlpTmSt2(1) - c)*(MGlpTmSt2(1) + c)
	MGlpTmSt2(2) = MGlpT2 - MStop2(2)
	MGlpTmSt4(2) = MGlpTmSt2(2)**2
	MGlpTmStxGlT4(2) = (MGlpTmSt2(2) - c)*(MGlpTmSt2(2) + c)

	MSq2Diff(1,1) = (MSbot(1) - MStop(1))*(MSbot(1) + MStop(1))
	MSq2Diff(2,1) = (MSbot(2) - MStop(1))*(MSbot(2) + MStop(1))
	MSq2Diff(1,2) = (MSbot(1) - MStop(2))*(MSbot(1) + MStop(2))
	MSq2Diff(2,2) = (MSbot(2) - MStop(2))*(MSbot(2) + MStop(2))

	UStop2(1,1) = Sq(UStop(1,1))
	UStop2(2,1) = Sq(UStop(2,1))
	UStop2(1,2) = Sq(UStop(1,2))
	UStop2(2,2) = Sq(UStop(2,2))

	UCStop(3,1) = UStop(1,1)*UStopC(2,1)
	UCStop(3,2) = UStop(1,2)*UStopC(2,2)
	UCStop(1,3) = UStop(1,1)*UStopC(1,2)
	UCStop(2,3) = UStop(2,1)*UStopC(2,2)
	UCStop(3,3) = UStop(1,1)*UStopC(2,2)
	UCStop(3,4) = UStop(1,2)*UStopC(2,1)

	UUStop(1,1) = UStop(1,1)**2
	UUStop(2,1) = UStop(2,1)**2
	UUStop(1,2) = UStop(1,2)**2
	UUStop(2,2) = UStop(2,2)**2

	UUStop(3,1) = UStop(1,1)*UStop(2,1)
	UUStop(3,2) = UStop(1,2)*UStop(2,2)
	UUStop(1,3) = UStop(1,1)*UStop(1,2)
	UUStop(2,3) = UStop(2,1)*UStop(2,2)
	UUStop(3,3) = UStop(1,1)*UStop(2,2)
	UUStop(3,4) = UStop(1,2)*UStop(2,1)

	A0delStop(1) = A0del(MStop2(1), Q)
	A0delStop(2) = A0del(MStop2(2), Q)
	A0delGl = A0del(MGl2, Q)
	A0delT = A0del(MT2, Q)

	call TLhr_abbr1_1
	call TLhr_abbr1_2
	call TLhr_abbr1_3
	call TLhr_abbr1_4
	call TLhr_abbr1_5
	call TLhr_abbr1_6
	call TLhr_abbr1_7
	call TLhr_abbr1_8
	call TLhr_abbr1_9
	call TLhr_abbr1_10
	call TLhr_abbr1_11
	call TLhr_abbr1_12
	call TLhr_abbr1_13
	call TLhr_abbr1_14
	call TLhr_abbr1_15

	if( debuglevel .ge. 2 ) then
	  DSELF "==========================="	ENDL
	  DSELF "two-loop self-energies (hr)"	ENDL
	  DSELF "---------------------------"	ENDL
	endif

	call TLhr_self1

	c = EL/(2*SW*MW)

	if( inputmass .eq. 3 ) then
	  seinput = selfA0A0
	else
	  seinput = selfHmHp
	endif

	se2R(h0h0) = selfh0h0 - CBA**2*seinput +
     &    c*SBA*(CBA*SBA*tadHH - (1 + CBA**2)*tadh0)

	se2R(HHHH) = selfHHHH - SBA**2*seinput +
     &    c*CBA*(CBA*SBA*tadh0 - (1 + SBA**2)*tadHH)

	se2R(A0A0) = selfA0A0 - seinput

	se2R(HmHp) = selfHmHp - seinput

	if( debuglevel .ge. 2 ) then
	  DSELF "se2R(h0h0) =", se2R(h0h0)	ENDL
	  DSELF "se2R(HHHH) =", se2R(HHHH)	ENDL
	  DSELF "se2R(A0A0) =", se2R(A0A0)	ENDL
	  DSELF "se2R(HmHp) =", se2R(HmHp)	ENDL
	endif

	if( higgsmix .lt. 2 ) return

	call TLhr_abbr2_1
	call TLhr_abbr2_2
	call TLhr_abbr2_3
	call TLhr_self2

	se2R(h0HH) = selfh0HH + CBA*SBA*seinput -
     &    c*(CBA**3*tadh0 + SBA**3*tadHH)

	if( debuglevel .ge. 2 ) then
	  DSELF "se2R(h0HH) =", se2R(h0HH)	ENDL
	endif

	if( higgsmix .lt. 3 ) return

	call TLhr_abbr3_1
	call TLhr_abbr3_2
	call TLhr_abbr3_3
	call TLhr_abbr3_4
	call TLhr_self3

	se2R(h0A0) = selfh0A0 - c*SBA*tadA0

	se2R(HHA0) = selfHHA0 - c*CBA*tadA0

	if( debuglevel .ge. 2 ) then
	  DSELF "se2R(h0A0) =", se2R(h0A0)	ENDL
	  DSELF "se2R(HHA0) =", se2R(HHA0)	ENDL
	endif
	end

