* ReverseEigen.F
* recover the original matrix A from the eigenvalues and
* the transformation matrix U by forming A = U^+ diag(d) U.
* this file is part of FeynHiggs
* last modified 16 Jun 06 th

#include "externals.h"


	subroutine ReverseEigen(n, A,ldA, d, U,ldU)
	implicit none
	integer n, ldA, ldU
	double complex A(ldA,*), U(ldU,*)
	double precision d(*)

	integer i, j, k
	double complex s

	do j = 1, n
	  do i = 1, n
	    s = 0
	    do k = 1, n
	      s = s + d(k)*DCONJG(U(k,i))*U(k,j)
	    enddo
	    A(i,j) = s
	  enddo
	enddo
	end

