* GetPara.F
* retrieve the SUSY parameters from the internal arrays
* this file is part of FeynHiggs
* last modified 13 Oct 08 th

#include "externals.h"
#include "debug.h"


	subroutine FHGetPara(error,
     &    nmfv_, MSf_, USf_, MASf_, UASf_,
     &    MCha_, UCha_, VCha_, MNeu_, ZNeu_, DeltaMB_, MGl_)
	implicit none
	integer error
	integer nmfv_
	double precision MSf_(2*4*3), MASf_(6*2)
	double precision MCha_(2), MNeu_(4), MGl_
	double complex USf_(2*2*4*3), UASf_(6*6*2)
	double complex UCha_(2*2), VCha_(2*2)
	double complex ZNeu_(4*4), DeltaMB_

#include "FH.h"
#define __SUBROUTINE__ "FHGetPara"

	integer i

	error = 0

	CheckPara()

	if( error .gt. 0 ) return

	nmfv_ = nmfv

	do i = 1, 2*4*3
	  MSf_(i) = MSf_flat(i)
	enddo

	do i = 1, 2*2*4*3
	  USf_(i) = USf_flat(i)
	enddo

	do i = 1, 6*2
	  MASf_(i) = MASf_flat(i)
	enddo

	do i = 1, 6*6*2
	  UASf_(i) = UASf_flat(i)
	enddo

	do i = 1, 2
	  MCha_(i) = MCha(i)
	enddo

	do i = 1, 2*2
	  UCha_(i) = UCha_flat(i)
	enddo

	do i = 1, 2*2
	  VCha_(i) = VCha_flat(i)
	enddo

	do i = 1, 4
	  MNeu_(i) = MNeu(i)
	enddo

	do i = 1, 4*4
	  ZNeu_(i) = ZNeu_flat(i)
	enddo

	DeltaMB_ = DeltaMBc(5)
	MGl_ = MGl
	end

