* RetrieveNMFV.F
* retrieve the non-minimal flavour-violation parameters
* this file is part of FeynHiggs
* last modified 28 Jul 08 th

#include "externals.h"
#include "debug.h"


	subroutine FHRetrieveNMFV(error,
     &    deltaLLuc_, deltaLRuc_, deltaRLuc_, deltaRRuc_,
     &    deltaLLct_, deltaLRct_, deltaRLct_, deltaRRct_,
     &    deltaLLut_, deltaLRut_, deltaRLut_, deltaRRut_,
     &    deltaLLds_, deltaLRds_, deltaRLds_, deltaRRds_,
     &    deltaLLsb_, deltaLRsb_, deltaRLsb_, deltaRRsb_,
     &    deltaLLdb_, deltaLRdb_, deltaRLdb_, deltaRRdb_)
	implicit none
	integer error
	double complex deltaLLuc_, deltaLRuc_
	double complex deltaRLuc_, deltaRRuc_
	double complex deltaLLct_, deltaLRct_
	double complex deltaRLct_, deltaRRct_
	double complex deltaLLut_, deltaLRut_
	double complex deltaRLut_, deltaRRut_
	double complex deltaLLds_, deltaLRds_
	double complex deltaRLds_, deltaRRds_
	double complex deltaLLsb_, deltaLRsb_
	double complex deltaRLsb_, deltaRRsb_
	double complex deltaLLdb_, deltaLRdb_
	double complex deltaRLdb_, deltaRRdb_

#include "FH.h"
#define __SUBROUTINE__ "FHRetrieveNMFV"

	error = 0

	CheckPara()

	if( error .ne. 0 ) return

	deltaLLuc_ = deltaSf_LL(1,2,3)
	deltaLRuc_ = deltaSf_LR(1,2,3)
	deltaRLuc_ = deltaSf_RL(1,2,3)
	deltaRRuc_ = deltaSf_RR(1,2,3)

	deltaLLct_ = deltaSf_LL(2,3,3)
	deltaLRct_ = deltaSf_LR(2,3,3)
	deltaRLct_ = deltaSf_RL(2,3,3)
	deltaRRct_ = deltaSf_RR(2,3,3)

	deltaLLut_ = deltaSf_LL(1,3,3)
	deltaLRut_ = deltaSf_LR(1,3,3)
	deltaRLut_ = deltaSf_RL(1,3,3)
	deltaRRut_ = deltaSf_RR(1,3,3)

	deltaLLds_ = deltaSf_LL(1,2,4)
	deltaLRds_ = deltaSf_LR(1,2,4)
	deltaRLds_ = deltaSf_RL(1,2,4)
	deltaRRds_ = deltaSf_RR(1,2,4)

	deltaLLsb_ = deltaSf_LL(2,3,4)
	deltaLRsb_ = deltaSf_LR(2,3,4)
	deltaRLsb_ = deltaSf_RL(2,3,4)
	deltaRRsb_ = deltaSf_RR(2,3,4)

	deltaLLdb_ = deltaSf_LL(1,3,4)
	deltaLRdb_ = deltaSf_LR(1,3,4)
	deltaRLdb_ = deltaSf_RL(1,3,4)
	deltaRRdb_ = deltaSf_RR(1,3,4)
	end

