* SetFlags.F
* set the flags for FeynHiggs
* this file is part of FeynHiggs
* last modified 20 Dec 08 th

#include "externals.h"
#include "debug.h"
#include "version.h"


	subroutine FHSetFlags(error,
     &    mssmpart_, fieldren_, tanbren_,
     &    higgsmix_, p2approx_, looplevel_,
     &    runningMT_, tlBotResum_, tlCplxApprox_)
	implicit none
	integer error
	integer mssmpart_, fieldren_, tanbren_
	integer higgsmix_, p2approx_, looplevel_
	integer runningMT_, tlBotResum_, tlCplxApprox_

#include "FH.h"
#define __SUBROUTINE__ "FHSetFlags"

	character*10 env

	logical blurb
	data blurb /.TRUE./

	if( blurb ) then
	  print *, "-----------------------------------------------------"
	  print *, "FeynHiggs "//FHVERSION
	  print *, "built on "//FHBUILDDATE
	  print *, "T. Hahn, S. Heinemeyer, W. Hollik, H. Rzehak, G. Weiglein"
	  print *, "http://www.feynhiggs.de"
	  print *, "-----------------------------------------------------"
	  blurb = .FALSE.
c	  call setfpu ! JE CHANGE: commented out this call
	endif

	flags_valid = 0
	para_valid = 0
	higgs_valid = 0
	coup_valid = 0

	debuglevel = 0
	uzint = 1
	uzext = 2

	call getenv("FHDEBUG", env)
	read(env, *, end=9, err=9) debuglevel
	DFLAGS "debug level ", debuglevel ENDL
9	continue

	call getenv("FHSELECTUZ", env)
	read(env, *, end=10, err=10) uzint, uzext
	DFLAGS "uzint, uzext ", uzint, uzext ENDL
10	continue

	error = 0

#define Check(flag, lo, hi, name) \
if(flag.lt.lo .or. flag.gt.hi) Error(name//" invalid")

	Check(mssmpart_,     0, 4, "mssmpart")
	Check(fieldren_,     0, 4, "fieldren")
	Check(tanbren_,      0, 2, "tanbren")
	Check(higgsmix_,     1, 4, "higgsmix")
	Check(p2approx_,     0, 4, "p2approx")
	Check(looplevel_,    0, 2, "looplevel")
	Check(runningMT_,    0, 3, "runningMT")
	Check(tlBotResum_,   0, 1, "tlBotResum")
	Check(tlCplxApprox_, 0, 3, "tlCplxApprox")

	if( mssmpart_ .eq. 0 .and. higgsmix_ .gt. 2 )
     &    Error("mssmpart = 0 with higgsmix > 2 not allowed")

	if( fieldren_ .eq. 4 .and. tanbren_ .eq. 1 )
     &    Error("fieldren = 4 not compatible with tanbren = 1")

	if( error .gt. 0 ) goto 999

	mssmpart = mssmpart_
	fieldren = fieldren_
	tanbren = tanbren_
	higgsmix = higgsmix_
	p2approx = p2approx_
	looplevel = looplevel_
	runningMT = runningMT_
	tlBotResum = tlBotResum_
	tlCplxApprox = tlCplxApprox_

	if( mssmpart .eq. 0 ) p2approx = 1

	flags_valid = valid

999	continue

	if( debuglevel .lt. 1 ) return

	DFLAGS "============================"	ENDL
	DFLAGS "flags set by FHSetFlags"	ENDL
	DFLAGS "----------------------------"	ENDL
	DFLAGS "mssmpart     =", mssmpart	ENDL
	DFLAGS "fieldren     =", fieldren	ENDL
	DFLAGS "tanbren      =", tanbren	ENDL
	DFLAGS "higgsmix     =", higgsmix	ENDL
	DFLAGS "p2approx     =", p2approx	ENDL
	DFLAGS "looplevel    =", looplevel	ENDL
	DFLAGS "runningMT    =", runningMT	ENDL
	DFLAGS "tlBotResum   =", tlBotResum	ENDL
	DFLAGS "tlCplxApprox =", tlCplxApprox	ENDL
	end

