* dse_A0G0.F
* this file is part of FeynHiggs
* generated 13 Oct 2008 14:46

#include "externals.h"
#include "debug.h"


	double complex function dse_A0G0(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex dse_A0G0_mfv, dse_A0G0_nmfv
	external dse_A0G0_mfv, dse_A0G0_nmfv

	if( nmfv .eq. 0 ) then
	  dse_A0G0 = dse_A0G0_mfv(k2)
	else
	  dse_A0G0 = dse_A0G0_nmfv(k2)
	endif

#ifdef DEBUG
	DHIGGS 'k2 =', k2 ENDL
	DHIGGS 'dse_A0G0 =', dse_A0G0 ENDL
#endif
	end


************************************************************************


	double complex function dse_A0G0_mfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha3, Cha4, Gen3, Neu3, Neu4, Sfe3, Sfe4, g
	double complex dup1, dup10, dup11, dup12, dup13, dup14, dup15
	double complex dup2, dup3, dup4, dup5, dup6, dup7, dup8, dup9

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_A0G0_mfv = 0

	do Gen3 = g,3

        dse_A0G0_mfv = dse_A0G0_mfv - 
     -   3/(4.D0*Pi)*(Alfa*(B1(k2,Mfy2(3,Gen3),Mfy2(3,Gen3)) + 
     -         k2*DB1(k2,Mfy2(3,Gen3),Mfy2(3,Gen3)))*Mfy2(3,Gen3))/
     -     (MW2*SW2*TB)

	enddo

	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

        dse_A0G0_mfv = dse_A0G0_mfv + 
     -   3/(16.D0*Pi)*(Alfa*DB0(k2,MSf2(Sfe3,3,Gen3),
     -        MSf2(Sfe4,3,Gen3))*Mfy2(3,Gen3)*
     -       (-(MUEC*TB*USf(Sfe4,2,3,Gen3)*USfC(Sfe3,1,3,Gen3)) - 
     -         Af(3,Gen3,Gen3)*USf(Sfe4,2,3,Gen3)*
     -          USfC(Sfe3,1,3,Gen3) + 
     -         MUE*TB*USf(Sfe4,1,3,Gen3)*USfC(Sfe3,2,3,Gen3) + 
     -         AfC(3,Gen3,Gen3)*USf(Sfe4,1,3,Gen3)*
     -          USfC(Sfe3,2,3,Gen3))*
     -       ((-MUEC + TB*Af(3,Gen3,Gen3))*USf(Sfe3,2,3,Gen3)*
     -          USfC(Sfe4,1,3,Gen3) + 
     -         (MUE - TB*AfC(3,Gen3,Gen3))*USf(Sfe3,1,3,Gen3)*
     -          USfC(Sfe4,2,3,Gen3)))/(MW2*SW2*TB2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_A0G0_mfv =', dse_A0G0_mfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen3 = g,3

        dse_A0G0_mfv = dse_A0G0_mfv + 
     -   3/(4.D0*Pi)*(Alfa*TB*
     -       (B1(k2,Mf2(4,Gen3),Mf2(4,Gen3)) + 
     -         k2*DB1(k2,Mf2(4,Gen3),Mf2(4,Gen3)))*Mf(4,Gen3)*
     -       Mfy(4,Gen3))/(MW2*SW2)

	enddo

	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

        dse_A0G0_mfv = dse_A0G0_mfv - 
     -   3/(16.D0*Pi)*(Alfa*DB0(k2,MSf2(Sfe3,4,Gen3),
     -        MSf2(Sfe4,4,Gen3))*Mfy2(4,Gen3)*
     -       (-((MUEC + TB*Af(4,Gen3,Gen3))*USf(Sfe4,2,4,Gen3)*
     -            USfC(Sfe3,1,4,Gen3)) + 
     -         (MUE + TB*AfC(4,Gen3,Gen3))*USf(Sfe4,1,4,Gen3)*
     -          USfC(Sfe3,2,4,Gen3))*
     -       ((-(MUEC*TB) + Af(4,Gen3,Gen3))*USf(Sfe3,2,4,Gen3)*
     -          USfC(Sfe4,1,4,Gen3) + 
     -         (MUE*TB - AfC(4,Gen3,Gen3))*USf(Sfe3,1,4,Gen3)*
     -          USfC(Sfe4,2,4,Gen3)))/(MW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_A0G0_mfv =', dse_A0G0_mfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        dse_A0G0_mfv = dse_A0G0_mfv + 
     -   1/(4.D0*Pi)*(Alfa*TB*
     -       (B1(k2,Mf2(2,Gen3),Mf2(2,Gen3)) + 
     -         k2*DB1(k2,Mf2(2,Gen3),Mf2(2,Gen3)))*Mf2(2,Gen3))/
     -     (MW2*SW2)

	enddo

	do Sfe4 = 1,2
	do Sfe3 = 1,2
	do Gen3 = 1,3

        dse_A0G0_mfv = dse_A0G0_mfv - 
     -   1/(16.D0*Pi)*(Alfa*DB0(k2,MSf2(Sfe3,2,Gen3),
     -        MSf2(Sfe4,2,Gen3))*Mf2(2,Gen3)*
     -       (-((MUEC + TB*Af(2,Gen3,Gen3))*USf(Sfe4,2,2,Gen3)*
     -            USfC(Sfe3,1,2,Gen3)) + 
     -         (MUE + TB*AfC(2,Gen3,Gen3))*USf(Sfe4,1,2,Gen3)*
     -          USfC(Sfe3,2,2,Gen3))*
     -       ((-(MUEC*TB) + Af(2,Gen3,Gen3))*USf(Sfe3,2,2,Gen3)*
     -          USfC(Sfe4,1,2,Gen3) + 
     -         (MUE*TB - AfC(2,Gen3,Gen3))*USf(Sfe3,1,2,Gen3)*
     -          USfC(Sfe4,2,2,Gen3)))/(MW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_A0G0_mfv =', dse_A0G0_mfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        dse_A0G0_mfv = dse_A0G0_mfv + 
     -   1/(16.D0*Pi)*(Alfa*(C2B*MW2*S2B*
     -          (SAB**2*DB0(k2,MA02,Mh02) + 
     -            CAB**2*DB0(k2,MA02,MHH2)) - 
     -         (C2B*MW2*S2B*SAB**2 + CBA*CW2*(4*k2*SBA + MZ2*SBA))*
     -          DB0(k2,Mh02,MZ2) + 
     -         (-(C2B*CAB**2*MW2*S2B) + 
     -            CBA*CW2*(4*k2*SBA + MZ2*SBA))*DB0(k2,MHH2,MZ2) + 
     -         4*CBA*CW2*SBA*
     -          (-B0(k2,Mh02,MZ2) + B0(k2,MHH2,MZ2) - 
     -            B1(k2,MZ2,Mh02) + B1(k2,MZ2,MHH2) + 
     -            k2*(-DB1(k2,MZ2,Mh02) + DB1(k2,MZ2,MHH2)))))/
     -     (CW2**2*SW2)

	do Cha4 = 1,2
	do Cha3 = 1,2

        dup1 = SB*UCha(Cha4,2)*VCha(Cha3,1) + 
     -   CB*UCha(Cha4,1)*VCha(Cha3,2)

        dup2 = -(CB*UCha(Cha3,2)*VCha(Cha4,1)) + 
     -   SB*UCha(Cha3,1)*VCha(Cha4,2)

        dup3 = -(CB*UChaC(Cha4,2)*VChaC(Cha3,1)) + 
     -   SB*UChaC(Cha4,1)*VChaC(Cha3,2)

        dup4 = SB*UChaC(Cha3,2)*VChaC(Cha4,1) + 
     -   CB*UChaC(Cha3,1)*VChaC(Cha4,2)

        dse_A0G0_mfv = dse_A0G0_mfv + 
     -   1/(4.D0*Pi)*(-(Alfa*(dup1*dup3 + dup2*dup4)*
     -          (B1(k2,MCha2(Cha3),MCha2(Cha4)) + 
     -            k2*DB1(k2,MCha2(Cha3),MCha2(Cha4)))) + 
     -       Alfa*DB0(k2,MCha2(Cha3),MCha2(Cha4))*
     -        (-((dup1*dup3 + dup2*dup4)*MCha2(Cha3)) + 
     -          MCha(Cha3)*MCha(Cha4)*
     -           (dup1*dup2 - 
     -             CB*dup4*UChaC(Cha4,2)*VChaC(Cha3,1) + 
     -             dup4*SB*UChaC(Cha4,1)*VChaC(Cha3,2))))/SW2

	enddo
	enddo

	do Neu4 = 1,4
	do Neu3 = 1,4

	dup5 = SW*ZNeu(Neu3,1) - CW*ZNeu(Neu3,2)

	dup6 = SW*ZNeu(Neu4,1) - CW*ZNeu(Neu4,2)

	dup7 = -(SW*ZNeu(Neu4,1)) + CW*ZNeu(Neu4,2)

	dup8 = SB*ZNeu(Neu4,3) - CB*ZNeu(Neu4,4)

	dup9 = CB*ZNeu(Neu4,3) + SB*ZNeu(Neu4,4)

	dup10 = SW*ZNeuC(Neu3,1) - CW*ZNeuC(Neu3,2)

	dup11 = SW*ZNeuC(Neu4,1) - CW*ZNeuC(Neu4,2)

	dup12 = -(SW*ZNeuC(Neu4,1)) + CW*ZNeuC(Neu4,2)

	dup13 = SB*ZNeuC(Neu4,3) - CB*ZNeuC(Neu4,4)

	dup14 = CB*ZNeuC(Neu4,3) + SB*ZNeuC(Neu4,4)

        dup15 = (dup5*dup9 + CB*dup6*ZNeu(Neu3,3) + 
     -      dup6*SB*ZNeu(Neu3,4))*
     -    (dup10*dup13 + dup11*SB*ZNeuC(Neu3,3) + 
     -      CB*dup12*ZNeuC(Neu3,4)) + 
     -   (dup5*dup8 + dup6*SB*ZNeu(Neu3,3) + CB*dup7*ZNeu(Neu3,4))*
     -    (dup10*dup14 + dup11*
     -       (CB*ZNeuC(Neu3,3) + SB*ZNeuC(Neu3,4)))

        dse_A0G0_mfv = dse_A0G0_mfv + 
     -   1/(16.D0*Pi)*(Alfa*dup15*
     -        (B1(k2,MNeu2(Neu3),MNeu2(Neu4)) + 
     -          k2*DB1(k2,MNeu2(Neu3),MNeu2(Neu4))) + 
     -       Alfa*DB0(k2,MNeu2(Neu3),MNeu2(Neu4))*
     -        (dup15*MNeu2(Neu3) - 
     -          MNeu(Neu3)*MNeu(Neu4)*
     -           ((dup5*dup8 + dup6*SB*ZNeu(Neu3,3) + 
     -                CB*dup7*ZNeu(Neu3,4))*
     -              (dup5*dup9 + CB*dup6*ZNeu(Neu3,3) + 
     -                dup6*SB*ZNeu(Neu3,4)) + 
     -             (dup10*dup13 + dup11*SB*ZNeuC(Neu3,3) + 
     -                CB*dup12*ZNeuC(Neu3,4))*
     -              (dup10*dup14 + 
     -                dup11*(CB*ZNeuC(Neu3,3) + SB*ZNeuC(Neu3,4))))
     -          ))/(CW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_A0G0_mfv =', dse_A0G0_mfv ENDL
#endif

	end



************************************************************************


	double complex function dse_A0G0_nmfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All3, All4, Cha3, Cha4, Gen3, Ind1, Ind2, Ind3, Ind4
	integer Neu3, Neu4, Sfe3, Sfe4, g
	double complex dup1, dup10, dup11, dup12, dup13, dup14, dup15
	double complex dup2, dup3, dup4, dup5, dup6, dup7, dup8, dup9

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_A0G0_nmfv = 0

	do Gen3 = g,3

        dse_A0G0_nmfv = dse_A0G0_nmfv - 
     -   3/(4.D0*Pi)*(Alfa*(B1(k2,Mfy2(3,Gen3),Mfy2(3,Gen3)) + 
     -         k2*DB1(k2,Mfy2(3,Gen3),Mfy2(3,Gen3)))*Mfy2(3,Gen3))/
     -     (MW2*SW2*TB)

	enddo

	do All4 = g,6,g
	do All3 = g,6,g
	do Ind4 = g,3
	do Ind3 = g,3
	do Ind2 = g,3
	do Ind1 = g,3

        dse_A0G0_nmfv = dse_A0G0_nmfv + 
     -   3/(16.D0*Pi)*(Alfa*DB0(k2,MASf2(All3,3),MASf2(All4,3))*
     -       (-((Af(3,Ind1,Ind2) + MUEC*TB*Delta(Ind1,Ind2))*
     -            Mfy(3,Ind1)*UASf(All4,3 + Ind2,3)*
     -            UASfC(All3,Ind1,3)) + 
     -         (MUE*TB*Delta(Ind1,Ind2)*Mfy(3,Ind1) + 
     -            AfC(3,Ind2,Ind1)*Mfy(3,Ind2))*UASf(All4,Ind2,3)*
     -          UASfC(All3,3 + Ind1,3))*
     -       ((TB*Af(3,Ind3,Ind4) - MUEC*Delta(Ind3,Ind4))*
     -          Mfy(3,Ind3)*UASf(All3,3 + Ind4,3)*
     -          UASfC(All4,Ind3,3) + 
     -         (MUE*Delta(Ind3,Ind4)*Mfy(3,Ind3) - 
     -            TB*AfC(3,Ind4,Ind3)*Mfy(3,Ind4))*
     -          UASf(All3,Ind4,3)*UASfC(All4,3 + Ind3,3)))/
     -     (MW2*SW2*TB2)

	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_A0G0_nmfv =', dse_A0G0_nmfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen3 = g,3

        dse_A0G0_nmfv = dse_A0G0_nmfv + 
     -   3/(4.D0*Pi)*(Alfa*TB*
     -       (B1(k2,Mf2(4,Gen3),Mf2(4,Gen3)) + 
     -         k2*DB1(k2,Mf2(4,Gen3),Mf2(4,Gen3)))*Mf(4,Gen3)*
     -       Mfy(4,Gen3))/(MW2*SW2)

	enddo

	do All4 = g,6,g
	do All3 = g,6,g
	do Ind4 = g,3
	do Ind3 = g,3
	do Ind2 = g,3
	do Ind1 = g,3

        dse_A0G0_nmfv = dse_A0G0_nmfv - 
     -   3/(16.D0*Pi)*(Alfa*DB0(k2,MASf2(All3,4),MASf2(All4,4))*
     -       (-((TB*Af(4,Ind3,Ind4) + MUEC*Delta(Ind3,Ind4))*
     -            Mfy(4,Ind3)*UASf(All4,3 + Ind4,4)*
     -            UASfC(All3,Ind3,4)) + 
     -         (MUE*Delta(Ind3,Ind4)*Mfy(4,Ind3) + 
     -            TB*AfC(4,Ind4,Ind3)*Mfy(4,Ind4))*
     -          UASf(All4,Ind4,4)*UASfC(All3,3 + Ind3,4))*
     -       ((Af(4,Ind1,Ind2) - MUEC*TB*Delta(Ind1,Ind2))*
     -          Mfy(4,Ind1)*UASf(All3,3 + Ind2,4)*
     -          UASfC(All4,Ind1,4) + 
     -         (MUE*TB*Delta(Ind1,Ind2)*Mfy(4,Ind1) - 
     -            AfC(4,Ind2,Ind1)*Mfy(4,Ind2))*UASf(All3,Ind2,4)*
     -          UASfC(All4,3 + Ind1,4)))/(MW2*SW2)

	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_A0G0_nmfv =', dse_A0G0_nmfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        dse_A0G0_nmfv = dse_A0G0_nmfv + 
     -   1/(4.D0*Pi)*(Alfa*TB*
     -       (B1(k2,Mf2(2,Gen3),Mf2(2,Gen3)) + 
     -         k2*DB1(k2,Mf2(2,Gen3),Mf2(2,Gen3)))*Mf2(2,Gen3))/
     -     (MW2*SW2)

	enddo

	do Sfe4 = 1,2
	do Sfe3 = 1,2
	do Gen3 = 1,3

        dse_A0G0_nmfv = dse_A0G0_nmfv - 
     -   1/(16.D0*Pi)*(Alfa*DB0(k2,MSf2(Sfe3,2,Gen3),
     -        MSf2(Sfe4,2,Gen3))*Mf2(2,Gen3)*
     -       (-((MUEC + TB*Af(2,Gen3,Gen3))*USf(Sfe4,2,2,Gen3)*
     -            USfC(Sfe3,1,2,Gen3)) + 
     -         (MUE + TB*AfC(2,Gen3,Gen3))*USf(Sfe4,1,2,Gen3)*
     -          USfC(Sfe3,2,2,Gen3))*
     -       ((-(MUEC*TB) + Af(2,Gen3,Gen3))*USf(Sfe3,2,2,Gen3)*
     -          USfC(Sfe4,1,2,Gen3) + 
     -         (MUE*TB - AfC(2,Gen3,Gen3))*USf(Sfe3,1,2,Gen3)*
     -          USfC(Sfe4,2,2,Gen3)))/(MW2*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_A0G0_nmfv =', dse_A0G0_nmfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        dse_A0G0_nmfv = dse_A0G0_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*(C2B*MW2*S2B*
     -          (SAB**2*DB0(k2,MA02,Mh02) + 
     -            CAB**2*DB0(k2,MA02,MHH2)) - 
     -         (C2B*MW2*S2B*SAB**2 + CBA*CW2*(4*k2*SBA + MZ2*SBA))*
     -          DB0(k2,Mh02,MZ2) + 
     -         (-(C2B*CAB**2*MW2*S2B) + 
     -            CBA*CW2*(4*k2*SBA + MZ2*SBA))*DB0(k2,MHH2,MZ2) + 
     -         4*CBA*CW2*SBA*
     -          (-B0(k2,Mh02,MZ2) + B0(k2,MHH2,MZ2) - 
     -            B1(k2,MZ2,Mh02) + B1(k2,MZ2,MHH2) + 
     -            k2*(-DB1(k2,MZ2,Mh02) + DB1(k2,MZ2,MHH2)))))/
     -     (CW2**2*SW2)

	do Cha4 = 1,2
	do Cha3 = 1,2

        dup1 = SB*UCha(Cha4,2)*VCha(Cha3,1) + 
     -   CB*UCha(Cha4,1)*VCha(Cha3,2)

        dup2 = -(CB*UCha(Cha3,2)*VCha(Cha4,1)) + 
     -   SB*UCha(Cha3,1)*VCha(Cha4,2)

        dup3 = -(CB*UChaC(Cha4,2)*VChaC(Cha3,1)) + 
     -   SB*UChaC(Cha4,1)*VChaC(Cha3,2)

        dup4 = SB*UChaC(Cha3,2)*VChaC(Cha4,1) + 
     -   CB*UChaC(Cha3,1)*VChaC(Cha4,2)

        dse_A0G0_nmfv = dse_A0G0_nmfv + 
     -   1/(4.D0*Pi)*(-(Alfa*(dup1*dup3 + dup2*dup4)*
     -          (B1(k2,MCha2(Cha3),MCha2(Cha4)) + 
     -            k2*DB1(k2,MCha2(Cha3),MCha2(Cha4)))) + 
     -       Alfa*DB0(k2,MCha2(Cha3),MCha2(Cha4))*
     -        (-((dup1*dup3 + dup2*dup4)*MCha2(Cha3)) + 
     -          MCha(Cha3)*MCha(Cha4)*
     -           (dup1*dup2 - 
     -             CB*dup4*UChaC(Cha4,2)*VChaC(Cha3,1) + 
     -             dup4*SB*UChaC(Cha4,1)*VChaC(Cha3,2))))/SW2

	enddo
	enddo

	do Neu4 = 1,4
	do Neu3 = 1,4

	dup5 = SW*ZNeu(Neu3,1) - CW*ZNeu(Neu3,2)

	dup6 = SW*ZNeu(Neu4,1) - CW*ZNeu(Neu4,2)

	dup7 = -(SW*ZNeu(Neu4,1)) + CW*ZNeu(Neu4,2)

	dup8 = SB*ZNeu(Neu4,3) - CB*ZNeu(Neu4,4)

	dup9 = CB*ZNeu(Neu4,3) + SB*ZNeu(Neu4,4)

	dup10 = SW*ZNeuC(Neu3,1) - CW*ZNeuC(Neu3,2)

	dup11 = SW*ZNeuC(Neu4,1) - CW*ZNeuC(Neu4,2)

	dup12 = -(SW*ZNeuC(Neu4,1)) + CW*ZNeuC(Neu4,2)

	dup13 = SB*ZNeuC(Neu4,3) - CB*ZNeuC(Neu4,4)

	dup14 = CB*ZNeuC(Neu4,3) + SB*ZNeuC(Neu4,4)

        dup15 = (dup5*dup9 + CB*dup6*ZNeu(Neu3,3) + 
     -      dup6*SB*ZNeu(Neu3,4))*
     -    (dup10*dup13 + dup11*SB*ZNeuC(Neu3,3) + 
     -      CB*dup12*ZNeuC(Neu3,4)) + 
     -   (dup5*dup8 + dup6*SB*ZNeu(Neu3,3) + CB*dup7*ZNeu(Neu3,4))*
     -    (dup10*dup14 + dup11*
     -       (CB*ZNeuC(Neu3,3) + SB*ZNeuC(Neu3,4)))

        dse_A0G0_nmfv = dse_A0G0_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*dup15*
     -        (B1(k2,MNeu2(Neu3),MNeu2(Neu4)) + 
     -          k2*DB1(k2,MNeu2(Neu3),MNeu2(Neu4))) + 
     -       Alfa*DB0(k2,MNeu2(Neu3),MNeu2(Neu4))*
     -        (dup15*MNeu2(Neu3) - 
     -          MNeu(Neu3)*MNeu(Neu4)*
     -           ((dup5*dup8 + dup6*SB*ZNeu(Neu3,3) + 
     -                CB*dup7*ZNeu(Neu3,4))*
     -              (dup5*dup9 + CB*dup6*ZNeu(Neu3,3) + 
     -                dup6*SB*ZNeu(Neu3,4)) + 
     -             (dup10*dup13 + dup11*SB*ZNeuC(Neu3,3) + 
     -                CB*dup12*ZNeuC(Neu3,4))*
     -              (dup10*dup14 + 
     -                dup11*(CB*ZNeuC(Neu3,3) + SB*ZNeuC(Neu3,4))))
     -          ))/(CW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_A0G0_nmfv =', dse_A0G0_nmfv ENDL
#endif

	end


