* dse_HmHp.F
* this file is part of FeynHiggs
* generated 13 Oct 2008 14:46

#include "externals.h"
#include "debug.h"


	double complex function dse_HmHp(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex dse_HmHp_mfv, dse_HmHp_nmfv
	external dse_HmHp_mfv, dse_HmHp_nmfv

	if( nmfv .eq. 0 ) then
	  dse_HmHp = dse_HmHp_mfv(k2)
	else
	  dse_HmHp = dse_HmHp_nmfv(k2)
	endif

#ifdef DEBUG
	DHIGGS 'k2 =', k2 ENDL
	DHIGGS 'dse_HmHp =', dse_HmHp ENDL
#endif
	end


************************************************************************


	double complex function dse_HmHp_mfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha3, Gen3, Gen4, Neu3, Sfe3, Sfe4, g
	double complex dup1, dup2, dup3

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_HmHp_mfv = 0

	do Gen4 = g,3
	do Gen3 = g,3

        dse_HmHp_mfv = dse_HmHp_mfv + 
     -   3/(4.D0*Pi)*(Alfa*CKM(Gen3,Gen4)*CKMC(Gen3,Gen4)*
     -       (-((B1(k2,Mf2(4,Gen4),Mfy2(3,Gen3)) + 
     -              k2*DB1(k2,Mf2(4,Gen4),Mfy2(3,Gen3)))*
     -            (Mfy2(3,Gen3) + TB2**2*Mfy2(4,Gen4))) - 
     -         DB0(k2,Mf2(4,Gen4),Mfy2(3,Gen3))*
     -          (2*TB2*Mf(4,Gen4)*Mfy(4,Gen4)*Mfy2(3,Gen3) + 
     -            Mf2(4,Gen4)*(Mfy2(3,Gen3) + TB2**2*Mfy2(4,Gen4)))
     -         ))/(MW2*SW2*TB2)

	enddo
	enddo

	do Gen4 = g,3
	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

	dup1 = -(MW2*S2B*TB) + Mfy2(3,Gen3) + TB2*Mfy2(4,Gen4)

        dse_HmHp_mfv = dse_HmHp_mfv + 
     -   3/(8.D0*Pi)*(Alfa*CKM(Gen3,Gen4)*CKMC(Gen3,Gen4)*
     -       DB0(k2,MSf2(Sfe3,3,Gen3),MSf2(Sfe4,4,Gen4))*
     -       (Mfy(4,Gen4)*USf(Sfe4,2,4,Gen4)*
     -          ((MUEC*TB + TB2*Af(4,Gen4,Gen4))*
     -             USfC(Sfe3,1,3,Gen3) + 
     -            (1 + TB2)*Mfy(3,Gen3)*USfC(Sfe3,2,3,Gen3)) + 
     -         USf(Sfe4,1,4,Gen4)*
     -          (dup1*USfC(Sfe3,1,3,Gen3) + 
     -            MUE*TB*Mfy(3,Gen3)*USfC(Sfe3,2,3,Gen3) + 
     -            AfC(3,Gen3,Gen3)*Mfy(3,Gen3)*USfC(Sfe3,2,3,Gen3))
     -         )*(Mfy(3,Gen3)*USf(Sfe3,2,3,Gen3)*
     -          (MUEC*TB*USfC(Sfe4,1,4,Gen4) + 
     -            Af(3,Gen3,Gen3)*USfC(Sfe4,1,4,Gen4) + 
     -            Mfy(4,Gen4)*USfC(Sfe4,2,4,Gen4) + 
     -            TB2*Mfy(4,Gen4)*USfC(Sfe4,2,4,Gen4)) + 
     -         USf(Sfe3,1,3,Gen3)*
     -          (dup1*USfC(Sfe4,1,4,Gen4) + 
     -            (MUE*TB + TB2*AfC(4,Gen4,Gen4))*Mfy(4,Gen4)*
     -             USfC(Sfe4,2,4,Gen4))))/(MW2*SW2*TB2)

	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_HmHp_mfv =', dse_HmHp_mfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_HmHp_mfv =', dse_HmHp_mfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        dse_HmHp_mfv = dse_HmHp_mfv - 
     -   1/(4.D0*Pi)*(Alfa*TB2*
     -       (B1(k2,0.D0,Mf2(2,Gen3)) + k2*DB1(k2,0.D0,Mf2(2,Gen3)))*
     -       Mf2(2,Gen3))/(MW2*SW2)

	enddo

	do Sfe3 = 1,2
	do Gen3 = 1,3

        dse_HmHp_mfv = dse_HmHp_mfv + 
     -   1/(8.D0*Pi)*(Alfa*DB0(k2,MSf2(1,1,Gen3),MSf2(Sfe3,2,Gen3))*
     -       ((MW2*S2B - TB*Mf2(2,Gen3))*USf(Sfe3,1,2,Gen3) - 
     -         (MUEC + TB*Af(2,Gen3,Gen3))*Mf(2,Gen3)*
     -          USf(Sfe3,2,2,Gen3))*
     -       ((MW2*S2B - TB*Mf2(2,Gen3))*USfC(Sfe3,1,2,Gen3) - 
     -         (MUE + TB*AfC(2,Gen3,Gen3))*Mf(2,Gen3)*
     -          USfC(Sfe3,2,2,Gen3)))/(MW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_HmHp_mfv =', dse_HmHp_mfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        dse_HmHp_mfv = dse_HmHp_mfv + 
     -   1/(16.D0*Pi)*(Alfa*(MW2*(C2B*SAB + 2*CW2*SBA)**2*
     -          DB0(k2,Mh02,MHp2) + 
     -         (MW2*S2B**2*SAB**2 + 
     -            CBA*(CBA*CW2**2*(-k2 - Mh02 + MW2) - 
     -               2*CW2*MW2*S2B*SAB))*DB0(k2,Mh02,MW2) + 
     -         (C2B*CAB - 2*CBA*CW2)**2*MW2*DB0(k2,MHH2,MHp2) + 
     -         (CAB*(CAB*MW2*S2B**2 - 2*CW2*MW2*S2B*SBA) + 
     -            CW2**2*(-(k2*SBA**2) - MHH2*SBA**2 + MW2*SBA**2))
     -           *DB0(k2,MHH2,MW2) - 
     -         CW2*(4*CW2*SW2*B0(k2,0.D0,MHp2) + 
     -            CW2*B0(k2,MA02,MW2) + 
     -            CBA**2*CW2*B0(k2,Mh02,MW2) + 
     -            CW2*SBA**2*B0(k2,MHH2,MW2) - 
     -            2*CW2*B1(k2,MA02,MW2) - 
     -            2*CBA**2*CW2*B1(k2,Mh02,MW2) - 
     -            2*CW2*SBA**2*B1(k2,MHH2,MW2) - 
     -            8*CW2*SW2*B1(k2,MHp2,0.D0) + 
     -            (CW2 - SW2)**2*
     -             (B0(k2,MHp2,MZ2) - 2*B1(k2,MHp2,MZ2)) + 
     -            4*CW2*(k2 + MHp2)*SW2*DB0(k2,0.D0,MHp2) + 
     -            CW2*(k2 + MA02 - MW2)*DB0(k2,MA02,MW2) + 
     -            (k2 + MHp2)*(CW2 - SW2)**2*DB0(k2,MHp2,MZ2) - 
     -            2*CW2*k2*DB1(k2,MA02,MW2) - 
     -            2*CBA**2*CW2*k2*DB1(k2,Mh02,MW2) - 
     -            2*CW2*k2*SBA**2*DB1(k2,MHH2,MW2) - 
     -            8*CW2*k2*SW2*DB1(k2,MHp2,0.D0) - 
     -            2*k2*(CW2 - SW2)**2*DB1(k2,MHp2,MZ2))))/
     -     (CW2**2*SW2)

	do Neu3 = 1,4
	do Cha3 = 1,2

	dup2 = (SW*ZNeu(Neu3,1) + CW*ZNeu(Neu3,2))/CW

	dup3 = (SW*ZNeuC(Neu3,1) + CW*ZNeuC(Neu3,2))/CW

        dse_HmHp_mfv = dse_HmHp_mfv + 
     -   1/(2.D0*Pi)*(Alfa*(B1(k2,MCha2(Cha3),MNeu2(Neu3)) + 
     -          k2*DB1(k2,MCha2(Cha3),MNeu2(Neu3)))*
     -        (-(1/4.D0*(SB2*
     -               (dup2*Sqrt(2.D0)*UCha(Cha3,2) - 
     -                 2*UCha(Cha3,1)*ZNeu(Neu3,3))*
     -               (dup3*Sqrt(2.D0)*UChaC(Cha3,2) - 
     -                 2*UChaC(Cha3,1)*ZNeuC(Neu3,3)))) - 
     -          (CB2*(dup2*VCha(Cha3,2) + 
     -               Sqrt(2.D0)*VCha(Cha3,1)*ZNeu(Neu3,4))*
     -             (dup3*VChaC(Cha3,2) + 
     -               Sqrt(2.D0)*VChaC(Cha3,1)*ZNeuC(Neu3,4)))/2.D0) + 
     -       Alfa*DB0(k2,MCha2(Cha3),MNeu2(Neu3))*
     -        (-(1/4.D0*(SB2*MCha2(Cha3)*
     -               (dup2*Sqrt(2.D0)*UCha(Cha3,2) - 
     -                 2*UCha(Cha3,1)*ZNeu(Neu3,3))*
     -               (dup3*Sqrt(2.D0)*UChaC(Cha3,2) - 
     -                 2*UChaC(Cha3,1)*ZNeuC(Neu3,3)))) - 
     -          (CB2*MCha2(Cha3)*
     -             (dup2*VCha(Cha3,2) + 
     -               Sqrt(2.D0)*VCha(Cha3,1)*ZNeu(Neu3,4))*
     -             (dup3*VChaC(Cha3,2) + 
     -               Sqrt(2.D0)*VChaC(Cha3,1)*ZNeuC(Neu3,4)))/2.D0 - 
     -          CB*SB*MCha(Cha3)*MNeu(Neu3)*
     -           (((-(dup2*UCha(Cha3,2)) + 
     -                  Sqrt(2.D0)*UCha(Cha3,1)*ZNeu(Neu3,3))*
     -                (dup2*VCha(Cha3,2) + 
     -                  Sqrt(2.D0)*VCha(Cha3,1)*ZNeu(Neu3,4)))/2.D0 + 
     -             ((-(dup3*UChaC(Cha3,2)) + 
     -                  Sqrt(2.D0)*UChaC(Cha3,1)*ZNeuC(Neu3,3))*
     -                (dup3*VChaC(Cha3,2) + 
     -                  Sqrt(2.D0)*VChaC(Cha3,1)*ZNeuC(Neu3,4)))/2.D0))
     -       )/SW2

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_HmHp_mfv =', dse_HmHp_mfv ENDL
#endif

	end



************************************************************************


	double complex function dse_HmHp_nmfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All3, All4, Cha3, Gen3, Gen4, Ind1, Ind2, Ind3, Ind4
	integer Neu3, Sfe3, g
	double complex dup1, dup2

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_HmHp_nmfv = 0

	do Gen4 = g,3
	do Gen3 = g,3

        dse_HmHp_nmfv = dse_HmHp_nmfv + 
     -   3/(4.D0*Pi)*(Alfa*CKM(Gen3,Gen4)*CKMC(Gen3,Gen4)*
     -       (-((B1(k2,Mf2(4,Gen4),Mfy2(3,Gen3)) + 
     -              k2*DB1(k2,Mf2(4,Gen4),Mfy2(3,Gen3)))*
     -            (Mfy2(3,Gen3) + TB2**2*Mfy2(4,Gen4))) - 
     -         DB0(k2,Mf2(4,Gen4),Mfy2(3,Gen3))*
     -          (2*TB2*Mf(4,Gen4)*Mfy(4,Gen4)*Mfy2(3,Gen3) + 
     -            Mf2(4,Gen4)*(Mfy2(3,Gen3) + TB2**2*Mfy2(4,Gen4)))
     -         ))/(MW2*SW2*TB2)

	enddo
	enddo

	do All4 = g,6,g
	do All3 = g,6,g
	do Ind4 = g,3
	do Ind3 = g,3
	do Ind2 = g,3
	do Ind1 = g,3

        dse_HmHp_nmfv = dse_HmHp_nmfv + 
     -   3/(8.D0*Pi)*(Alfa*CKM(Ind1,Ind2)*CKMC(Ind3,Ind4)*
     -       DB0(k2,MASf2(All3,3),MASf2(All4,4))*
     -       (UASf(All4,Ind4,4)*
     -          ((MW2*S2B*TB - Mfy2(3,Ind3) - TB2*Mfy2(4,Ind4))*
     -             UASfC(All3,Ind3,3) - 
     -            (MUE*TB*Mfy(3,Ind3) + 
     -               AfC(3,Ind4,Ind3)*Mfy(3,Ind4))*
     -             UASfC(All3,3 + Ind3,3)) - 
     -         UASf(All4,3 + Ind4,4)*
     -          ((TB2*Af(4,Ind3,Ind4)*Mfy(4,Ind3) + 
     -               MUEC*TB*Mfy(4,Ind4))*UASfC(All3,Ind3,3) + 
     -            (1 + TB2)*Mfy(3,Ind3)*Mfy(4,Ind4)*
     -             UASfC(All3,3 + Ind3,3)))*
     -       (-(UASf(All3,3 + Ind1,3)*
     -            ((MUEC*TB*Mfy(3,Ind1) + 
     -                 Af(3,Ind2,Ind1)*Mfy(3,Ind2))*
     -               UASfC(All4,Ind2,4) + 
     -              (1 + TB2)*Mfy(3,Ind1)*Mfy(4,Ind2)*
     -               UASfC(All4,3 + Ind2,4))) + 
     -         UASf(All3,Ind1,3)*
     -          ((MW2*S2B*TB - Mfy2(3,Ind1) - TB2*Mfy2(4,Ind2))*
     -             UASfC(All4,Ind2,4) - 
     -            (TB2*AfC(4,Ind1,Ind2)*Mfy(4,Ind1) + 
     -               MUE*TB*Mfy(4,Ind2))*UASfC(All4,3 + Ind2,4))))/
     -     (MW2*SW2*TB2)

	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_HmHp_nmfv =', dse_HmHp_nmfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_HmHp_nmfv =', dse_HmHp_nmfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        dse_HmHp_nmfv = dse_HmHp_nmfv - 
     -   1/(4.D0*Pi)*(Alfa*TB2*
     -       (B1(k2,0.D0,Mf2(2,Gen3)) + k2*DB1(k2,0.D0,Mf2(2,Gen3)))*
     -       Mf2(2,Gen3))/(MW2*SW2)

	enddo

	do Sfe3 = 1,2
	do Gen3 = 1,3

        dse_HmHp_nmfv = dse_HmHp_nmfv + 
     -   1/(8.D0*Pi)*(Alfa*DB0(k2,MSf2(1,1,Gen3),MSf2(Sfe3,2,Gen3))*
     -       ((MW2*S2B - TB*Mf2(2,Gen3))*USf(Sfe3,1,2,Gen3) - 
     -         (MUEC + TB*Af(2,Gen3,Gen3))*Mf(2,Gen3)*
     -          USf(Sfe3,2,2,Gen3))*
     -       ((MW2*S2B - TB*Mf2(2,Gen3))*USfC(Sfe3,1,2,Gen3) - 
     -         (MUE + TB*AfC(2,Gen3,Gen3))*Mf(2,Gen3)*
     -          USfC(Sfe3,2,2,Gen3)))/(MW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_HmHp_nmfv =', dse_HmHp_nmfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        dse_HmHp_nmfv = dse_HmHp_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*(MW2*(C2B*SAB + 2*CW2*SBA)**2*
     -          DB0(k2,Mh02,MHp2) + 
     -         (MW2*S2B**2*SAB**2 + 
     -            CBA*(CBA*CW2**2*(-k2 - Mh02 + MW2) - 
     -               2*CW2*MW2*S2B*SAB))*DB0(k2,Mh02,MW2) + 
     -         (C2B*CAB - 2*CBA*CW2)**2*MW2*DB0(k2,MHH2,MHp2) + 
     -         (CAB*(CAB*MW2*S2B**2 - 2*CW2*MW2*S2B*SBA) + 
     -            CW2**2*(-(k2*SBA**2) - MHH2*SBA**2 + MW2*SBA**2))
     -           *DB0(k2,MHH2,MW2) - 
     -         CW2*(4*CW2*SW2*B0(k2,0.D0,MHp2) + 
     -            CW2*B0(k2,MA02,MW2) + 
     -            CBA**2*CW2*B0(k2,Mh02,MW2) + 
     -            CW2*SBA**2*B0(k2,MHH2,MW2) - 
     -            2*CW2*B1(k2,MA02,MW2) - 
     -            2*CBA**2*CW2*B1(k2,Mh02,MW2) - 
     -            2*CW2*SBA**2*B1(k2,MHH2,MW2) - 
     -            8*CW2*SW2*B1(k2,MHp2,0.D0) + 
     -            (CW2 - SW2)**2*
     -             (B0(k2,MHp2,MZ2) - 2*B1(k2,MHp2,MZ2)) + 
     -            4*CW2*(k2 + MHp2)*SW2*DB0(k2,0.D0,MHp2) + 
     -            CW2*(k2 + MA02 - MW2)*DB0(k2,MA02,MW2) + 
     -            (k2 + MHp2)*(CW2 - SW2)**2*DB0(k2,MHp2,MZ2) - 
     -            2*CW2*k2*DB1(k2,MA02,MW2) - 
     -            2*CBA**2*CW2*k2*DB1(k2,Mh02,MW2) - 
     -            2*CW2*k2*SBA**2*DB1(k2,MHH2,MW2) - 
     -            8*CW2*k2*SW2*DB1(k2,MHp2,0.D0) - 
     -            2*k2*(CW2 - SW2)**2*DB1(k2,MHp2,MZ2))))/
     -     (CW2**2*SW2)

	do Neu3 = 1,4
	do Cha3 = 1,2

	dup1 = (SW*ZNeu(Neu3,1) + CW*ZNeu(Neu3,2))/CW

	dup2 = (SW*ZNeuC(Neu3,1) + CW*ZNeuC(Neu3,2))/CW

        dse_HmHp_nmfv = dse_HmHp_nmfv + 
     -   1/(2.D0*Pi)*(Alfa*(B1(k2,MCha2(Cha3),MNeu2(Neu3)) + 
     -          k2*DB1(k2,MCha2(Cha3),MNeu2(Neu3)))*
     -        (-(1/4.D0*(SB2*
     -               (dup1*Sqrt(2.D0)*UCha(Cha3,2) - 
     -                 2*UCha(Cha3,1)*ZNeu(Neu3,3))*
     -               (dup2*Sqrt(2.D0)*UChaC(Cha3,2) - 
     -                 2*UChaC(Cha3,1)*ZNeuC(Neu3,3)))) - 
     -          (CB2*(dup1*VCha(Cha3,2) + 
     -               Sqrt(2.D0)*VCha(Cha3,1)*ZNeu(Neu3,4))*
     -             (dup2*VChaC(Cha3,2) + 
     -               Sqrt(2.D0)*VChaC(Cha3,1)*ZNeuC(Neu3,4)))/2.D0) + 
     -       Alfa*DB0(k2,MCha2(Cha3),MNeu2(Neu3))*
     -        (-(1/4.D0*(SB2*MCha2(Cha3)*
     -               (dup1*Sqrt(2.D0)*UCha(Cha3,2) - 
     -                 2*UCha(Cha3,1)*ZNeu(Neu3,3))*
     -               (dup2*Sqrt(2.D0)*UChaC(Cha3,2) - 
     -                 2*UChaC(Cha3,1)*ZNeuC(Neu3,3)))) - 
     -          (CB2*MCha2(Cha3)*
     -             (dup1*VCha(Cha3,2) + 
     -               Sqrt(2.D0)*VCha(Cha3,1)*ZNeu(Neu3,4))*
     -             (dup2*VChaC(Cha3,2) + 
     -               Sqrt(2.D0)*VChaC(Cha3,1)*ZNeuC(Neu3,4)))/2.D0 - 
     -          CB*SB*MCha(Cha3)*MNeu(Neu3)*
     -           (((-(dup1*UCha(Cha3,2)) + 
     -                  Sqrt(2.D0)*UCha(Cha3,1)*ZNeu(Neu3,3))*
     -                (dup1*VCha(Cha3,2) + 
     -                  Sqrt(2.D0)*VCha(Cha3,1)*ZNeu(Neu3,4)))/2.D0 + 
     -             ((-(dup2*UChaC(Cha3,2)) + 
     -                  Sqrt(2.D0)*UChaC(Cha3,1)*ZNeuC(Neu3,3))*
     -                (dup2*VChaC(Cha3,2) + 
     -                  Sqrt(2.D0)*VChaC(Cha3,1)*ZNeuC(Neu3,4)))/2.D0))
     -       )/SW2

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_HmHp_nmfv =', dse_HmHp_nmfv ENDL
#endif

	end


