* dse_WW.F
* this file is part of FeynHiggs
* generated 13 Oct 2008 14:46

#include "externals.h"
#include "debug.h"


	double complex function dse_WW(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex dse_WW_mfv, dse_WW_nmfv
	external dse_WW_mfv, dse_WW_nmfv

	if( nmfv .eq. 0 ) then
	  dse_WW = dse_WW_mfv(k2)
	else
	  dse_WW = dse_WW_nmfv(k2)
	endif

#ifdef DEBUG
	DHIGGS 'k2 =', k2 ENDL
	DHIGGS 'dse_WW =', dse_WW ENDL
#endif
	end


************************************************************************


	double complex function dse_WW_mfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha3, Gen3, Gen4, Neu3, Sfe3, Sfe4, g
	double complex dup1, dup2, dup3, dup4

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_WW_mfv = 0

	do Gen4 = g,3
	do Gen3 = g,3

        dse_WW_mfv = dse_WW_mfv - 
     -   3/(4.D0*Pi)*(Alfa*CKM(Gen3,Gen4)*CKMC(Gen3,Gen4)*
     -       (B1(k2,Mf2(4,Gen4),Mfy2(3,Gen3)) - 
     -         2*DB00(k2,Mf2(4,Gen4),Mfy2(3,Gen3)) + 
     -         k2*DB1(k2,Mf2(4,Gen4),Mfy2(3,Gen3)) + 
     -         DB0(k2,Mf2(4,Gen4),Mfy2(3,Gen3))*Mf2(4,Gen4)))/SW2

	enddo
	enddo

	do Gen4 = g,3
	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

        dse_WW_mfv = 1/(2.D0*Pi)*
     -   (2*Pi*(dse_WW_mfv*SW2) - 
     -      3*Alfa*CKM(Gen3,Gen4)*CKMC(Gen3,Gen4)*
     -       DB00(k2,MSf2(Sfe3,3,Gen3),MSf2(Sfe4,4,Gen4))*
     -       USf(Sfe3,1,3,Gen3)*USf(Sfe4,1,4,Gen4)*
     -       USfC(Sfe3,1,3,Gen3)*USfC(Sfe4,1,4,Gen4))/SW2

	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_WW_mfv =', dse_WW_mfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_WW_mfv =', dse_WW_mfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        dse_WW_mfv = dse_WW_mfv - 
     -   1/(4.D0*Pi)*(Alfa*(B1(k2,0.D0,Mf2(2,Gen3)) - 
     -         2*DB00(k2,0.D0,Mf2(2,Gen3)) + 
     -         k2*DB1(k2,0.D0,Mf2(2,Gen3))))/SW2

	enddo

	do Sfe3 = 1,2
	do Gen3 = 1,3

        dse_WW_mfv = 1/(2.D0*Pi)*
     -   (2*Pi*(dse_WW_mfv*SW2) - 
     -      Alfa*DB00(k2,MSf2(1,1,Gen3),MSf2(Sfe3,2,Gen3))*
     -       USf(Sfe3,1,2,Gen3)*USfC(Sfe3,1,2,Gen3))/SW2

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_WW_mfv =', dse_WW_mfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        dse_WW_mfv = dse_WW_mfv + 
     -   1/(4.D0*Pi)*(Alfa*(CW2**2*(-5*k2 - 2*MW2) + MW2*SW2**2)*
     -        DB0(k2,MW2,MZ2) - 
     -       Alfa*CW2*(5*SW2*B0(k2,0.D0,MW2) - 
     -          MW2*SBA**2*DB0(k2,Mh02,MW2) + DB00(k2,MA02,MHp2) + 
     -          SBA**2*(DB00(k2,Mh02,MW2) + DB00(k2,MHH2,MHp2)) + 
     -          CBA**2*(-(MW2*DB0(k2,MHH2,MW2)) + 
     -             DB00(k2,Mh02,MHp2) + DB00(k2,MHH2,MW2)) + 
     -          DB00(k2,MZ2,MW2) + 
     -          SW2*(2*B1(k2,MW2,0.D0) + MW2*DB0(k2,0.D0,MW2) + 
     -             8*DB00(k2,MW2,0.D0) + 
     -             k2*(5*DB0(k2,0.D0,MW2) + 2*DB1(k2,MW2,0.D0))) + 
     -          CW2*(5*B0(k2,MW2,MZ2) + 
     -             2*(B1(k2,MW2,MZ2) + 4*DB00(k2,MW2,MZ2) + 
     -                k2*DB1(k2,MW2,MZ2)))))/(CW2*SW2)

	do Neu3 = 1,4
	do Cha3 = 1,2

        dup1 = (Sqrt(2.D0)*UChaC(Cha3,1)*ZNeu(Neu3,2) + 
     -     UChaC(Cha3,2)*ZNeu(Neu3,3))/Sqrt(2.D0)

        dup2 = (Sqrt(2.D0)*VChaC(Cha3,1)*ZNeu(Neu3,2) - 
     -     VChaC(Cha3,2)*ZNeu(Neu3,4))/Sqrt(2.D0)

        dup3 = (Sqrt(2.D0)*UCha(Cha3,1)*ZNeuC(Neu3,2) + 
     -     UCha(Cha3,2)*ZNeuC(Neu3,3))/Sqrt(2.D0)

        dup4 = (Sqrt(2.D0)*VCha(Cha3,1)*ZNeuC(Neu3,2) - 
     -     VCha(Cha3,2)*ZNeuC(Neu3,4))/Sqrt(2.D0)

        dse_WW_mfv = dse_WW_mfv + 
     -   1/(2.D0*Pi)*(-(Alfa*(dup1*dup3 + dup2*dup4)*
     -          (B1(k2,MCha2(Cha3),MNeu2(Neu3)) - 
     -            2*DB00(k2,MCha2(Cha3),MNeu2(Neu3)) + 
     -            k2*DB1(k2,MCha2(Cha3),MNeu2(Neu3)))) + 
     -       Alfa*DB0(k2,MCha2(Cha3),MNeu2(Neu3))*
     -        (-(dup2*dup4*MCha2(Cha3)) + 
     -          dup3*dup4*MCha(Cha3)*MNeu(Neu3) + 
     -          dup1*(-(dup3*MCha2(Cha3)) + 
     -             dup2*MCha(Cha3)*MNeu(Neu3))))/SW2

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_WW_mfv =', dse_WW_mfv ENDL
#endif

	end



************************************************************************


	double complex function dse_WW_nmfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All3, All4, Cha3, Gen3, Gen4, Ind1, Ind2, Ind3, Ind4
	integer Neu3, Sfe3, g
	double complex dup1, dup2, dup3, dup4

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_WW_nmfv = 0

	do Gen4 = g,3
	do Gen3 = g,3

        dse_WW_nmfv = dse_WW_nmfv - 
     -   3/(4.D0*Pi)*(Alfa*CKM(Gen3,Gen4)*CKMC(Gen3,Gen4)*
     -       (B1(k2,Mf2(4,Gen4),Mfy2(3,Gen3)) - 
     -         2*DB00(k2,Mf2(4,Gen4),Mfy2(3,Gen3)) + 
     -         k2*DB1(k2,Mf2(4,Gen4),Mfy2(3,Gen3)) + 
     -         DB0(k2,Mf2(4,Gen4),Mfy2(3,Gen3))*Mf2(4,Gen4)))/SW2

	enddo
	enddo

	do All4 = g,6,g
	do All3 = g,6,g
	do Ind4 = g,3
	do Ind3 = g,3
	do Ind2 = g,3
	do Ind1 = g,3

        dse_WW_nmfv = 1/(2.D0*Pi)*
     -   (2*Pi*(dse_WW_nmfv*SW2) - 
     -      3*Alfa*CKM(Ind3,Ind1)*CKMC(Ind4,Ind2)*
     -       DB00(k2,MASf2(All3,3),MASf2(All4,4))*
     -       UASf(All3,Ind3,3)*UASf(All4,Ind2,4)*
     -       UASfC(All3,Ind4,3)*UASfC(All4,Ind1,4))/SW2

	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_WW_nmfv =', dse_WW_nmfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_WW_nmfv =', dse_WW_nmfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        dse_WW_nmfv = dse_WW_nmfv - 
     -   1/(4.D0*Pi)*(Alfa*(B1(k2,0.D0,Mf2(2,Gen3)) - 
     -         2*DB00(k2,0.D0,Mf2(2,Gen3)) + 
     -         k2*DB1(k2,0.D0,Mf2(2,Gen3))))/SW2

	enddo

	do Sfe3 = 1,2
	do Gen3 = 1,3

        dse_WW_nmfv = 1/(2.D0*Pi)*
     -   (2*Pi*(dse_WW_nmfv*SW2) - 
     -      Alfa*DB00(k2,MSf2(1,1,Gen3),MSf2(Sfe3,2,Gen3))*
     -       USf(Sfe3,1,2,Gen3)*USfC(Sfe3,1,2,Gen3))/SW2

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_WW_nmfv =', dse_WW_nmfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        dse_WW_nmfv = dse_WW_nmfv + 
     -   1/(4.D0*Pi)*(Alfa*(CW2**2*(-5*k2 - 2*MW2) + MW2*SW2**2)*
     -        DB0(k2,MW2,MZ2) - 
     -       Alfa*CW2*(5*SW2*B0(k2,0.D0,MW2) - 
     -          MW2*SBA**2*DB0(k2,Mh02,MW2) + DB00(k2,MA02,MHp2) + 
     -          SBA**2*(DB00(k2,Mh02,MW2) + DB00(k2,MHH2,MHp2)) + 
     -          CBA**2*(-(MW2*DB0(k2,MHH2,MW2)) + 
     -             DB00(k2,Mh02,MHp2) + DB00(k2,MHH2,MW2)) + 
     -          DB00(k2,MZ2,MW2) + 
     -          SW2*(2*B1(k2,MW2,0.D0) + MW2*DB0(k2,0.D0,MW2) + 
     -             8*DB00(k2,MW2,0.D0) + 
     -             k2*(5*DB0(k2,0.D0,MW2) + 2*DB1(k2,MW2,0.D0))) + 
     -          CW2*(5*B0(k2,MW2,MZ2) + 
     -             2*(B1(k2,MW2,MZ2) + 4*DB00(k2,MW2,MZ2) + 
     -                k2*DB1(k2,MW2,MZ2)))))/(CW2*SW2)

	do Neu3 = 1,4
	do Cha3 = 1,2

        dup1 = (Sqrt(2.D0)*UChaC(Cha3,1)*ZNeu(Neu3,2) + 
     -     UChaC(Cha3,2)*ZNeu(Neu3,3))/Sqrt(2.D0)

        dup2 = (Sqrt(2.D0)*VChaC(Cha3,1)*ZNeu(Neu3,2) - 
     -     VChaC(Cha3,2)*ZNeu(Neu3,4))/Sqrt(2.D0)

        dup3 = (Sqrt(2.D0)*UCha(Cha3,1)*ZNeuC(Neu3,2) + 
     -     UCha(Cha3,2)*ZNeuC(Neu3,3))/Sqrt(2.D0)

        dup4 = (Sqrt(2.D0)*VCha(Cha3,1)*ZNeuC(Neu3,2) - 
     -     VCha(Cha3,2)*ZNeuC(Neu3,4))/Sqrt(2.D0)

        dse_WW_nmfv = dse_WW_nmfv + 
     -   1/(2.D0*Pi)*(-(Alfa*(dup1*dup3 + dup2*dup4)*
     -          (B1(k2,MCha2(Cha3),MNeu2(Neu3)) - 
     -            2*DB00(k2,MCha2(Cha3),MNeu2(Neu3)) + 
     -            k2*DB1(k2,MCha2(Cha3),MNeu2(Neu3)))) + 
     -       Alfa*DB0(k2,MCha2(Cha3),MNeu2(Neu3))*
     -        (-(dup2*dup4*MCha2(Cha3)) + 
     -          dup3*dup4*MCha(Cha3)*MNeu(Neu3) + 
     -          dup1*(-(dup3*MCha2(Cha3)) + 
     -             dup2*MCha(Cha3)*MNeu(Neu3))))/SW2

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_WW_nmfv =', dse_WW_nmfv ENDL
#endif

	end


