* se_A0Z.F
* this file is part of FeynHiggs
* generated 13 Oct 2008 14:46

#include "externals.h"
#include "debug.h"


	double complex function se_A0Z(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex se_A0Z_mfv, se_A0Z_nmfv
	external se_A0Z_mfv, se_A0Z_nmfv

	if( nmfv .eq. 0 ) then
	  se_A0Z = se_A0Z_mfv(k2)
	else
	  se_A0Z = se_A0Z_nmfv(k2)
	endif

#ifdef DEBUG
	DHIGGS 'k2 =', k2 ENDL
	DHIGGS 'se_A0Z =', se_A0Z ENDL
#endif
	end


************************************************************************


	double complex function se_A0Z_mfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha3, Cha4, Gen3, Neu3, Neu4, Sfe3, Sfe4, g
	double complex dup1, dup10, dup11, dup12, dup13, dup14, dup15
	double complex dup2, dup3, dup4, dup5, dup6, dup7, dup8, dup9

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	se_A0Z_mfv = 0

	do Gen3 = g,3

        se_A0Z_mfv = 1/(8.D0*Pi)*
     -   (8*Pi*(se_A0Z_mfv*CW*MW*SW2*TB) + 
     -      3*cI*(Alfa*B0(k2,Mfy2(3,Gen3),Mfy2(3,Gen3))*
     -         Mfy2(3,Gen3)))/(CW*MW*SW2*TB)

	enddo

	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

        se_A0Z_mfv = se_A0Z_mfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (B0(k2,MSf2(Sfe3,3,Gen3),MSf2(Sfe4,3,Gen3)) + 
     -         2*B1(k2,MSf2(Sfe3,3,Gen3),MSf2(Sfe4,3,Gen3)))*
     -       Mfy(3,Gen3)*(-(MUEC*TB*USf(Sfe4,2,3,Gen3)*
     -            USfC(Sfe3,1,3,Gen3)) - 
     -         Af(3,Gen3,Gen3)*USf(Sfe4,2,3,Gen3)*
     -          USfC(Sfe3,1,3,Gen3) + 
     -         MUE*TB*USf(Sfe4,1,3,Gen3)*USfC(Sfe3,2,3,Gen3) + 
     -         AfC(3,Gen3,Gen3)*USf(Sfe4,1,3,Gen3)*
     -          USfC(Sfe3,2,3,Gen3))*
     -       (-3*USf(Sfe3,1,3,Gen3)*USfC(Sfe4,1,3,Gen3) + 
     -         SW2*(4*USf(Sfe3,1,3,Gen3)*USfC(Sfe4,1,3,Gen3) + 
     -            4*USf(Sfe3,2,3,Gen3)*USfC(Sfe4,2,3,Gen3))))/
     -     (CW*MW*SW2*TB)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_A0Z_mfv =', se_A0Z_mfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen3 = g,3

        se_A0Z_mfv = 1/(8.D0*Pi)*
     -   (8*Pi*(se_A0Z_mfv*CW*MW*SW2) - 
     -      3*cI*(Alfa*TB*B0(k2,Mf2(4,Gen3),Mf2(4,Gen3))*
     -         Mf(4,Gen3)*Mfy(4,Gen3)))/(CW*MW*SW2)

	enddo

	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

        se_A0Z_mfv = se_A0Z_mfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (B0(k2,MSf2(Sfe3,4,Gen3),MSf2(Sfe4,4,Gen3)) + 
     -         2*B1(k2,MSf2(Sfe3,4,Gen3),MSf2(Sfe4,4,Gen3)))*
     -       Mfy(4,Gen3)*((MUEC + TB*Af(4,Gen3,Gen3))*
     -          USf(Sfe4,2,4,Gen3)*USfC(Sfe3,1,4,Gen3) - 
     -         (MUE + TB*AfC(4,Gen3,Gen3))*USf(Sfe4,1,4,Gen3)*
     -          USfC(Sfe3,2,4,Gen3))*
     -       (-3*USf(Sfe3,1,4,Gen3)*USfC(Sfe4,1,4,Gen3) + 
     -         SW2*(2*USf(Sfe3,1,4,Gen3)*USfC(Sfe4,1,4,Gen3) + 
     -            2*USf(Sfe3,2,4,Gen3)*USfC(Sfe4,2,4,Gen3))))/
     -     (CW*MW*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_A0Z_mfv =', se_A0Z_mfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        se_A0Z_mfv = 1/(8.D0*Pi)*
     -   (8*Pi*(se_A0Z_mfv*CW*MW*SW2) - 
     -      cI*(Alfa*TB*B0(k2,Mf2(2,Gen3),Mf2(2,Gen3))*Mf2(2,Gen3))
     -      )/(CW*MW*SW2)

	enddo

	do Sfe4 = 1,2
	do Sfe3 = 1,2
	do Gen3 = 1,3

        se_A0Z_mfv = se_A0Z_mfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (B0(k2,MSf2(Sfe3,2,Gen3),MSf2(Sfe4,2,Gen3)) + 
     -         2*B1(k2,MSf2(Sfe3,2,Gen3),MSf2(Sfe4,2,Gen3)))*
     -       Mf(2,Gen3)*((MUEC + TB*Af(2,Gen3,Gen3))*
     -          USf(Sfe4,2,2,Gen3)*USfC(Sfe3,1,2,Gen3) - 
     -         (MUE + TB*AfC(2,Gen3,Gen3))*USf(Sfe4,1,2,Gen3)*
     -          USfC(Sfe3,2,2,Gen3))*
     -       (-(USf(Sfe3,1,2,Gen3)*USfC(Sfe4,1,2,Gen3)) + 
     -         SW2*(2*USf(Sfe3,1,2,Gen3)*USfC(Sfe4,1,2,Gen3) + 
     -            2*USf(Sfe3,2,2,Gen3)*USfC(Sfe4,2,2,Gen3))))/
     -     (CW*MW*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_A0Z_mfv =', se_A0Z_mfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        se_A0Z_mfv = se_A0Z_mfv - 
     -   cI/(16.D0*Pi)*(Alfa*MW*
     -       (SAB*SBA*(S2B*B0(k2,Mh02,MZ2) + 
     -            2*S2B*B1(k2,Mh02,MZ2)) + 
     -         C2B*(CBA*SAB*
     -             (B0(k2,MA02,Mh02) + 2*B1(k2,Mh02,MA02)) + 
     -            CAB*SBA*(B0(k2,MA02,MHH2) + 2*B1(k2,MHH2,MA02)))+
     -           CBA*(CAB*S2B*
     -             (-B0(k2,MHH2,MZ2) - 2*B1(k2,MHH2,MZ2)) + 
     -            SBA*(4*B0(k2,Mh02,MZ2) - 4*B0(k2,MHH2,MZ2) + 
     -               2*B1(k2,MZ2,Mh02) - 2*B1(k2,MZ2,MHH2)))))/
     -     (CW*CW2*SW2)

	do Cha4 = 1,2
	do Cha3 = 1,2

        dup1 = SW2*Delta(Cha3,Cha4) - 
     -   1/2.D0*(UCha(Cha3,2)*UChaC(Cha4,2)) - 
     -   UCha(Cha3,1)*UChaC(Cha4,1)

        dup2 = SB*UCha(Cha4,2)*VCha(Cha3,1) + 
     -   CB*UCha(Cha4,1)*VCha(Cha3,2)

        dup3 = SW2*Delta(Cha3,Cha4) - 
     -   1/2.D0*(VCha(Cha4,2)*VChaC(Cha3,2)) - 
     -   VCha(Cha4,1)*VChaC(Cha3,1)

        dup4 = SB*UChaC(Cha3,2)*VChaC(Cha4,1) + 
     -   CB*UChaC(Cha3,1)*VChaC(Cha4,2)

        se_A0Z_mfv = se_A0Z_mfv + 
     -   cI/(2.D0*Pi)*(Alfa*((-(dup1*dup2) + dup3*dup4)*
     -          B0(k2,MCha2(Cha3),MCha2(Cha4))*MCha(Cha3) - 
     -         B1(k2,MCha2(Cha3),MCha2(Cha4))*
     -          (-(dup3*dup4*MCha(Cha3)) + dup2*dup3*MCha(Cha4) + 
     -            dup1*(dup2*MCha(Cha3) - dup4*MCha(Cha4)))))/
     -     (CW*SW2*Sqrt(2.D0))

	enddo
	enddo

	do Neu4 = 1,4
	do Neu3 = 1,4

	dup5 = SW*ZNeu(Neu3,1) - CW*ZNeu(Neu3,2)

	dup6 = SW*ZNeu(Neu4,1) - CW*ZNeu(Neu4,2)

	dup7 = -(SW*ZNeu(Neu4,1)) + CW*ZNeu(Neu4,2)

	dup8 = SB*ZNeu(Neu4,3) - CB*ZNeu(Neu4,4)

	dup9 = SW*ZNeuC(Neu3,1) - CW*ZNeuC(Neu3,2)

	dup10 = ZNeu(Neu4,3)*ZNeuC(Neu3,3) - ZNeu(Neu4,4)*ZNeuC(Neu3,4)

	dup11 = SW*ZNeuC(Neu4,1) - CW*ZNeuC(Neu4,2)

	dup12 = -(SW*ZNeuC(Neu4,1)) + CW*ZNeuC(Neu4,2)

	dup13 = SB*ZNeuC(Neu4,3) - CB*ZNeuC(Neu4,4)

        dup14 = -(ZNeu(Neu3,3)*ZNeuC(Neu4,3)) + 
     -   ZNeu(Neu3,4)*ZNeuC(Neu4,4)

        dup15 = dup14*(dup5*dup8 + dup6*SB*ZNeu(Neu3,3) + 
     -      CB*dup7*ZNeu(Neu3,4)) - 
     -   dup10*(dup13*dup9 + dup11*SB*ZNeuC(Neu3,3) + 
     -      CB*dup12*ZNeuC(Neu3,4))

        se_A0Z_mfv = se_A0Z_mfv - 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (dup15*B0(k2,MNeu2(Neu3),MNeu2(Neu4))*MNeu(Neu3) + 
     -         B1(k2,MNeu2(Neu3),MNeu2(Neu4))*
     -          (dup15*MNeu(Neu3) - 
     -            MNeu(Neu4)*
     -             (-(dup10*
     -                  (dup5*dup8 + dup6*SB*ZNeu(Neu3,3) + 
     -                    CB*dup7*ZNeu(Neu3,4))) + 
     -               dup14*
     -                (dup13*dup9 + dup11*SB*ZNeuC(Neu3,3) + 
     -                  CB*dup12*ZNeuC(Neu3,4))))))/(CW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_A0Z_mfv =', se_A0Z_mfv ENDL
#endif

	end



************************************************************************


	double complex function se_A0Z_nmfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All3, All4, Cha3, Cha4, Gen3, Ind1, Ind2, Ind3, Neu3
	integer Neu4, Sfe3, Sfe4, g
	double complex dup1, dup10, dup11, dup12, dup13, dup14, dup15
	double complex dup2, dup3, dup4, dup5, dup6, dup7, dup8, dup9

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	se_A0Z_nmfv = 0

	do Gen3 = g,3

        se_A0Z_nmfv = 1/(8.D0*Pi)*
     -   (8*Pi*(se_A0Z_nmfv*CW*MW*SW2*TB) + 
     -      3*cI*(Alfa*B0(k2,Mfy2(3,Gen3),Mfy2(3,Gen3))*
     -         Mfy2(3,Gen3)))/(CW*MW*SW2*TB)

	enddo

	do All4 = g,6,g
	do All3 = g,6,g
	do Ind3 = g,3
	do Ind2 = g,3
	do Ind1 = g,3

        se_A0Z_nmfv = se_A0Z_nmfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (B0(k2,MASf2(All3,3),MASf2(All4,3)) + 
     -         2*B1(k2,MASf2(All3,3),MASf2(All4,3)))*
     -       (-((Af(3,Ind2,Ind3) + MUEC*TB*Delta(Ind2,Ind3))*
     -            Mfy(3,Ind2)*UASf(All4,3 + Ind3,3)*
     -            UASfC(All3,Ind2,3)) + 
     -         (MUE*TB*Delta(Ind2,Ind3)*Mfy(3,Ind2) + 
     -            AfC(3,Ind3,Ind2)*Mfy(3,Ind3))*UASf(All4,Ind3,3)*
     -          UASfC(All3,3 + Ind2,3))*
     -       (-3*UASf(All3,Ind1,3)*UASfC(All4,Ind1,3) + 
     -         SW2*(4*UASf(All3,Ind1,3)*UASfC(All4,Ind1,3) + 
     -            4*UASf(All3,3 + Ind1,3)*UASfC(All4,3 + Ind1,3))))
     -      /(CW*MW*SW2*TB)

	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_A0Z_nmfv =', se_A0Z_nmfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen3 = g,3

        se_A0Z_nmfv = 1/(8.D0*Pi)*
     -   (8*Pi*(se_A0Z_nmfv*CW*MW*SW2) - 
     -      3*cI*(Alfa*TB*B0(k2,Mf2(4,Gen3),Mf2(4,Gen3))*
     -         Mf(4,Gen3)*Mfy(4,Gen3)))/(CW*MW*SW2)

	enddo

	do All4 = g,6,g
	do All3 = g,6,g
	do Ind3 = g,3
	do Ind2 = g,3
	do Ind1 = g,3

        se_A0Z_nmfv = se_A0Z_nmfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (B0(k2,MASf2(All3,4),MASf2(All4,4)) + 
     -         2*B1(k2,MASf2(All3,4),MASf2(All4,4)))*
     -       ((TB*Af(4,Ind2,Ind3) + MUEC*Delta(Ind2,Ind3))*
     -          Mfy(4,Ind2)*UASf(All4,3 + Ind3,4)*
     -          UASfC(All3,Ind2,4) - 
     -         (MUE*Delta(Ind2,Ind3)*Mfy(4,Ind2) + 
     -            TB*AfC(4,Ind3,Ind2)*Mfy(4,Ind3))*
     -          UASf(All4,Ind3,4)*UASfC(All3,3 + Ind2,4))*
     -       (-3*UASf(All3,Ind1,4)*UASfC(All4,Ind1,4) + 
     -         SW2*(2*UASf(All3,Ind1,4)*UASfC(All4,Ind1,4) + 
     -            2*UASf(All3,3 + Ind1,4)*UASfC(All4,3 + Ind1,4))))
     -      /(CW*MW*SW2)

	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_A0Z_nmfv =', se_A0Z_nmfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        se_A0Z_nmfv = 1/(8.D0*Pi)*
     -   (8*Pi*(se_A0Z_nmfv*CW*MW*SW2) - 
     -      cI*(Alfa*TB*B0(k2,Mf2(2,Gen3),Mf2(2,Gen3))*Mf2(2,Gen3))
     -      )/(CW*MW*SW2)

	enddo

	do Sfe4 = 1,2
	do Sfe3 = 1,2
	do Gen3 = 1,3

        se_A0Z_nmfv = se_A0Z_nmfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (B0(k2,MSf2(Sfe3,2,Gen3),MSf2(Sfe4,2,Gen3)) + 
     -         2*B1(k2,MSf2(Sfe3,2,Gen3),MSf2(Sfe4,2,Gen3)))*
     -       Mf(2,Gen3)*((MUEC + TB*Af(2,Gen3,Gen3))*
     -          USf(Sfe4,2,2,Gen3)*USfC(Sfe3,1,2,Gen3) - 
     -         (MUE + TB*AfC(2,Gen3,Gen3))*USf(Sfe4,1,2,Gen3)*
     -          USfC(Sfe3,2,2,Gen3))*
     -       (-(USf(Sfe3,1,2,Gen3)*USfC(Sfe4,1,2,Gen3)) + 
     -         SW2*(2*USf(Sfe3,1,2,Gen3)*USfC(Sfe4,1,2,Gen3) + 
     -            2*USf(Sfe3,2,2,Gen3)*USfC(Sfe4,2,2,Gen3))))/
     -     (CW*MW*SW2)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_A0Z_nmfv =', se_A0Z_nmfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        se_A0Z_nmfv = se_A0Z_nmfv - 
     -   cI/(16.D0*Pi)*(Alfa*MW*
     -       (SAB*SBA*(S2B*B0(k2,Mh02,MZ2) + 
     -            2*S2B*B1(k2,Mh02,MZ2)) + 
     -         C2B*(CBA*SAB*
     -             (B0(k2,MA02,Mh02) + 2*B1(k2,Mh02,MA02)) + 
     -            CAB*SBA*(B0(k2,MA02,MHH2) + 2*B1(k2,MHH2,MA02)))+
     -           CBA*(CAB*S2B*
     -             (-B0(k2,MHH2,MZ2) - 2*B1(k2,MHH2,MZ2)) + 
     -            SBA*(4*B0(k2,Mh02,MZ2) - 4*B0(k2,MHH2,MZ2) + 
     -               2*B1(k2,MZ2,Mh02) - 2*B1(k2,MZ2,MHH2)))))/
     -     (CW*CW2*SW2)

	do Cha4 = 1,2
	do Cha3 = 1,2

        dup1 = SW2*Delta(Cha3,Cha4) - 
     -   1/2.D0*(UCha(Cha3,2)*UChaC(Cha4,2)) - 
     -   UCha(Cha3,1)*UChaC(Cha4,1)

        dup2 = SB*UCha(Cha4,2)*VCha(Cha3,1) + 
     -   CB*UCha(Cha4,1)*VCha(Cha3,2)

        dup3 = SW2*Delta(Cha3,Cha4) - 
     -   1/2.D0*(VCha(Cha4,2)*VChaC(Cha3,2)) - 
     -   VCha(Cha4,1)*VChaC(Cha3,1)

        dup4 = SB*UChaC(Cha3,2)*VChaC(Cha4,1) + 
     -   CB*UChaC(Cha3,1)*VChaC(Cha4,2)

        se_A0Z_nmfv = se_A0Z_nmfv + 
     -   cI/(2.D0*Pi)*(Alfa*((-(dup1*dup2) + dup3*dup4)*
     -          B0(k2,MCha2(Cha3),MCha2(Cha4))*MCha(Cha3) - 
     -         B1(k2,MCha2(Cha3),MCha2(Cha4))*
     -          (-(dup3*dup4*MCha(Cha3)) + dup2*dup3*MCha(Cha4) + 
     -            dup1*(dup2*MCha(Cha3) - dup4*MCha(Cha4)))))/
     -     (CW*SW2*Sqrt(2.D0))

	enddo
	enddo

	do Neu4 = 1,4
	do Neu3 = 1,4

	dup5 = SW*ZNeu(Neu3,1) - CW*ZNeu(Neu3,2)

	dup6 = SW*ZNeu(Neu4,1) - CW*ZNeu(Neu4,2)

	dup7 = -(SW*ZNeu(Neu4,1)) + CW*ZNeu(Neu4,2)

	dup8 = SB*ZNeu(Neu4,3) - CB*ZNeu(Neu4,4)

	dup9 = SW*ZNeuC(Neu3,1) - CW*ZNeuC(Neu3,2)

	dup10 = ZNeu(Neu4,3)*ZNeuC(Neu3,3) - ZNeu(Neu4,4)*ZNeuC(Neu3,4)

	dup11 = SW*ZNeuC(Neu4,1) - CW*ZNeuC(Neu4,2)

	dup12 = -(SW*ZNeuC(Neu4,1)) + CW*ZNeuC(Neu4,2)

	dup13 = SB*ZNeuC(Neu4,3) - CB*ZNeuC(Neu4,4)

        dup14 = -(ZNeu(Neu3,3)*ZNeuC(Neu4,3)) + 
     -   ZNeu(Neu3,4)*ZNeuC(Neu4,4)

        dup15 = dup14*(dup5*dup8 + dup6*SB*ZNeu(Neu3,3) + 
     -      CB*dup7*ZNeu(Neu3,4)) - 
     -   dup10*(dup13*dup9 + dup11*SB*ZNeuC(Neu3,3) + 
     -      CB*dup12*ZNeuC(Neu3,4))

        se_A0Z_nmfv = se_A0Z_nmfv - 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (dup15*B0(k2,MNeu2(Neu3),MNeu2(Neu4))*MNeu(Neu3) + 
     -         B1(k2,MNeu2(Neu3),MNeu2(Neu4))*
     -          (dup15*MNeu(Neu3) - 
     -            MNeu(Neu4)*
     -             (-(dup10*
     -                  (dup5*dup8 + dup6*SB*ZNeu(Neu3,3) + 
     -                    CB*dup7*ZNeu(Neu3,4))) + 
     -               dup14*
     -                (dup13*dup9 + dup11*SB*ZNeuC(Neu3,3) + 
     -                  CB*dup12*ZNeuC(Neu3,4))))))/(CW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_A0Z_nmfv =', se_A0Z_nmfv ENDL
#endif

	end


