* td_A0.F
* this file is part of FeynHiggs
* generated 13 Oct 2008 14:46

#include "externals.h"
#include "debug.h"


	double complex function td_A0()
	implicit none


#include "FH.h"

	double complex td_A0_mfv, td_A0_nmfv
	external td_A0_mfv, td_A0_nmfv

	if( nmfv .eq. 0 ) then
	  td_A0 = td_A0_mfv()
	else
	  td_A0 = td_A0_nmfv()
	endif

#ifdef DEBUG

	DHIGGS 'td_A0 =', td_A0 ENDL
#endif
	end


************************************************************************


	double complex function td_A0_mfv()
	implicit none

#include "FH.h"
#include "looptools.h"

	integer Cha2, Gen2, Neu2, Sfe2, g
	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	td_A0_mfv = 0

	do Gen2 = g,3
	do Sfe2 = 1,2

        td_A0_mfv = td_A0_mfv + 
     -   (3*cI)/(32.D0*Pi**2)*
     -    (EL*A0(MSf2(Sfe2,3,Gen2))*Mfy(3,Gen2)*
     -       (MUEC*TB*USf(Sfe2,2,3,Gen2)*USfC(Sfe2,1,3,Gen2) + 
     -         Af(3,Gen2,Gen2)*USf(Sfe2,2,3,Gen2)*
     -          USfC(Sfe2,1,3,Gen2) - 
     -         MUE*TB*USf(Sfe2,1,3,Gen2)*USfC(Sfe2,2,3,Gen2) - 
     -         AfC(3,Gen2,Gen2)*USf(Sfe2,1,3,Gen2)*
     -          USfC(Sfe2,2,3,Gen2)))/(MW*SW*TB)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_mfv =', td_A0_mfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen2 = g,3
	do Sfe2 = 1,2

        td_A0_mfv = td_A0_mfv + 
     -   (3*cI)/(32.D0*Pi**2)*
     -    (EL*A0(MSf2(Sfe2,4,Gen2))*Mfy(4,Gen2)*
     -       ((MUEC + TB*Af(4,Gen2,Gen2))*USf(Sfe2,2,4,Gen2)*
     -          USfC(Sfe2,1,4,Gen2) - 
     -         (MUE + TB*AfC(4,Gen2,Gen2))*USf(Sfe2,1,4,Gen2)*
     -          USfC(Sfe2,2,4,Gen2)))/(MW*SW)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_mfv =', td_A0_mfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Sfe2 = 1,2
	do Gen2 = 1,3

        td_A0_mfv = td_A0_mfv + 
     -   cI/(32.D0*Pi**2)*(EL*A0(MSf2(Sfe2,2,Gen2))*Mf(2,Gen2)*
     -       ((MUEC + TB*Af(2,Gen2,Gen2))*USf(Sfe2,2,2,Gen2)*
     -          USfC(Sfe2,1,2,Gen2) - 
     -         (MUE + TB*AfC(2,Gen2,Gen2))*USf(Sfe2,1,2,Gen2)*
     -          USfC(Sfe2,2,2,Gen2)))/(MW*SW)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_mfv =', td_A0_mfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

	do Cha2 = 1,2

        td_A0_mfv = td_A0_mfv - 
     -   cI/(8.D0*Pi**2)*(EL*A0(MCha2(Cha2))*MCha(Cha2)*
     -       (SB*(UCha(Cha2,2)*VCha(Cha2,1) - 
     -            UChaC(Cha2,2)*VChaC(Cha2,1)) + 
     -         CB*(UCha(Cha2,1)*VCha(Cha2,2) - 
     -            UChaC(Cha2,1)*VChaC(Cha2,2))))/(SW*Sqrt(2.D0))

	enddo

	do Neu2 = 1,4

        td_A0_mfv = td_A0_mfv + 
     -   cI/(16.D0*Pi**2)*(EL*A0(MNeu2(Neu2))*MNeu(Neu2)*
     -       (SW*ZNeu(Neu2,1)*
     -          (SB*ZNeu(Neu2,3) - CB*ZNeu(Neu2,4)) + 
     -         CW*ZNeu(Neu2,2)*
     -          (-(SB*ZNeu(Neu2,3)) + CB*ZNeu(Neu2,4)) - 
     -         (SW*ZNeuC(Neu2,1) - CW*ZNeuC(Neu2,2))*
     -          (SB*ZNeuC(Neu2,3) - CB*ZNeuC(Neu2,4))))/(CW*SW)

	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_mfv =', td_A0_mfv ENDL
#endif

	end



************************************************************************


	double complex function td_A0_nmfv()
	implicit none

#include "FH.h"
#include "looptools.h"

	integer All2, Cha2, Gen2, Ind1, Ind2, Neu2, Sfe2, g
	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	td_A0_nmfv = 0

	do All2 = g,6,g
	do Ind2 = g,3
	do Ind1 = g,3

        td_A0_nmfv = td_A0_nmfv + 
     -   (3*cI)/(32.D0*Pi**2)*
     -    (EL*A0(MASf2(All2,3))*
     -       ((Af(3,Ind1,Ind2) + MUEC*TB*Delta(Ind1,Ind2))*
     -          Mfy(3,Ind1)*UASf(All2,3 + Ind2,3)*
     -          UASfC(All2,Ind1,3) - 
     -         (MUE*TB*Delta(Ind1,Ind2)*Mfy(3,Ind1) + 
     -            AfC(3,Ind2,Ind1)*Mfy(3,Ind2))*UASf(All2,Ind2,3)*
     -          UASfC(All2,3 + Ind1,3)))/(MW*SW*TB)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_nmfv =', td_A0_nmfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do All2 = g,6,g
	do Ind2 = g,3
	do Ind1 = g,3

        td_A0_nmfv = td_A0_nmfv + 
     -   (3*cI)/(32.D0*Pi**2)*
     -    (EL*A0(MASf2(All2,4))*
     -       ((TB*Af(4,Ind1,Ind2) + MUEC*Delta(Ind1,Ind2))*
     -          Mfy(4,Ind1)*UASf(All2,3 + Ind2,4)*
     -          UASfC(All2,Ind1,4) - 
     -         (MUE*Delta(Ind1,Ind2)*Mfy(4,Ind1) + 
     -            TB*AfC(4,Ind2,Ind1)*Mfy(4,Ind2))*
     -          UASf(All2,Ind2,4)*UASfC(All2,3 + Ind1,4)))/(MW*SW)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_nmfv =', td_A0_nmfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Sfe2 = 1,2
	do Gen2 = 1,3

        td_A0_nmfv = td_A0_nmfv + 
     -   cI/(32.D0*Pi**2)*(EL*A0(MSf2(Sfe2,2,Gen2))*Mf(2,Gen2)*
     -       ((MUEC + TB*Af(2,Gen2,Gen2))*USf(Sfe2,2,2,Gen2)*
     -          USfC(Sfe2,1,2,Gen2) - 
     -         (MUE + TB*AfC(2,Gen2,Gen2))*USf(Sfe2,1,2,Gen2)*
     -          USfC(Sfe2,2,2,Gen2)))/(MW*SW)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_nmfv =', td_A0_nmfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

	do Cha2 = 1,2

        td_A0_nmfv = td_A0_nmfv - 
     -   cI/(8.D0*Pi**2)*(EL*A0(MCha2(Cha2))*MCha(Cha2)*
     -       (SB*(UCha(Cha2,2)*VCha(Cha2,1) - 
     -            UChaC(Cha2,2)*VChaC(Cha2,1)) + 
     -         CB*(UCha(Cha2,1)*VCha(Cha2,2) - 
     -            UChaC(Cha2,1)*VChaC(Cha2,2))))/(SW*Sqrt(2.D0))

	enddo

	do Neu2 = 1,4

        td_A0_nmfv = td_A0_nmfv + 
     -   cI/(16.D0*Pi**2)*(EL*A0(MNeu2(Neu2))*MNeu(Neu2)*
     -       (SW*ZNeu(Neu2,1)*
     -          (SB*ZNeu(Neu2,3) - CB*ZNeu(Neu2,4)) + 
     -         CW*ZNeu(Neu2,2)*
     -          (-(SB*ZNeu(Neu2,3)) + CB*ZNeu(Neu2,4)) - 
     -         (SW*ZNeuC(Neu2,1) - CW*ZNeuC(Neu2,2))*
     -          (SB*ZNeuC(Neu2,3) - CB*ZNeuC(Neu2,4))))/(CW*SW)

	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_nmfv =', td_A0_nmfv ENDL
#endif

	end


