* EigenSf.F
* diagonalization of the Hermitian 2-by-2 sfermion mass matrix
* this file is part of FeynHiggs
* last modified 19 Mar 08 th

#include "externals.h"


	subroutine EigenSf(fail, m, msq, U, M11, Mf, Xf, sort)
	implicit none
	logical fail
	double precision m(2), msq(4)
	double complex U(2,*)
	double precision M11(2), Mf
	double complex Xf
	integer sort

	double precision m1, m2, M12sq, delta, h, c
	double complex s

* Note the conventions for better numerical stability:
* - M11(1) is the difference M11 - M22,
* - M11(2) is M22.

	m2 = Mf**2
	M12sq = m2*(DBLE(Xf)**2 + DIMAG(Xf)**2)
	h = .5D0*(M11(1) + sign(sqrt(M11(1)**2 + 4*M12sq), M11(1)))
	if( h .ne. 0 ) h = 1/h
	delta = h*M12sq
	c = 1/sqrt(delta*h + 1)
	s = h*c*Mf*DCONJG(Xf)

	m2 = M11(2) + m2
	msq(4) = 2*m2 + M11(1)
	m1 = m2 + M11(1) + delta
	m2 = m2 - delta
	msq(3) = M11(1) + 2*delta

	if( sort .ne. 0 .and. m1 .gt. m2 ) then
	  msq(1) = m2
	  msq(2) = m1
	  U(1,1) = -DCONJG(s)
	  U(2,2) = s
	  U(1,2) = c
	  U(2,1) = c
	else
	  msq(1) = m1
	  msq(2) = m2
	  msq(3) = -msq(3)
	  U(1,1) = c
	  U(2,2) = c
	  U(1,2) = s
	  U(2,1) = -DCONJG(s)
	endif

	fail = m1 .lt. 0 .or. m2 .lt. 0
	msq(1) = max(1D-100, msq(1))
	m(1) = sqrt(msq(1))
	msq(2) = max(2D-100, msq(2))
	m(2) = sqrt(msq(2))
	end

