* RetrievePara.F
* retrieve the input parameters from FeynHiggs
* this file is part of FeynHiggs
* last modified 28 Jul 07 th

#include "externals.h"
#include "debug.h"


	subroutine FHRetrievePara(error, scalefactor_,
     &    AlfasMZ_, MC_, MT_, MB_, MW_, MZ_,
     &    TB_, MA0_, MHp_,
     &    M3SL_, M3SE_, M3SQ_, M3SU_, M3SD_,
     &    M2SL_, M2SE_, M2SQ_, M2SU_, M2SD_,
     &    M1SL_, M1SE_, M1SQ_, M1SU_, M1SD_,
     &    MUE_,
     &    Atau_, At_, Ab_, Amu_, Ac_, As_, Ae_, Au_, Ad_,
     &    M_1_, M_2_, M_3_,
     &    Qtau_, Qt_, Qb_)
	implicit none
	integer error
	double precision scalefactor_
	double precision AlfasMZ_, MC_, MT_, MB_, MW_, MZ_
	double precision TB_, MA0_, MHp_
	double precision M3SL_, M3SE_, M3SQ_, M3SU_, M3SD_
	double precision M2SL_, M2SE_, M2SQ_, M2SU_, M2SD_
	double precision M1SL_, M1SE_, M1SQ_, M1SU_, M1SD_
	double complex MUE_, M_1_, M_2_, M_3_
	double complex At_, Ab_, Atau_, Ac_, As_, Amu_, Au_, Ad_, Ae_
	double precision Qtau_, Qt_, Qb_

#include "FH.h"
#define __SUBROUTINE__ "FHRetrievePara"

	error = 0

	CheckPara()

	if( error .ne. 0 ) return

	scalefactor_ = scalefactor

	AlfasMZ_ = AlfasMZ

	MC_ = MC
	MT_ = MT
	MB_ = MB
	MW_ = MW
	MZ_ = MZ

	TB_ = TB
	if( inputmass .eq. 3 ) then
	  MA0_ = MA0
	  MHp_ = -1
	else
	  MA0_ = -1
	  MHp_ = MHp
	endif

	M3SL_ = SignSqrt(MSS2(1,2,3))
	M3SE_ = SignSqrt(MSS2(2,2,3))
	M3SQ_ = SignSqrt(MSS2(1,3,3))
	M3SU_ = SignSqrt(MSS2(2,3,3))
	M3SD_ = SignSqrt(MSS2(2,4,3))

	M2SL_ = SignSqrt(MSS2(1,2,2))
	M2SE_ = SignSqrt(MSS2(2,2,2))
	M2SQ_ = SignSqrt(MSS2(1,3,2))
	M2SU_ = SignSqrt(MSS2(2,3,2))
	M2SD_ = SignSqrt(MSS2(2,4,2))

	M1SL_ = SignSqrt(MSS2(1,2,1))
	M1SE_ = SignSqrt(MSS2(2,2,1))
	M1SQ_ = SignSqrt(MSS2(1,3,1))
	M1SU_ = SignSqrt(MSS2(2,3,1))
	M1SD_ = SignSqrt(MSS2(2,4,1))

	MUE_ = MUE

	Atau_ = Af(2,3,3)
	At_ = Af(3,3,3)
	Ab_ = Af(4,3,3)

	Amu_ = Af(2,2,2)
	Ac_ = Af(3,2,2)
	As_ = Af(4,2,2)

	Ae_ = Af(2,1,1)
	Au_ = Af(3,1,1)
	Ad_ = Af(4,1,1)

	M_1_ = M_1
	M_2_ = M_2
	M_3_ = M_3

	Qtau_ = Qtau
	Qt_ = Qt
	Qb_ = Qb
	end

