* dse_GmGp.F
* this file is part of FeynHiggs
* generated 13 Oct 2008 14:46

#include "externals.h"
#include "debug.h"


	double complex function dse_GmGp(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex dse_GmGp_mfv, dse_GmGp_nmfv
	external dse_GmGp_mfv, dse_GmGp_nmfv

	if( nmfv .eq. 0 ) then
	  dse_GmGp = dse_GmGp_mfv(k2)
	else
	  dse_GmGp = dse_GmGp_nmfv(k2)
	endif

#ifdef DEBUG
	DHIGGS 'k2 =', k2 ENDL
	DHIGGS 'dse_GmGp =', dse_GmGp ENDL
#endif
	end


************************************************************************


	double complex function dse_GmGp_mfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha3, Gen3, Gen4, Neu3, Sfe3, Sfe4, g
	double complex dup1, dup2, dup3

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_GmGp_mfv = 0

	do Gen4 = g,3
	do Gen3 = g,3

        dse_GmGp_mfv = dse_GmGp_mfv + 
     -   3/(4.D0*Pi)*(Alfa*CKM(Gen3,Gen4)*CKMC(Gen3,Gen4)*
     -       (DB0(k2,Mf2(4,Gen4),Mfy2(3,Gen3))*Mf2(4,Gen4)*
     -          (-Mf2(4,Gen4) + Mfy2(3,Gen3)) - 
     -         (B1(k2,Mf2(4,Gen4),Mfy2(3,Gen3)) + 
     -            k2*DB1(k2,Mf2(4,Gen4),Mfy2(3,Gen3)))*
     -          (Mf2(4,Gen4) + Mfy2(3,Gen3))))/(MW2*SW2)

	enddo
	enddo

	do Gen4 = g,3
	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

	dup1 = C2B*MW2 + Mfy2(3,Gen3) - Mfy2(4,Gen4)

        dse_GmGp_mfv = dse_GmGp_mfv + 
     -   3/(8.D0*Pi)*(Alfa*CKM(Gen3,Gen4)*CKMC(Gen3,Gen4)*
     -       DB0(k2,MSf2(Sfe3,3,Gen3),MSf2(Sfe4,4,Gen4))*
     -       (TB*(dup1*USf(Sfe4,1,4,Gen4) + 
     -            (MUEC*TB - Af(4,Gen4,Gen4))*Mfy(4,Gen4)*
     -             USf(Sfe4,2,4,Gen4))*USfC(Sfe3,1,3,Gen3) + 
     -         (-MUE + TB*AfC(3,Gen3,Gen3))*Mfy(3,Gen3)*
     -          USf(Sfe4,1,4,Gen4)*USfC(Sfe3,2,3,Gen3))*
     -       ((-MUEC + TB*Af(3,Gen3,Gen3))*Mfy(3,Gen3)*
     -          USf(Sfe3,2,3,Gen3)*USfC(Sfe4,1,4,Gen4) + 
     -         USf(Sfe3,1,3,Gen3)*
     -          (dup1*TB*USfC(Sfe4,1,4,Gen4) + 
     -            (MUE*TB2 - TB*AfC(4,Gen4,Gen4))*Mfy(4,Gen4)*
     -             USfC(Sfe4,2,4,Gen4))))/(MW2*SW2*TB2)

	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_GmGp_mfv =', dse_GmGp_mfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_GmGp_mfv =', dse_GmGp_mfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        dse_GmGp_mfv = dse_GmGp_mfv - 
     -   1/(4.D0*Pi)*(Alfa*(B1(k2,0.D0,Mf2(2,Gen3)) + 
     -         k2*DB1(k2,0.D0,Mf2(2,Gen3)))*Mf2(2,Gen3))/(MW2*SW2)

	enddo

	do Sfe3 = 1,2
	do Gen3 = 1,3

        dse_GmGp_mfv = dse_GmGp_mfv + 
     -   1/(8.D0*Pi)*(Alfa*DB0(k2,MSf2(1,1,Gen3),MSf2(Sfe3,2,Gen3))*
     -       ((C2B*MW2 - Mf2(2,Gen3))*USf(Sfe3,1,2,Gen3) + 
     -         (MUEC*TB - Af(2,Gen3,Gen3))*Mf(2,Gen3)*
     -          USf(Sfe3,2,2,Gen3))*
     -       ((C2B*MW2 - Mf2(2,Gen3))*USfC(Sfe3,1,2,Gen3) + 
     -         (MUE*TB - AfC(2,Gen3,Gen3))*Mf(2,Gen3)*
     -          USfC(Sfe3,2,2,Gen3)))/(MW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_GmGp_mfv =', dse_GmGp_mfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        dse_GmGp_mfv = dse_GmGp_mfv + 
     -   1/(16.D0*Pi)*(Alfa*(-4*CW2**2*SW2*B0(k2,0.D0,MW2) - 
     -         CW2**2*SBA**2*B0(k2,Mh02,MW2) - 
     -         CBA**2*CW2**2*B0(k2,MHH2,MW2) - 
     -         CW2*(CW2*(1 + CW2 - 2*SW2) + SW2**2)*
     -          B0(k2,MW2,MZ2) + 2*CW2**2*SBA**2*B1(k2,Mh02,MW2) + 
     -         2*CBA**2*CW2**2*B1(k2,MHH2,MW2) + 
     -         8*CW2**2*SW2*B1(k2,MW2,0.D0) + 
     -         2*CW2*(CW2 - SW2)**2*B1(k2,MW2,MZ2) + 
     -         2*CW2**2*B1(k2,MZ2,MW2) - 
     -         4*CW2**2*(k2 - 3*MW2)*SW2*DB0(k2,0.D0,MW2) + 
     -         CW2**2*MW2*DB0(k2,MA02,MHp2) + 
     -         MW2*(CBA*CW2 - S2B*SAB)**2*DB0(k2,Mh02,MHp2) + 
     -         (C2B**2*MW2*SAB**2 + 
     -            CW2**2*(-(k2*SBA**2) - Mh02*SBA**2))*
     -          DB0(k2,Mh02,MW2) + 
     -         MW2*(CAB*S2B - CW2*SBA)**2*DB0(k2,MHH2,MHp2) + 
     -         (CBA**2*CW2**2*(-k2 - MHH2) + C2B**2*CAB**2*MW2)*
     -          DB0(k2,MHH2,MW2) - 
     -         CW2*(CW2**2*(k2 + MW2) + 
     -            CW2*(MZ2 + MW2*(-2 - 2*SW2) + k2*(1 - 2*SW2)) + 
     -            SW2*(MW2*(2 - 15*SW2) + k2*SW2))*DB0(k2,MW2,MZ2)+
     -           2*CW2**2*k2*SBA**2*DB1(k2,Mh02,MW2) + 
     -         2*CBA**2*CW2**2*k2*DB1(k2,MHH2,MW2) + 
     -         8*CW2**2*k2*SW2*DB1(k2,MW2,0.D0) + 
     -         2*CW2*k2*(CW2 - SW2)**2*DB1(k2,MW2,MZ2) + 
     -         2*CW2**2*k2*DB1(k2,MZ2,MW2)))/(CW2**2*SW2)

	do Neu3 = 1,4
	do Cha3 = 1,2

	dup2 = (SW*ZNeu(Neu3,1) + CW*ZNeu(Neu3,2))/CW

	dup3 = (SW*ZNeuC(Neu3,1) + CW*ZNeuC(Neu3,2))/CW

        dse_GmGp_mfv = dse_GmGp_mfv + 
     -   1/(2.D0*Pi)*(Alfa*(B1(k2,MCha2(Cha3),MNeu2(Neu3)) + 
     -          k2*DB1(k2,MCha2(Cha3),MNeu2(Neu3)))*
     -        (-(1/4.D0*(CB2*
     -               (dup2*Sqrt(2.D0)*UCha(Cha3,2) - 
     -                 2*UCha(Cha3,1)*ZNeu(Neu3,3))*
     -               (dup3*Sqrt(2.D0)*UChaC(Cha3,2) - 
     -                 2*UChaC(Cha3,1)*ZNeuC(Neu3,3)))) - 
     -          (SB2*(dup2*VCha(Cha3,2) + 
     -               Sqrt(2.D0)*VCha(Cha3,1)*ZNeu(Neu3,4))*
     -             (dup3*VChaC(Cha3,2) + 
     -               Sqrt(2.D0)*VChaC(Cha3,1)*ZNeuC(Neu3,4)))/2.D0) + 
     -       Alfa*DB0(k2,MCha2(Cha3),MNeu2(Neu3))*
     -        (-(1/4.D0*(CB2*MCha2(Cha3)*
     -               (dup2*Sqrt(2.D0)*UCha(Cha3,2) - 
     -                 2*UCha(Cha3,1)*ZNeu(Neu3,3))*
     -               (dup3*Sqrt(2.D0)*UChaC(Cha3,2) - 
     -                 2*UChaC(Cha3,1)*ZNeuC(Neu3,3)))) - 
     -          (SB2*MCha2(Cha3)*
     -             (dup2*VCha(Cha3,2) + 
     -               Sqrt(2.D0)*VCha(Cha3,1)*ZNeu(Neu3,4))*
     -             (dup3*VChaC(Cha3,2) + 
     -               Sqrt(2.D0)*VChaC(Cha3,1)*ZNeuC(Neu3,4)))/2.D0 + 
     -          CB*SB*MCha(Cha3)*MNeu(Neu3)*
     -           (((-(dup2*UCha(Cha3,2)) + 
     -                  Sqrt(2.D0)*UCha(Cha3,1)*ZNeu(Neu3,3))*
     -                (dup2*VCha(Cha3,2) + 
     -                  Sqrt(2.D0)*VCha(Cha3,1)*ZNeu(Neu3,4)))/2.D0 + 
     -             ((-(dup3*UChaC(Cha3,2)) + 
     -                  Sqrt(2.D0)*UChaC(Cha3,1)*ZNeuC(Neu3,3))*
     -                (dup3*VChaC(Cha3,2) + 
     -                  Sqrt(2.D0)*VChaC(Cha3,1)*ZNeuC(Neu3,4)))/2.D0))
     -       )/SW2

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_GmGp_mfv =', dse_GmGp_mfv ENDL
#endif

	end



************************************************************************


	double complex function dse_GmGp_nmfv(k2)
	implicit none
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All3, All4, Cha3, Gen3, Gen4, Ind1, Ind2, Ind3, Ind4
	integer Neu3, Sfe3, g
	double complex dup1, dup2

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	dse_GmGp_nmfv = 0

	do Gen4 = g,3
	do Gen3 = g,3

        dse_GmGp_nmfv = dse_GmGp_nmfv + 
     -   3/(4.D0*Pi)*(Alfa*CKM(Gen3,Gen4)*CKMC(Gen3,Gen4)*
     -       (DB0(k2,Mf2(4,Gen4),Mfy2(3,Gen3))*Mf2(4,Gen4)*
     -          (-Mf2(4,Gen4) + Mfy2(3,Gen3)) - 
     -         (B1(k2,Mf2(4,Gen4),Mfy2(3,Gen3)) + 
     -            k2*DB1(k2,Mf2(4,Gen4),Mfy2(3,Gen3)))*
     -          (Mf2(4,Gen4) + Mfy2(3,Gen3))))/(MW2*SW2)

	enddo
	enddo

	do All4 = g,6,g
	do All3 = g,6,g
	do Ind4 = g,3
	do Ind3 = g,3
	do Ind2 = g,3
	do Ind1 = g,3

        dse_GmGp_nmfv = dse_GmGp_nmfv + 
     -   3/(8.D0*Pi)*(Alfa*CKM(Ind3,Ind4)*CKMC(Ind1,Ind2)*
     -       DB0(k2,MASf2(All3,3),MASf2(All4,4))*
     -       (TB*((C2B*MW2 + Mfy2(3,Ind1) - Mfy2(4,Ind2))*
     -             UASf(All4,Ind2,4) + 
     -            (-(Af(4,Ind1,Ind2)*Mfy(4,Ind1)) + 
     -               MUEC*TB*Mfy(4,Ind2))*UASf(All4,3 + Ind2,4))*
     -          UASfC(All3,Ind1,3) + 
     -         (-(MUE*Mfy(3,Ind1)) + 
     -            TB*AfC(3,Ind2,Ind1)*Mfy(3,Ind2))*
     -          UASf(All4,Ind2,4)*UASfC(All3,3 + Ind1,3))*
     -       ((-(MUEC*Mfy(3,Ind3)) + 
     -            TB*Af(3,Ind4,Ind3)*Mfy(3,Ind4))*
     -          UASf(All3,3 + Ind3,3)*UASfC(All4,Ind4,4) + 
     -         UASf(All3,Ind3,3)*
     -          (TB*(C2B*MW2 + Mfy2(3,Ind3) - Mfy2(4,Ind4))*
     -             UASfC(All4,Ind4,4) + 
     -            (-(TB*AfC(4,Ind3,Ind4)*Mfy(4,Ind3)) + 
     -               MUE*TB2*Mfy(4,Ind4))*UASfC(All4,3 + Ind4,4))))
     -      /(MW2*SW2*TB2)

	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_GmGp_nmfv =', dse_GmGp_nmfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_GmGp_nmfv =', dse_GmGp_nmfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        dse_GmGp_nmfv = dse_GmGp_nmfv - 
     -   1/(4.D0*Pi)*(Alfa*(B1(k2,0.D0,Mf2(2,Gen3)) + 
     -         k2*DB1(k2,0.D0,Mf2(2,Gen3)))*Mf2(2,Gen3))/(MW2*SW2)

	enddo

	do Sfe3 = 1,2
	do Gen3 = 1,3

        dse_GmGp_nmfv = dse_GmGp_nmfv + 
     -   1/(8.D0*Pi)*(Alfa*DB0(k2,MSf2(1,1,Gen3),MSf2(Sfe3,2,Gen3))*
     -       ((C2B*MW2 - Mf2(2,Gen3))*USf(Sfe3,1,2,Gen3) + 
     -         (MUEC*TB - Af(2,Gen3,Gen3))*Mf(2,Gen3)*
     -          USf(Sfe3,2,2,Gen3))*
     -       ((C2B*MW2 - Mf2(2,Gen3))*USfC(Sfe3,1,2,Gen3) + 
     -         (MUE*TB - AfC(2,Gen3,Gen3))*Mf(2,Gen3)*
     -          USfC(Sfe3,2,2,Gen3)))/(MW2*SW2)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_GmGp_nmfv =', dse_GmGp_nmfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        dse_GmGp_nmfv = dse_GmGp_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*(-4*CW2**2*SW2*B0(k2,0.D0,MW2) - 
     -         CW2**2*SBA**2*B0(k2,Mh02,MW2) - 
     -         CBA**2*CW2**2*B0(k2,MHH2,MW2) - 
     -         CW2*(CW2*(1 + CW2 - 2*SW2) + SW2**2)*
     -          B0(k2,MW2,MZ2) + 2*CW2**2*SBA**2*B1(k2,Mh02,MW2) + 
     -         2*CBA**2*CW2**2*B1(k2,MHH2,MW2) + 
     -         8*CW2**2*SW2*B1(k2,MW2,0.D0) + 
     -         2*CW2*(CW2 - SW2)**2*B1(k2,MW2,MZ2) + 
     -         2*CW2**2*B1(k2,MZ2,MW2) - 
     -         4*CW2**2*(k2 - 3*MW2)*SW2*DB0(k2,0.D0,MW2) + 
     -         CW2**2*MW2*DB0(k2,MA02,MHp2) + 
     -         MW2*(CBA*CW2 - S2B*SAB)**2*DB0(k2,Mh02,MHp2) + 
     -         (C2B**2*MW2*SAB**2 + 
     -            CW2**2*(-(k2*SBA**2) - Mh02*SBA**2))*
     -          DB0(k2,Mh02,MW2) + 
     -         MW2*(CAB*S2B - CW2*SBA)**2*DB0(k2,MHH2,MHp2) + 
     -         (CBA**2*CW2**2*(-k2 - MHH2) + C2B**2*CAB**2*MW2)*
     -          DB0(k2,MHH2,MW2) - 
     -         CW2*(CW2**2*(k2 + MW2) + 
     -            CW2*(MZ2 + MW2*(-2 - 2*SW2) + k2*(1 - 2*SW2)) + 
     -            SW2*(MW2*(2 - 15*SW2) + k2*SW2))*DB0(k2,MW2,MZ2)+
     -           2*CW2**2*k2*SBA**2*DB1(k2,Mh02,MW2) + 
     -         2*CBA**2*CW2**2*k2*DB1(k2,MHH2,MW2) + 
     -         8*CW2**2*k2*SW2*DB1(k2,MW2,0.D0) + 
     -         2*CW2*k2*(CW2 - SW2)**2*DB1(k2,MW2,MZ2) + 
     -         2*CW2**2*k2*DB1(k2,MZ2,MW2)))/(CW2**2*SW2)

	do Neu3 = 1,4
	do Cha3 = 1,2

	dup1 = (SW*ZNeu(Neu3,1) + CW*ZNeu(Neu3,2))/CW

	dup2 = (SW*ZNeuC(Neu3,1) + CW*ZNeuC(Neu3,2))/CW

        dse_GmGp_nmfv = dse_GmGp_nmfv + 
     -   1/(2.D0*Pi)*(Alfa*(B1(k2,MCha2(Cha3),MNeu2(Neu3)) + 
     -          k2*DB1(k2,MCha2(Cha3),MNeu2(Neu3)))*
     -        (-(1/4.D0*(CB2*
     -               (dup1*Sqrt(2.D0)*UCha(Cha3,2) - 
     -                 2*UCha(Cha3,1)*ZNeu(Neu3,3))*
     -               (dup2*Sqrt(2.D0)*UChaC(Cha3,2) - 
     -                 2*UChaC(Cha3,1)*ZNeuC(Neu3,3)))) - 
     -          (SB2*(dup1*VCha(Cha3,2) + 
     -               Sqrt(2.D0)*VCha(Cha3,1)*ZNeu(Neu3,4))*
     -             (dup2*VChaC(Cha3,2) + 
     -               Sqrt(2.D0)*VChaC(Cha3,1)*ZNeuC(Neu3,4)))/2.D0) + 
     -       Alfa*DB0(k2,MCha2(Cha3),MNeu2(Neu3))*
     -        (-(1/4.D0*(CB2*MCha2(Cha3)*
     -               (dup1*Sqrt(2.D0)*UCha(Cha3,2) - 
     -                 2*UCha(Cha3,1)*ZNeu(Neu3,3))*
     -               (dup2*Sqrt(2.D0)*UChaC(Cha3,2) - 
     -                 2*UChaC(Cha3,1)*ZNeuC(Neu3,3)))) - 
     -          (SB2*MCha2(Cha3)*
     -             (dup1*VCha(Cha3,2) + 
     -               Sqrt(2.D0)*VCha(Cha3,1)*ZNeu(Neu3,4))*
     -             (dup2*VChaC(Cha3,2) + 
     -               Sqrt(2.D0)*VChaC(Cha3,1)*ZNeuC(Neu3,4)))/2.D0 + 
     -          CB*SB*MCha(Cha3)*MNeu(Neu3)*
     -           (((-(dup1*UCha(Cha3,2)) + 
     -                  Sqrt(2.D0)*UCha(Cha3,1)*ZNeu(Neu3,3))*
     -                (dup1*VCha(Cha3,2) + 
     -                  Sqrt(2.D0)*VCha(Cha3,1)*ZNeu(Neu3,4)))/2.D0 + 
     -             ((-(dup2*UChaC(Cha3,2)) + 
     -                  Sqrt(2.D0)*UChaC(Cha3,1)*ZNeuC(Neu3,3))*
     -                (dup2*VChaC(Cha3,2) + 
     -                  Sqrt(2.D0)*VChaC(Cha3,1)*ZNeuC(Neu3,4)))/2.D0))
     -       )/SW2

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'dse_GmGp_nmfv =', dse_GmGp_nmfv ENDL
#endif

	end


