* SetRecord.F
* initialize the FH parameters from a record
* this file is part of FeynHiggs
* last modified 7 Apr 08 th

#include "externals.h"
#include "debug.h"


	subroutine FHSetRecord(error, record, scalefactor)
	implicit none
	integer error
	double precision scalefactor

#include "FHRecord.h"
#define __SUBROUTINE__ "FHSetRecord"

	RecordDecl(record)

	integer v

	if( record(iAdmin,iVar) .eq. 0 ) then
	  Error("must call FHLoopRecord before FHSetRecord")
	  return
	endif

	call FHSetSMPara(error, record(iinvAlfa,iVar),
     &    record(iAlfasMZ,iVar), record(iGF,iVar),
     &    record(iMS,iVar), record(iMC,iVar), record(iMB,iVar),
     &    record(iMW,iVar), record(iMZ,iVar),
     &    record(iCKMlambda,iVar), record(iCKMA,iVar),
     &    record(iCKMrho,iVar), record(iCKMeta,iVar))
	if( error .ne. 0 ) return

	call FHRetrieveSMPara(error, record(iinvAlfa,iVar),
     &    record(iAlfasMZ,iVar), record(iGF,iVar),
     &    record(iMS,iVar), record(iMC,iVar), record(iMB,iVar),
     &    record(iMW,iVar), record(iMZ,iVar),
     &    record(iCKMlambda,iVar), record(iCKMA,iVar),
     &    record(iCKMrho,iVar), record(iCKMeta,iVar))
	if( error .ne. 0 ) return

	call FHSetPara(error, scalefactor, record(iMT,iVar),
     &    record(iTB,iVar), record(iMA0,iVar), record(iMHp,iVar),
     &    record(iM3SL,iVar), record(iM3SE,iVar),
     &    record(iM3SQ,iVar), record(iM3SU,iVar), record(iM3SD,iVar),
     &    record(iM2SL,iVar), record(iM2SE,iVar),
     &    record(iM2SQ,iVar), record(iM2SU,iVar), record(iM2SD,iVar),
     &    record(iM1SL,iVar), record(iM1SE,iVar),
     &    record(iM1SQ,iVar), record(iM1SU,iVar), record(iM1SD,iVar),
     &    record(iMUE,iVar),
     &    record(iAtau,iVar), record(iAt,iVar), record(iAb,iVar),
     &    record(iAmu,iVar), record(iAc,iVar), record(iAs,iVar),
     &    record(iAe,iVar), record(iAu,iVar), record(iAd,iVar),
     &    record(iM1,iVar), record(iM2,iVar), record(iM3,iVar),
     &    record(iQtau,iVar), record(iQt,iVar), record(iQb,iVar))
	if( error .ne. 0 ) return

	do v = ideltaLLuc, ideltaRRdb, 4
	  if( record(iRe(v),iVar) .ne. 0 .or.
     &        record(iIm(v),iVar) .ne. 0 ) then
	    call FHSetNMFV(error,
     &        record(ideltaLLuc,iVar), record(ideltaLRuc,iVar),
     &        record(ideltaRLuc,iVar), record(ideltaRRuc,iVar),
     &        record(ideltaLLct,iVar), record(ideltaLRct,iVar),
     &        record(ideltaRLct,iVar), record(ideltaRRct,iVar),
     &        record(ideltaLLut,iVar), record(ideltaLRut,iVar),
     &        record(ideltaRLut,iVar), record(ideltaRRut,iVar),
     &        record(ideltaLLds,iVar), record(ideltaLRds,iVar),
     &        record(ideltaRLds,iVar), record(ideltaRRds,iVar),
     &        record(ideltaLLsb,iVar), record(ideltaLRsb,iVar),
     &        record(ideltaRLsb,iVar), record(ideltaRRsb,iVar),
     &        record(ideltaLLdb,iVar), record(ideltaLRdb,iVar),
     &        record(ideltaRLdb,iVar), record(ideltaRRdb,iVar))
	    return
	  endif
	enddo
	end

