* Phi.F
* this file is part of FeynHiggs
* last modified 6 Nov 06 th

#include "externals.h"


	double precision function Phi(x, y, z)
	implicit none
	double precision x, y, z

* from Davydychev and Tausk, Nucl. Phys. B397 (1993) 23

	double precision myPhi
	external myPhi

	if( x .le. z .and. y .le. z ) then
	  Phi = myPhi(x, y, z)
	else if( z .le. x .and. y .le. x ) then
	  Phi = z/x*myPhi(z, y, x)
	else
	  Phi = z/y*myPhi(z, x, y)
	endif
	end


************************************************************************
	
	double precision function myPhi(x, y, z)
	implicit none
	double precision x, y, z

	double precision u, v, upv, umv
	double complex clam, alt, cxp, cxm, ccphi

	double complex Dilog
	external Dilog

	double precision Pi
	parameter (Pi = 3.1415926535897932384626433832795029D0)

	u = sqrt(x/z)
	v = sqrt(y/z)
	upv = u + v
	umv = u - v
	clam = sqrt(DCMPLX((1 - upv)*(1 + upv)*(1 - umv)*(1 + umv)))

	cxp = .5D0*(1 + upv*umv - clam)
	alt = .5D0*(1 + upv*umv + clam)
	if( abs(cxp) .lt. abs(alt) ) cxp = u**2/alt
	cxm = .5D0*(1 - upv*umv - clam)
	alt = .5D0*(1 - upv*umv + clam)
	if( abs(cxm) .lt. abs(alt) ) cxm = v**2/alt

* phi function from Eq. (A4)

	ccphi = 2*(log(cxp)*log(cxm) - 2*log(u)*log(v) -
     &    (Dilog(cxp) + Dilog(cxm)) + Pi**2/6D0)/clam
	myPhi = DBLE(ccphi)
	end

