* td_HH.F
* this file is part of FeynHiggs
* generated 13 Oct 2008 14:46

#include "externals.h"
#include "debug.h"


	double complex function td_HH()
	implicit none


#include "FH.h"

	double complex td_HH_mfv, td_HH_nmfv
	external td_HH_mfv, td_HH_nmfv

	if( nmfv .eq. 0 ) then
	  td_HH = td_HH_mfv()
	else
	  td_HH = td_HH_nmfv()
	endif

#ifdef DEBUG

	DHIGGS 'td_HH =', td_HH ENDL
#endif
	end


************************************************************************


	double complex function td_HH_mfv()
	implicit none

#include "FH.h"
#include "looptools.h"

	integer Cha2, Gen2, Neu2, Sfe2, g
	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	td_HH_mfv = 0

	do Gen2 = g,3

        td_HH_mfv = 1/(8.D0*Pi**2)*
     -   (8*Pi**2*(td_HH_mfv*MW*SB*SW) - 
     -      3*EL*SA*A0(Mfy2(3,Gen2))*Mfy2(3,Gen2))/(MW*SB*SW)

	enddo

	do Gen2 = g,3
	do Sfe2 = 1,2

        td_HH_mfv = td_HH_mfv + 
     -   1/(32.D0*Pi**2)*(EL*A0(MSf2(Sfe2,3,Gen2))*
     -       (USf(Sfe2,1,3,Gen2)*
     -          ((CAB*MW*MZ*SB*(3 - 4*SW2) + 6*CW*SA*Mfy2(3,Gen2))*
     -             USfC(Sfe2,1,3,Gen2) + 
     -            3*CW*(-(CA*MUE) + SA*AfC(3,Gen2,Gen2))*
     -             Mfy(3,Gen2)*USfC(Sfe2,2,3,Gen2)) + 
     -         USf(Sfe2,2,3,Gen2)*
     -          (3*CW*(-(CA*MUEC) + SA*Af(3,Gen2,Gen2))*
     -             Mfy(3,Gen2)*USfC(Sfe2,1,3,Gen2) + 
     -            2*(2*CAB*MW*MZ*SB*SW2 + 3*CW*SA*Mfy2(3,Gen2))*
     -             USfC(Sfe2,2,3,Gen2))))/(CW*MW*SB*SW)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_HH_mfv =', td_HH_mfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen2 = g,3

        td_HH_mfv = 1/(8.D0*Pi**2)*
     -   (8*Pi**2*(td_HH_mfv*CB*MW*SW) - 
     -      3*CA*EL*A0(Mf2(4,Gen2))*Hff(2,Gen2,4)*Mf(4,Gen2)*
     -       Mfy(4,Gen2))/(CB*MW*SW)

	enddo

	do Gen2 = g,3
	do Sfe2 = 1,2

        td_HH_mfv = td_HH_mfv + 
     -   1/(32.D0*Pi**2)*(EL*A0(MSf2(Sfe2,4,Gen2))*
     -       (USf(Sfe2,1,4,Gen2)*
     -          ((CAB*CB*MW*MZ*(-3 + 2*SW2) + 
     -               6*CA*CW*Mfy2(4,Gen2))*USfC(Sfe2,1,4,Gen2) + 
     -            3*CW*(-(MUE*SA) + CA*AfC(4,Gen2,Gen2))*
     -             Mfy(4,Gen2)*USfC(Sfe2,2,4,Gen2)) + 
     -         USf(Sfe2,2,4,Gen2)*
     -          (3*CW*(-(MUEC*SA) + CA*Af(4,Gen2,Gen2))*
     -             Mfy(4,Gen2)*USfC(Sfe2,1,4,Gen2) - 
     -            2*(CAB*CB*MW*MZ*SW2 - 3*CA*CW*Mfy2(4,Gen2))*
     -             USfC(Sfe2,2,4,Gen2))))/(CB*CW*MW*SW)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_HH_mfv =', td_HH_mfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen2 = 1,3

        td_HH_mfv = td_HH_mfv + 
     -   1/(32.D0*Pi**2)*(EL*
     -       (CAB*CB*MW*MZ*A0(MSf2(1,1,Gen2)) - 
     -         4*CA*CW*A0(Mf2(2,Gen2))*Mf2(2,Gen2)))/(CB*CW*MW*SW)

	enddo

	do Sfe2 = 1,2
	do Gen2 = 1,3

        td_HH_mfv = td_HH_mfv + 
     -   1/(32.D0*Pi**2)*(EL*A0(MSf2(Sfe2,2,Gen2))*
     -       (USf(Sfe2,1,2,Gen2)*
     -          ((CAB*CB*MW*MZ*(-1 + 2*SW2) + 2*CA*CW*Mf2(2,Gen2))*
     -             USfC(Sfe2,1,2,Gen2) + 
     -            CW*(-(MUE*SA) + CA*AfC(2,Gen2,Gen2))*Mf(2,Gen2)*
     -             USfC(Sfe2,2,2,Gen2)) + 
     -         USf(Sfe2,2,2,Gen2)*
     -          (CW*(-(MUEC*SA) + CA*Af(2,Gen2,Gen2))*Mf(2,Gen2)*
     -             USfC(Sfe2,1,2,Gen2) + 
     -            2*(-(CAB*CB*MW*MZ*SW2) + CA*CW*Mf2(2,Gen2))*
     -             USfC(Sfe2,2,2,Gen2))))/(CB*CW*MW*SW)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_HH_mfv =', td_HH_mfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        td_HH_mfv = td_HH_mfv + 
     -   1/(64.D0*Pi**2)*(EL*MW*
     -       (-(C2B*CAB*A0(MA02)) - 
     -         (C2A*CAB - 2*S2A*SAB)*A0(Mh02) + 
     -         3*C2A*CAB*A0(MHH2) + 
     -         2*(-(C2B*CAB) + 2*CBA*CW2)*A0(MHp2) + 
     -         2*(C2B*CAB + 6*CBA*CW2)*A0(MW2) + 
     -         (C2B*CAB + 6*CBA)*A0(MZ2)))/(CW2*SW)

	do Cha2 = 1,2

        td_HH_mfv = td_HH_mfv - 
     -   1/(8.D0*Pi**2)*(EL*A0(MCha2(Cha2))*MCha(Cha2)*
     -       (CA*(UCha(Cha2,2)*VCha(Cha2,1) + 
     -            UChaC(Cha2,2)*VChaC(Cha2,1)) + 
     -         SA*(UCha(Cha2,1)*VCha(Cha2,2) + 
     -            UChaC(Cha2,1)*VChaC(Cha2,2))))/(SW*Sqrt(2.D0))

	enddo

	do Neu2 = 1,4

        td_HH_mfv = td_HH_mfv + 
     -   1/(16.D0*Pi**2)*(EL*A0(MNeu2(Neu2))*MNeu(Neu2)*
     -       (SW*ZNeu(Neu2,1)*
     -          (CA*ZNeu(Neu2,3) - SA*ZNeu(Neu2,4)) + 
     -         CW*ZNeu(Neu2,2)*
     -          (-(CA*ZNeu(Neu2,3)) + SA*ZNeu(Neu2,4)) + 
     -         (SW*ZNeuC(Neu2,1) - CW*ZNeuC(Neu2,2))*
     -          (CA*ZNeuC(Neu2,3) - SA*ZNeuC(Neu2,4))))/(CW*SW)

	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_HH_mfv =', td_HH_mfv ENDL
#endif

	end



************************************************************************


	double complex function td_HH_nmfv()
	implicit none

#include "FH.h"
#include "looptools.h"

	integer All2, Cha2, Gen2, Ind1, Ind2, Neu2, Sfe2, g
	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	td_HH_nmfv = 0

	do Gen2 = g,3

        td_HH_nmfv = 1/(8.D0*Pi**2)*
     -   (8*Pi**2*(td_HH_nmfv*MW*SB*SW) - 
     -      3*EL*SA*A0(Mfy2(3,Gen2))*Mfy2(3,Gen2))/(MW*SB*SW)

	enddo

	do All2 = g,6,g
	do Ind2 = g,3
	do Ind1 = g,3

        td_HH_nmfv = td_HH_nmfv + 
     -   1/(32.D0*Pi**2)*(EL*A0(MASf2(All2,3))*
     -       ((Delta(Ind1,Ind2)*
     -             (CAB*MW*MZ*SB*(3 - 4*SW2) + 
     -               6*CW*SA*Mfy2(3,Ind1))*UASf(All2,Ind2,3) + 
     -            3*CW*(SA*Af(3,Ind1,Ind2) - 
     -               CA*MUEC*Delta(Ind1,Ind2))*Mfy(3,Ind1)*
     -             UASf(All2,3 + Ind2,3))*UASfC(All2,Ind1,3) + 
     -         (3*CW*(-(CA*MUE*Delta(Ind1,Ind2)*Mfy(3,Ind1)) + 
     -               SA*AfC(3,Ind2,Ind1)*Mfy(3,Ind2))*
     -             UASf(All2,Ind2,3) + 
     -            2*Delta(Ind1,Ind2)*
     -             (2*CAB*MW*MZ*SB*SW2 + 3*CW*SA*Mfy2(3,Ind1))*
     -             UASf(All2,3 + Ind2,3))*UASfC(All2,3 + Ind1,3)))/
     -     (CW*MW*SB*SW)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_HH_nmfv =', td_HH_nmfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen2 = g,3

        td_HH_nmfv = 1/(8.D0*Pi**2)*
     -   (8*Pi**2*(td_HH_nmfv*CB*MW*SW) - 
     -      3*CA*EL*A0(Mf2(4,Gen2))*Hff(2,Gen2,4)*Mf(4,Gen2)*
     -       Mfy(4,Gen2))/(CB*MW*SW)

	enddo

	do All2 = g,6,g
	do Ind2 = g,3
	do Ind1 = g,3

        td_HH_nmfv = td_HH_nmfv + 
     -   1/(32.D0*Pi**2)*(EL*A0(MASf2(All2,4))*
     -       ((Delta(Ind1,Ind2)*
     -             (CAB*CB*MW*MZ*(-3 + 2*SW2) + 
     -               6*CA*CW*Mfy2(4,Ind1))*UASf(All2,Ind2,4) + 
     -            3*CW*(CA*Af(4,Ind1,Ind2) - 
     -               MUEC*SA*Delta(Ind1,Ind2))*Mfy(4,Ind1)*
     -             UASf(All2,3 + Ind2,4))*UASfC(All2,Ind1,4) + 
     -         (3*CW*(-(MUE*SA*Delta(Ind1,Ind2)*Mfy(4,Ind1)) + 
     -               CA*AfC(4,Ind2,Ind1)*Mfy(4,Ind2))*
     -             UASf(All2,Ind2,4) - 
     -            2*Delta(Ind1,Ind2)*
     -             (CAB*CB*MW*MZ*SW2 - 3*CA*CW*Mfy2(4,Ind1))*
     -             UASf(All2,3 + Ind2,4))*UASfC(All2,3 + Ind1,4)))/
     -     (CB*CW*MW*SW)

	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_HH_nmfv =', td_HH_nmfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen2 = 1,3

        td_HH_nmfv = td_HH_nmfv + 
     -   1/(32.D0*Pi**2)*(EL*
     -       (CAB*CB*MW*MZ*A0(MSf2(1,1,Gen2)) - 
     -         4*CA*CW*A0(Mf2(2,Gen2))*Mf2(2,Gen2)))/(CB*CW*MW*SW)

	enddo

	do Sfe2 = 1,2
	do Gen2 = 1,3

        td_HH_nmfv = td_HH_nmfv + 
     -   1/(32.D0*Pi**2)*(EL*A0(MSf2(Sfe2,2,Gen2))*
     -       (USf(Sfe2,1,2,Gen2)*
     -          ((CAB*CB*MW*MZ*(-1 + 2*SW2) + 2*CA*CW*Mf2(2,Gen2))*
     -             USfC(Sfe2,1,2,Gen2) + 
     -            CW*(-(MUE*SA) + CA*AfC(2,Gen2,Gen2))*Mf(2,Gen2)*
     -             USfC(Sfe2,2,2,Gen2)) + 
     -         USf(Sfe2,2,2,Gen2)*
     -          (CW*(-(MUEC*SA) + CA*Af(2,Gen2,Gen2))*Mf(2,Gen2)*
     -             USfC(Sfe2,1,2,Gen2) + 
     -            2*(-(CAB*CB*MW*MZ*SW2) + CA*CW*Mf2(2,Gen2))*
     -             USfC(Sfe2,2,2,Gen2))))/(CB*CW*MW*SW)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_HH_nmfv =', td_HH_nmfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        td_HH_nmfv = td_HH_nmfv + 
     -   1/(64.D0*Pi**2)*(EL*MW*
     -       (-(C2B*CAB*A0(MA02)) - 
     -         (C2A*CAB - 2*S2A*SAB)*A0(Mh02) + 
     -         3*C2A*CAB*A0(MHH2) + 
     -         2*(-(C2B*CAB) + 2*CBA*CW2)*A0(MHp2) + 
     -         2*(C2B*CAB + 6*CBA*CW2)*A0(MW2) + 
     -         (C2B*CAB + 6*CBA)*A0(MZ2)))/(CW2*SW)

	do Cha2 = 1,2

        td_HH_nmfv = td_HH_nmfv - 
     -   1/(8.D0*Pi**2)*(EL*A0(MCha2(Cha2))*MCha(Cha2)*
     -       (CA*(UCha(Cha2,2)*VCha(Cha2,1) + 
     -            UChaC(Cha2,2)*VChaC(Cha2,1)) + 
     -         SA*(UCha(Cha2,1)*VCha(Cha2,2) + 
     -            UChaC(Cha2,1)*VChaC(Cha2,2))))/(SW*Sqrt(2.D0))

	enddo

	do Neu2 = 1,4

        td_HH_nmfv = td_HH_nmfv + 
     -   1/(16.D0*Pi**2)*(EL*A0(MNeu2(Neu2))*MNeu(Neu2)*
     -       (SW*ZNeu(Neu2,1)*
     -          (CA*ZNeu(Neu2,3) - SA*ZNeu(Neu2,4)) + 
     -         CW*ZNeu(Neu2,2)*
     -          (-(CA*ZNeu(Neu2,3)) + SA*ZNeu(Neu2,4)) + 
     -         (SW*ZNeuC(Neu2,1) - CW*ZNeuC(Neu2,2))*
     -          (CA*ZNeuC(Neu2,3) - SA*ZNeuC(Neu2,4))))/(CW*SW)

	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_HH_nmfv =', td_HH_nmfv ENDL
#endif

	end


