* DeltaRho_2L.F
* this file is part of FeynHiggs
* last modified 21 May 10 th

#include "externals.h"


 	double precision function DeltaRho_2L_gluon()
        implicit none

#include "FH.h"

	double precision drf1
	external drf1

	DeltaRho_2L_gluon = GF*AlfasMT/(4*sqrt2*pi**3)*(
     &    USf2(1,1,3,3)*USf2(1,1,4,3)*drf1(MSf2(1,3,3), MSf2(1,4,3)) +
     &    USf2(1,1,3,3)*USf2(2,1,4,3)*drf1(MSf2(1,3,3), MSf2(2,4,3)) +
     &    USf2(2,1,3,3)*USf2(1,1,4,3)*drf1(MSf2(2,3,3), MSf2(1,4,3)) +
     &    USf2(2,1,3,3)*USf2(2,1,4,3)*drf1(MSf2(2,3,3), MSf2(2,4,3)) -
     &    USf2(1,2,3,3)*USf2(2,2,3,3)*drf1(MSf2(1,3,3), MSf2(2,3,3)) -
     &    USf2(1,2,4,3)*USf2(2,2,4,3)*drf1(MSf2(1,4,3), MSf2(2,4,3)) )
	end


************************************************************************

	double precision function drf1(x2, y2)
	implicit none
	double precision x2, y2

	double complex ff, x, y, xlogxy

	double complex Dilog
	external Dilog

	double complex Ieps
	parameter (Ieps = (0D0, 1D-9))

	if( x2 .eq. y2 ) then
	  drf1 = 0
	  return
	endif

	x = (sqrt(x2) - Ieps)**2
	y = (sqrt(y2) - Ieps)**2
	xlogxy = x*log(x/y)

	ff = x + y
     &    - 2*y/(x - y)*xlogxy*(2 + xlogxy/y)
     &    + (x + y)*(xlogxy/(x - y))**2
     &    - 2*(x - y)*Dilog(1 - x/y)
c     &    - 2*(x - y)*(1 - x/y)
	drf1 = DBLE(ff)
	end

