* huuSM-CalcRenConst.F
* renormalization constants
* generated by FormCalc 27 May 2010 17:34
* this file is part of FeynHiggs

#include "externals.h"
#include "debug.h"


	subroutine huuSM_CalcRenConst
	implicit none

#include "Decay.h"
#include "huuSM-renconst.h"

	integer Gen3, Gen4

	double complex dup1, dup2, dup3, dup4, tmp1, tmp2, tmp3, tmp4
	double complex tmp5, tmp6, tmp7

        dMWsq1 = 1/(16.D0*Pi)*
     -   (AlfaMZ*((CW2**2*(-12*MW2 - 8*MZ2) + 4*MW2*SW2**2)*
     -         DBLE(B0(MW2,MW2,MZ2)) + 
     -        CW2*(6*DBLE(A0(MW2)) + (1 + 12*CW2)*DBLE(A0(MZ2)) + 
     -           DBLE(A0(MHiggs2(hno))) - 
     -           32*SW2*DBLE(B00(MW2,MW2,0.D0)) - 
     -           4*(DBLE(B00(MW2,MW2,MZ2)) + 
     -              DBLE(B00(MW2,MW2,MHiggs2(hno)))) + 
     -           MW2*(4*DBLE(B0(MW2,MW2,MHiggs2(hno))) + 
     -              SW2*(-8*DBLE(B0(MW2,0.D0,MW2)) + 
     -                 8*DBLE(B1(MW2,MW2,0.D0))))) + 
     -        CW2**2*(-32*DBLE(B00(MW2,MW2,MZ2)) + 
     -           8*MW2*DBLE(B1(MW2,MW2,MZ2)))))/(CW2*SW2)

	do Gen3 = 1,3

        dMWsq1 = dMWsq1 - 
     -   1/(4.D0*Pi)*(AlfaMZ*
     -       (DBLE(A0(Mf2(2,Gen3))) - 
     -         2*DBLE(B00(MW2,0.D0,Mf2(2,Gen3))) + 
     -         MW2*DBLE(B1(MW2,0.D0,Mf2(2,Gen3)))))/SW2

	enddo

	do Gen4 = 1,3

	tmp1 = A0(Mfy2(7,Gen4))

	do Gen3 = 1,3

        dMWsq1 = dMWsq1 - 
     -   3/(4.D0*Pi)*(AlfaMZ*CKM(Gen3,Gen4)*CKMC(Gen3,Gen4)*
     -       (DBLE(tmp1) - 
     -         2*DBLE(B00(MW2,Mfy2(6,Gen3),Mfy2(7,Gen4))) + 
     -         MW2*DBLE(B1(MW2,Mfy2(6,Gen3),Mfy2(7,Gen4))) + 
     -         DBLE(B0(MW2,Mfy2(6,Gen3),Mfy2(7,Gen4)))*Mfy2(6,Gen3)
     -         ))/SW2

	enddo

	enddo

#ifdef DETAILED_DEBUG
	DCOUP 'dMWsq1 =', dMWsq1 ENDL
#endif

	dup1 = (CW2*(9*CW2 - 2*SW2) + SW2**2)/(CW2*SW2)

        dMZsq1 = 1/(16.D0*Pi)*
     -   (AlfaMZ*(4*MW2*DBLE(B0(MZ2,MZ2,MHiggs2(hno))) + 
     -        2*CW2**2*dup1*SW2*
     -         (DBLE(A0(MW2)) - 2*DBLE(B00(MZ2,MW2,MW2))) + 
     -        CW2*(DBLE(A0(MZ2)) + DBLE(A0(MHiggs2(hno))) + 
     -           8*MW2*SW2**2*DBLE(B0(MZ2,MW2,MW2)) + 
     -           12*DBLE(B00(MZ2,0.D0,0.D0)) - 
     -           4*DBLE(B00(MZ2,MHiggs2(hno),MZ2)) - 
     -           6*MZ2*DBLE(B1(MZ2,0.D0,0.D0))) + 
     -        CW2**3*((-8*MW2 - 20*MZ2)*DBLE(B0(MZ2,MW2,MW2)) - 
     -           8*MZ2*DBLE(B1(MZ2,MW2,MW2)))))/(CW2**2*SW2)

	do Gen3 = 1,3

        dMZsq1 = dMZsq1 - 
     -   1/(24.D0*Pi)*(AlfaMZ*
     -       ((9 + SW2*(-24 + 32*SW2))*DBLE(A0(Mfy2(6,Gen3))) + 
     -         (9 - 12*SW2 + 8*SW2**2)*DBLE(A0(Mfy2(7,Gen3))) + 
     -         (24*SW2 - 48*SW2**2)*
     -          DBLE(B00(MZ2,Mf2(2,Gen3),Mf2(2,Gen3))) + 
     -         (48*SW2 - 64*SW2**2)*
     -          DBLE(B00(MZ2,Mfy2(6,Gen3),Mfy2(6,Gen3))) + 
     -         (24*SW2 - 16*SW2**2)*
     -          DBLE(B00(MZ2,Mfy2(7,Gen3),Mfy2(7,Gen3))) + 
     -         MZ2*((-12*SW2 + 24*SW2**2)*
     -             DBLE(B1(MZ2,Mf2(2,Gen3),Mf2(2,Gen3))) + 
     -            (9 - 24*SW2 + 32*SW2**2)*
     -             DBLE(B1(MZ2,Mfy2(6,Gen3),Mfy2(6,Gen3))) + 
     -            (9 + SW2*(-12 + 8*SW2))*
     -             DBLE(B1(MZ2,Mfy2(7,Gen3),Mfy2(7,Gen3)))) + 
     -         3*((1 + SW2*(-4 + 8*SW2))*DBLE(A0(Mf2(2,Gen3))) - 
     -            2*DBLE(B00(MZ2,Mf2(2,Gen3),Mf2(2,Gen3))) - 
     -            6*(DBLE(B00(MZ2,Mfy2(6,Gen3),Mfy2(6,Gen3))) + 
     -               DBLE(B00(MZ2,Mfy2(7,Gen3),Mfy2(7,Gen3)))) + 
     -            MZ2*DBLE(B1(MZ2,Mf2(2,Gen3),Mf2(2,Gen3))) + 
     -            DBLE(B0(MZ2,Mf2(2,Gen3),Mf2(2,Gen3)))*
     -             Mf2(2,Gen3) + 
     -            3*(DBLE(B0(MZ2,Mfy2(6,Gen3),Mfy2(6,Gen3)))*
     -                Mfy2(6,Gen3) + 
     -               DBLE(B0(MZ2,Mfy2(7,Gen3),Mfy2(7,Gen3)))*
     -                Mfy2(7,Gen3)))))/(CW2*SW2)

	enddo

#ifdef DETAILED_DEBUG
	DCOUP 'dMZsq1 =', dMZsq1 ENDL
#endif

	dSW1 = 1/2.D0*(CW2*(dMZsq1*MW2 - dMWsq1*MZ2))/(MW2*MZ2*SW)

#ifdef DETAILED_DEBUG
	DCOUP 'dSW1 =', dSW1 ENDL
#endif

        dZAA1 = 1/(4.D0*Pi)*
     -   (AlfaMZ*(5*DBLE(B0(0.D0,MW2,MW2)) + 
     -       2*(DBLE(B1(0.D0,MW2,MW2)) + 6*DBLE(DB00(0.D0,MW2,MW2)))))

	do Gen3 = 1,3

        dZAA1 = dZAA1 + 1/(3.D0*Pi)*
     -    (AlfaMZ*(3*DBLE(A0(Mf2(2,Gen3))) + 
     -         4*DBLE(A0(Mfy2(6,Gen3))) + DBLE(A0(Mfy2(7,Gen3))) - 
     -         6*DBLE(B00(MZ2,Mf2(2,Gen3),Mf2(2,Gen3))) - 
     -         8*DBLE(B00(MZ2,Mfy2(6,Gen3),Mfy2(6,Gen3))) - 
     -         2*DBLE(B00(MZ2,Mfy2(7,Gen3),Mfy2(7,Gen3))) + 
     -         MZ2*(3*DBLE(B1(MZ2,Mf2(2,Gen3),Mf2(2,Gen3))) + 
     -            4*DBLE(B1(MZ2,Mfy2(6,Gen3),Mfy2(6,Gen3))) + 
     -            DBLE(B1(MZ2,Mfy2(7,Gen3),Mfy2(7,Gen3))))))/MZ2

	enddo

#ifdef DETAILED_DEBUG
	DCOUP 'dZAA1 =', dZAA1 ENDL
#endif

        dZH1 = 1/(32.D0*Pi)*
     -   (AlfaMZ*(-(CW2**2*
     -           (2*DBLE(DB0(MHiggs2(hno),MW2,MW2)) + 
     -             DBLE(DB0(MHiggs2(hno),MZ2,MZ2)) + 
     -             9*DBLE(DB0(MHiggs2(hno),MHiggs2(hno),
     -                MHiggs2(hno))))*MHiggs2(hno)**2) + 
     -        MW2*(4*(-4*MW2 + CW2*MZ2)*
     -            DBLE(DB0(MHiggs2(hno),MZ2,MZ2)) + 
     -           2*CW2*(2*CW2*DBLE(B0(MHiggs2(hno),MW2,MW2)) + 
     -              DBLE(B0(MHiggs2(hno),MZ2,MZ2)) - 
     -              2*(DBLE(B1(MHiggs2(hno),MZ2,MZ2)) + 
     -                 CW2*
     -                  (2*DBLE(B1(MHiggs2(hno),MW2,MW2)) + 
     -                    6*MW2*DBLE(DB0(MHiggs2(hno),MW2,MW2))))+
     -                (2*CW2*DBLE(DB0(MHiggs2(hno),MW2,MW2)) + 
     -                 DBLE(DB0(MHiggs2(hno),MZ2,MZ2)) - 
     -                 2*(2*CW2*DBLE(DB1(MHiggs2(hno),MW2,MW2)) + 
     -                    DBLE(DB1(MHiggs2(hno),MZ2,MZ2))))*
     -               MHiggs2(hno)))))/(CW2**2*MW2*SW2)

	do Gen3 = 1,3

        dZH1 = dZH1 + 1/(4.D0*Pi)*
     -    (AlfaMZ*(Mf2(2,Gen3)*
     -          (DBLE(B1(MHiggs2(hno),Mf2(2,Gen3),Mf2(2,Gen3))) + 
     -            2*DBLE(DB0(MHiggs2(hno),Mf2(2,Gen3),
     -               Mf2(2,Gen3)))*Mf2(2,Gen3)) + 
     -         3*(Mfy2(6,Gen3)*
     -             (DBLE(B1(MHiggs2(hno),Mfy2(6,Gen3),
     -                 Mfy2(6,Gen3))) + 
     -               2*DBLE(DB0(MHiggs2(hno),Mfy2(6,Gen3),
     -                  Mfy2(6,Gen3)))*Mfy2(6,Gen3)) + 
     -            Mfy2(7,Gen3)*
     -             (DBLE(B1(MHiggs2(hno),Mfy2(7,Gen3),
     -                 Mfy2(7,Gen3))) + 
     -               2*DBLE(DB0(MHiggs2(hno),Mfy2(7,Gen3),
     -                  Mfy2(7,Gen3)))*Mfy2(7,Gen3))) + 
     -         (DBLE(DB1(MHiggs2(hno),Mf2(2,Gen3),Mf2(2,Gen3)))*
     -             Mf2(2,Gen3) + 
     -            3*(DBLE(DB1(MHiggs2(hno),Mfy2(6,Gen3),
     -                  Mfy2(6,Gen3)))*Mfy2(6,Gen3) + 
     -               DBLE(DB1(MHiggs2(hno),Mfy2(7,Gen3),
     -                  Mfy2(7,Gen3)))*Mfy2(7,Gen3)))*MHiggs2(hno))
     -       )/(MW2*SW2)

	enddo

#ifdef DETAILED_DEBUG
	DCOUP 'dZH1 =', dZH1 ENDL
#endif

        dZZA1 = 1/(2.D0*Pi)*
     -   (AlfaMZ*(2*MW2*DBLE(B0(0.D0,MW2,MW2)) - 
     -        (5*CW2 - SW2)*
     -         (DBLE(A0(MW2)) - 2*DBLE(B00(0.D0,MW2,MW2)))))/
     -    (CW*MZ2*SW)

	do Gen3 = 1,3

	dup2 = (1 - 4*SW2)/SW

	dup3 = 1/3.D0*(3 - 8*SW2)/SW

	dup4 = 1/3.D0*(3 - 4*SW2)/SW

        dZZA1 = dZZA1 + 1/(2.D0*Pi)*
     -    (AlfaMZ*(dup2*(DBLE(A0(Mf2(2,Gen3))) - 
     -            2*DBLE(B00(0.D0,Mf2(2,Gen3),Mf2(2,Gen3)))) + 
     -         2*dup3*(DBLE(A0(Mfy2(6,Gen3))) - 
     -            2*DBLE(B00(0.D0,Mfy2(6,Gen3),Mfy2(6,Gen3)))) + 
     -         dup4*(DBLE(A0(Mfy2(7,Gen3))) - 
     -            2*DBLE(B00(0.D0,Mfy2(7,Gen3),Mfy2(7,Gen3))))))/
     -     (CW*MZ2)

	enddo

#ifdef DETAILED_DEBUG
	DCOUP 'dZZA1 =', dZZA1 ENDL
#endif

	dZe1 = -(1/2.D0*(CW*dZAA1 + dZZA1*SW)/CW)

#ifdef DETAILED_DEBUG
	DCOUP 'dZe1 =', dZe1 ENDL
#endif

	do gno1 = 1,3

#ifdef DETAILED_DEBUG
	DCOUP 'gno1 =', gno1 ENDL
#endif

        dMf1(3,gno1) = -(1/(144.D0*Pi)*
     -     (AlfaMZ*Mfy(6,gno1)*
     -        (9*CW2*(-DBLE(B0(Mfy2(6,gno1),Mfy2(6,gno1),
     -                MHiggs2(hno))) + 
     -             DBLE(B1(Mfy2(6,gno1),Mfy2(6,gno1),MHiggs2(hno)))
     -             )*Mfy2(6,gno1) + 
     -          DBLE(B0(Mfy2(6,gno1),MZ2,Mfy2(6,gno1)))*
     -           (MW2*SW2*(-48 + 64*SW2) + 9*CW2*Mfy2(6,gno1)) + 
     -          DBLE(B1(Mfy2(6,gno1),Mfy2(6,gno1),MZ2))*
     -           (MW2*(9 + SW2*(-24 + 32*SW2)) + 
     -             9*CW2*Mfy2(6,gno1))))/(CW2*MW2*SW2))

	do Gen3 = 1,3

        dMf1(3,gno1) = dMf1(3,gno1) - 
     -   1/(16.D0*Pi)*(AlfaMZ*CKM(gno1,Gen3)*CKMC(gno1,Gen3)*
     -       Mfy(6,gno1)*(2*
     -          DBLE(B0(Mfy2(6,gno1),MW2,Mfy2(7,Gen3)))*
     -          Mfy2(7,Gen3) + 
     -         DBLE(B1(Mfy2(6,gno1),Mfy2(7,Gen3),MW2))*
     -          (2*MW2 + Mfy2(6,gno1) + Mfy2(7,Gen3))))/(MW2*SW2)

	enddo

#ifdef DETAILED_DEBUG
	DCOUP 'dMf1(3,gno1) =', dMf1(3,gno1) ENDL
#endif

	enddo

	do gno1 = 1,3

	tmp2 = B1(Mfy2(6,gno1),Mfy2(6,gno1),MZ2)

	tmp3 = B1(Mfy2(6,gno1),Mfy2(6,gno1),MHiggs2(hno))

	tmp4 = DB0(Mfy2(6,gno1),MZ2,Mfy2(6,gno1))

	tmp5 = DB0(Mfy2(6,gno1),Mfy2(6,gno1),MHiggs2(hno))

	tmp6 = DB1(Mfy2(6,gno1),Mfy2(6,gno1),MZ2)

	tmp7 = DB1(Mfy2(6,gno1),Mfy2(6,gno1),MHiggs2(hno))

	do gno2 = 1,3

#ifdef DETAILED_DEBUG
	DCOUP 'gno1,gno2 =', gno1,gno2 ENDL
#endif

	if( gno1.eq.gno2 ) then

        dZfL1(3,gno1,gno2) = 
     -  1/(144.D0*Pi)*(AlfaMZ*
     -      (DBLE(tmp2)*(2*MW2*(3 - 4*SW2)**2 + 
     -           9*CW2*Mfy2(6,gno1)) + 
     -        Mfy2(6,gno1)*
     -         (MW2*(32*SW2*(-3 + 4*SW2)*DBLE(tmp4) + 
     -              2*(9 + SW2*(-24 + 32*SW2))*DBLE(tmp6)) + 
     -           9*CW2*(DBLE(tmp3) + 
     -              2*(DBLE(tmp4) - DBLE(tmp5) + DBLE(tmp6) + 
     -                 DBLE(tmp7))*Mfy2(6,gno1)))))/(CW2*MW2*SW2)

	do Gen3 = 1,3

        dZfL1(3,gno1,gno2) = 
     -  dZfL1(3,gno1,gno2) + 
     -   1/(8.D0*Pi)*(AlfaMZ*CKM(gno1,Gen3)*CKMC(gno1,Gen3)*
     -       (DBLE(B1(Mfy2(6,gno1),Mfy2(7,Gen3),MW2))*
     -          (2*MW2 + Mfy2(7,Gen3)) + 
     -         Mfy2(6,gno1)*
     -          (2*DBLE(DB0(Mfy2(6,gno1),MW2,Mfy2(7,Gen3)))*
     -             Mfy2(7,Gen3) + 
     -            DBLE(DB1(Mfy2(6,gno1),Mfy2(7,Gen3),MW2))*
     -             (2*MW2 + Mfy2(6,gno1) + Mfy2(7,Gen3)))))/
     -     (MW2*SW2)

	enddo

	else

	dZfL1(3,gno1,gno2) = 0

	do Gen3 = 1,3

        dZfL1(3,gno1,gno2) = 
     -  dZfL1(3,gno1,gno2) - 
     -   1/(4.D0*Pi)*(AlfaMZ*CKM(gno1,Gen3)*CKMC(gno2,Gen3)*
     -       (DBLE(B0(Mfy2(6,gno2),MW2,Mfy2(7,Gen3)))*
     -          (Mfy2(6,gno1) + Mfy2(6,gno2))*Mfy2(7,Gen3) + 
     -         DBLE(B1(Mfy2(6,gno2),Mfy2(7,Gen3),MW2))*
     -          Mfy2(6,gno2)*(2*MW2 + Mfy2(6,gno1) + Mfy2(7,Gen3)))
     -       )/(MW2*SW2*(Mfy2(6,gno1) - Mfy2(6,gno2)))

	enddo

	endif

#ifdef DETAILED_DEBUG
	DCOUP 'dZfL1(3,gno1,gno2) =', dZfL1(3,gno1,gno2) ENDL
#endif

	if( gno1.eq.gno2 ) then

        dZfR1(3,gno1,gno2) = 
     -  1/(144.D0*Pi)*(AlfaMZ*
     -      (DBLE(tmp2)*(32*MW2*SW2**2 + 9*CW2*Mfy2(6,gno1)) + 
     -        Mfy2(6,gno1)*
     -         (MW2*(32*SW2*(-3 + 4*SW2)*DBLE(tmp4) + 
     -              2*(9 + SW2*(-24 + 32*SW2))*DBLE(tmp6)) + 
     -           9*CW2*(DBLE(tmp3) + 
     -              2*(DBLE(tmp4) - DBLE(tmp5) + DBLE(tmp6) + 
     -                 DBLE(tmp7))*Mfy2(6,gno1)))))/(CW2*MW2*SW2)

	do Gen3 = 1,3

        dZfR1(3,gno1,gno2) = 
     -  dZfR1(3,gno1,gno2) + 
     -   1/(8.D0*Pi)*(AlfaMZ*CKM(gno1,Gen3)*CKMC(gno1,Gen3)*
     -       Mfy2(6,gno1)*(DBLE(B1(Mfy2(6,gno1),Mfy2(7,Gen3),
     -           MW2)) + 2*
     -          DBLE(DB0(Mfy2(6,gno1),MW2,Mfy2(7,Gen3)))*
     -          Mfy2(7,Gen3) + 
     -         DBLE(DB1(Mfy2(6,gno1),Mfy2(7,Gen3),MW2))*
     -          (2*MW2 + Mfy2(6,gno1) + Mfy2(7,Gen3))))/(MW2*SW2)

	enddo

	else

	dZfR1(3,gno1,gno2) = 0

	do Gen3 = 1,3

        dZfR1(3,gno1,gno2) = 
     -  dZfR1(3,gno1,gno2) - 
     -   1/(4.D0*Pi)*(AlfaMZ*CKM(gno1,Gen3)*CKMC(gno2,Gen3)*
     -       Mfy(6,gno1)*Mfy(6,gno2)*
     -       (2*DBLE(B0(Mfy2(6,gno2),MW2,Mfy2(7,Gen3)))*
     -          Mfy2(7,Gen3) + 
     -         DBLE(B1(Mfy2(6,gno2),Mfy2(7,Gen3),MW2))*
     -          (2*MW2 + Mfy2(6,gno2) + Mfy2(7,Gen3))))/
     -     (MW2*SW2*(Mfy2(6,gno1) - Mfy2(6,gno2)))

	enddo

	endif

#ifdef DETAILED_DEBUG
	DCOUP 'dZfR1(3,gno1,gno2) =', dZfR1(3,gno1,gno2) ENDL
#endif

	enddo

	enddo

	end

