* GetPara.F
* retrieve the SUSY parameters from the internal arrays
* this file is part of FeynHiggs
* last modified 12 Aug 10 th

#include "externals.h"
#include "debug.h"


	subroutine FHGetPara(error,
     &    nmfv_, MASf_, UASf_,
     &    MCha_, UCha_, VCha_, MNeu_, ZNeu_,
     &    Deltab_, MGl_)
	implicit none
	integer error
	integer nmfv_
	double precision MASf_(6,4)
	double precision MCha_(2), MNeu_(4), MGl_
	double complex UASf_(6*6,4), UCha_(2*2), VCha_(2*2)
	double complex ZNeu_(4*4), Deltab_

#include "FH.h"
#define __SUBROUTINE__ "FHGetPara"

	integer i, t

	error = 0

	CheckSf()

	if( error .gt. 0 ) return

	nmfv_ = nmfv

	do t = 1, 4
	  do i = 1, 6
	    MASf_(i,t) = MASf(i,t)
	  enddo
	  do i = 1, 6*6
	    UASf_(i,t) = UASf_flat(i,t)
	  enddo
	enddo

	do i = 1, 2
	  MCha_(i) = MCha(i)
	enddo

	do i = 1, 2*2
	  UCha_(i) = UCha_flat(i)
	enddo

	do i = 1, 2*2
	  VCha_(i) = VCha_flat(i)
	enddo

	do i = 1, 4
	  MNeu_(i) = MNeu(i)
	enddo

	do i = 1, 4*4
	  ZNeu_(i) = ZNeu_flat(i)
	enddo

	Deltab_ = Deltaf(4,3)
	MGl_ = MGl
	end

