* MDcorr.F
* mass-matrix corrections
* generated by db 26 May 2010 15:59
* this file is part of FeynHiggs

#include "externals.h"


	subroutine MDcorr(se, g1, g2, p2, as, Q)
	implicit none
	double complex se(3)
	integer g1, g2
	double precision p2, as, Q

#include "FH.h"
#include "looptools.h"

	integer Cha3, Gen3, Neu3, Sfe3

	se(1) = 0

	do Sfe3 = 1,2

        se(1) = 2/(3.D0*Pi)*
     -    (as*M_3C*B0q(p2,MGl2,MSdL2(Sfe3,g1),Q)*Delta(g1,g2)*
     -      USdL(Sfe3,1,g1)*USdLC(Sfe3,2,g1)) + se(1)

	enddo

	do Sfe3 = 1,2
	do Neu3 = 1,4

        se(1) = -(1/(72.D0*Pi)*
     -      (AlfaGF*B0q(p2,MNeuL(Neu3)**2,MSdL2(Sfe3,g1),Q)*
     -         Delta(g1,g2)*MNeuL(Neu3)*
     -         (CB*MW*USdL(Sfe3,1,g1)*
     -            (SW*ZNeuLC(Neu3,1) - 3*CW*ZNeuLC(Neu3,2)) + 
     -           3*CW*Mfy(4,g1)*USdL(Sfe3,2,g1)*ZNeuLC(Neu3,3))*
     -         (2*CB*MW*SW*USdLC(Sfe3,2,g1)*ZNeuLC(Neu3,1) + 
     -           3*CW*Mfy(4,g1)*USdLC(Sfe3,1,g1)*ZNeuLC(Neu3,3)))/
     -       (CB2*CW2*MW2*SW2)) + se(1)

	enddo
	enddo

	do Sfe3 = 1,2
	do Gen3 = 1,3
	do Cha3 = 1,2

        se(1) = 1/(8.D0*Pi*sqrt2)*
     -    (AlfaGF*B0q(p2,MChaL(Cha3)**2,MSf2(Sfe3,3,Gen3),Q)*
     -       CKM(Gen3,g1)*CKMC(Gen3,g2)*MChaL(Cha3)*Mfy(4,g2)*
     -       UChaLC(Cha3,2)*USfC(Sfe3,1,3,Gen3)*
     -       (-(sqrt2*(Mfy(3,Gen3)*USf(Sfe3,2,3,Gen3)*
     -              VChaLC(Cha3,2))) + 
     -         2*MW*SB*USf(Sfe3,1,3,Gen3)*VChaLC(Cha3,1)))/
     -     (CB*MW2*SB*SW2) + se(1)

	enddo
	enddo
	enddo

	se(2) = 0

	do Sfe3 = 1,2

        se(2) = 1/(3.D0*Pi)*
     -    (as*B1q(p2,MGl2,MSdL2(Sfe3,g1),Q)*Delta(g1,g2)*
     -      USdL(Sfe3,1,g1)*USdLC(Sfe3,1,g1)) + se(2)

	enddo

	do Sfe3 = 1,2
	do Neu3 = 1,4

        se(2) = 1/(144.D0*Pi)*
     -    (AlfaGF*B1q(p2,MNeuL(Neu3)**2,MSdL2(Sfe3,g1),Q)*
     -       Delta(g1,g2)*(CB*MW*USdLC(Sfe3,1,g1)*
     -          (SW*ZNeuL(Neu3,1) - 3*CW*ZNeuL(Neu3,2)) + 
     -         3*CW*Mfy(4,g1)*USdLC(Sfe3,2,g1)*ZNeuL(Neu3,3))*
     -       (CB*MW*USdL(Sfe3,1,g1)*
     -          (SW*ZNeuLC(Neu3,1) - 3*CW*ZNeuLC(Neu3,2)) + 
     -         3*CW*Mfy(4,g1)*USdL(Sfe3,2,g1)*ZNeuLC(Neu3,3)))/
     -     (CB2*CW2*MW2*SW2) + se(2)

	enddo
	enddo

	do Sfe3 = 1,2
	do Gen3 = 1,3
	do Cha3 = 1,2

        se(2) = 1/(32.D0*Pi)*
     -    (AlfaGF*B1q(p2,MChaL(Cha3)**2,MSf2(Sfe3,3,Gen3),Q)*
     -       CKM(Gen3,g1)*CKMC(Gen3,g2)*
     -       (-(sqrt2*(Mfy(3,Gen3)*USfC(Sfe3,2,3,Gen3)*
     -              VChaL(Cha3,2))) + 
     -         2*MW*SB*USfC(Sfe3,1,3,Gen3)*VChaL(Cha3,1))*
     -       (-(sqrt2*(Mfy(3,Gen3)*USf(Sfe3,2,3,Gen3)*
     -              VChaLC(Cha3,2))) + 
     -         2*MW*SB*USf(Sfe3,1,3,Gen3)*VChaLC(Cha3,1)))/
     -     (MW2*SB2*SW2) + se(2)

	enddo
	enddo
	enddo

	se(3) = 0

	do Sfe3 = 1,2

        se(3) = 1/(3.D0*Pi)*
     -    (as*B1q(p2,MGl2,MSdL2(Sfe3,g1),Q)*Delta(g1,g2)*
     -      USdL(Sfe3,2,g1)*USdLC(Sfe3,2,g1)) + se(3)

	enddo

	do Sfe3 = 1,2
	do Neu3 = 1,4

        se(3) = 1/(144.D0*Pi)*
     -    (AlfaGF*B1q(p2,MNeuL(Neu3)**2,MSdL2(Sfe3,g1),Q)*
     -       Delta(g1,g2)*(2*CB*MW*SW*USdL(Sfe3,2,g1)*
     -          ZNeuL(Neu3,1) + 
     -         3*CW*Mfy(4,g1)*USdL(Sfe3,1,g1)*ZNeuL(Neu3,3))*
     -       (2*CB*MW*SW*USdLC(Sfe3,2,g1)*ZNeuLC(Neu3,1) + 
     -         3*CW*Mfy(4,g1)*USdLC(Sfe3,1,g1)*ZNeuLC(Neu3,3)))/
     -     (CB2*CW2*MW2*SW2) + se(3)

	enddo
	enddo

	do Sfe3 = 1,2
	do Gen3 = 1,3
	do Cha3 = 1,2

        se(3) = 1/(16.D0*Pi)*
     -    (AlfaGF*B1q(p2,MChaL(Cha3)**2,MSf2(Sfe3,3,Gen3),Q)*
     -       CKM(Gen3,g1)*CKMC(Gen3,g2)*Mfy(4,g1)*Mfy(4,g2)*
     -       UChaL(Cha3,2)*UChaLC(Cha3,2)*USf(Sfe3,1,3,Gen3)*
     -       USfC(Sfe3,1,3,Gen3))/(CB2*MW2*SW2) + se(3)

	enddo
	enddo
	enddo

	end

