* RetrievePara.F
* retrieve the input parameters from FeynHiggs
* this file is part of FeynHiggs
* last modified 7 Jul 10 th

#include "externals.h"
#include "debug.h"


	subroutine FHRetrievePara(error, scalefactor_,
     &    MT_, TB_, MA0_, MHp_,
     &    M3SL_, M3SE_, M3SQ_, M3SU_, M3SD_,
     &    M2SL_, M2SE_, M2SQ_, M2SU_, M2SD_,
     &    M1SL_, M1SE_, M1SQ_, M1SU_, M1SD_,
     &    MUE_,
     &    Atau_, At_, Ab_, Amu_, Ac_, As_, Ae_, Au_, Ad_,
     &    M_1_, M_2_, M_3_,
     &    Qtau_, Qt_, Qb_)
	implicit none
	integer error
	double precision scalefactor_
	double precision MT_, TB_, MA0_, MHp_
	double precision M3SL_, M3SE_, M3SQ_, M3SU_, M3SD_
	double precision M2SL_, M2SE_, M2SQ_, M2SU_, M2SD_
	double precision M1SL_, M1SE_, M1SQ_, M1SU_, M1SD_
	double complex MUE_, M_1_, M_2_, M_3_
	double complex At_, Ab_, Atau_, Ac_, As_, Amu_, Au_, Ad_, Ae_
	double precision Qtau_, Qt_, Qb_

#include "FH.h"
#define __SUBROUTINE__ "FHRetrievePara"

	double precision signsqrt
	double complex c
	signsqrt(c) = sign(sqrt(abs(DBLE(c))), DBLE(c))

	error = 0

	CheckPara()

	if( error .gt. 0 ) return

	scalefactor_ = scalefactor

	MT_ = MT
	TB_ = TB
	if( inputmass .eq. 3 ) then
	  MA0_ = MA0
	  MHp_ = -1
	else
	  MA0_ = -1
	  MHp_ = MHp
	endif

	M3SL_ = signsqrt(MSS2(1,2,3,3))
	M3SE_ = signsqrt(MSS2(2,2,3,3))
	M3SQ_ = signsqrt(MSS2(1,3,3,3))
	M3SU_ = signsqrt(MSS2(2,3,3,3))
	M3SD_ = signsqrt(MSS2(2,4,3,3))

	M2SL_ = signsqrt(MSS2(1,2,2,2))
	M2SE_ = signsqrt(MSS2(2,2,2,2))
	M2SQ_ = signsqrt(MSS2(1,3,2,2))
	M2SU_ = signsqrt(MSS2(2,3,2,2))
	M2SD_ = signsqrt(MSS2(2,4,2,2))

	M1SL_ = signsqrt(MSS2(1,2,1,1))
	M1SE_ = signsqrt(MSS2(2,2,1,1))
	M1SQ_ = signsqrt(MSS2(1,3,1,1))
	M1SU_ = signsqrt(MSS2(2,3,1,1))
	M1SD_ = signsqrt(MSS2(2,4,1,1))

	MUE_ = MUE

	Atau_ = Af(2,3)
	At_ = Af(3,3)
	Ab_ = Af(4,3)

	Amu_ = Af(2,2)
	Ac_ = Af(3,2)
	As_ = Af(4,2)

	Ae_ = Af(2,1)
	Au_ = Af(3,1)
	Ad_ = Af(4,1)

	M_1_ = M_1
	M_2_ = M_2
	M_3_ = M_3

	Qtau_ = QSf(2)
	Qt_ = QSf(3)
	Qb_ = QSf(4)
	end

