* SetNMFV.F
* set the non-minimal flavour-violation parameters
* this file is part of FeynHiggs
* last modified 19 Sep 09 th

#include "externals.h"
#include "debug.h"
#include "SLHADefs.h"


	subroutine FHSetNMFV(error,
     &    deltaLL12_, deltaLL23_, deltaLL13_,
     &    deltaLRuc_, deltaLRct_, deltaLRut_,
     &    deltaRLuc_, deltaRLct_, deltaRLut_,
     &    deltaRRuc_, deltaRRct_, deltaRRut_,
     &    deltaLRds_, deltaLRsb_, deltaLRdb_,
     &    deltaRLds_, deltaRLsb_, deltaRLdb_,
     &    deltaRRds_, deltaRRsb_, deltaRRdb_)
	implicit none
	integer error, t
	double complex deltaLL12_, deltaLL23_, deltaLL13_
	double complex deltaLRuc_, deltaLRct_, deltaLRut_
	double complex deltaRLuc_, deltaRLct_, deltaRLut_
	double complex deltaRRuc_, deltaRRct_, deltaRRut_
	double complex deltaLRds_, deltaLRsb_, deltaLRdb_
	double complex deltaRLds_, deltaRLsb_, deltaRLdb_
	double complex deltaRRds_, deltaRRsb_, deltaRRdb_

#include "FH.h"
#include "FHRecord.h"
#define __SUBROUTINE__ "FHSetNMFV"

	double precision XL1, XR1, XL2, XR2, XL3, XR3

	error = 0

	CheckPara()

	if( error .gt. 0 ) return

	if( debuglevel .ge. 2 ) then
	  DPARA "============================"	ENDL
	  DPARA "FHSetNMFV input:"		ENDL
	  DPARA "----------------------------"	ENDL

	  DTAGrez(ideltaLL12, deltaLL12_)
	  DTAGimz(ideltaLL12, deltaLL12_)
	  DTAGrez(ideltaLL23, deltaLL23_)
	  DTAGimz(ideltaLL23, deltaLL23_)
	  DTAGrez(ideltaLL13, deltaLL13_)
	  DTAGimz(ideltaLL13, deltaLL13_)

	  DTAGrez(ideltaLRuc, deltaLRuc_)
	  DTAGimz(ideltaLRuc, deltaLRuc_)
	  DTAGrez(ideltaLRct, deltaLRct_)
	  DTAGimz(ideltaLRct, deltaLRct_)
	  DTAGrez(ideltaLRut, deltaLRut_)
	  DTAGimz(ideltaLRut, deltaLRut_)

	  DTAGrez(ideltaRLuc, deltaRLuc_)
	  DTAGimz(ideltaRLuc, deltaRLuc_)
	  DTAGrez(ideltaRLct, deltaRLct_)
	  DTAGimz(ideltaRLct, deltaRLct_)
	  DTAGrez(ideltaRLut, deltaRLut_)
	  DTAGimz(ideltaRLut, deltaRLut_)

	  DTAGrez(ideltaRRuc, deltaRRuc_)
	  DTAGimz(ideltaRRuc, deltaRRuc_)
	  DTAGrez(ideltaRRct, deltaRRct_)
	  DTAGimz(ideltaRRct, deltaRRct_)
	  DTAGrez(ideltaRRut, deltaRRut_)
	  DTAGimz(ideltaRRut, deltaRRut_)

	  DTAGrez(ideltaLRds, deltaLRds_)
	  DTAGimz(ideltaLRds, deltaLRds_)
	  DTAGrez(ideltaLRsb, deltaLRsb_)
	  DTAGimz(ideltaLRsb, deltaLRsb_)
	  DTAGrez(ideltaLRdb, deltaLRdb_)
	  DTAGimz(ideltaLRdb, deltaLRdb_)

	  DTAGrez(ideltaRLds, deltaRLds_)
	  DTAGimz(ideltaRLds, deltaRLds_)
	  DTAGrez(ideltaRLsb, deltaRLsb_)
	  DTAGimz(ideltaRLsb, deltaRLsb_)
	  DTAGrez(ideltaRLdb, deltaRLdb_)
	  DTAGimz(ideltaRLdb, deltaRLdb_)

	  DTAGrez(ideltaRRds, deltaRRds_)
	  DTAGimz(ideltaRRds, deltaRRds_)
	  DTAGrez(ideltaRRsb, deltaRRsb_)
	  DTAGimz(ideltaRRsb, deltaRRsb_)
	  DTAGrez(ideltaRRdb, deltaRRdb_)
	  DTAGimz(ideltaRRdb, deltaRRdb_)
	endif


	deltaSf_LL(1,2,3) = deltaLL12_
	deltaSf_LL(2,3,3) = deltaLL23_
	deltaSf_LL(1,3,3) = deltaLL13_

	deltaSf_LR(1,2,3) = deltaLRuc_
	deltaSf_LR(2,3,3) = deltaLRct_
	deltaSf_LR(1,3,3) = deltaLRut_

	deltaSf_RL(1,2,3) = deltaRLuc_
	deltaSf_RL(2,3,3) = deltaRLct_
	deltaSf_RL(1,3,3) = deltaRLut_

	deltaSf_RR(1,2,3) = deltaRRuc_
	deltaSf_RR(2,3,3) = deltaRRct_
	deltaSf_RR(1,3,3) = deltaRRut_

	deltaSf_LL(1,2,4) = deltaLL12_
	deltaSf_LL(2,3,4) = deltaLL23_
	deltaSf_LL(1,3,4) = deltaLL13_

	deltaSf_LR(1,2,4) = deltaLRds_
	deltaSf_LR(2,3,4) = deltaLRsb_
	deltaSf_LR(1,3,4) = deltaLRdb_

	deltaSf_RL(1,2,4) = deltaRLds_
	deltaSf_RL(2,3,4) = deltaRLsb_
	deltaSf_RL(1,3,4) = deltaRLdb_

	deltaSf_RR(1,2,4) = deltaRRds_
	deltaSf_RR(2,3,4) = deltaRRsb_
	deltaSf_RR(1,3,4) = deltaRRdb_

	do t = 3, 4
	  XL1 = sqrt(DBLE(MSS2(1,t,1,1)) + DSf(1,t) + Mf2(t,1))
	  XR1 = sqrt(DBLE(MSS2(2,t,1,1)) + DSf(2,t) + Mf2(t,1))
	  XL2 = sqrt(DBLE(MSS2(1,t,2,2)) + DSf(1,t) + Mf2(t,2))
	  XR2 = sqrt(DBLE(MSS2(2,t,2,2)) + DSf(2,t) + Mf2(t,2))
	  XL3 = sqrt(DBLE(MSS2(1,t,3,3)) + DSf(1,t) + Mf2(t,3))
	  XR3 = sqrt(DBLE(MSS2(2,t,3,3)) + DSf(2,t) + Mf2(t,3))

	  MSS2(1,t,1,2) = deltaSf_LL(1,2,t)*XL1*XL2
	  MSS2(1,t,2,3) = deltaSf_LL(2,3,t)*XL2*XL3
	  MSS2(1,t,1,3) = deltaSf_LL(1,3,t)*XL1*XL3

	  MSS2(2,t,1,2) = deltaSf_RR(1,2,t)*XR1*XR2
	  MSS2(2,t,2,3) = deltaSf_RR(2,3,t)*XR2*XR3
	  MSS2(2,t,1,3) = deltaSf_RR(1,3,t)*XR1*XR3

	  Kf(t,1,2) = deltaSf_LR(1,2,t)*XL1*XR2
	  Kf(t,2,3) = deltaSf_LR(2,3,t)*XL2*XR3
	  Kf(t,1,3) = deltaSf_LR(1,3,t)*XL1*XR3
	  Kf(t,2,1) = DCONJG(deltaSf_RL(1,2,t)*XR1*XL2)
	  Kf(t,3,2) = DCONJG(deltaSf_RL(2,3,t)*XR2*XL3)
	  Kf(t,3,1) = DCONJG(deltaSf_RL(1,3,t)*XR1*XL3)

	  nmfv = ibset(nmfv, t)
	enddo

	sf_valid = 0
	end


************************************************************************

	subroutine SetNMFVSLHA(t, MSQ2_, MSU2_, TU_)
	implicit none
	integer t
	double complex MSQ2_(3,3), MSU2_(3,3), TU_(3,3)

#include "FH.h"

	integer g, g2
	double precision x
	double precision XL1, XR1, XL2, XR2, XL3, XR3

	if( debuglevel .ge. 2 ) then
	  DPARA "============================"	ENDL
	  DPARA "SetNMFVSLHA input:"		ENDL
	  DPARA "----------------------------"	ENDL
	  DPARA "t =", t			ENDL
	  DPARA "MSQ2(1,1) =", MSQ2_(1,1)	ENDL
	  DPARA "    (1,2) =", MSQ2_(1,2)	ENDL
	  DPARA "    (1,3) =", MSQ2_(1,3)	ENDL
	  DPARA "    (2,2) =", MSQ2_(2,2)	ENDL
	  DPARA "    (2,3) =", MSQ2_(2,3)	ENDL
	  DPARA "    (3,3) =", MSQ2_(3,3)	ENDL
	  DPARA "MSU2(1,1) =", MSU2_(1,1)	ENDL
	  DPARA "    (1,2) =", MSU2_(1,2)	ENDL
	  DPARA "    (1,3) =", MSU2_(1,3)	ENDL
	  DPARA "    (2,2) =", MSU2_(2,2)	ENDL
	  DPARA "    (2,3) =", MSU2_(2,3)	ENDL
	  DPARA "    (3,3) =", MSU2_(3,3)	ENDL
	  DPARA "  TU(1,1) =", TU_(1,1)		ENDL
	  DPARA "    (1,2) =", TU_(1,2)		ENDL
	  DPARA "    (1,3) =", TU_(1,3)		ENDL
	  DPARA "    (2,1) =", TU_(2,1)		ENDL
	  DPARA "    (2,2) =", TU_(2,2)		ENDL
	  DPARA "    (2,3) =", TU_(2,3)		ENDL
	  DPARA "    (3,1) =", TU_(3,1)		ENDL
	  DPARA "    (3,2) =", TU_(3,2)		ENDL
	  DPARA "    (3,3) =", TU_(3,3)		ENDL
	endif

	do g2 = 1, 3
	  do g = g2, 3
	    MSS2(1,t,g,g2) = 0
	    if( MSQ2_(g,g2) .ne. invalid ) MSS2(1,t,g,g2) = MSQ2_(g,g2)
	  enddo
	enddo

	do g2 = 1, 3
	  do g = g2, 3
	    MSS2(2,t,g,g2) = 0
	    if( MSU2_(g,g2) .ne. invalid ) MSS2(2,t,g,g2) = MSU2_(g,g2)
	  enddo
	enddo

	x = vev/sqrt2*CSB(t)
	do g2 = 1, 3
	  do g = 1, 3
	    Kf(t,g,g2) = 0
	    if( TU_(g,g2) .ne. invalid ) Kf(t,g,g2) = x*TU_(g,g2)
	  enddo
	enddo

	XL1 = 1/sqrt(DBLE(MSS2(1,t,1,1)) + DSf(1,t) + Mf2(t,1))
	XR1 = 1/sqrt(DBLE(MSS2(2,t,1,1)) + DSf(2,t) + Mf2(t,1))
	XL2 = 1/sqrt(DBLE(MSS2(1,t,2,2)) + DSf(1,t) + Mf2(t,2))
	XR2 = 1/sqrt(DBLE(MSS2(2,t,2,2)) + DSf(2,t) + Mf2(t,2))
	XL3 = 1/sqrt(DBLE(MSS2(1,t,3,3)) + DSf(1,t) + Mf2(t,3))
	XR3 = 1/sqrt(DBLE(MSS2(2,t,3,3)) + DSf(2,t) + Mf2(t,3))

	deltaSf_LL(1,2,t) = MSS2(1,t,1,2)*XL1*XL2
	deltaSf_LR(1,2,t) = Kf(t,1,2)*XL1*XR2
	deltaSf_RL(1,2,t) = DCONJG(Kf(t,2,1))*XR1*XL2
	deltaSf_RR(1,2,t) = MSS2(2,t,1,2)*XR1*XR2

	deltaSf_LL(2,3,t) = MSS2(1,t,2,3)*XL2*XL3
	deltaSf_LR(2,3,t) = Kf(t,2,3)*XL2*XR3
	deltaSf_RL(2,3,t) = DCONJG(Kf(t,3,2))*XR2*XL3
	deltaSf_RR(2,3,t) = MSS2(2,t,2,3)*XR2*XR3

	deltaSf_LL(1,3,t) = MSS2(1,t,1,3)*XL1*XL3
	deltaSf_LR(1,3,t) = Kf(t,1,3)*XL1*XR3
	deltaSf_RL(1,3,t) = DCONJG(Kf(t,3,1))*XR1*XL3
	deltaSf_RR(1,3,t) = MSS2(2,t,1,3)*XR1*XR3

	Af(t,1) = Kf(t,1,1)/Mf(t,1)
	Af(t,2) = Kf(t,2,2)/Mf(t,2)
	Af(t,3) = Kf(t,3,3)/Mf(t,3)

	nmfv = ibset(nmfv, t)
	end

