* se_WW.F
* this file is part of FeynHiggs
* generated 27 May 2010 12:34

#include "externals.h"
#include "debug.h"


	double complex function se_WW(k2, ty)
	implicit none
	double precision k2
	integer ty


#include "FH.h"

	double complex se_WW_mfv, se_WW_nmfv
	external se_WW_mfv, se_WW_nmfv

	if( nmfv .eq. 0 ) then
	  se_WW = se_WW_mfv(k2, ty)
	else
	  se_WW = se_WW_nmfv(k2, ty)
	endif

#ifdef DEBUG
	DHIGGS 'k2 =', k2 ENDL
	DHIGGS 'se_WW =', se_WW ENDL
#endif
	end


************************************************************************


	double complex function se_WW_mfv(k2,ty)
	implicit none
	integer ty
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha3, Gen3, Gen4, Neu3, Sfe3, Sfe4, g
	double complex dup1, dup2, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6
	double complex tmp7

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	se_WW_mfv = 0

	do Gen3 = g,3
	do Sfe3 = 1,2

        se_WW_mfv = se_WW_mfv + 
     -   3/(8.D0*Pi)*(Alfa1L*
     -       (A0(MSf2(Sfe3,3,Gen3))*USf2(Sfe3,1,3,Gen3) + 
     -         A0(MSf2(Sfe3,ty,Gen3))*USf2(Sfe3,1,ty,Gen3)))/SW2

	enddo
	enddo

	do Gen3 = g,3

	tmp1 = B0(k2,Mfy2(3,Gen3),0.D0)

	tmp2 = B00(k2,Mfy2(3,Gen3),0.D0)

	tmp3 = B1(k2,Mfy2(3,Gen3),0.D0)

	do Gen4 = g,3

        se_WW_mfv = se_WW_mfv - 
     -   3/(4.D0*Pi)*(Alfa1L*CKMin(Gen3,Gen4)*CKMinC(Gen3,Gen4)*
     -       (-2*tmp2 + k2*tmp3 + tmp1*Mfy2(3,Gen3)))/SW2

	enddo

	enddo

	do Gen4 = g,3
	do Gen3 = g,3
	do Sfe4 = 1,2
	do Sfe3 = 1,2

        se_WW_mfv = se_WW_mfv - 
     -   3/(2.D0*Pi)*(Alfa1L*
     -       B00(k2,MSf2(Sfe3,3,Gen3),MSf2(Sfe4,ty,Gen4))*
     -       CKMin(Gen3,Gen4)*CKMinC(Gen3,Gen4)*
     -       USf(Sfe4,1,ty,Gen4)*USf2(Sfe3,1,3,Gen3)*
     -       USfC(Sfe4,1,ty,Gen4))/SW2

	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_WW_mfv =', se_WW_mfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen3 = g,3

	tmp4 = B0(k2,Mfy2(3,Gen3),0.D0)

	tmp5 = B00(k2,Mfy2(3,Gen3),0.D0)

	tmp6 = B1(k2,Mfy2(3,Gen3),0.D0)

	do Gen4 = g,3

        se_WW_mfv = se_WW_mfv - 
     -   3/(4.D0*Pi)*(Alfa1L*CKMin(Gen3,Gen4)*CKMinC(Gen3,Gen4)*
     -       (2*tmp5 + A0(Mfy2(ty,Gen4)) - 
     -         2*B00(k2,Mfy2(3,Gen3),Mfy2(ty,Gen4)) + 
     -         k2*(-tmp6 + B1(k2,Mfy2(3,Gen3),Mfy2(ty,Gen4))) + 
     -         (-tmp4 + B0(k2,Mfy2(3,Gen3),Mfy2(ty,Gen4)))*
     -          Mfy2(3,Gen3)))/SW2

	enddo

	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_WW_mfv =', se_WW_mfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        se_WW_mfv = se_WW_mfv + 
     -   1/(8.D0*Pi)*(Alfa1L*
     -       (A0(MSf2(1,1,Gen3)) + 4*B00(k2,0.D0,Mf2(2,Gen3)) - 
     -         2*(A0(Mf2(2,Gen3)) + k2*B1(k2,0.D0,Mf2(2,Gen3)))))/SW2

	enddo

	do Sfe3 = 1,2
	do Gen3 = 1,3

        se_WW_mfv = se_WW_mfv + 
     -   1/(8.D0*Pi)*(Alfa1L*
     -       (A0(MSf2(Sfe3,2,Gen3)) - 
     -         4*B00(k2,MSf2(1,1,Gen3),MSf2(Sfe3,2,Gen3)))*
     -       USf2(Sfe3,1,2,Gen3))/SW2

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_WW_mfv =', se_WW_mfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        se_WW_mfv = se_WW_mfv + 
     -   1/(16.D0*Pi)*(Alfa1L*
     -       (4*(CW2**2*(-3*k2 - 2*MZ2) + MW2*SW2**2)*
     -          B0(k2,MW2,MZ2) + 
     -         CW2*(A0(MA02) + A0(Mh02) + A0(MHH2) + 
     -            (1 + 12*CW2)*A0(MZ2) + 
     -            2*(A0(MHp2) + 3*A0(MW2) + 
     -               2*(MW2*
     -                   (SBA2*B0(k2,Mh02,MW2) + 
     -                     CBA2*B0(k2,MHH2,MW2)) - 
     -                  B00(k2,MA02,MHp2) - 
     -                  SBA2*
     -                   (B00(k2,Mh02,MW2) + B00(k2,MHH2,MHp2)) - 
     -                  CBA2*
     -                   (B00(k2,Mh02,MHp2) + B00(k2,MHH2,MW2)) + 
     -                  SW2*
     -                   (-3*k2*B0(k2,0.D0,MW2) + 
     -                     MW2*B0(k2,0.D0,MW2) - 8*B00(k2,MW2,0.D0)) - 
     -                  8*CW2*B00(k2,MW2,MZ2) - B00(k2,MZ2,MW2) + 
     -                  2*k2*SW2*B1(k2,MW2,0.D0) + 
     -                  2*CW2*k2*B1(k2,MW2,MZ2))))))/(CW2*SW2)

	do Cha3 = 1,2

	tmp7 = A0(MCha2(Cha3))

	do Neu3 = 1,4

        dup1 = sqrt2*(UChaC(Cha3,1)*ZNeu(Neu3,2)) + 
     -   UChaC(Cha3,2)*ZNeu(Neu3,3)

        dup2 = sqrt2*(UChaC(Cha3,2)*ZNeu(Neu3,3)) + 
     -   2*UChaC(Cha3,1)*ZNeu(Neu3,2)

        se_WW_mfv = se_WW_mfv + 
     -   1/(4.D0*Pi*sqrt2**2)*
     -    (Alfa1L*(sqrt2**2*
     -          (B0(k2,MCha2(Cha3),MNeu2(Neu3))*
     -            ((k2 - MNeu2(Neu3))*
     -               ((dup2*UCha(Cha3,1) + 
     -                    VCha(Cha3,1)*
     -                     (-(sqrt2*
     -                      (VChaC(Cha3,2)*ZNeu(Neu3,4))) + 
     -                       2*VChaC(Cha3,1)*ZNeu(Neu3,2)))*
     -                  ZNeuC(Neu3,2) + 
     -                 dup1*UCha(Cha3,2)*ZNeuC(Neu3,3) + 
     -                 VCha(Cha3,2)*
     -                  (-(sqrt2*(VChaC(Cha3,1)*ZNeu(Neu3,2))) + 
     -                    VChaC(Cha3,2)*ZNeu(Neu3,4))*ZNeuC(Neu3,4)
     -                 ) + 
     -              MCha(Cha3)*MNeu(Neu3)*
     -               (dup2*VChaC(Cha3,1)*ZNeu(Neu3,2) - 
     -                 dup1*VChaC(Cha3,2)*ZNeu(Neu3,4) + 
     -                 VCha(Cha3,1)*ZNeuC(Neu3,2)*
     -                  (sqrt2*(UCha(Cha3,2)*ZNeuC(Neu3,3)) + 
     -                    2*UCha(Cha3,1)*ZNeuC(Neu3,2)) - 
     -                 VCha(Cha3,2)*
     -                  (sqrt2*(UCha(Cha3,1)*ZNeuC(Neu3,2)) + 
     -                    UCha(Cha3,2)*ZNeuC(Neu3,3))*ZNeuC(Neu3,4)
     -                 ))) + 
     -         2*(-tmp7 + 2*B00(k2,MCha2(Cha3),MNeu2(Neu3)) + 
     -            k2*B1(k2,MCha2(Cha3),MNeu2(Neu3)))*
     -          ((sqrt2*(UChaC(Cha3,1)*ZNeu(Neu3,2)) + 
     -               UChaC(Cha3,2)*ZNeu(Neu3,3))*
     -             (sqrt2*(UCha(Cha3,1)*ZNeuC(Neu3,2)) + 
     -               UCha(Cha3,2)*ZNeuC(Neu3,3)) + 
     -            (sqrt2*(VChaC(Cha3,1)*ZNeu(Neu3,2)) - 
     -               VChaC(Cha3,2)*ZNeu(Neu3,4))*
     -             (sqrt2*(VCha(Cha3,1)*ZNeuC(Neu3,2)) - 
     -               VCha(Cha3,2)*ZNeuC(Neu3,4)))))/SW2

	enddo

	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_WW_mfv =', se_WW_mfv ENDL
#endif

	end



************************************************************************


	double complex function se_WW_nmfv(k2,ty)
	implicit none
	integer ty
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All3, All4, Cha3, Gen3, Gen4, Ind1, Ind2, Ind3, Ind4
	integer Neu3, Sfe3, g
	double complex dup1, dup2, tmp1, tmp10, tmp2, tmp3, tmp4, tmp5
	double complex tmp6, tmp7, tmp8, tmp9

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	se_WW_nmfv = 0

	do All3 = 1,6,g

	tmp1 = A0(MASf2(All3,3))

	tmp2 = A0(MASf2(All3,ty))

	do Ind1 = 1,3

        se_WW_nmfv = se_WW_nmfv + 
     -   3/(8.D0*Pi)*(Alfa1L*
     -       (tmp1*UASf(All3,Ind1,3)*UASfC(All3,Ind1,3) + 
     -         tmp2*UASf(All3,Ind1,ty)*UASfC(All3,Ind1,ty)))/SW2

	enddo

	enddo

	do Gen3 = g,3

	tmp3 = B0(k2,Mfy2(3,Gen3),0.D0)

	tmp4 = B00(k2,Mfy2(3,Gen3),0.D0)

	tmp5 = B1(k2,Mfy2(3,Gen3),0.D0)

	do Gen4 = g,3

        se_WW_nmfv = se_WW_nmfv - 
     -   3/(4.D0*Pi)*(Alfa1L*CKMin(Gen3,Gen4)*CKMinC(Gen3,Gen4)*
     -       (-2*tmp4 + k2*tmp5 + tmp3*Mfy2(3,Gen3)))/SW2

	enddo

	enddo

	do All4 = 1,6,g
	do All3 = 1,6,g

	tmp6 = B00(k2,MASf2(All3,3),MASf2(All4,ty))

	do Ind4 = 1,3
	do Ind3 = 1,3
	do Ind2 = 1,3
	do Ind1 = 1,3

        se_WW_nmfv = se_WW_nmfv - 
     -   3/(2.D0*Pi)*(Alfa1L*tmp6*CKMin(Ind1,Ind2)*CKMinC(Ind3,Ind4)*
     -       UASf(All3,Ind1,3)*UASf(All4,Ind4,ty)*
     -       UASfC(All3,Ind3,3)*UASfC(All4,Ind2,ty))/SW2

	enddo
	enddo
	enddo
	enddo

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_WW_nmfv =', se_WW_nmfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen3 = g,3

	tmp7 = B0(k2,Mfy2(3,Gen3),0.D0)

	tmp8 = B00(k2,Mfy2(3,Gen3),0.D0)

	tmp9 = B1(k2,Mfy2(3,Gen3),0.D0)

	do Gen4 = g,3

        se_WW_nmfv = se_WW_nmfv - 
     -   3/(4.D0*Pi)*(Alfa1L*CKMin(Gen3,Gen4)*CKMinC(Gen3,Gen4)*
     -       (2*tmp8 + A0(Mfy2(ty,Gen4)) - 
     -         2*B00(k2,Mfy2(3,Gen3),Mfy2(ty,Gen4)) + 
     -         k2*(-tmp9 + B1(k2,Mfy2(3,Gen3),Mfy2(ty,Gen4))) + 
     -         (-tmp7 + B0(k2,Mfy2(3,Gen3),Mfy2(ty,Gen4)))*
     -          Mfy2(3,Gen3)))/SW2

	enddo

	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_WW_nmfv =', se_WW_nmfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Gen3 = 1,3

        se_WW_nmfv = se_WW_nmfv + 
     -   1/(8.D0*Pi)*(Alfa1L*
     -       (A0(MSf2(1,1,Gen3)) + 4*B00(k2,0.D0,Mf2(2,Gen3)) - 
     -         2*(A0(Mf2(2,Gen3)) + k2*B1(k2,0.D0,Mf2(2,Gen3)))))/SW2

	enddo

	do Sfe3 = 1,2
	do Gen3 = 1,3

        se_WW_nmfv = se_WW_nmfv + 
     -   1/(8.D0*Pi)*(Alfa1L*
     -       (A0(MSf2(Sfe3,2,Gen3)) - 
     -         4*B00(k2,MSf2(1,1,Gen3),MSf2(Sfe3,2,Gen3)))*
     -       USf2(Sfe3,1,2,Gen3))/SW2

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_WW_nmfv =', se_WW_nmfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

        se_WW_nmfv = se_WW_nmfv + 
     -   1/(16.D0*Pi)*(Alfa1L*
     -       (4*(CW2**2*(-3*k2 - 2*MZ2) + MW2*SW2**2)*
     -          B0(k2,MW2,MZ2) + 
     -         CW2*(A0(MA02) + A0(Mh02) + A0(MHH2) + 
     -            (1 + 12*CW2)*A0(MZ2) + 
     -            2*(A0(MHp2) + 3*A0(MW2) + 
     -               2*(MW2*
     -                   (SBA2*B0(k2,Mh02,MW2) + 
     -                     CBA2*B0(k2,MHH2,MW2)) - 
     -                  B00(k2,MA02,MHp2) - 
     -                  SBA2*
     -                   (B00(k2,Mh02,MW2) + B00(k2,MHH2,MHp2)) - 
     -                  CBA2*
     -                   (B00(k2,Mh02,MHp2) + B00(k2,MHH2,MW2)) + 
     -                  SW2*
     -                   (-3*k2*B0(k2,0.D0,MW2) + 
     -                     MW2*B0(k2,0.D0,MW2) - 8*B00(k2,MW2,0.D0)) - 
     -                  8*CW2*B00(k2,MW2,MZ2) - B00(k2,MZ2,MW2) + 
     -                  2*k2*SW2*B1(k2,MW2,0.D0) + 
     -                  2*CW2*k2*B1(k2,MW2,MZ2))))))/(CW2*SW2)

	do Cha3 = 1,2

	tmp10 = A0(MCha2(Cha3))

	do Neu3 = 1,4

        dup1 = sqrt2*(UChaC(Cha3,1)*ZNeu(Neu3,2)) + 
     -   UChaC(Cha3,2)*ZNeu(Neu3,3)

        dup2 = sqrt2*(UChaC(Cha3,2)*ZNeu(Neu3,3)) + 
     -   2*UChaC(Cha3,1)*ZNeu(Neu3,2)

        se_WW_nmfv = se_WW_nmfv + 
     -   1/(4.D0*Pi*sqrt2**2)*
     -    (Alfa1L*(sqrt2**2*
     -          (B0(k2,MCha2(Cha3),MNeu2(Neu3))*
     -            ((k2 - MNeu2(Neu3))*
     -               ((dup2*UCha(Cha3,1) + 
     -                    VCha(Cha3,1)*
     -                     (-(sqrt2*
     -                      (VChaC(Cha3,2)*ZNeu(Neu3,4))) + 
     -                       2*VChaC(Cha3,1)*ZNeu(Neu3,2)))*
     -                  ZNeuC(Neu3,2) + 
     -                 dup1*UCha(Cha3,2)*ZNeuC(Neu3,3) + 
     -                 VCha(Cha3,2)*
     -                  (-(sqrt2*(VChaC(Cha3,1)*ZNeu(Neu3,2))) + 
     -                    VChaC(Cha3,2)*ZNeu(Neu3,4))*ZNeuC(Neu3,4)
     -                 ) + 
     -              MCha(Cha3)*MNeu(Neu3)*
     -               (dup2*VChaC(Cha3,1)*ZNeu(Neu3,2) - 
     -                 dup1*VChaC(Cha3,2)*ZNeu(Neu3,4) + 
     -                 VCha(Cha3,1)*ZNeuC(Neu3,2)*
     -                  (sqrt2*(UCha(Cha3,2)*ZNeuC(Neu3,3)) + 
     -                    2*UCha(Cha3,1)*ZNeuC(Neu3,2)) - 
     -                 VCha(Cha3,2)*
     -                  (sqrt2*(UCha(Cha3,1)*ZNeuC(Neu3,2)) + 
     -                    UCha(Cha3,2)*ZNeuC(Neu3,3))*ZNeuC(Neu3,4)
     -                 ))) + 
     -         2*(-tmp10 + 2*B00(k2,MCha2(Cha3),MNeu2(Neu3)) + 
     -            k2*B1(k2,MCha2(Cha3),MNeu2(Neu3)))*
     -          ((sqrt2*(UChaC(Cha3,1)*ZNeu(Neu3,2)) + 
     -               UChaC(Cha3,2)*ZNeu(Neu3,3))*
     -             (sqrt2*(UCha(Cha3,1)*ZNeuC(Neu3,2)) + 
     -               UCha(Cha3,2)*ZNeuC(Neu3,3)) + 
     -            (sqrt2*(VChaC(Cha3,1)*ZNeu(Neu3,2)) - 
     -               VChaC(Cha3,2)*ZNeu(Neu3,4))*
     -             (sqrt2*(VCha(Cha3,1)*ZNeuC(Neu3,2)) - 
     -               VCha(Cha3,2)*ZNeuC(Neu3,4)))))/SW2

	enddo

	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'se_WW_nmfv =', se_WW_nmfv ENDL
#endif

	end


