* td_A0.F
* this file is part of FeynHiggs
* generated 27 May 2010 12:34

#include "externals.h"
#include "debug.h"


	double complex function td_A0(ty)
	implicit none
	integer ty


#include "FH.h"

	double complex td_A0_mfv, td_A0_nmfv
	external td_A0_mfv, td_A0_nmfv

	if( nmfv .eq. 0 ) then
	  td_A0 = td_A0_mfv(ty)
	else
	  td_A0 = td_A0_nmfv(ty)
	endif

#ifdef DEBUG

	DHIGGS 'td_A0 =', td_A0 ENDL
#endif
	end


************************************************************************


	double complex function td_A0_mfv(ty)
	implicit none
	integer ty

#include "FH.h"
#include "looptools.h"

	integer Cha2, Gen2, Neu2, Sfe2, g

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	td_A0_mfv = 0

	do Gen2 = g,3
	do Sfe2 = 1,2

        td_A0_mfv = td_A0_mfv + 
     -   (3*cI)/(32.D0*Pi**2)*
     -    (EL1L*A0(MSf2(Sfe2,3,Gen2))*
     -       ((Kf(3,Gen2,Gen2) + MUEC*TB*Mfy(3,Gen2))*
     -          USf(Sfe2,2,3,Gen2)*USfC(Sfe2,1,3,Gen2) - 
     -         (KfC(3,Gen2,Gen2) + MUE*TB*Mfy(3,Gen2))*
     -          USf(Sfe2,1,3,Gen2)*USfC(Sfe2,2,3,Gen2)))/(MW*SW*TB)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_mfv =', td_A0_mfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do Gen2 = g,3
	do Sfe2 = 1,2

        td_A0_mfv = td_A0_mfv + 
     -   (3*cI)/(32.D0*Pi**2)*
     -    (EL1L*A0(MSf2(Sfe2,ty,Gen2))*
     -       ((TB*Kf(ty,Gen2,Gen2) + MUEC*Mfy(ty,Gen2))*
     -          USf(Sfe2,2,ty,Gen2)*USfC(Sfe2,1,ty,Gen2) - 
     -         (TB*KfC(ty,Gen2,Gen2) + MUE*Mfy(ty,Gen2))*
     -          USf(Sfe2,1,ty,Gen2)*USfC(Sfe2,2,ty,Gen2)))/(MW*SW)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_mfv =', td_A0_mfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Sfe2 = 1,2
	do Gen2 = 1,3

        td_A0_mfv = td_A0_mfv + 
     -   cI/(32.D0*Pi**2)*(EL1L*A0(MSf2(Sfe2,2,Gen2))*
     -       ((TB*Kf(2,Gen2,Gen2) + MUEC*Mf(2,Gen2))*
     -          USf(Sfe2,2,2,Gen2)*USfC(Sfe2,1,2,Gen2) - 
     -         (TB*KfC(2,Gen2,Gen2) + MUE*Mf(2,Gen2))*
     -          USf(Sfe2,1,2,Gen2)*USfC(Sfe2,2,2,Gen2)))/(MW*SW)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_mfv =', td_A0_mfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

	do Cha2 = 1,2

        td_A0_mfv = td_A0_mfv + 
     -   cI/(8.D0*Pi**2*sqrt2)*
     -    (EL1L*A0(MCha2(Cha2))*MCha(Cha2)*
     -       (SB*(-(UCha(Cha2,2)*VCha(Cha2,1)) + 
     -            UChaC(Cha2,2)*VChaC(Cha2,1)) + 
     -         CB*(-(UCha(Cha2,1)*VCha(Cha2,2)) + 
     -            UChaC(Cha2,1)*VChaC(Cha2,2))))/SW

	enddo

	do Neu2 = 1,4

        td_A0_mfv = td_A0_mfv + 
     -   cI/(16.D0*Pi**2)*(EL1L*A0(MNeu2(Neu2))*MNeu(Neu2)*
     -       (SW*ZNeu(Neu2,1)*
     -          (SB*ZNeu(Neu2,3) - CB*ZNeu(Neu2,4)) + 
     -         CW*ZNeu(Neu2,2)*
     -          (-(SB*ZNeu(Neu2,3)) + CB*ZNeu(Neu2,4)) - 
     -         (SW*ZNeuC(Neu2,1) - CW*ZNeuC(Neu2,2))*
     -          (SB*ZNeuC(Neu2,3) - CB*ZNeuC(Neu2,4))))/(CW*SW)

	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_mfv =', td_A0_mfv ENDL
#endif

	end



************************************************************************


	double complex function td_A0_nmfv(ty)
	implicit none
	integer ty

#include "FH.h"
#include "looptools.h"

	integer All2, Cha2, Gen2, Ind1, Ind2, Neu2, Sfe2, g
	double complex tmp1, tmp2

	g = 2*ibits(mssmpart - 3, 3, 1) + 1

	td_A0_nmfv = 0

	do All2 = 1,6,g

	tmp1 = A0(MASf2(All2,3))

	do Ind2 = 1,3
	do Ind1 = 1,3

        td_A0_nmfv = td_A0_nmfv + 
     -   (3*cI)/(32.D0*Pi**2)*
     -    (EL1L*tmp1*((Kf(3,Ind1,Ind2) + 
     -            MUEC*TB*Delta(Ind1,Ind2)*Mfy(3,Ind1))*
     -          UASf(All2,3 + Ind2,3)*UASfC(All2,Ind1,3) - 
     -         (KfC(3,Ind2,Ind1) + 
     -            MUE*TB*Delta(Ind1,Ind2)*Mfy(3,Ind1))*
     -          UASf(All2,Ind2,3)*UASfC(All2,3 + Ind1,3)))/
     -     (MW*SW*TB)

	enddo
	enddo

	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_nmfv =', td_A0_nmfv ENDL
#endif

	if( mssmpart .eq. 1 ) return

	do All2 = 1,6,g

	tmp2 = A0(MASf2(All2,ty))

	do Ind2 = 1,3
	do Ind1 = 1,3

        td_A0_nmfv = td_A0_nmfv + 
     -   (3*cI)/(32.D0*Pi**2)*
     -    (EL1L*tmp2*((TB*Kf(ty,Ind1,Ind2) + 
     -            MUEC*Delta(Ind1,Ind2)*Mfy(ty,Ind1))*
     -          UASf(All2,3 + Ind2,ty)*UASfC(All2,Ind1,ty) - 
     -         (TB*KfC(ty,Ind2,Ind1) + 
     -            MUE*Delta(Ind1,Ind2)*Mfy(ty,Ind1))*
     -          UASf(All2,Ind2,ty)*UASfC(All2,3 + Ind1,ty)))/
     -     (MW*SW)

	enddo
	enddo

	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_nmfv =', td_A0_nmfv ENDL
#endif

	if( mssmpart .eq. 2 ) return

	do Sfe2 = 1,2
	do Gen2 = 1,3

        td_A0_nmfv = td_A0_nmfv + 
     -   cI/(32.D0*Pi**2)*(EL1L*A0(MSf2(Sfe2,2,Gen2))*
     -       ((TB*Kf(2,Gen2,Gen2) + MUEC*Mf(2,Gen2))*
     -          USf(Sfe2,2,2,Gen2)*USfC(Sfe2,1,2,Gen2) - 
     -         (TB*KfC(2,Gen2,Gen2) + MUE*Mf(2,Gen2))*
     -          USf(Sfe2,1,2,Gen2)*USfC(Sfe2,2,2,Gen2)))/(MW*SW)

	enddo
	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_nmfv =', td_A0_nmfv ENDL
#endif

	if( mssmpart .eq. 3 ) return

	do Cha2 = 1,2

        td_A0_nmfv = td_A0_nmfv + 
     -   cI/(8.D0*Pi**2*sqrt2)*
     -    (EL1L*A0(MCha2(Cha2))*MCha(Cha2)*
     -       (SB*(-(UCha(Cha2,2)*VCha(Cha2,1)) + 
     -            UChaC(Cha2,2)*VChaC(Cha2,1)) + 
     -         CB*(-(UCha(Cha2,1)*VCha(Cha2,2)) + 
     -            UChaC(Cha2,1)*VChaC(Cha2,2))))/SW

	enddo

	do Neu2 = 1,4

        td_A0_nmfv = td_A0_nmfv + 
     -   cI/(16.D0*Pi**2)*(EL1L*A0(MNeu2(Neu2))*MNeu(Neu2)*
     -       (SW*ZNeu(Neu2,1)*
     -          (SB*ZNeu(Neu2,3) - CB*ZNeu(Neu2,4)) + 
     -         CW*ZNeu(Neu2,2)*
     -          (-(SB*ZNeu(Neu2,3)) + CB*ZNeu(Neu2,4)) - 
     -         (SW*ZNeuC(Neu2,1) - CW*ZNeuC(Neu2,2))*
     -          (SB*ZNeuC(Neu2,3) - CB*ZNeuC(Neu2,4))))/(CW*SW)

	enddo

#ifdef DETAILED_DEBUG
	DHIGGS 'td_A0_nmfv =', td_A0_nmfv ENDL
#endif

	end


