* SetRecord.F
* initialize the FH parameters from a record
* this file is part of FeynHiggs
* last modified 22 Oct 09 th

#include "externals.h"
#include "debug.h"


	subroutine FHSetRecord(error, record, scalefactor)
	implicit none
	integer error
	double precision scalefactor

#include "FHRecord.h"
#define __SUBROUTINE__ "FHSetRecord"

	RecordDecl(record)

	if( record(iAdmin,iVar) .eq. 0 ) then
	  Error("must call FHLoopRecord before FHSetRecord")
	  return
	endif

	call FHSetSMPara(error, record(iinvAlfaMZ,iVar),
     &    record(iAlfasMZ,iVar), record(iGF,iVar),
     &    record(iMS,iVar), record(iMC,iVar), record(iMB,iVar),
     &    record(iMW,iVar), record(iMZ,iVar),
     &    record(iCKMlambda,iVar), record(iCKMA,iVar),
     &    record(iCKMrho,iVar), record(iCKMeta,iVar))
	if( error .ne. 0 ) return

	call FHRetrieveSMPara(error, record(iinvAlfaMZ,iVar),
     &    record(iAlfasMZ,iVar), record(iGF,iVar),
     &    record(iMS,iVar), record(iMC,iVar), record(iMB,iVar),
     &    record(iMW,iVar), record(iMZ,iVar),
     &    record(iCKMlambda,iVar), record(iCKMA,iVar),
     &    record(iCKMrho,iVar), record(iCKMeta,iVar))
	if( error .ne. 0 ) return

	call FHSetPara(error, scalefactor, record(iMT,iVar),
     &    record(iTB,iVar), record(iMA0,iVar), record(iMHp,iVar),
     &    record(iM3SL,iVar), record(iM3SE,iVar),
     &    record(iM3SQ,iVar), record(iM3SU,iVar), record(iM3SD,iVar),
     &    record(iM2SL,iVar), record(iM2SE,iVar),
     &    record(iM2SQ,iVar), record(iM2SU,iVar), record(iM2SD,iVar),
     &    record(iM1SL,iVar), record(iM1SE,iVar),
     &    record(iM1SQ,iVar), record(iM1SU,iVar), record(iM1SD,iVar),
     &    record(iMUE,iVar),
     &    record(iAtau,iVar), record(iAt,iVar), record(iAb,iVar),
     &    record(iAmu,iVar), record(iAc,iVar), record(iAs,iVar),
     &    record(iAe,iVar), record(iAu,iVar), record(iAd,iVar),
     &    record(iM1,iVar), record(iM2,iVar), record(iM3,iVar),
     &    record(iQtau,iVar), record(iQt,iVar), record(iQb,iVar))
	if( error .ne. 0 ) return

	if( abs(record(ideltaLL12,iVar)) +
     &    abs(record(ideltaLL23,iVar)) +
     &    abs(record(ideltaLL13,iVar)) + 
     &    abs(record(ideltaLRuc,iVar)) +
     &    abs(record(ideltaLRct,iVar)) +
     &    abs(record(ideltaLRut,iVar)) +
     &    abs(record(ideltaRLuc,iVar)) +
     &    abs(record(ideltaRLct,iVar)) +
     &    abs(record(ideltaRLut,iVar)) +
     &    abs(record(ideltaRRuc,iVar)) +
     &    abs(record(ideltaRRct,iVar)) +
     &    abs(record(ideltaRRut,iVar)) +
     &    abs(record(ideltaLRds,iVar)) +
     &    abs(record(ideltaLRsb,iVar)) +
     &    abs(record(ideltaLRdb,iVar)) +
     &    abs(record(ideltaRLds,iVar)) +
     &    abs(record(ideltaRLsb,iVar)) +
     &    abs(record(ideltaRLdb,iVar)) +
     &    abs(record(ideltaRRds,iVar)) +
     &    abs(record(ideltaRRsb,iVar)) +
     &    abs(record(ideltaRRdb,iVar)) .gt. 1D-13 )
     &    call FHSetNMFV(error,
     &      record(ideltaLL12,iVar), record(ideltaLL23,iVar),
     &      record(ideltaLL13,iVar),
     &      record(ideltaLRuc,iVar), record(ideltaLRct,iVar),
     &      record(ideltaLRut,iVar),
     &      record(ideltaRLuc,iVar), record(ideltaRLct,iVar),
     &      record(ideltaRLut,iVar),
     &      record(ideltaRRuc,iVar), record(ideltaRRct,iVar),
     &      record(ideltaRRut,iVar),
     &      record(ideltaLRds,iVar), record(ideltaLRsb,iVar),
     &      record(ideltaLRdb,iVar),
     &      record(ideltaRLds,iVar), record(ideltaRLsb,iVar),
     &      record(ideltaRLdb,iVar),
     &      record(ideltaRRds,iVar), record(ideltaRRsb,iVar),
     &      record(ideltaRRdb,iVar))
	end

