* EigenSf.F
* diagonalization of the Hermitian 2-by-2 sfermion mass matrix
* this file is part of FeynHiggs
* last modified 18 Jun 09 th

#include "externals.h"


	subroutine EigenSf(fail, ld, m, msq, U, M11, Mf, Xf, sort)
	implicit none
	integer fail, ld
	double precision m(ld,*), msq(ld,*)
	double complex U(ld,2,ld,*)
	double precision M11(*), Mf
	double complex Xf
	integer sort

	double precision m1, m2, M12sq, delta, h, c
	double complex s

* Note the conventions for better numerical stability:
* - M11(1) is the difference M11 - M22,
* - M11(2) is M22.

	m2 = Mf**2
	M12sq = m2*(DBLE(Xf)**2 + DIMAG(Xf)**2)
	h = .5D0*(M11(1) + sign(sqrt(M11(1)**2 + 4*M12sq), M11(1)))
	if( h .ne. 0 ) h = 1/h
	delta = h*M12sq
	c = 1/sqrt(delta*h + 1)
	s = h*c*Mf*DCONJG(Xf)

	msq(1,3) = M11(1) + 2*delta
	m2 = M11(2) + m2
	msq(1,4) = 2*m2 + M11(1)
	m1 = m2 + M11(1) + delta
	m2 = m2 - delta

	if( sort .ne. 0 .and. m1 .gt. m2 ) then
	  msq(1,1) = m2
	  msq(1,2) = m1
	  U(1,1,1,1) = -DCONJG(s)
	  U(1,2,1,2) = s
	  U(1,1,1,2) = c
	  U(1,2,1,1) = c
	else
	  msq(1,1) = m1
	  msq(1,2) = m2
	  msq(1,3) = -msq(1,3)
	  U(1,1,1,1) = c
	  U(1,2,1,2) = c
	  U(1,1,1,2) = s
	  U(1,2,1,1) = -DCONJG(s)
	endif

	if( m1 .lt. 0 .or. m2 .lt. 0 ) fail = 1

	msq(1,1) = max(1D-100, msq(1,1))
	m(1,1) = sqrt(msq(1,1))
	msq(1,2) = max(2D-100, msq(1,2))
	m(1,2) = sqrt(msq(1,2))
	end

