#!/bin/bash

startdir="$PWD"

namedir=`basename $PWD`

echo '*************************************'
echo ' '
echo './configure, then run example :'
echo ' '
./configure
cd example_programs
./demonstrateHiggsBounds_commandline.bat > temp_output.txt
echo 'Is there anything between here...'
grep 'hello' temp_output.txt
grep 'WARNING' temp_output.txt
rm temp_output.txt
echo '... and here'
cd ..
echo '*************************************'
echo ' '
echo 'make hyperclean :'
echo ' '
make hyperclean
echo 'remove the makefile:'
echo ' '
rm makefile
echo ' '
echo '*************************************'
echo ' '
echo 'CHECK THAT INPUTMETHOD = DATFILE'
echo ' '
grep 'inputmethod=' HiggsBounds.F90
echo ' '
echo '*************************************'
echo ' '
echo 'CHECK THAT ESP = 2.0D-2'
echo ' '
grep 'eps=' S95tables.f90
echo ' '
echo '*************************************'
echo ' '
echo 'CHECK THAT deltaMh_TEV=10.0D0'
echo ' '
grep 'deltaMh_TEV=' S95tables.f90
echo ' '
echo '*************************************'
echo ' '
echo 'CHECK THAT deltaMh_LEP=2.0D0'
echo ' '
grep 'deltaMh_LEP=' S95tables.f90
echo ' '
echo '*************************************'
echo ' '
echo 'CHECK THAT debug=.False and '
echo '#define  DEBUGGING is commented out'
echo ' '
grep 'debug=' HiggsBounds_subroutines.F90
grep '#define  DEBUGGING' HiggsBounds.F90
echo ' '
echo '*************************************'
echo ' '
echo 'create '$namedir'temp:'
echo ' '

copyfiles=`ls *.f90 *.F90 *.F *.f *.bat README COPYING *.in */*.h */*.dat */*/*.dat */*.dat-for-comparison */*.bat */*.F */*.f */*.input */*.dat-for-comparison-SM_vs_4thGen */*.txt */*/*.txt */*/*/*.txt */*/*_HDecay`

#echo $copyfiles
tempdir="$namedir"F90
#echo 'tempdir=' $tempdir

cd ..

mkdir "$tempdir"

listdir="cs-ratios_sigma-bg-Hb example_data example_programs Expt_tables Theory_tables example_data/SM_sample-data Expt_tables/CDFtables Expt_tables/D0tables Expt_tables/LEPtables Expt_tables/LEPtables/LEPtables2 Expt_tables/TSMtables Theory_tables/HDecay_BR-SM "

for direcname in $listdir ; do
 mkdir "$tempdir"/"$direcname"
done

cp "$namedir"/pubconfigure "$tempdir"/configure

for filename in $copyfiles ; do
 cp "$namedir"/"$filename" "$tempdir"/"$filename"
done

echo 'create ../'$namedir'.tar.gz :'
rm "$namedir".tar.gz
tar czf "$namedir".tar.gz "$tempdir"
rm -r "$tempdir"

cd $namedir

echo ' '
echo '*************************************'
echo ' '
echo 'finished'
echo ' '
echo '*************************************'
