      subroutine MSbartoOnShell(msusytlmsbar, msusytrmsbar, xtmsbar, 
     $     mtmsbar, msusytlos, msusytros, xtos, mtos, mtpole,
     $     mglx, asx, tbx, mzx, mwx) 


      include 'varcom2.h'
      include 'ShiftMSbarOSMSt1sqvar.f'
      include 'ShiftMSbarOSMSt2sqvar.f'
      include 'ShiftMSbarOSsttvar.f'
      include 'ShiftMSbarOSMTGluDREDvar.f'

      integer msbarselec,mtmsbarselec
      double precision msusytlmsbar, msusytrmsbar, xtmsbar, mtmsbar,
     $                 msusytlos, msusytros, msusytlos2, msusytros2,
     $                 xtos, mtos, dt1, dt2, mtpole
      double precision msusytl, msusytr, mtlr, 
     $                 mst1os, mst2os, sttos, cttos
      double precision mglx, tbx, tb, beta, c2b, mzx, mz, sw2x, sw2,
     $                 as, asx
      double precision ml2t, mr2t, ml2b, mr2b, sgnt, sgnb, tt, bb,
     $                 m12, m22, mst
      double precision shift1, shift2, shiftx, shiftt
      double precision rot(1:2,1:2), rottrans(1:2,1:2), 
     $                 mdiag(1:2,1:2), mnondiag(1:2,1:2), z(1:2,1:2)

      common /msbarselec/ msbarselec, mtmsbarselec

      eps = 1d-6
      cf = 4d0/3d0
      pi = 3.14159265358979d0

      msusytl = msusytlmsbar
      msusytr = msusytrmsbar
      mtlr = xtmsbar
      mt = mtmsbar
c      write(*,*) 'running mt in M2O:', real(mt)
      mgl = mglx
      as = asx
      gs = dsqrt(4d0 * pi * as)
      tb = tbx
      beta = datan(tb)
      c2b = dcos(2d0 * beta)
      mz = mzx
      sw2 = dsqrt(1 - mzx**2/mwx**2)

      ml2t = msusytl**2 + mz**2*c2b*( .5d0 - 2d0/3d0*sw2) + mt**2
      mr2t = msusytr**2 + mz**2*c2b*(        2d0/3d0*sw2) + mt**2
c      ml2b = msusybl**2 + mz**2*c2b*(-.5d0 + 1d0/3d0*sw2) + mb**2
c      mr2b = msusybr**2 + mz**2*c2b*(      - 1d0/3d0*sw2) + mb**2
c      write(*,*) 'diagonal entries:'
c      write(*,*) ml2t, mr2t
      sgnt = (ml2t - mr2t)/dabs(ml2t - mr2t)
c      sgnb = (ml2b - mr2b)/dabs(ml2b - mr2b)

      m12 = .5d0*(ml2t + mr2t 
     $            + sgnt * dsqrt((ml2t - mr2t)**2 + 4d0*mt**2*mtlr**2))
      m22 = .5d0*(ml2t + mr2t 
     $            - sgnt * dsqrt((ml2t - mr2t)**2 + 4d0*mt**2*mtlr**2))

      if ((m12.lt.0d0) .or. (m22.lt.0d0))  then
         MSt1 = 0d0
         MSt2 = 0d0
         write(*,*) "Error: unphysical MSbar Stop masses"
         goto 100
      endif
      MSt1 = dsqrt(m12)
      MSt2 = dsqrt(m22)

      tt = datan(-sgnt*2d0*mt*mtlr/
     $           (-sgnt*(ml2t - mr2t) 
     $            -dsqrt((ml2t - mr2t)**2 + 4d0 * mt**2 * mtlr**2)))

c      if (MSt1.gt.MSt2) then
c         mst = mst1
c         mst1 = mst2
c         mst2 = mst
c         tt = tt - pi/2d0
c      endif

      stt = dsin(tt)
      ctt = dcos(tt)

c      write(*,*) 'stop variables:'
c      write(*,*) real(ml2t), real(mr2t), real(sgnt), real(tt), real(stt)


c      bb = datan(-sgnb*2d0*mb*mlrb/
c     $           (-sgnb*(ml2b - mr2b) 
c     $            -dsqrt((ml2b - mr2b)**2 + 4d0 * mb**2 * mlrb**2)))

c      stb = dsin(bb)
c      ctb = dcos(bb)

c --> rotation check
      dt1 = mz**2 * c2b * (.5d0 - 2d0/3d0 * sw2)
      dt2 = mz**2 * c2b * (       2d0/3d0 * sw2)

      mdiag(1,1) = mst1**2
      mdiag(1,2) = 0d0
      mdiag(2,1) = 0d0
      mdiag(2,2) = mst2**2
      rottrans(1,1) = dsqrt(1d0 - stt**2)
      rottrans(1,2) = -stt
      rottrans(2,1) = stt
      rottrans(2,2) = rottrans(1,1)

      rot(1,1) = dsqrt(1d0 - stt**2)
      rot(1,2) = stt
      rot(2,1) = -stt
      rot(2,2) = rot(1,1)
      call diagonalization(rottrans, mdiag, rot, mnondiag)

      msusytlos2 = mnondiag(1,1) - mt**2 - dt1
      msusytros2 = mnondiag(2,2) - mt**2 - dt2
c$$$      write(*,*) "rotation check:"
c$$$      write(*,*) real(dsqrt(msusytlos2)), real(mnondiag(1,2)/mt)
c$$$      write(*,*) real(mnondiag(2,1)/mt), real(dsqrt(msusytros2))
c --> end of rotation check 
 

      mue = dsqrt(mst1 * mst2)
      include 'ShiftMSbarOSMSt1sqsum.f'
      shift1 = dreal(ShiftMSbarOSMSt1sq)

      include 'ShiftMSbarOSMSt2sqsum.f'
      shift2 = dreal(ShiftMSbarOSMSt2sq)

      include 'ShiftMSbarOSsttsum.f'
      shiftx = dreal(ShiftMSbarOSstt)
      if (dabs(stt).lt.1d-5) shiftx = 0d0
      mue = mt
      include 'ShiftMSbarOSMTGluDREDsum.f'
      shiftt = dreal(ShiftMSbarOSMTGluDRED)

      mst1os = dsqrt(mst1**2 - shift1)
      mst2os = dsqrt(mst2**2 - shift2)
      sttos = stt - shiftx
      mtos = mt - shiftt
c      mtos = 175d0
c      write(*,*) real(mst1os), real(mst2os), real(sttos), real(mtos)
c      write(*,*) real(shift1), real(shift2), real(shiftx), real(shiftt)
c      write(*,*) ShiftMSbarOSMSt1sq, ShiftMSbarOSMSt2sq,
c     $           ShiftMSbarOSstt, ShiftMSbarOSMTGluDRED
      

      dt1 = mz**2 * c2b * (.5d0 - 2d0/3d0 * sw2)
      dt2 = mz**2 * c2b * (       2d0/3d0 * sw2)

      mdiag(1,1) = mst1os**2
      mdiag(1,2) = 0d0
      mdiag(2,1) = 0d0
      mdiag(2,2) = mst2os**2
c      cttos = dsqrt(1d0 - sttos**2)
      rottrans(1,1) = dsqrt(1d0 - sttos**2)
      rottrans(1,2) = -sttos
      rottrans(2,1) = sttos
      rottrans(2,2) = rottrans(1,1)

      rot(1,1) = dsqrt(1d0 - sttos**2)
      rot(1,2) = sttos
      rot(2,1) = -sttos
      rot(2,2) = rot(1,1)
      call diagonalization(rottrans, mdiag, rot, mnondiag)

      msusytlos2 = mnondiag(1,1) - mtos**2 - dt1
      msusytros2 = mnondiag(2,2) - mtos**2 - dt2
      if ((msusytlos2.ge.0d0).and.(msusytros2.ge.0d0)) then
         msusytlos = dsqrt(mnondiag(1,1) - mtos**2 - dt1)
         msusytros = dsqrt(mnondiag(2,2) - mtos**2 - dt2)
         xtos = mnondiag(1,2)/mtos
c$$$      write(*,*) "rotation check:"
c$$$      write(*,*) real(dsqrt(msusytlos2)), real(mnondiag(1,2)/mtos)
c$$$      write(*,*) real(mnondiag(2,1)/mtos), real(dsqrt(msusytros2))
c$$$c         write(*,*) mnondiag(1,2), mnondiag(2,1)
      else
         msusytl = 0d0
         msusytr = 0d0
         xtos = 0d0
      endif



c$$$      write(*,*) 
c$$$      write(*,*) "MSbar to OnShell"
c$$$      write(*,*) "================"
c$$$      write(*,*)
c$$$      write(*,*) "MStopL, MStopR, Xt"
c$$$      write(*,*) real(msusytlmsbar), real(msusytrmsbar), 
c$$$     $           real(xtmsbar)
c$$$      write(*,*) real(msusytlos), real(msusytros),
c$$$     $           real(xtos)
c$$$      write(*,*)
c$$$      write(*,*) "MSt1, MSt2, stt, MT"
c$$$      write(*,*) real(mst1), real(mst2), real(stt), real(mtmsbar)
c$$$      write(*,*) real(mst1os), real(mst2os), real(sttos), real(mtos)
c$$$      write(*,*) 

 100  continue

      end


