C-----B22(K^2,M1,M2)--------------------------------------

      COMPLEX*16 FUNCTION B22(K2,M1,M2)

      IMPLICIT NONE
      COMPLEX*16 AA,B0
      DOUBLE PRECISION K2,M1,M2,M12,M22
      integer pri,naeh,mtn,dr,b22on

      common/print/pri,naeh,mtn,dr,b22on

      M12=M1*M1
      M22=M2*M2

      if (b22on.eq.1) dr=0
      if (dr.eq.0) then
         IF (K2.GT.0D0) THEN
            B22=(.5D0*(AA(M1)+AA(M2))+(M12+M22-K2/2D0)*B0(K2,M1,M2)
     &           +(M12-M22)/(2.D0*K2)*(AA(M1)-AA(M2))
     &           -(M12-M22)**2/(2.D0*K2)*B0(K2,M1,M2)+M12+M22-K2/3.D0)/6.D0
         ELSE IF (M1.NE.M2) THEN
            B22=1/6.D0*(AA(M2)+2.D0*M12*B0(K2,M1,M2)+M12+M22
     &           -(M12-M22)/2.D0*B0(K2,M1,M2)-(M1**2+M2**2)/4.D0
     &           -M12*M22/(2.D0*(M12-M22))*(B0(K2,M1,M1)-B0(K2,M2,M2)))
         ELSE
            B22=(AA(M1)+2.D0*M12*B0(K2,M1,M2)+2.D0*M12)/6.D0
         ENDIF
      elseif (dr.eq.1) then
         IF (K2.GT.0D0) THEN
            B22=(.5D0*(AA(M1)+AA(M2))+(M12+M22-K2/2D0)*B0(K2,M1,M2)
     &           +(M12-M22)/(2.D0*K2)*(AA(M1)-AA(M2))
     &           -(M12-M22)**2/(2.D0*K2)*B0(K2,M1,M2))/6.D0
         ELSE IF (M1.NE.M2) THEN
            B22=1/6.D0*(AA(M2)+2.D0*M12*B0(K2,M1,M2)
     &           -(M12-M22)/2.D0*B0(K2,M1,M2)-(M1**2+M2**2)/4.D0
     &           -M12*M22/(2.D0*(M12-M22))*(B0(K2,M1,M1)-B0(K2,M2,M2)))
         ELSE
            B22=(AA(M1)+2.D0*M12*B0(K2,M1,M2)+2.D0*M12)/6.D0
         ENDIF
      else
         write (*,*) 'Fehler in B22'
      endif

      if (b22on.eq.1) dr=1
      END

C-----DELB22(K^2,M1^2,M2^2)--------------------------------

      COMPLEX*16 FUNCTION DELB22(K2,M12,M22)

      IMPLICIT NONE
      DOUBLE PRECISION K2,M12,M22

      DELB22=(3.D0*(M12+M22)-K2)/12.D0

      END



C-----B22S(K^2,M1,M2)--------------------------------------

      COMPLEX*16 FUNCTION B22S(K2,M1,M2)

      IMPLICIT NONE
      COMPLEX*16 B0,B0S,B0SS
      DOUBLE PRECISION K2,M1,M2,M12,M22
      integer pri,naeh,mtn,dr,b22on

      common/print/pri,naeh,mtn,dr,b22on

      M12=M1*M1
      M22=M2*M2
      k2=0.d0

c      IF (K2.NE.0D0) THEN
c        WRITE(*,*) 'B22`(q^2 <> 0) KANN NICHT BERECHNET WERDEN'
c      ENDIF
      IF (K2.NE.0D0) GOTO 1850

      if (b22on.eq.1) dr=0
      if (dr.eq.0) then
         IF (M1.EQ.M2) GOTO 1830
         B22S=(2D0*M12*B0S(0D0,M1,M2)
     &        -B0(0D0,M1,M2)/2D0-(M12-M22)/2D0*B0S(0D0,M1,M2)
     &        -(M12-M22)/2D0*(B0S(0D0,M1,M2)+(M12-M22)*B0SS(0D0,M1,M2))
     &        -1D0/3D0)/6D0
         GOTO 1850
         
 1830    B22S=(2D0*M12*B0S(0D0,M1,M1)-B0(0D0,M1,M1)/2D0-1D0/3D0)/6D0
      elseif (dr.eq.1) then
         IF (M1.EQ.M2) GOTO 1840
         B22S=(2D0*M12*B0S(0D0,M1,M2)
     &        -B0(0D0,M1,M2)/2D0-(M12-M22)/2D0*B0S(0D0,M1,M2)
     &        -(M12-M22)/2D0*(B0S(0D0,M1,M2)+(M12-M22)*B0SS(0D0,M1,M2))
     &         )/6D0
         GOTO 1850

 1840    B22S=(2D0*M12*B0S(0D0,M1,M1)-B0(0D0,M1,M1)/2D0)/6D0
      endif

      if (b22on.eq.1) dr=1
1850  END


C-----B1(K^2,M1,M2)----------------------------------------
C     ACHTUNG: NUR SPEZIELLER FALL: K^2<>0, 0<>M1<>M2<>0

      COMPLEX*16 FUNCTION B1(K2,M1,M2)

      IMPLICIT NONE
      DOUBLE PRECISION K2,M1,M12,M2,M22
      COMPLEX*16 B0,AA

      M12=M1**2
      M22=M2**2

      B1=(AA(M1)-AA(M2)+(M22-M12-K2)*B0(K2,M1,M2))/(2D0*K2)

      END


C-----B0'(K^2,M1,M2)--------------------------------------

      COMPLEX*16 FUNCTION B0S(K2,M1,M2)

      IMPLICIT NONE
      DOUBLE PRECISION K2,M1,M12,M2,M22,MM,MM2
      COMPLEX*16 B0

      M12=M1*M1
      M22=M2*M2

      IF (K2.EQ.0D0) GOTO 1850

      IF (M12+M22.NE.0D0) GOTO 1810
      B0S=-1D0/K2
      GOTO 1899

1810  IF (M1.NE.M2) GOTO 1820
      B0S=(2D0*M12/K2*(B0(K2,M1,M1)-B0(0D0,M1,M1))-1D0)/(K2-4D0*M12)
      GOTO 1899

1820  IF (M1.EQ.0D0) GOTO 1830
      IF (M2.EQ.0D0) GOTO 1832
      B0S=((M12+M22)*B0(K2,M1,M2)-M12*B0(0D0,M1,M1)-M22*B0(0D0,M2,M2)
     &     -K2-(M12-M22)**2/K2*(B0(K2,M1,M2)-B0(0D0,M1,M2)))/
     &     ((K2-(M1-M2)**2)*(K2-(M1+M2)**2))
      GOTO 1899

1830  MM=M1
      GOTO 1835
1832  MM=M2
1835  MM2=MM*MM
      B0S=(MM2*B0(K2,0D0,MM)-M2*B0(0D0,MM,MM)-K2-MM**4/K2*(B0(K2,0D0,MM)
     &     -B0(0D0,0D0,MM)))/(K2-MM2)**2
      GOTO 1899

1850  IF (M1.NE.M2) GOTO 1860
      B0S=1/(6D0*M12)
      GOTO 1899

1860  IF (M1.EQ.0D0) GOTO 1870
      IF (M2.EQ.0D0) GOTO 1872
      B0S=(M12+M22)/(2D0*(M12-M22)**2)+M12*M22/(M12-M22)**3*
     &    (B0(0D0,M1,M1)-B0(0D0,M2,M2))
      GOTO 1899

1870  B0S=1D0/(2D0*M22)
      GOTO 1899
1872  B0S=1D0/(2D0*M12)


1899  END


C-----B0''(K2,M1,M2)--------------------------------------

      COMPLEX*16 FUNCTION B0SS(K2,M1,M2)

      IMPLICIT NONE
      DOUBLE PRECISION K2,M1,M12,M2,M22,MM,MM2

      M12=M1*M1
      M22=M2*M2

      IF (K2.NE.0D0) THEN
        WRITE(*,*) 'B0``(q^2 <> 0) KANN NICHT BERECHNET WERDEN'
      ENDIF
      IF (K2.NE.0D0) GOTO 1940

      IF (M1.NE.M2) GOTO 1900
      B0SS=1D0/(30D0*M12)
      GOTO 1940

1900  IF (M1.EQ.0D0) GOTO 1930
      IF (M2.EQ.0D0) GOTO 1932
      B0SS=(M1**4+10D0*M12*M22+M2**4)/(3D0*(M12-M22)**4)
     &     +(2D0*M12*M22*(M12+M22))/(M12-M22)**5*LOG(M12/M22)
      GOTO 1940

1930  B0SS=1D0/(3D0*M2**4)
      GOTO 1940
1932  B0SS=1D0/(3D0*M1**4)


1940  END


C-----A(M)---IM PROGRAMM:AA(M)----------------------------

      COMPLEX*16 FUNCTION AA(M)

      IMPLICIT NONE
      DOUBLE PRECISION M

      IF (M.EQ.0D0) THEN
        AA=0.D0
      ELSE
        AA=M**2*(-LOG(M**2)+1.D0)
      ENDIF

      END

C-----B0(K^2,M1,M2)---------------------------------------

      COMPLEX*16 FUNCTION B0(K2,mM1,mM2)

      IMPLICIT NONE
      COMPLEX*16 B0B0,B1B1,THETHA
      DOUBLE PRECISION K2,M1,M2,M12,M22,EE,mm1,mm2

      EE=1D-200
      m1=mm1
      m2=mm2
      THETHA=(0.D0,0.D0)
      IF (K2.GE.0.D0) THETHA=(0.D0,3.14159265358979D0)
      IF (M1.EQ.0.D0) M1=1.D-50
      M12=M1*M1
      IF (M2.EQ.0.D0) M2=1.D-50
      M22=M2*M2

      IF (K2.EQ.0D0) GOTO 1980
      IF (M12+M22.LT.1D-50) THEN
        B0=2-LOG(K2)+THETHA
      ELSE
        CALL BQUER(K2,M1,M2,B0B0,B1B1)
        B0=B0B0-LOG(M1*M2)
      ENDIF
      GOTO 2000

1980  IF (M12.NE.M22) GOTO 1990
      B0=-LOG(M12)
      GOTO 2000

1990  B0=1D0-(M12*LOG(M12)-(M22)*LOG(M22))/(M12-M22)

2000  END

C-----HOLLIKS PROGRAMM--------------------------------------------------
C********************************************************
C
      SUBROUTINE BQUER(S,M1,M2,B0,B1)
C
C  B0 AND B1 ARE THE (FINITE) INARIANT FUNCTIONS IN THE
C  2-POINT INTEGRALS.
C  S = Q**2;  M1,M2 ARE THE INTERNAL MASSES
C
      IMPLICIT REAL*8(A-Z)
      DOUBLE PRECISION DREAL,S,M1,M2,EE
      EXTERNAL F,G
      COMPLEX*16 B0,B1,CF
      EE=1.D-100
      XM1=M1**2
      XM2=M2**2
      IF (M1.EQ.M2) THEN
        LM=0.
      ELSE
        LM=DLOG(M2/M1)
      ENDIF
      CF=DCMPLX( F(S,M1,M2),G(S,M1,M2))
      IF (M1.EQ.M2) GOTO 10
      B0=1.D0-(XM2+XM1)/(XM2-XM1)*LM+CF
      B1=-.25D0+XM1/(XM2-XM1)*LM+(XM2-XM1-S)/2.D0/S*CF
      GOTO 20
10    CONTINUE
      B0=CF
      B1=-.5D0*CF
20    RETURN
      END
C********************************************************
C  !! WIRD NICHT BENTIGT !!
C     SUBROUTINE BQUER1(X,M1,M2,B0,B1,P0,P1)
C**************************************************************
C  THE SCALAR VERTEX INTEGRAL WITH EQUAL EXTERNAL MASSES MF   *
C**************************************************************
C
      COMPLEX*16 FUNCTION C0(WUS,Q,M2,M3,M1)
C
C  S = MOMENTUM TRANSFER; M1,M2,M3  ARE THE INTERNAL MASSES
C
      IMPLICIT REAL*8 (A-Y)
      COMPLEX*16 Z1,Z2,Z11,Z12,Z21 ,Z22,CL1,CL2,CL3,CSPEN,SPENCE,
     &           INT,DCMPLX,CSCAL
      DOUBLE PRECISION DREAL,Q,S,WUS,EE
      EE=1.D-100
      S=WUS*WUS
      MF=Q
      XMF=MF*MF
C.........XM1 ETC.   ARE FERMION AND BOSON MASSES SQUARED
      XM1=M1*M1
      XM2=M2*M2
      XM3=M3*M3
C     WRITE(*,*)REAL(M1),REAL(M2),REAL(M3)
C
C..T'HOOFT-VELTMAN PARAMETERS
      A=1.D0
      B=XMF/S
      C=-1.D0
      D=XM1-XM2-S
      E=XM3-XM1-XMF+S
      F=XM2/S
      D=D/S
      E=E/S
C..DISCRIMINANTE FOR ALPHA-EQUATION
      DISC=C*C-4.D0*A*B
      IF (DISC .LT. 0.D0) GOTO 500
      AL=(-C-DSQRT(DISC))/2.D0/B
      NENNER=C+2.D0*AL*B
C..THE FIRST INTEGRAL.............................................
C     Y0=-(D+E*AL+2.D0*A+C*AL)/NENNER+EE
C     Y01=Y0-1.D0+EE
      Y0=-(D+E*AL+2.D0*A+C*AL)/NENNER
      Y01=Y0-1.D0
      D1=(C+E)**2-4.D0*B*(A+D+F)
      X1=-(C+E)/2.D0/B
      IF (D1.GT.0.D0) GOTO 10
C.......COMPLEX ZEROES OF LOGARITHMS
      SQ1=DSQRT(-D1)
      X2=SQ1/2.D0/B
      Z1=DCMPLX(X1,X2)
      Z2=DCMPLX(X1,-X2)
      Z11=Y0/(Y0-Z1)
      Z12=(Y01+EE)/(Y0-Z1)
      Z21=Y0/(Y0-Z2)
      Z22=(Y01+EE)/(Y0-Z2)
      CL1=SPENCE(Z11)-SPENCE(Z12)+SPENCE(Z21)-SPENCE(Z22)
      GOTO 15
10    CONTINUE
C........REAL ZEROES
      SQ1=DSQRT(D1)
      X2=SQ1/2.D0/B
      Y1=X1+X2
      Y2=X1-X2
      SIG1= Y0/DABS(Y0)
      SIG2= Y01/DABS(Y01)
      Y11=Y0/(Y0-Y1)
      Y12=(Y01+EE)/(Y0-Y1)
      Y21=Y0/(Y0-Y2)
      Y22=(Y01+EE)/(Y0-Y2)
c      CL1=CSPEN(Y11,SIG1)-CSPEN(Y12,SIG2)+CSPEN(Y21,-SIG1)
c     &   -CSPEN(Y22,-SIG2)
      CL1=CSPEN(dcmplx(Y11,SIG1))-CSPEN(dcmplx(Y12,SIG2))
     $   +CSPEN(dcmplx(Y21,-SIG1))
     &   -CSPEN(dcmplx(Y22,-SIG2))
15    CONTINUE
C..THE SECOND INTEGRAL............................................
C     Y0=-(D+E*AL)/NENNER/(1.D0-AL)+EE
C     Y01=Y0-1.D0+EE
      Y0=-(D+E*AL)/NENNER/(1.D0-AL)
      Y01=Y0-1.D0
      D2=(E+D)**2-4.D0*F*(A+B+C)
      X1=-(E+D)/2.D0/(A+B+C)
      IF(D2.GT.0.D0) GOTO 20
C.......COMPLEX ZEROES OF LOGARITHMS
      SQ2=DSQRT(-D2)
      X2=SQ2/2.D0/(A+B+C)
      Z1=DCMPLX(X1,X2)
      Z2=DCMPLX(X1,-X2)
      Z11=Y0/(Y0-Z1)
      Z12=(Y01+EE)/(Y0-Z1)
      Z21=Y0/(Y0-Z2)
      Z22=(Y01+EE)/(Y0-Z2)
      CL2=SPENCE(Z11)-SPENCE(Z12)+SPENCE(Z21)-SPENCE(Z22)
      GOTO 25
20    CONTINUE
C........REAL ZEROES
      X2=DSQRT(D2)/2.D0/(A+B+C)
      Y1=X1+X2
      Y2=X1-X2
      Y11=Y0/(Y0-Y1)
      Y12=(Y01+EE)/(Y0-Y1)
      Y21=Y0/(Y0-Y2)
      Y22=(Y01+EE)/(Y0-Y2)
      SIG1= Y0/DABS(Y0)
      SIG2= Y01/DABS(Y01)
c      CL2=CSPEN(Y11,SIG1)-CSPEN(Y12,SIG2)+CSPEN(Y21,-SIG1)
c     &   -CSPEN(Y22,-SIG2)
      CL2=CSPEN(dcmplx(Y11,SIG1))-CSPEN(dcmplx(Y12,SIG2))
     $   +CSPEN(dcmplx(Y21,-SIG1))
     &   -CSPEN(dcmplx(Y22,-SIG2))
25    CONTINUE
C..THE THIRD INTEGRAL............................................
C     Y0=(D+E*AL)/NENNER/AL+EE
C     Y01=Y0-1.D0+EE
      Y0=(D+E*AL)/NENNER/AL
      Y01=Y0-1.D0
      D3=D*D-4.D0*A*F
      X1=-D/2.D0/A
      IF (D3.GT.0.D0) GOTO 30
C........COMPLEX ZEROES OF LOGARITHMS
      SQ3=DSQRT(-D3)
      X2=SQ3/2.D0/A
      Z1=DCMPLX(X1,X2)
      Z2=DCMPLX(X1,-X2)
      Z11=Y0/(Y0-Z1)
      Z12=(Y01+EE)/(Y0-Z1)
      Z21=Y0/(Y0-Z2)
      Z22=(Y01+EE)/(Y0-Z2)
      CL3=SPENCE(Z11)-SPENCE(Z12)+SPENCE(Z21)-SPENCE(Z22)
      GOTO 35
30    CONTINUE
C........REAL ZEROES
      X2=DSQRT(D3)/2.D0/A
      Y1=X1+X2
      Y2=X1-X2
 31   FORMAT(1H ,3E12.4)
      Y11=Y0 /(Y0-Y1)
      Y12=(Y01+EE)/(Y0-Y1)
      Y21=Y0/(Y0-Y2)
      Y22=(Y01+EE)/(Y0-Y2)
      SIG1= Y0/DABS(Y0)
      SIG2= Y01/DABS(Y01)
c      CL3=CSPEN(Y11,SIG1)-CSPEN(Y12,SIG2)+CSPEN(Y21,-SIG1)
c     &   -CSPEN(Y22,-SIG2)
      CL3=CSPEN(dcmplx(Y11,SIG1))-CSPEN(dcmplx(Y12,SIG2))
     $   +CSPEN(dcmplx(Y21,-SIG1))
     &   -CSPEN(dcmplx(Y22,-SIG2))
35    CONTINUE
C..SUMMATION OF THE 3 INTEGRALS ....................................
      INT=-CL1+CL2-CL3
      CSCAL=INT/NENNER/S
      GOTO 501
500   CONTINUE
C..ERROR MESSAGE FOR COMPLEX ALPHA................................
      WRITE(6,21)
21    FORMAT(1H ,'  I CANNOT HANDLE A COMPLEX ALPHA (SH)')
      write(*,*) 'mf:',mf
      write(*,*) 'wus:',wus
      write(*,*) 'Int. Massen:',m1,m2,m3
      GOTO 502
501   C0=CSCAL
502   RETURN
      END
C
C*******************************************************************
C
c$$$      COMPLEX FUNCTION CSPEN*16(X,SIG)
c$$$      IMPLICIT REAL*8(A-Y)
c$$$      COMPLEX*16 Z,CPI,SPENCE,ZX
c$$$      DOUBLE PRECISION DREAL
c$$$      PI=3.1415926536D0
c$$$      PI6=PI*PI/6.D0
c$$$      CPI=DCMPLX(0.D0,PI)
c$$$      IF (X.LT.1.D0) GOTO 10
c$$$      IF(X.EQ.1.D0) GOTO 11
c$$$      LX=DLOG(X)
c$$$      X1=1.D0-X
c$$$      LX1=DLOG(-X1)
c$$$      Z=DCMPLX(X1,0.D0)
c$$$      IF (SIG.GT.0.D0) GOTO 5
c$$$      CSPEN=-SPENCE(Z)+PI6-LX*(LX1+CPI)
c$$$      GOTO 20
c$$$5     CSPEN=-SPENCE(Z)+PI6-LX*(LX1-CPI)
c$$$      GOTO 20
c$$$10    ZX=DCMPLX(X,0.D0)
c$$$      CSPEN=SPENCE(ZX)
c$$$      GOTO 20
c$$$11    CSPEN=DCMPLX(PI6,0.D0)
c$$$20    RETURN
c$$$      END
C
C**************************************************************
C
      COMPLEX FUNCTION CLN*16(X,SIG)
      IMPLICIT REAL*8(A-Z)
      COMPLEX*16 Z,CPI,CDLOG
      DOUBLE PRECISION DREAL
      PI=3.1415926536D0
      CPI=DCMPLX(0.D0,PI)
      IF (X.GT.0.D0) GOTO 10
      X1=-X
      IF (SIG.GT.0.D0) GOTO 5
      CLN=DLOG(X1)-CPI
      GOTO 20
5     CLN=DLOG(X1)+CPI
      GOTO 20
10    Y=DLOG(X)
      CLN=DCMPLX(Y,0.D0)
20    RETURN
      END
      COMPLEX FUNCTION SPENCE*16(XX)
C  THE DILOGARITHM FOR GENERAL COMPLEX ARGUMENT.
C  NOT ALLOWED: REAL(XX) GT 1 WITH IMAG(XX)=0.
      IMPLICIT REAL*8(A-Z)
      INTEGER N
      COMPLEX*16 XX,X,Z,D,P,       CDLOG
      DOUBLE PRECISION DREAL
      DIMENSION A(19)
      PI=3.1415926536D0
      X=XX
      XR=DREAL(X)
      XI=DIMAG(X)
      IF(XR.NE.1.) GOTO 111
      IF(XI.EQ.0.) GOTO 20
111   CONTINUE
C    PROJECTION INTO THE CONVERGENCE RADIUS
      VOR=1.D0
      P=DCMPLX(0.D0,0.D0)
      R=DREAL(X)
      IF (R .LE. 0.5D0) GOTO 1
      P=PI*PI/6.D0- CDLOG(X)*CDLOG(1.D0-X)
      VOR=-1.D0
      X=1.D0-X
    1 CONTINUE
      B=CDABS(X)
      IF (B .LT. 1.D0) GOTO 2
      P=P - (PI*PI/6.D0+ CDLOG(-X)*CDLOG(-X)/2.D0)*VOR
      VOR=VOR*(-1.D0)
      X=1.D0/X
    2 CONTINUE
C    CALCULATION OF THE SPENCE FUNCTION
      A(1)=1.D0
      A(2)=-0.5D0
      A(3)=1.D0/6.D0
      A(5)=-1.D0/30.D0
      A(7)=1.D0/42.D0
      A(9)=-1.D0/30.D0
      A(11)=5.D0/66.D0
      A(13)=-691.D0/2730.D0
      A(15)=7.D0/6.D0
      A(17)=-3617.D0/510.D0
      A(19)=43867.D0/798.D0
      DO 5 N=2,9,1
      A(2*N)=0.D0
    5 CONTINUE
      Z=(-1.D0)*CDLOG(1.D0-X)
      D=DCMPLX(A(19),0.D0)
      DO 10 N=1,18,1
      D=D*Z/(20.D0-N) + A(19-N)
   10 CONTINUE
      D=D*Z
      SPENCE=D*VOR + P
      GOTO 30
   20 CONTINUE
      SPENCE=PI*PI/6.D0
   30 CONTINUE
      RETURN
      END
***************************************************
      DOUBLE PRECISION FUNCTION F(S,MA,MB)
* Real part of the function F(s,ma,mb)
      IMPLICIT REAL*8(A-Z)
      DOUBLE PRECISION DREAL
      PARAMETER(EPS=1.D-6)
      MA2=MA**2
      MB2=MB**2
      IF(ABS(S).LT.EPS) THEN
             F=0.0D0
      ELSEIF(MA.LT.EPS) THEN
           IF(S.GT.MB2+EPS) THEN
             F=1.D0+(1.D0-MB2/S)*LOG(1./(S/MB2-1.D0))
           ELSEIF(S.LT.MB2-EPS) THEN
             F=1.D0+(1.D0-MB2/S)*LOG(1./(1.D0-S/MB2))
           ELSE
             F=1.D0
           ENDIF
      ELSEIF(MB.LT.EPS) THEN
           IF(S.GT.MA2+EPS) THEN
             F=1.D0+(1.D0-MA2/S)*LOG(1./(S/MA2-1.D0))
           ELSEIF(S.LT.MA2-EPS) THEN
             F=1.D0+(1.D0-MA2/S)*LOG(1./(1.D0-S/MA2))
           ELSE
             F=1.D0
           ENDIF
      ELSE
          IF(ABS(MB-MA).LT.EPS) THEN
           F=2.D0
          ELSE
           F=1.D0+((MA2-MB2)/S-(MA2+MB2)/(MA2-MB2))*LOG(MB/MA)
          ENDIF
          IF(S.GE.(MA+MB)**2) THEN
            RPLUS=SQRT(S-(MA+MB)**2)
            RMIN =SQRT(S-(MA-MB)**2)
            F=F- RPLUS*RMIN*LOG((RPLUS+RMIN)**2/(4.D0*MA*MB))/S
          ELSEIF(S.LT.(MA-MB)**2) THEN
            RPLUS=SQRT((MA+MB)**2-S)
            RMIN =SQRT((MA-MB)**2-S)
            F=F+ RPLUS*RMIN*LOG((RPLUS+RMIN)**2/(4.D0*MA*MB))/S
          ELSE
            RPLUS=SQRT((MA+MB)**2-S)
            RMIN =SQRT(S-(MA-MB)**2)
            F=F- 2.D0*RPLUS*RMIN*ATAN(RMIN/RPLUS)/S
          ENDIF
        ENDIF
        END
      DOUBLE PRECISION FUNCTION DF(S,MA,MB)
*****   Derivative of the real part of the function F(s,ma,mb).    *****
      IMPLICIT REAL*8(A-Z)
      DOUBLE PRECISION DREAL
      PARAMETER(EPS=1.D-6)
      IF(S.LT.(MA-MB)**2) THEN
         RPLUS=SQRT((MA+MB)**2-S)
         RMIN =SQRT((MA-MB)**2-S)
         DF=( (MB**2-MA**2)*LOG(MB/MA)/S-
     .   ((RMIN**2+2.D0*RMIN**2*RPLUS**2/S+RPLUS**2)/(2.D0*RMIN*RPLUS))*
     .           LOG((RMIN+RPLUS)**2/(4.D0*MA*MB))  -1.D0 )/S
      ELSEIF(S.LT.(MA+MB)**2) THEN
         RPLUS=SQRT((MA+MB)**2/S-1.D0)
         RMIN =SQRT(1.D0-(MA-MB)**2/S)
         DF=( (MB**2-MA**2)*LOG(MB/MA)/S+
     .        ((RMIN**2+2.D0*RMIN**2*RPLUS**2-RPLUS**2)/(RMIN*RPLUS))*
     .           ATAN(RMIN/RPLUS)  -1.D0 )/S
      ELSE
         RPLUS=SQRT(S-(MA+MB)**2)
         RMIN =SQRT(S-(MA-MB)**2)
         DF=( (MB**2-MA**2)*LOG(MB/MA)/S-
     .   ((RMIN**2-2.D0*RMIN**2*RPLUS**2/S+RPLUS**2)/(2.D0*RMIN*RPLUS))*
     .           LOG((RMIN+RPLUS)**2/(4.D0*MA*MB))  -1.D0 )/S
*        Y=SQRT(S-4.D0*MA**2)
*        Z=SQRT(S)
*        DF=( (Y**2-S)*LOG((Z+Y)/(Z-Y))/(2.D0*Z*Y)-1.D0)/S
      ENDIF
      END
      DOUBLE PRECISION FUNCTION G(S,MA,MB)
* Imaginary part of the function F(s,ma,mb)
      IMPLICIT DOUBLE PRECISION (A-Z)
      PARAMETER (PI=3.1415926535897932D0)
      G = 0.D0
      IF(S.GT.(MA+MB)**2)  G=PI*SQRT((S-(MA+MB)**2)*(S-(MA-MB)**2))/S
      END


C----------------------------------------------------------------------


c      DOUBLE PRECISION FUNCTION DREAL(AAA)

c      COMPLEX*16 AAA
c      DREAL=DIMAG(AAA*(0.D0,1.D0))

c      END


