c --> calculation of physical parameters from unphysical stop/sbot parameters
      subroutine def2

      include 'varcom.h'
      include 'MSb1shiftDREDvar.f'
      include 'MSb1shiftDREGvar.f'
      double precision ml2t, mr2t, ml2b, mr2b, sgnt, sgnb, tt, bb
     $               , m12, m22, delmsb1

      ml2t = msusytl**2 + mz**2*c2b*( .5d0 - 2d0/3d0*sw2) + mt**2
      mr2t = msusytr**2 + mz**2*c2b*(        2d0/3d0*sw2) + mt**2
      ml2b = msusybl**2 + mz**2*c2b*(-.5d0 + 1d0/3d0*sw2) + mb**2
      mr2b = msusybr**2 + mz**2*c2b*(      - 1d0/3d0*sw2) + mb**2
c      write(*,*) 'diagonal entries:'
c      write(*,*) ml2t, mr2t
      sgnt = (ml2t - mr2t)/dabs(ml2t - mr2t)
      sgnb = (ml2b - mr2b)/dabs(ml2b - mr2b)

      tt = datan(-sgnt*2d0*mt*mlrt/
     $           (-sgnt*(ml2t - mr2t) 
     $            -dsqrt((ml2t - mr2t)**2 + 4d0 * mt**2 * mlrt**2)))

      stt = dsin(tt)
      ctt = dcos(tt)

c      write(*,*) 'stop variables:'
c      write(*,*) real(ml2t), real(mr2t), real(sgnt), real(tt), real(stt)


      bb = datan(-sgnb*2d0*mb*mlrb/
     $           (-sgnb*(ml2b - mr2b) 
     $            -dsqrt((ml2b - mr2b)**2 + 4d0 * mb**2 * mlrb**2)))

      stb = dsin(bb)
      ctb = dcos(bb)

      m12 = .5d0*(ml2t + mr2t 
     $            + sgnt * dsqrt((ml2t - mr2t)**2 + 4d0*mt**2*mlrt**2))
      m22 = .5d0*(ml2t + mr2t 
     $            - sgnt * dsqrt((ml2t - mr2t)**2 + 4d0*mt**2*mlrt**2))

      
      if ((m12.lt.0d0) .or. (m22.lt.0d0))  then
         MSt1 = 0d0
         MSt2 = 0d0
         goto 100
      endif
      MSt1 = dsqrt(m12)
      MSt2 = dsqrt(m22)

 100  continue

      m12 = .5d0*(ml2b + mr2b 
     $            + sgnb * dsqrt((ml2b - mr2b)**2 + 4d0*mb**2*mlrb**2))
      m22 = .5d0*(ml2b + mr2b 
     $            - sgnb * dsqrt((ml2b - mr2b)**2 + 4d0*mb**2*mlrb**2))

      
      if ((m12.lt.0d0) .or. (m22.lt.0d0))  then
         MSb1 = 0d0
         MSb2 = 0d0
         goto 200
      endif
      MSb1 = dsqrt(m12)
      MSb2 = dsqrt(m22)

      if ((MSt1.eq.0d0).or.(MSt2.eq.0d0)) goto 200
      
c      write(*,*) real(msusytl), real(msusytr), 
c     $           real(msusybl), real(msusybr)
c      write(*,*) real(mlrt), real(mlrb)
c      write(*,*) 'Squark masses:'
c      write(*,*) real(MSt1), real(MSt2), real(stt)
c      write(*,*) real(MSb1), real(MSb2), real(stb)

c --> the following constitutes a finite shift in MSb1 in O(alpha_s)
c     which results in a contribution in O(alpha alpha_s) when inserted
c     in the one-loop calculation
      b = datan(tb)
      if (dr1l.eq.0) then
         delmsb1 = 0d0
      elseif (dr1l.eq.1) then
         include 'MSb1shiftDREGsum.f'
         delmsb1 = MSb1shiftDREG
         write(*,*) 'mass shift (DREG) applied for MSb1',
     $              real(msb1), real(dsqrt(msb1**2 + delmsb1))
      elseif (dr1l.eq.2) then
         include 'MSb1shiftDREDsum.f'
         delmsb1 = MSb1shiftDRED
         write(*,*) 'mass shift (DRED) applied for MSb1',
     $              real(msb1), real(dsqrt(msb1**2 + delmsb1))
      else
         write(*,*) 'WARNING: dr1l has forbidden value!!!'
         delmsb1 = 0d0
      endif
      msb1 = dsqrt(msb1**2 + delmsb1)
c      write(*,*) 'def2: MSb1:', real(msb1)

 200  continue


      end

c-------------------------------------------------------------------

c --> calculation of unphysical parameters from physical stop parameters
      subroutine def3(xtb,mst2,delmst,stt,
     $                xmsusytl,xmsusytr,xmsusybl,xmsusybr,xmtlr)

      double precision mst2,delmst,stt,ctt
      double precision xmsusytl,xmsusytr,xmsusybl,xmsusybr,xmtlr,
     $                 xmsusytl2, xmsusytr2
      double precision xmw,xmz,xmt,xtb,xb,xc2b,xsw2,dt1,dt2
      double precision rot(1:2,1:2), rottrans(1:2,1:2), 
     $                 mdiag(1:2,1:2), mnondiag(1:2,1:2), z(1:2,1:2)

      common /smpara1/ xmw,xmz,xmt

c      write(*,*) 'Parameters in def3:'
c      write(*,*) xtb, mst2, stt, delmst

      xb = datan(xtb)
      xc2b = dcos(2d0*xb)
      xsw2 = 1d0 - xmw**2/xmz**2
      dt1 = xmz**2 * xc2b * (.5d0 - 2d0/3d0 * xsw2)
      dt2 = xmz**2 * xc2b * (       2d0/3d0 * xsw2)

      mdiag(1,1) = (mst2 - delmst)**2
      mdiag(1,2) = 0d0
      mdiag(2,1) = 0d0
      mdiag(2,2) = mst2**2
      ctt = dsqrt(1d0 - stt**2)
      rot(1,1) = ctt
      rot(1,2) = stt
      rot(2,1) = -stt
      rot(2,2) = ctt
      rottrans(1,1) = ctt
      rottrans(1,2) = -stt
      rottrans(2,1) = stt
      rottrans(2,2) = ctt

      call matmult(rottrans, mdiag, z)
      call matmult(z, rot, mnondiag)

      xmsusytl2 = mnondiag(1,1) - xmt**2 - dt1
      xmsusytr2 = mnondiag(2,2) - xmt**2 - dt2
      if ((xmsusytl2.ge.0d0).and.(xmsusytr2.ge.0d0)) then
         xmsusytl = dsqrt(mnondiag(1,1) - xmt**2 - dt1)
         xmsusytr = dsqrt(mnondiag(2,2) - xmt**2 - dt2)
         xmsusybl = xmsusytl
         xmsusybr = xmsusybl
         xmtlr = mnondiag(1,2)/xmt
      else
         xmsusytl = 0d0
         xmsusytr = 0d0
         xmsusybl = 0d0
         xmsusybr = 0d0
         xmtlr = 0d0
      endif

c      write(*,*) 'parameters from def3:'
c      write(*,*) xmsusytl, xmsusytr, xmsusybl, xmtlr

      end


c-------------------------------------------------------------------

c --> calculation of physical parameters for one fermion sector
      subroutine def4(msusyl,msusyr,xf,mf,tb,msf1,msf2,stf,f)

c     f = 1: top-type fermions
c     f = 2: bottom type fermions

      double precision msusyl, msusyr, xf, mf, tb, msf1, msf2, stf, ctf
      double precision mw, mz, sw2, c2b, dum
      integer f
      double precision ml2t, mr2t, ml2b, mr2b, sgnt, sgnb, tt, bb
     $               , m12, m22
      common /smpara1/ mw, mz, dum

      sw2 = 1d0 - mw**2/mz**2
      c2b = dcos(2d0 * datan(tb))

      if (f.eq.1) then
         ml2t = msusyl**2 + mz**2*c2b*( .5d0 - 2d0/3d0*sw2) + mf**2
         mr2t = msusyr**2 + mz**2*c2b*(        2d0/3d0*sw2) + mf**2
      elseif (f.eq.2) then
         ml2t = msusyl**2 + mz**2*c2b*(-.5d0 + 1d0/3d0*sw2) + mf**2
         mr2t = msusyr**2 + mz**2*c2b*(      - 1d0/3d0*sw2) + mf**2
      else
         write(*,*) 'fermion selection in def4 out or range'
         stop
      endif
c      write(*,*) 'diagonal entries:'
c      write(*,*) ml2t, mr2t
      sgnt = (ml2t - mr2t)/dabs(ml2t - mr2t)

      tt = datan(-sgnt*2d0*mf*xf/
     $           (-sgnt*(ml2t - mr2t) 
     $            -dsqrt((ml2t - mr2t)**2 + 4d0 * mf**2 * xf**2)))

      stf = dsin(tt)
      ctf = dcos(tt)

c      write(*,*) 'stop variables:'
c      write(*,*) real(ml2t), real(mr2t), real(sgnt), real(tt), real(stt)


      m12 = .5d0*(ml2t + mr2t 
     $            + sgnt * dsqrt((ml2t - mr2t)**2 + 4d0*mf**2*xf**2))
      m22 = .5d0*(ml2t + mr2t 
     $            - sgnt * dsqrt((ml2t - mr2t)**2 + 4d0*mf**2*xf**2))

      
      if ((m12.lt.0d0) .or. (m22.lt.0d0))  then
         MSf1 = 0d0
         MSf2 = 0d0
         goto 100
      endif
      MSf1 = dsqrt(m12)
      MSf2 = dsqrt(m22)

 100  continue

c$$$      write(*,*) "Msusy    :",msusy
c$$$      write(*,*) "Mlr      :",mlr
c$$$      write(*,*) "MT       :", MT
c$$$      write(*,*) "theta_top:",tt
c$$$      write(*,*) "-Pi/4    :",-Pi/4d0
      
c      write(*,*) real(msusytl), real(msusytr), 
c     $           real(msusybl), real(msusybr)
c      write(*,*) real(xf), real(mlrb)
c      write(*,*) 'Squark masses:'
c      write(*,*) real(MSt1), real(MSt2), real(stt)
c      write(*,*) real(MSb1), real(MSb2), real(stb)


      end

c-------------------------------------------------------------------

c --> calculation of unphysical parameters from physical parameters
c     for one sfermion type
      subroutine def4b(msf1, msf2, stf, mf, qf, xtb, msusyl,msusyr,xf,f)

c     f = 1: top-type fermions
c     f = 2: bottom type fermions

      double precision msf1, msf2, stf, mf, qf,
     $                 msusyl, msusyr, xf, msusyl2, msusyr2
      double precision xmw,xmz,xmt,xtb,xb,xc2b,xsw2,dt1,dt2
      double precision rot(1:2,1:2), rottrans(1:2,1:2), 
     $                 mdiag(1:2,1:2), mnondiag(1:2,1:2), z(1:2,1:2)
      integer f

      common /smpara1/ xmw,xmz,xmt

c      write(*,*) 'Parameters in def4b:',
c     $     real(msf1), real(msf2), real(stf), real(mf), real(qf), 
c     $     real(xtb)

      xb = datan(xtb)
      xc2b = dcos(2d0*xb)
      xsw2 = 1d0 - xmw**2/xmz**2
      if (f.eq.1) then
         dt1 = xmz**2 * xc2b * (.5d0 - qf * xsw2)
         dt2 = xmz**2 * xc2b * (       qf * xsw2)
      elseif (f.eq.2) then
         dt1 = xmz**2 * xc2b * (-.5d0 - qf * xsw2)
         dt2 = xmz**2 * xc2b * (        qf * xsw2)
      else
         write(*,*) 'Error in def4b: sfermion selection'
      endif

      mdiag(1,1) = msf1**2
      mdiag(1,2) = 0d0
      mdiag(2,1) = 0d0
      mdiag(2,2) = msf2**2
      ctf = dsqrt(1d0 - stf**2)
      rot(1,1) = ctf
      rot(1,2) = stf
      rot(2,1) = -stf
      rot(2,2) = ctf
      rottrans(1,1) = ctf
      rottrans(1,2) = -stf
      rottrans(2,1) = stf
      rottrans(2,2) = ctf

      call diagonalization(rottrans, mdiag, rot, mnondiag)

      msusyl2 = mnondiag(1,1) - mf**2 - dt1
      msusyr2 = mnondiag(2,2) - mf**2 - dt2
      if ((msusyl2.ge.0d0).and.(msusyr2.ge.0d0)) then
         msusyl = dsqrt(mnondiag(1,1) - mf**2 - dt1)
         msusyr = dsqrt(mnondiag(2,2) - mf**2 - dt2)
         xf = mnondiag(1,2)/mf
      else
         msusyl = 0d0
         msusyr = 0d0
         xf = 0d0
      endif

c      write(*,*) 'parameters from def4b:',
c     $           real(msusyl), real(msusyr), real(xf)
c      write(*,*) real(mnondiag(1,1)), real(mnondiag(1,2)),
c     $           real(mnondiag(2,1)), real(mnondiag(2,2))

      end


c-------------------------------------------------------------------

c --> calculation of unphysical parameters from physical stop/sbot parameters
      subroutine def5(tb,mt,mw,mz,mst1,mst2,stt,msbotr, xb,
     $                msusytl,msusytr,msusybl,msusybr,mtlr,mblr)

      double precision mst1,mst2,stt,ctt
      double precision msusytl,msusytr,msusybl,msusybr,mtlr,mblr,
     $                 msusytl2, msusytr2, msbotr, xb
      double precision mw,mz,mt,tb,b,c2b,sw2,dt1,dt2
      double precision rot(1:2,1:2), rottrans(1:2,1:2), 
     $                 mdiag(1:2,1:2), mnondiag(1:2,1:2), z(1:2,1:2)

c      write(*,*) 'Parameters in def5:'
c      write(*,*) real(tb), real(mt), real(mw), real(mz), real(mst1),
c     $           real(mst2), real(stt), real(msbotr), real(xb)

      b = datan(tb)
      c2b = dcos(2d0*b)
      sw2 = 1d0 - mw**2/mz**2
      dt1 = mz**2 * c2b * (.5d0 - 2d0/3d0 * sw2)
      dt2 = mz**2 * c2b * (       2d0/3d0 * sw2)

      mdiag(1,1) = mst1**2
      mdiag(1,2) = 0d0
      mdiag(2,1) = 0d0
      mdiag(2,2) = mst2**2
      ctt = dsqrt(1d0 - stt**2)
      rot(1,1) = ctt
      rot(1,2) = stt
      rot(2,1) = -stt
      rot(2,2) = ctt
      rottrans(1,1) = ctt
      rottrans(1,2) = -stt
      rottrans(2,1) = stt
      rottrans(2,2) = ctt

      call diagonalization(rottrans, mdiag, rot, mnondiag)
c      write(*,*) 'after diagonalization'
 
      msusytl2 = mnondiag(1,1) - mt**2 - dt1
      msusytr2 = mnondiag(2,2) - mt**2 - dt2
      if ((msusytl2.ge.0d0).and.(msusytr2.ge.0d0)) then
         msusytl = dsqrt(mnondiag(1,1) - mt**2 - dt1)
         msusytr = dsqrt(mnondiag(2,2) - mt**2 - dt2)
         msusybl = msusytl
         msusybr = msbotr
         mtlr = mnondiag(1,2)/mt
         mblr = xb
      else
         msusytl = 0d0
         msusytr = 0d0
         msusybl = 0d0
         msusybr = 0d0
         mtlr = 0d0
         mblr = 0d0
      endif
c      write(*,*) 'def5 completed'

      end


c-------------------------------------------------------------------

      subroutine matmult(a, b, c)

      double precision a(1:2,1:2), b(1:2,1:2), c(1:2,1:2)

      c(1,1) = a(1,1)*b(1,1) + a(1,2)*b(2,1)
      c(1,2) = a(1,1)*b(1,2) + a(1,2)*b(2,2)
      c(2,1) = a(2,1)*b(1,1) + a(2,2)*b(2,1)
      c(2,2) = a(2,1)*b(1,2) + a(2,2)*b(2,2)

      end

c-------------------------------------------------------------------

      subroutine diagonalization(a, b, c, d)

      double precision a(1:2,1:2), b(1:2,1:2), c(1:2,1:2), d(1:2,1:2),
     $                 e(1:2,1:2)

      call matmult(a, b, e)
      call matmult(e, c, d)

      end

c-------------------------------------------------------------------

      subroutine diagonalization2(cos11, sin12, b, d)

      double precision a(1:2,1:2), b(1:2,1:2), c(1:2,1:2), d(1:2,1:2),
     $                 e(1:2,1:2), cos11, sin12

      a(1,1) = cos11
      a(1,2) = sin12
      a(2,1) = -a(1,2)
      a(2,2) = a(1,1)
      c(1,1) = a(1,1)
      c(1,2) = a(2,1)
      c(2,1) = a(1,2)
      c(2,2) = a(2,2)


      call matmult(a, b, e)
      call matmult(e, c, d)

      end

c------------------------------------------------------------------------

