      subroutine delrho(mst1, mst2, stt, msb1, msb2, stb, mgl, 
     $           mt, mb, xgf, as, cf, gs, el, mz, mw, 
     $           mh12eff, mh22eff, ma, aleff, beta,
     $           res1loop, res2loopgluon, res2loopgluino,
     $           res2loopmt2yuk, res2loopmt2yuksm)

      include 'delrhoGluinovar.f'
      include 'delrhoMT2Yukvar.f'
      include 'delrhoMT2YukSMvar.f'
      double precision mst1, mst2, stt, ctt, mt, 
     $                 msb1, msb2, stb, ctb, mb, mgl, 
     $                 gf, as, pi, res, xgf, cf, gs, el, mw, mz, pref
      double precision oneloop, twoloop, f0, f1,
     $                 res1loop, res2loopgluon, res2loopgluino,
     $                 res2loopmt2yuk, res2loopmt2yuksm

      double precision xmh12, xmh22, xma, xsa, xca,
     $                 mh12eff, mh22eff, ma, aleff, beta
      common/xhiggs/ xmh12, xmh22, xma, xsa, xca

      integer delmbresum
      double precision dmb, mbbdmb
      double precision msb1dmb, msb2dmb, stbdmb, tsbdmb
      double precision msb1save, msb2save, stbsave
      common /deltambresum/dmb, msb1dmb, msb2dmb, stbdmb, tsbdmb, 
     $                     delmbresum
      mbbdmb = mbb/(1d0 + dmb)

      if (delmbresum.eq.2) then
         msb1save = msb1
         msb2save = msb2
         stbsave = stb
         msb1 = msb1dmb
         msb2 = msb2dmb
         stb = stbdmb
      endif

c$$$      write(*,*) 'paramters in delrho:'
c$$$      write(*,*) 'mst1, mst2, stt, msb1, msb2, stb, xgf, as, mt, mb'
c$$$      write(*,*) 'mgl, cf, gs, el, mz, mw, mh, mH, MA, al, be'
c$$$      write(*,*) real(mst1), real(mst2), real(stt), real(msb1), 
c$$$     $           real(msb2), real(stb), real(xgf), real(as),
c$$$     $           real(mt), real(mb), real(mgl), real(cf), real(gs),
c$$$     $           real(el), real(mz), real(mw), real(mh12eff),
c$$$     $           real(mh22eff), real(ma), real(aleff), real(beta)

      pi = 3.14159265358979d0
      gf = xgf
      ctt = dsqrt(1d0 - stt**2)
      ctb = dsqrt(1d0 - stb**2)
      pref = (3d0 * cf * gs**2 * el**2 * mz**2)/
     $       (2**6 * mw**2 * (mw**2 - mz**2) * pi**4)
      prefmt2yuk = (3d0 * el**4 * mt**4 * mz**4)/
     $             (2**12 * mw**4 * (mw**2 - mz**2)**2 * pi**4)
      xmh12 = mh12eff
      xmh22 = mh22eff
      xsa = dsin(aleff)
      xca = dcos(aleff)
      xma = ma
 
      oneloop = 3d0 * gf/(8d0 * dsqrt(2d0) * pi**2) *
     $          ( - stt**2 * ctt**2 * f0(mst1**2, mst2**2)
     $            - stb**2 * ctb**2 * f0(msb1**2, msb2**2)
     $            + ctt**2 * ctb**2 * f0(mst1**2, msb1**2)
     $            + ctt**2 * stb**2 * f0(mst1**2, msb2**2)
     $            + stt**2 * ctb**2 * f0(mst2**2, msb1**2)
     $            + stt**2 * stb**2 * f0(mst2**2, msb2**2) )

      twoloop = gf * as/(4d0 * dsqrt(2d0) * pi**3) *
     $          ( - stt**2 * ctt**2 * f1(mst1**2, mst2**2)
     $            - stb**2 * ctb**2 * f1(msb1**2, msb2**2)
     $            + ctt**2 * ctb**2 * f1(mst1**2, msb1**2)
     $            + ctt**2 * stb**2 * f1(mst1**2, msb2**2)
     $            + stt**2 * ctb**2 * f1(mst2**2, msb1**2)
     $            + stt**2 * stb**2 * f1(mst2**2, msb2**2) )

c      write(*,*) 'vor delrhoGluinosum.f'
      if ((mst1.eq.msb1).or.(mst2.eq.msb1)) then
c         write(*,*) 'MSb1 correction for Delta rho gluino'
         msb1 = msb1 + 0.5d0
         include 'delrhoGluinosum.f'
         msb1 = msb1 - 0.5d0
      elseif ((mst1.eq.msb2).or.(mst2.eq.msb2)) then
c         write(*,*) 'MSb2 correction for Delta rho gluino'
         msb2 = msb2 + 0.5d0
         include 'delrhoGluinosum.f'
         msb2 = msb2 - 0.5d0
      else
c         write(*,*) 'no masses equal'
         include 'delrhoGluinosum.f'
      endif

c      write(*,*) 'DelrhoSub:'
c      write(*,*) oneloop, twoloop, delrhoGluino, delrhoGluino*pref
      res1loop = oneloop
      res2loopgluon = twoloop
      res2loopgluino = dreal(delrhoGluino) * pref
c --> new routine for switching of the gluino contribution for large masses
      fak = 2.718281828d0**
     $      (- (switchoff(mst1) + switchoff(mst2) +
     $          switchoff(msb1) + switchoff(msb2) + 
     $          switchoff(mgl) ))
      res2loopgluino = res2loopgluino * fak
c      write(*,*) 'delrho gluino factor:', fak
c --> old routine for switching of the gluino contribution for large masses
c      if (dabs(res2loopgluino).gt.dabs(res1loop/3d0)) then
c         res2loopgluino = 0d0
c      endif


      include 'delrhoMT2Yuksum.f'
      include 'delrhoMT2YukSMsum.f'
      res2loopmt2yuk   = delrhomt2yuk   * prefmt2yuk
      res2loopmt2yuksm = delrhomt2yuksm * prefmt2yuk
c      write(*,*) 'MT2Yuk:', res2loopmt2yuk, res2loopmt2yuksm, prefmt2yuk



c$$$      write(*,*) 'delrhosub:'
c$$$      write(*,*) real(oneloop), real(twoloop)
c$$$      write(*,*)
c$$$      write(*,*) 'single parts:'
c$$$      twoloop = gf * as/(4d0 * dsqrt(2d0) * pi**3) *
c$$$     $          ( - stt**2 * ctt**2 * f1(mst1**2, mst2**2))
c$$$      write(*,*) twoloop
c$$$      twoloop = gf * as/(4d0 * dsqrt(2d0) * pi**3) *
c$$$     $          ( - stb**2 * ctb**2 * f1(msb1**2, msb2**2))
c$$$      write(*,*) twoloop
c$$$      twoloop = gf * as/(4d0 * dsqrt(2d0) * pi**3) *
c$$$     $          ( + ctt**2 * ctb**2 * f1(mst1**2, msb1**2))
c$$$      write(*,*) twoloop
c$$$      twoloop = gf * as/(4d0 * dsqrt(2d0) * pi**3) *
c$$$     $          ( + ctt**2 * stb**2 * f1(mst1**2, msb2**2))
c$$$      write(*,*) twoloop
c$$$      twoloop = gf * as/(4d0 * dsqrt(2d0) * pi**3) *
c$$$     $          ( + stt**2 * ctb**2 * f1(mst2**2, msb1**2))
c$$$      write(*,*) twoloop
c$$$      twoloop = gf * as/(4d0 * dsqrt(2d0) * pi**3) *
c$$$     $          ( + stt**2 * stb**2 * f1(mst2**2, msb2**2))
c$$$      write(*,*) twoloop

      if (delmbresum.eq.2) then
         msb1 = msb1save
         msb2 = msb2save
         stb = stbsave
         ctb = dsqrt(1d0 - stb**2)
      endif

      end


c-------------------------------------------------------------------

      double precision function f0(x,y)

      double precision x, y

      if (x.ne.y) then
c         write(*,*) 'f0:', x, y
      f0 = x + y - (2d0 * x * y)/(x - y) * dlog(x/y)
      else
      f0 = 0d0
      endif

      end


c-------------------------------------------------------------------

      double precision function f1(x2,y2)

      double precision x2, y2
      complex*16 ff, x, y, cspen
      
      x = (dsqrt(x2) - (0d0,1d0) * 10d-10)**2
      y = (dsqrt(y2) - (0d0,1d0) * 10d-10)**2

      if (x.ne.y) then
c         write(*,*) 'f1:', x, y
      ff = x + y 
     $   - (2d0 * x * y)/(x - y) * cdlog(x/y) * (2d0 + x/y * cdlog(x/y))
     $   + (x + y)*x**2/(x - y)**2 * (cdlog(x/y))**2 
     $   - 2d0 * (x - y) * cspen(1d0 - x/y)

      f1 = dreal(ff)
      else
      f1 = 0d0
      endif

      end


c-------------------------------------------------------------------

      double precision function switchoff(m)

      double precision m,so

      so = (m - 750d0)/125d0
      if (so.le.0d0) so = 0d0
      
      switchoff = so**2

      end

c-------------------------------------------------------------------




      
