C-----------------------------------------------------------------
      SUBROUTINE GAMMAWB2(T,CI2,F)            
C-----------------------------------------------------------------
C
C     Right hand side of 2-loop RGEs for evolution of 
C     Wilson coefficients CI2 below M_W scale
C          dCI2_i/dT = F_i(CI2) ~ \gamma_ji * CI2_j
C
C
      IMPLICIT NONE
      REAL*8 T,CI2(8),F(8)
      COMMON / G3/ G3
      REAL*8 G3
      SAVE /G3/
      REAL*8 PI,FAC1,FAC2
      INTEGER EN,NF,NU,ND,PAR
      
      EN=3
      NF=5
      NU=2
      ND=3
      par=0
C     
      PI=4.d0*ATAN(1.d0)
      FAC1=G3**2/(16.d0*PI**2)
      FAC2=G3**4/(16.d0*PI**2)**2
C
      F(1)=FAC1*(-2.d0*CI2(1)+6.d0*CI2(2))       
     $    +FAC2*((-22./3.d0-57./EN**2/2.d0-2./EN*NF/3.d0)*CI2(1)
     $          +(-19.*EN/6.d0+39./EN+2./3.d0*NF)*CI2(2))
      F(2)=FAC1*(6.d0*CI2(1)-2.d0*CI2(2))
     $    +FAC2*((-19.*EN/6.d0+39.d0/EN+2.*NF/3.d0)*CI2(1)
     $           +(-22./3.d0-57./EN**2/2.d0-3./EN*NF/3.d0)*CI2(2))
      F(3)=FAC1*(-2./9.d0*CI2(2)-22./9.d0*CI2(3)
     $         -2./9.d0*NF*CI2(4)-2./9.d0*NF*CI2(6))
     $    +FAC2*((3.d0*EN-2./3.d0/EN)*CI2(1)
     $          +(-32./27.d0+86./27.d0/EN**2)*CI2(2)
     $          +(-262./27.d0-1195./54.d0/EN**2+3.*EN*NF
     $            -10./3.d0/EN*NF)*CI2(3)
     $          +(17.*EN/6.d0+113./3.d0/EN-2./27.d0*EN*NF
     $            +74./27.d0/EN**2*NF)*CI2(4)
     $          +(-3.d0*EN*NF+20./3.d0/EN*NF)*CI2(5)
     $          +(-56./27.d0*NF-178./27.d0/EN**2*NF)*CI2(6))
      F(4)=FAC1*(2./3.d0*CI2(2)+22./3.d0*CI2(3)
     $          +(-2.d0+2./3.d0*NF)*CI2(4)+2./3.d0*NF*CI2(6))    
     $    +FAC2*(-7./3.d0*CI2(1)
     $          +(-176.*EN/27.d0-230./27.d0/EN)*CI2(2)
     $          +(-533.*EN/54.d0+593./27.d0/EN
     $            +1./3.d0*NF)*CI2(3)
     $          +(-12.d0-57./2.d0/EN**2+110./27.d0*NF
     $            -182./27.d0/EN*NF)*CI2(4)
     $          -11./3.d0*NF*CI2(5)
     $          +(-16.*EN/27.d0*NF+250./27.d0/EN*NF)*CI2(6))
      F(5)=FAC1*(-2./9.d0*CI2(2)-4./9.d0*CI2(3)
     $         -2./9.d0*NF*CI2(4)+2.d0*CI2(5)-2./9.d0*NF*CI2(6))
     $    +FAC2*((-3.d0*EN+16./3.d0/EN)*CI2(1)
     $          +(-122./27.d0-94./27.d0/EN**2)*CI2(2)
     $          +(-244./27.d0-188./27.d0/EN**2-3.d0*EN*NF
     $            +10./3.d0/EN*NF)*CI2(3)
     $          +(-6.d0*EN+32./3.d0/EN-56./27.d0*NF
     $            +2./27.d0/EN**2*NF)*CI2(4)
     $          +(137./6.d0+15./2.d0/EN**2+3.d0*EN*NF
     $            -20./3.d0/EN*NF)*CI2(5)
     $          +(-71./2.d0*EN-18.d0/EN+178./27.d0*NF
     $            +74./27.d0/EN**2*NF)*CI2(6))
      F(6)=FAC1*(2./3.d0*CI2(2)+4./3.d0*CI2(3)+2./3.d0*NF*CI2(4)
     $          -6.d0*CI2(5)+(-16.d0+2./3.d0*NF)*CI2(6))
     $    +FAC2*(-7./3.d0*EN*CI2(1)
     $          +(86.*EN/27.d0+130./27.d0/EN)*CI2(2)
     $          +(172.*EN/27.d0+260./27.d0/EN-NF/3.)*CI2(3)
     $          +(-14./3.d0+74.*EN/27.d0*NF
     $            -20./27.d0/EN*NF)*CI2(4)
     $          +(-100.*EN/3.d0+3./EN+11./3.d0*NF)*CI2(5)
     $          +(-203.*EN**2/6.d0+479./6.d0+15./2.d0/EN**2
     $            +200.*EN/27.d0*NF)*CI2(6))
      F(7)=FAC1*(416./81.d0*CI2(2)-464./81.d0*CI2(3)
     $          +(416./81.d0*NU-232./81.d0*ND)*CI2(4)
     $          +32./9.d0*CI2(5)
     $          +(-448./81.d0*NU+200./81.d0*ND)*CI2(6)
     $          +32./3.d0*CI2(7)-32./9.d0*CI2(8))
     $    +FAC2*(4688./27.d0*CI2(7)-2192./81.d0*CI2(8)
     $           +PAR*CI2(2))
      F(8)=FAC1*(3.d0*CI2(1)+70./27.d0*CI2(2)
     $          +(140./27.d0+3.d0*NF)*CI2(3)
     $          +(6.d0+70./27.d0*NF)*CI2(4)
     $          +(-14./3.d0-3.d0*NF)*CI2(5)
     $          +(-4.d0-119./27.d0*NF)*CI2(6)
     $          +28./3.d0*CI2(8))        
     $    +FAC2*(4063./27.d0*CI2(8)
     $           -PAR*CI2(2))
      
      RETURN
      END
