      subroutine dssuspect
c
c###########################################################
c     interface subroutine  between Suspect & Darksusy
c     February 2001
c     Author : Emmanuel NEZRI   nezri@in2p3.fr  
c
c###########################################################
c      implicit real*8(a-h,m,o-z)
      implicit none
      include 'dssusy.h'
      include 'dsidtag.h'
      integer i
      real*8 dmhu2,dmhd2,dMA,dMU,dM1,dM2,dM3,
     .       dMSL,dMTAUR,dMEL,dMER,dMSQ,dMTR,
     .       dMBR,dMUQ,dMUR,dMDR, dAL,dAU,dAD,
     .       m0,mhalf,A0,sgnmu0,tgbeta

c 2000 format (1x,a12,7(1x,e14.8))
c
c  
c..........Suspect commons needed for Darksusy inputs
c

      COMMON/MSUGRA/m0,mhalf,A0,sgnmu0,tgbeta
      COMMON/MSSMhpar/dmhu2,dmhd2,dMA,dMU
      COMMON/MSSMgpar/dM1,dM2,dM3
      COMMON/MSSMslep/dMSL,dMTAUR,dMEL,dMER
      COMMON/MSSMsqua/dMSQ,dMTR,dMBR,dMUQ,dMUR,dMDR
      COMMON/MSSMAtri/dAL,dAU,dAD

c
c
c.........Suspect parameters
      integer IKNOWL, INPUT
      integer ICHOICE(10)
      real*8 errmess(10)

c
c........set Suspect running options
c
c       IKNOWL=0;
        IKNOWL=1;     
c        IKNOWL=2;
c
c
       INPUT=0;
c      INPUT=1;
c
c
c............. ICHOICE................
c
c
c.....ICHOICE(1) CHOICE OF MODEL
c
c   purely unconstrained MSSM (= NO RG evol.)
c     ICHOICE(1) = 0  
c
c   RG evolved unconstrained MSSM
c       ICHOICE(1) = 1 
c
c   Unconstrained MSSM RG evolved from DOWN to UP
c      ICHOICE(1) = 2
c
c   reserved for later use (particular models)
c      ICHOICE(1) = 3--9
c
c   Minimal SUGRA Model
       ICHOICE(1)= 10
c
c   
c  
c.....ICHOICE(2) ELABORATION LEVEL of RG evolution:
c 
c   1-loop evolution, with simple threshold effects.
c       ICHOICE(2)=11
c
c   1-loop evolution, with more realistic thresholds
c      ICHOICE(2)=12
c
c   2-loop evolution,  simple threshold effects.
c      ICHOICE(2)=21
c
c   2-loop evolution, with more realistic threshold effects
c      ICHOICE(2)=22
c IMPORTANT: at present only ICHOICE(2)=11,21 is operative
c
c
c.....ICHOICE(3) Gauge COUPLING UNIFication and Yukawa UNIFICATION.
c
c   NO unification
c      ICHOICE(3)=0
c
c   gauge coupling unification (GUT (11), alpha_s(z) relaxed(12) )
c       ICHOICE(3)=11 
c
c  gauge unif AND bottom-tau Yukawa unif.
c     ICHOICE(3)=21
c
c
c.....ICHOICE(4) ACCURACY OF RG evolution:
c
c  Fast, but rather inaccurate RG evolution
c       ICHOICE(4)= 0
c
c  More accurate, but slower RG evolution 
c      ICHOICE(4)= 1
c
c.....ICHOICE(5) electroweak breaking
c
c  NO RADIATIVE electroweak breaking
c      ICHOICE(5)=0
c
c  RADIATIVE  breaking
c       ICHOICE(5)=1
c
c.....ICHOICE(6) : MA, MU or M^2_Hu, M^2_Hd
c
c  MA, MU input
c      ICHOICE(6)=0
c
c  M^2_Hu, M^2_Hd (high scale) input
       ICHOICE(6)=1
c
c
c.....ICHOICE(7)--ICHOICE(9) reserved for later use
c
c
c  COMPUTES RUNNING masses (FASTER) 
       ICHOICE(10)=0
c
c COMPUTES POLE masses
c      ICHOICE(10)=1
c
c
c

       print *,"call Suspect"
      call suspect12(IKNOWL, INPUT, ICHOICE, ERRMESS)
      print *,"suspect terminated"

c
c   connection between Suspect and Darksusy variables
c
      m1=dM1
      m2=dM2
      m3=dM3
      mu=dMU
      ma=dMA
      tanbe=tgbeta
      mqtilde=dMSQ

c
c   squark and sleptons mass matrices
c      
c  3rd family
      mass2q(3)=dMSQ*dMSQ
      mass2u(3)=dMTR*dMTR
      mass2d(3)=dMBR*dMBR
      mass2l(3)=dMSL*dMSL
      mass2e(3)=dMTAUR*dMTAUR
      asoftu(3)=dAU
      asoftd(3)=dAD
      asofte(3)=dAL
c  1rst and 2nd families
      do i=1,2
       mass2q(i)=dMUQ*dMUQ
       mass2u(i)=dMUR*dMUR
       mass2d(i)=dMDR*dMDR
       mass2l(i)=dMEL*dMEL
       mass2e(i)=dMER*dMER
       asoftu(i)=0
       asoftd(i)=0
       asofte(i)=0
      enddo
      return
      end
c












