c----------------------------------------------------------------------
c   Interface between DarkSUSY and HDECAY.
c   HDECAY is called and the results transferred to the DarkSUSY
c   common blocks. 
c   Author: Joakim Edsjo, edsjo@physto.se
c   Date: September 12, 2002
c   Modified: April 8, 2008 (incorrect tagging of H1 -> H3 Z decay fixed)
c----------------------------------------------------------------------

      subroutine dshdecay
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      include 'dssusy.h'
      logical first
      data first/.true./
      save first

c...Below are the HDECAY common blocks
      PARAMETER(K=6,NI=87,NSA=85,NSB=86,NLA=88,NLB=89,NHA=90,NHB=91,
     .          NHC=92,NAA=93,NAB=94,NCA=95,NCB=96,NRA=97,NRB=98,
     .          NSUSYL=81,NSUSYA=82,NSUSYH=83,NSUSYC=84,NPAR=80,
     .          NSUSYLA=79,NSUSYLB=78,NSUSYLC=77,NSUSYLD=76,NSUSYLE=75,
     .          NSUSYLF=59,NSUSYHF=58,
     .          NSUSYHA=74,NSUSYHB=73,NSUSYHC=72,NSUSYHD=71,NSUSYHE=70,
     .          NSUSYAA=69,NSUSYAB=68,NSUSYAC=67,NSUSYAD=66,NSUSYAE=65,
     .          NSUSYCA=64,NSUSYCB=63,NSUSYCC=62,NSUSYCD=61,NSUSYCE=60)
      DIMENSION GMN(4),XMN(4),GMC(2),GMST(2),GMSB(2),GMSL(2),
     .          GMSU(2),GMSD(2),GMSE(2),GMSN(2)
      DIMENSION HLBRSC(2,2),HLBRSN(4,4),HHBRSC(2,2),HHBRSN(4,4),
     .          HABRSC(2,2),HABRSN(4,4),HCBRSU(2,4),
     .          HHBRST(2,2),HHBRSB(2,2),HCBRSTB(2,2) 
      DIMENSION AC1(2,2),AC2(2,2),AC3(2,2),
     .          AN1(4,4),AN2(4,4),AN3(4,4),
     .          ACNL(2,4),ACNR(2,4)
      DIMENSION GLTT(2,2),GLBB(2,2),GHTT(2,2),GHBB(2,2),GCTB(2,2),
     .          GLEE(2,2),GHEE(2,2),GCEN(2,2)
      COMMON/MASSES/AMS,AMC,AMB,AMT
      COMMON/STRANGE/AMSB
      COMMON/PARAM/GF,ALPH,AMTAU,AMMUON,AMZ,AMW
      COMMON/CKMPAR/VUS,VCB,VUB
      COMMON/HMASS/AMSM,AMA,AML,AMH,AMCH,AMAR
      COMMON/BREAK/AMEL,AMER,AMSQ,AMUR,AMDR,AL,AU,AD,AMU,AM2
      COMMON/SFER1ST/AMQL1,AMUR1,AMDR1,AMEL1,AMER1
      COMMON/WZWDTH/GAMC0,GAMT0,GAMT1,GAMW,GAMZ
      COMMON/COUP/GAT,GAB,GLT,GLB,GHT,GHB,GZAH,GZAL,
     .            GHHH,GLLL,GHLL,GLHH,GHAA,GLAA,GLVV,GHVV,
     .            GLPM,GHPM,B,A
      COMMON/ALS/XLAMBDA,AMC0,AMB0,AMT0,N0
      COMMON/FLAG/IHIGGS,NNLO,IPOLE
      COMMON/ONSHELL/IONSH,IONWZ,IOFSUSY
      COMMON/OLDFASH/NFGG
      COMMON/WIDTHSM/SMBRB,SMBRL,SMBRM,SMBRS,SMBRC,SMBRT,SMBRG,SMBRGA,
     .               SMBRZGA,SMBRW,SMBRZ,SMWDTH
      COMMON/WIDTHA/ABRB,ABRL,ABRM,ABRS,ABRC,ABRT,ABRG,ABRGA,ABRZGA,
     .              ABRZ,AWDTH
      COMMON/WIDTHHL/HLBRB,HLBRL,HLBRM,HLBRS,HLBRC,HLBRT,HLBRG,HLBRGA,
     .               HLBRZGA,HLBRW,HLBRZ,HLBRA,HLBRAZ,HLBRHW,HLWDTH
      COMMON/WIDTHHH/HHBRB,HHBRL,HHBRM,HHBRS,HHBRC,HHBRT,HHBRG,HHBRGA,
     .               HHBRZGA,HHBRW,HHBRZ,HHBRH,HHBRA,HHBRAZ,HHBRHW,
     .               HHWDTH
      COMMON/WIDTHHC/HCBRB,HCBRL,HCBRM,HCBRBU,HCBRS,HCBRC,HCBRT,HCBRW,
     .               HCBRA,HCWDTH
      COMMON/WISUSY/HLBRSC,HLBRSN,HHBRSC,HHBRSN,HABRSC,HABRSN,HCBRSU,
     .              HLBRCHT,HHBRCHT,HABRCHT,HLBRNET,HHBRNET,HABRNET,
     .              HCBRCNT,HLBRSL,HHBRSL,HCBRSL,HABRSL,HABRST,HABRSB,
     .              HHBRSQ,HHBRST,HHBRSB,HHBRSQT,HCBRSQ,HCBRSTB,
     .              HCBRSQT,HLBRSQ,HLBRSQT
      COMMON/WISFER/BHLSLNL,BHLSLEL,BHLSLER,BHLSQUL,BHLSQUR,BHLSQDL,
     .              BHLSQDR,BHLST(2,2),BHLSB(2,2),BHLSTAU(2,2),
     .              BHHSLNL,BHHSLEL,BHHSLER,BHHSQUL,BHHSQUR,BHHSQDL,
     .              BHHSQDR,BHHST(2,2),BHHSB(2,2),BHHSTAU(2,2),
     .              BHASTAU,BHASB,BHAST,
     .              BHCSL00,BHCSL11,BHCSL21,BHCSQ,BHCSTB(2,2)
      COMMON/SMASS/GMN,XMN,GMC,GMST,GMSB,GMSL,GMSU,GMSD,GMSE,GMSN 

c...Set input values
      IHIGGS    = 5   ! All SUSY Higgses

c...Set default values from DarkSUSY values
      TGBET    = tanbe
      ALSMZ    = alph3mz
      ams      = ms2gev   ! should be s-quark MS-bar mass at 1 GeV
      amc      = mcmc ! mass(kc)
      amb      = mbmb ! mass(kb)
      amt      = mass(kt)
      amtau    = mass(ktau)
      ammuon   = mass(kmu)
      alph     = 137.0359895D0   ! 1/alpha at Q=0
      GF       = GFermi          ! Fermi decay constant.
      GAMW     = width(kw)
      GAMZ     = width(kz)
      AMZ      = mass(kz)
      AMW      = mass(kw)
      VUS      = ckms12
      VCB      = ckms23
      RVUB     = ckms13/ckms23 ! VUB/VCB

      write (*,*) tgbet,alsmz,ams,amc,amb,amt,amtau,ammuon,alph,gf,
     &     gamw,gamz,amz,amw,vus,vcb,rvub

c...HDECAY does not accept both mu and M2 negative (the chargino
c...routines in hdgaugino gets into an endless loop). Choose M2>0
c...and change signs of both mu and m2 when needed.
      if (m2.gt.0) then
        AMU      = mu
        AM2      = m2
      else
        AMU      = -mu
        AM2      = -m2
      endif
c...NOTE: The following values are taken from DarkSUSY. For MSSM
c...this is perfectly OK, but for mSUGRA it is doing things double
c...since HDECAY will recalculate things we already have. On the
c...other hand, the interface to HDECAY is kept simple.
      AMEL1    = sqrt(mass2l(1))
      AMER1    = sqrt(mass2e(1))
      AMQL1    = sqrt(mass2q(1))
      AMUR1    = sqrt(mass2u(1))
      AMDR1    = sqrt(mass2d(1))
      AMEL     = sqrt(mass2l(3))
      AMER     = sqrt(mass2e(3))
      AMSQ     = sqrt(mass2q(3))
      AMUR     = sqrt(mass2u(3))
      AMDR     = sqrt(mass2d(3))
      AL       = asofte(3)
      AU       = asoftu(3)
      AD       = asoftd(3)

      vub=rvub*vcb
      alph=1.d0/alph
      amsb=ams

      AMAR = mass(kh3)  ! mA mass

c...Set switches
      NNLO     = 0
      IONSH    = 0
      IONWZ    = 0
      IPOLE    = 0
      IOFSUSY  = 0   ! 0=include SUSY particles and loops
      INDIDEC  = 0
      NFGG     = 5

C--CHECK NFGG
      IF(NFGG.GT.5.OR.NFGG.LT.3)THEN
       WRITE(6,*)'NF-GG NOT VALID. TAKING THE DEFAULT NF-GG = 3....'
       NFGG = 3
      ENDIF

      AMC0=AMC
      AMB0=AMB
      AMT0=AMT
      ACC=1.D-8
      NLOOP=2
      XLAMBDA=hdxitla(NLOOP,ALSMZ,ACC)
      N0=5

      CALL hdalsini(ACC)

C--INITIALIZE COEFFICIENTS FOR POLYLOGARITHMS
      NBER = 18
      CALL BERNINI(NBER)


c...what is this?!? (JE)
      IWRISU = 1

      AMSM = AMAR
      AMA = AMAR

c...Now start calculating
      CALL hdsusycp(TGBET)
      CALL hdgaugino(AMU,AM2,B,A,GMC,GMN,XMN,AC1,AC2,AC3,
     .              AN1,AN2,AN3,ACNL,ACNR)         
      CALL hdsfermion(AMSQ,AMUR,AMDR,AMEL,AMER,AL,AU,AD,AMU,
     .               GMST,GMSB,GMSL,GMSU,GMSD,GMSE,GMSN, 
     .               GLEE,GLTT,GLBB,GHEE,GHTT,GHBB,
     .               GAEE,GATT,GABB,GCEN,GCTB)

C 

C
C **************************************************************

      CALL HDEC(TGBET)


c...Reset widths
      do i=1,32
        do j=1,4
          hdwidth(i,j)=0.0d0
        enddo
      enddo

c...H2 boson
      if (ihiggs.eq.1.or.ihiggs.eq.5) then
        mass(kh2)  = aml
        width(kh2) = hlwdth
        hdwidth(25,2) = hlbrb  * hlwdth ! b b-bar
        hdwidth(19,2) = hlbrl  * hlwdth ! tau- tau+
        hdwidth(17,2) = hlbrm  * hlwdth ! mu- mu+
        hdwidth(23,2) = hlbrs  * hlwdth ! s s-bar
        hdwidth(22,2) = hlbrc  * hlwdth ! c c-bar
        hdwidth(24,2) = hlbrt  * hlwdth ! t t-bar
        hdwidth(26,2) = hlbrg  * hlwdth ! glue glue
        hdwidth(28,2) = hlbrga * hlwdth ! gamma gamma
        hdwidth(29,2) = hlbrzga* hlwdth ! Z0 gamma
        hdwidth(13,2) = hlbrw  * hlwdth ! W+ W-
        hdwidth(12,2) = hlbrz  * hlwdth ! Z0 Z0
      else
        mass(kh2)  = 0.0d0
        width(kh2) = 0.0d0
      endif

c...H1 boson
      if (ihiggs.eq.2.or.ihiggs.eq.5) then
        mass(kh1)  = amh
        width(kh1) = hhwdth
        hdwidth(25,1) = hhbrb  * hhwdth ! b b-bar
        hdwidth(19,1) = hhbrl  * hhwdth ! tau- tau+
        hdwidth(17,1) = hhbrm  * hhwdth ! mu- mu+
        hdwidth(23,1) = hhbrs  * hhwdth ! s s-bar
        hdwidth(22,1) = hhbrc  * hhwdth ! c c-bar
        hdwidth(24,1) = hhbrt  * hhwdth ! t t-bar
        hdwidth(26,1) = hhbrg  * hhwdth ! glue glue
        hdwidth(28,1) = hhbrga * hhwdth ! gamma gamma
        hdwidth(29,1) = hhbrzga* hhwdth ! Z0 gamma
        hdwidth(13,1) = hhbrw  * hhwdth ! W+ W-
        hdwidth(12,1) = hhbrz  * hhwdth ! Z0 Z0
        hdwidth(3,1)  = hhbrh  * hhwdth ! H20 H20
        hdwidth(4,1)  = hhbra  * hhwdth ! H30 H30
        hdwidth(10,1) = hhbraz * hhwdth ! Z H30
        hdwidth(11,1) = hhbrhw * hhwdth ! W+ H- / W- H+
      else
        mass(kh1)  = 0.0d0
        width(kh1) = 0.0d0
      endif

c...H3 boson
      if (ihiggs.eq.3.or.ihiggs.eq.5) then
        mass(kh3)  = ama
        width(kh3) = awdth
        hdwidth(25,3) = abrb  * awdth ! b b-bar
        hdwidth(19,3) = abrl  * awdth ! tau- tau+
        hdwidth(17,3) = abrm  * awdth ! mu- mu+
        hdwidth(23,3) = abrs  * awdth ! s s-bar
        hdwidth(22,3) = abrc  * awdth ! c c-bar
        hdwidth(24,3) = abrt  * awdth ! t t-bar
        hdwidth(26,3) = abrg  * awdth ! glue glue
        hdwidth(28,3) = abrga * awdth ! gamma gamma
        hdwidth(29,3) = abrzga* awdth ! Z0 gamma
        hdwidth(9,3)  = abrz  * awdth ! Z0 H20
      else
        mass(kh3)  = 0.0d0
        width(kh3) = 0.0d0
      endif

c...H+ boson
      if (ihiggs.eq.4.or.ihiggs.eq.5) then
        mass(khc)  = amch
        width(khc) = hcwdth
        hdwidth(6,4)  = hcbrb * hcwdth
        hdwidth(12,4) = hcbrl * hcwdth
        hdwidth(11,4) = hcbrm * hcwdth
        hdwidth(2,4)  = hcbrs * hcwdth
        hdwidth(5,4)  = hcbrc * hcwdth
        hdwidth(9,4)  = hcbrt * hcwdth
        hdwidth(14,4) = hcbrw * hcwdth
        hdwidth(15,4) = hcbra * hcwdth
      else
        mass(khc)  = 0.0d0
        width(khc) = 0.0d0
      endif

      return
      end

